<?php 
//error_reporting(E_ALL);
require('includes/inc_db.php');
include('functions/function.php');
include('functions/detect_proxy.php');
#include('detect_vpn.php');
 
$rqtUpdate = "UPDATE reg_users SET last_login = :login, ip=:ip WHERE id=:id";
$stmtUpdate = $pdo->prepare($rqtUpdate);

if(isset($_SESSION['username'])){
    header("Location: home/dashboard.php");
} 
if(isset($_POST)){
   
          $rqt = "SELECT reg_users.*, RUC.is_master_reseller, RUC.cannot_create_sub  FROM reg_users LEFT JOIN panel.reg_users_credit AS RUC ON RUC.target_id = reg_users.id WHERE username = :username";
		  //die($rqt);
          $stmt = $pdo->prepare($rqt);
          $stmt->bindParam(":username",$_POST['username']);
          $stmt->execute();
          $result = $stmt->fetchAll(PDO::FETCH_ASSOC);
		  
          if(count($result)>0){
              if($result[0]["status"] == 1){
                  $password = crypt($_POST['password'], '$6$rounds=20000$xtreamcodes$');
                  if($password == $result[0]['password']){
                      $sqlDns = "SELECT * FROM `streaming_servers` WHERE `id` = 1 ORDER BY `id` ASC";
                      $stmtDns = $pdo->prepare($sqlDns);
                      $stmtDns->execute();
                      $resultDns = $stmtDns->fetchAll(PDO::FETCH_ASSOC);
                      $_SESSION["username"] = $_POST['username'];
                      $_SESSION["group_id"] = $result[0]['member_group_id'];
                      $_SESSION["need_update_pass"] = $result[0]['need_update_pass'];
                      $_SESSION["id"] = $result[0]['id'];
                      $_SESSION['is_master_reseller'] = $result[0]['is_master_reseller'];
                      $_SESSION['cannot_create_sub'] = $result[0]['cannot_create_sub'];
                      if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
                        $ip = $_SERVER['HTTP_CLIENT_IP'];
                      } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
                          $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
                      } else {
                          $ip = $_SERVER['REMOTE_ADDR'];
                      }
                      $nowT = time();
                      $stmtUpdate->bindParam(":login",$nowT);
                      $stmtUpdate->bindParam(":id",$result[0]['id']);
                      $stmtUpdate->bindParam(":ip",$ip);

                      $stmtUpdate->execute();
                      
                      logEvent($pdo,"Logged In",$_POST['username'],"With IP ".$ip);
                    
                      // $_SESSION["sub"] = array_keys(getRegisteredUsers($_SESSION["id"]));
                      if($result[0]['reseller_dns']== ""){
                          $_SESSION["dns"] = $resultDns[0]["domain_name"] ? $resultDns[0]["domain_name"] : $resultDns[0]["server_ip"];
                          $_SESSION["dns"] = $_SESSION["dns"].":".$resultDns[0]["http_broadcast_port"];
                      }else{
                          if(strpos($result[0]['reseller_dns'],":")){
                              $_SESSION["dns"] = $result[0]['reseller_dns'];
                          }else{
                              $_SESSION["dns"] = $result[0]['reseller_dns'].":".$resultDns[0]["http_broadcast_port"];
                          }
                      }
                      $rqtAdmin = "SELECT group_name, group_color, is_admin,create_sub_resellers FROM member_groups WHERE group_id = :id";
                      $stmt = $pdo->prepare($rqtAdmin);
                      // var_dump($result[0]);
                      $stmt->bindParam(":id",$result[0]['member_group_id']);
                      $stmt->execute();
                      $resultat = $stmt->fetchAll(PDO::FETCH_ASSOC);
                      $_SESSION['admin'] = $resultat[0]['is_admin'];
                      $_SESSION['createSub'] = $resultat[0]['create_sub_resellers'];
                      $_SESSION['group_name'] = $resultat[0]['group_name'];
                      $_SESSION['group_color'] = $resultat[0]['group_color'];
					  
                      $rqtCurrency = "SELECT currency FROM reg_users_credit WHERE target_id = :id";
                      $stmt = $pdoPanel->prepare($rqtCurrency);
                      // var_dump($result[0]);
                      $stmt->bindParam(":id", $_SESSION["id"]);
                      $stmt->execute();
                      $resultat = $stmt->fetchAll(PDO::FETCH_ASSOC);
                      $_SESSION['currency'] = $resultat[0]['currency'];
                      // var_dump($resultat);
                      header('Location: home/dashboard.php');
                  }else{
                      header('Location: login.php?msg=error');

                  }
              }else{
                  header('Location: login.php?msg=disabled');
              }
              
         

       }
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>ACTIVE-X | Log in</title>
  
	<!--<link rel="shortcut icon" href="/images/favicon/favicon.ico" />
	<link rel="icon" type="image/vnd.microsoft.icon" href="/images/favicon/favicon.ico">
	<link rel="icon" type="image/x-icon" href="/images/favicon/favicon.ico">-->
	
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- icheck bootstrap -->
  <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>
<body class="hold-transition login-page">
<div class="login-box">
  <div class="login-logo">
    <a href="/"><img src="images/logoveep.png" alt="logo" width="100%"></a>
  </div>
  <!-- /.login-logo -->
  <div class="card">
    <div class="card-body login-card-body">
      <p class="login-box-msg">ACTIVE-X+ Team Panel Dashboard</p>
		<?php
        if (isset($_GET['msg']))
        {		
            $trouble = $_GET['msg'];

            if ($trouble == "error")
            {
                echo '<div class="alert alert-danger" role="alert" style="width: 100%;max-width: 420px;padding: 15px;margin: 0 auto;">';
                echo 'Incorrect Username or Password';
                echo '</div><br>';
            }
            if ($trouble == "disabled")
            {
                echo '<div class="alert alert-danger" role="alert" style="width: 100%;max-width: 420px;padding: 15px;margin: 0 auto;">';
                echo 'Your account is disabled';
                echo '</div><br>';
            }if ($trouble == "captchaError")
            {
                echo '<div class="alert alert-danger" role="alert" style="width: 100%;max-width: 420px;padding: 15px;margin: 0 auto;">';
                echo 'Try again please';
                echo '</div><br>';
            }
        }?>
      <form action="login.php" method="post" id="formLogin">
	  <input type="hidden" class="form-control form-control-lg"  name="recaptchaResponse" id="recaptchaResponse">

        <div class="input-group mb-3">
          <input type="text" class="form-control" name="username" placeholder="Login">
          <div class="input-group-append">
            <div class="input-group-text">
              <span class="fas fa-envelope"></span>
            </div>
          </div>
        </div>
        <div class="input-group mb-3">
          <input type="password" class="form-control" name="password" placeholder="Password">
          <div class="input-group-append">
            <div class="input-group-text">
              <span class="fas fa-lock"></span>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-8">
            <div class="icheck-primary">
              <input type="checkbox" id="remember">
              <label for="remember">
                Remember Me
              </label>
            </div>
          </div>
          <!-- /.col -->
          <div class="col-4">
            <button  class="g-recaptcha btn btn-primary btn-block" data-sitekey="6LfrU9QaAAAAAKDGwenvzyvVTPj3nbl1ZLHu9i-0" 
                  data-callback='onSubmit' 
                  data-action='submit'  name="login" id="login" disabled>Sign In</button>
          </div>
          <!-- /.col -->
        </div>
      </form>
    </div>
    <!-- /.login-card-body -->
  </div>
</div>
<!-- /.login-box -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
  <script src="https://www.google.com/recaptcha/api.js" defer></script>

  <script>
    function onSubmit(token) {
     document.getElementById("formLogin").submit();
   }
   function enable(){
       document.getElementById('login').disabled = false;
   }
</script>
</body>
</html>

