<?php 
//require("../layout/header.php");

require('../includes/inc_db.php');
include "../functions/functions_xerox.php";


$rCategories = getCategories("series");
$rSeries = getSeries();

if (isset($_POST["submit_stream"])) {
    $rArray = Array();
    if (isset($_POST["c_movie_symlink"])) {
        if (isset($_POST["movie_symlink"])) {
            $rArray["movie_symlink"] = 1;
        } else {
            $rArray["movie_symlink"] = 0;
        }
    }
    if (isset($_POST["c_direct_source"])) {
        if (isset($_POST["direct_source"])) {
            $rArray["direct_source"] = 1;
        } else {
            $rArray["direct_source"] = 0;
        }
    }
    if (isset($_POST["c_read_native"])) {
        if (isset($_POST["read_native"])) {
            $rArray["read_native"] = 1;
        } else {
            $rArray["read_native"] = 0;
        }
    }
    if (isset($_POST["c_remove_subtitles"])) {
        if (isset($_POST["remove_subtitles"])) {
            $rArray["remove_subtitles"] = 1;
        } else {
            $rArray["remove_subtitles"] = 0;
        }
    }
    if (isset($_POST["c_custom_sid"])) {
        $rArray["custom_sid"] = $_POST["custom_sid"];
    }
    if (isset($_POST["c_target_container"])) {
        $rArray["target_container"] = json_encode(Array($_POST["target_container"]));
    }
    if (isset($_POST["c_transcode_profile_id"])) {
        $rArray["transcode_profile_id"] = $_POST["transcode_profile_id"];
        if ($rArray["transcode_profile_id"] > 0) {
            $rArray["enable_transcode"] = 1;
        } else {
            $rArray["enable_transcode"] = 0;
        }
    }
    $rStreamIDs = json_decode($_POST["streams"], True);
    if (count($rStreamIDs) > 0) {
        foreach ($rStreamIDs as $rStreamID) {
            $rQueries = Array();
            foreach ($rArray as $rKey => $rValue) {
                $rQueries[] = "`".ESC($rKey)."` = '".ESC($rValue)."'";
            }
            if (count($rQueries) > 0) {
                $rQueryString = join(",", $rQueries);
                $rQuery = "UPDATE `streams` SET ".$rQueryString." WHERE `id` = ".intval($rStreamID).";";
                if (!$db->query($rQuery)) {
                    $_STATUS = 1;
                }
            }
			if (isset($_POST["c_serie_name"])) {
                $db->query("UPDATE `series_episodes` SET `series_id` = '".intval($_POST["serie_name"])."' WHERE `stream_id` = ".intval($rStreamID).";");
                $db->query("UPDATE `streams` SET `series_no` = '".intval($_POST["serie_name"])."' WHERE `stream_id` = ".intval($rStreamID).";");
			}
            if (isset($_POST["c_server_tree"])) {
                $rStreamExists = Array();
                $result = $db->query("SELECT `server_stream_id`, `server_id` FROM `streams_sys` WHERE `stream_id` = ".intval($rStreamID).";");
                if (($result) && ($result->num_rows > 0)) {
                    while ($row = $result->fetch_assoc()) {
                        $rStreamExists[intval($row["server_id"])] = intval($row["server_stream_id"]);
                    }
                }
                 if (isset($_POST["server_tree_data_node"])) {
					//echo($_POST["server_tree_data_node"]);
                    $rStreamsAdded = Array();
                    $rServerTree = json_decode($_POST["server_tree_data_node"], True);
                    foreach ($rServerTree as $rServer) {
						if($rServer["hierarchy"] == "orgName"){
							
						}else{
                            $rServerID = intval($rServer["key"]);
                            $rStreamsAdded[] = $rServerID;
                            if ($rServer["hierarchy"] == "") {
                                $rParent = "NULL";
                            } else {
								$arr = explode(".",$rServer["hierarchy"]);
								
								$ssArray = str_replace('server_','', $arr[count($arr)-2]);
                                $rParent = intval($ssArray);
                            }
							
                            if (in_array($rServerID, $rOnDemandArray)) {
                                $rOD = 1;
                            } else {
                                $rOD = 0;
                            }
                            
                            if (isset($rStreamExists[$rServerID])) {
                                $db->query("UPDATE `streams_sys` SET `parent_id` = ".$rParent.", `on_demand` = ".$rOD." WHERE `server_stream_id` = ".$rStreamExists[$rServerID].";");
                            } else {
                                $db->query("INSERT INTO `streams_sys`(`stream_id`, `server_id`, `parent_id`, `on_demand`) VALUES(".intval($rInsertID).", ".$rServerID.", ".$rParent.", ".$rOD.");");
                            }
                        }
                    }
					
                    foreach ($rStreamExists as $rServerID => $rDBID) {
                        if (!in_array($rServerID, $rStreamsAdded)) {
                            $db->query("DELETE FROM `streams_sys` WHERE `server_stream_id` = ".$rDBID.";");
                        }
                    }
                }
            }
        }
        if (isset($_POST["reencode_on_edit"])) {
            APIRequest(Array("action" => "vod", "sub" => "start", "stream_ids" => array_values($rStreamIDs)));
        }
        if (isset($_POST["reprocess_tmdb"])) {
            foreach ($rStreamIDs as $rStreamID) {
                if (intval($rStreamID) > 0) {
                    $db->query("INSERT INTO `tmdb_async`(`type`, `stream_id`, `status`) VALUES(3, ".intval($rStreamID).", 0);");
                }
            }
        }
    }
    $_STATUS = 0;
}


$rTranscodeProfiles = getTranscodeProfiles();
$rServerTree = Array();
$rServerTree[] = Array("id" => "source", "parent" => "#", "text" => "<strong>".$_["stream_source"]."</strong>", "icon" => "fa fa-youtube-tv", "state" => Array("opened" => true));
foreach ($rServers as $rServer) {
    $rServerTree[] = Array("id" => $rServer["id"], "parent" => "#", "text" => $rServer["server_name"], "icon" => "fa fa-server-network", "state" => Array("opened" => true));
}



$serieOpen = "menu-open";
$serieActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />

		<link rel="stylesheet" href="../plugins/jOrgChart/css/jquery.jOrgChart.css"/>
		
		<link href="../plugins/jOrgChart/css/custom.css" type="text/css" rel="stylesheet" />
		<link href="../plugins/jOrgChart/css/prettify.css" type="text/css" rel="stylesheet" />
		
    <script type="text/javascript" src="../plugins/jOrgChart/prettify.js"></script>
		<style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}
	.select2-container--bootstrap4 .select2-selection--multiple .select2-selection__choice{
		background: #e3dcdc;
	}
	
	.jOrgChart table{
		width: 100%;
	}
  
  </style>
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1><?=$_["mass_edit_episodes"]?>  </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;"> 
                 <li>
                                        <a href="./episodes.php"><i class="fa fa-backspace"></i> <?=$_["view_episodes"]?></a>
				</li>
             </ol>
         
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?=$_["mass_edit_episodes"]?> <small id="selected_count"></small></h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                
				<div class="row">
                    <div class="col-xl-12">
                        <?php if ((isset($_STATUS)) && ($_STATUS == 0)) { if (!$rSettings["sucessedit"]) { ?>
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
							<?=$_["mass_edit_episodes_success"]?>
                        </div>
						<?php } else { ?>
                    <script type="text/javascript">
  					swal("", '<?=$_["mass_edit_episodes_success"]?>', "success");
  					</script> 
                        <?php } } else if ((isset($_STATUS)) && ($_STATUS > 0)) { if (!$rSettings["sucessedit"]) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
							<?=$_["generic_fail"]?>
                        </div>
                        <?php } else { ?>
                    <script type="text/javascript">
  					swal("", '<?=$_["generic_fail"]?>', "warning");
  					</script> 
                        <?php } } ?>
                        <div class="card">
                            <div class="card-body">
                                <form action="./episodes_mass.php" method="POST" id="stream_form">
                                    <input type="hidden" name="server_tree_data" id="server_tree_data" value="" />
                                    <input type="hidden" name="streams" id="streams" value="" />
									
																						
					<div class="row">
						
						<div class="col-md-12">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title"><?=$_["episodes"]?></h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										   
										   <div class="row">
                                                    <div class="col-md-3 col-6">
                                                        <input type="text" class="form-control" id="stream_search" value="" placeholder="<?=$_["search_episodes"]?>...">
                                                    </div>
                                                    <div class="col-md-3 col-6">
                                                        <select id="series_id" class="form-control" data-toggle="select2">
                                                            <option value=""><?=$_["all_series"]?></option>
															<?php foreach ($rSeries as $rSerie) { ?>
															<option value="<?=$rSerie["id"]?>"><?=$rSerie["title"]?></option>
															<?php } ?>
                                                        </select>
                                                    </div>
                                                    <div class="col-md-3 col-6">
                                                        <select id="filter" class="form-control" data-toggle="select2">
                                                            <option value="" selected><?=$_["no_filter"]?></option>
                                                            <option value="1"><?=$_["encoded"]?></option>
                                                            <option value="2"><?=$_["encoding"]?></option>
                                                            <option value="3"><?=$_["down"]?></option>
                                                            <option value="4"><?=$_["ready"]?></option>
                                                            <option value="5"><?=$_["direct"]?></option>
                                                        </select>
                                                    </div>
                                                    <div class="col-md-2 col-8">
                                                        <select id="show_entries" class="form-control" data-toggle="select2">
                                                            <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                            <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo " selected"; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                            <?php } ?>
                                                        </select>
                                                    </div>
                                                    <div class="col-md-1 col-2">
                                                        <button type="button" class="btn btn-info waves-effect waves-light" onClick="toggleStreams()">
                                                            <i class="fa fa-check-square"></i>
                                                        </button>
                                                    </div>
													<div class="col-md-12">
                                                    <table id="datatable-mass" class="table table-hover table-borderless mb-0">
                                                        <thead class="bg-light">
                                                            <tr>
                                                                <th class="text-center"><?=$_["id"]?></th>
                                                                <th><?=$_["episode_name"]?></th>
                                                                <th><?=$_["series"]?></th>
                                                                <th class="text-center"><?=$_["status"]?></th>
                                                            </tr>
                                                        </thead>
                                                        <tbody></tbody>
                                                    </table>
													</div>
                                                </div>
												
												
												
														
												
                                              
										 

											  
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						<div class="col-md-12">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title"><?=$_["details"]?></h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										<div class="row">
                                                    <div class="col-12">
                                                        <p class="sub-header">
															<?=$_["mass_edit_info"]?>
                                                        </p>
                                                        
														<div class="form-group row mb-4">
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="serie_name" name="c_serie_name">
                                                                <label></label>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="serie_name"><?=$_["series_name"]?></label>
                                                            <div class="col-md-8">
                                                                <select disabled name="serie_name" id="serie_name" class="form-control" data-toggle="select2">
                                                                    <?php foreach ($rSeries as $rCategory) { ?>
                                                                    <option value="<?=$rCategory["id"]?>"><?=$rCategory["title"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        
                                                        <div class="form-group row mb-4">
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="direct_source" data-type="switch" name="c_direct_source">
                                                                <label></label>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="direct_source"><?=$_["direct_source"]?></label>
                                                            <div class="col-md-2">
                                                                <input name="direct_source" id="direct_source" type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="read_native"><?=$_["native_frames"]?></label>
                                                            <div class="col-md-2">
                                                                <input name="read_native" id="read_native" type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="read_native" data-type="switch" name="c_read_native">
                                                                <label></label>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="movie_symlink" data-type="switch" checked name="c_movie_symlink">
                                                                <label></label>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="movie_symlink"><?=$_["create_symlink"]?></label>
                                                            <div class="col-md-2">
                                                                <input name="movie_symlink" id="movie_symlink" checked type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="custom_sid"><?=$_["custom_channel_sid"]?></label>
                                                            <div class="col-md-2">
                                                                <input type="text" disabled class="form-control" id="custom_sid" name="custom_sid" value="">
                                                            </div>
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="custom_sid" name="c_custom_sid">
                                                                <label></label>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="target_container" name="c_target_container">
                                                                <label></label>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="target_container"><?=$_["target_container"]?></label>
                                                            <div class="col-md-2">
                                                                <select disabled name="target_container" id="target_container" class="form-control" data-toggle="select2">
                                                                    <?php foreach (Array("mp4", "mkv", "avi", "mpg") as $rContainer) { ?>
                                                                    <option value="<?=$rContainer?>"><?=$rContainer?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="remove_subtitles"><?=$_["remove_subtitles"]?></label>
                                                            <div class="col-md-2">
                                                                <input name="remove_subtitles" id="remove_subtitles" type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="remove_subtitles" data-type="switch" name="c_remove_subtitles">
                                                                <label></label>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="transcode_profile_id" name="c_transcode_profile_id">
                                                                <label></label>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="transcode_profile_id"><?=$_["transcoding_profile"]?></label>
                                                            <div class="col-md-8">
                                                                <select name="transcode_profile_id" disabled id="transcode_profile_id" class="form-control" data-toggle="select2">
                                                                    <option selected value="0"><?=$_["transcoding_disabled"]?></option>
                                                                    <?php foreach ($rTranscodeProfiles as $rProfile) { ?>
                                                                    <option value="<?=$rProfile["profile_id"]?>"><?=$rProfile["profile_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
														 <div class="row">
															<div class="col-12">																															
																<ul id="org" style="display:none">											
																	<li>Source
																		<ul id="add"></ul>
																	</li>
																</ul>
																<div id="chart" class="orgChart"></div>
																
																<div class="text-center jOrgChart chart_list mt-3">
																	<?php foreach($rServers as $rServerItem) { ?>
																		<div id="<?=$rServerItem["id"]?>" class="add_node node">
																			<div><span class="fa fa-server"></span></div>
																			<div><?=$rServerItem["server_name"]?></div>
																		</div>													
																	<?php } ?>                                               						
																	
																</div>
																
																<div class="form-group row mb-4">
																	<div class="col-md-1"></div>
																	<label class="col-md-3 col-form-label" for="reencode_on_edit"><?=$_["reencode_on_edit"]?></label>
																	<div class="col-md-2">
																		<input name="reencode_on_edit" id="reencode_on_edit" type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd" />
																	</div>
																	<div class="col-md-1"></div>
																	<label class="col-md-3 col-form-label" for="reprocess_tmdb"><?=$_["reprocess_tmdb_data"]?></label>
																	<div class="col-md-2">
																		<input name="reprocess_tmdb" id="reprocess_tmdb" type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd" />
																	</div>
																</div>
															</div> <!-- end col -->
														</div> <!-- end row -->
                                                
											 
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						<div class="col-sm-12 text-right">
							<input name="submit_stream" type="submit" class="btn btn-primary" value="<?=$_["edit_episodes"]?>" />
						</div>
						
					</div>
									
									
									
									
                                </form>

                            </div> <!-- end card-body -->
                        </div> <!-- end card-->
                    </div> <!-- end col -->
                </div>
           
				
				
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>

        <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
  
   
         <script>
        var rSwitches = [];
        var rSelected = [];
        
        function getSeries() {
            return $("#series_id").val();
        }
        function getFilter() {
            return $("#filter").val();
        }
        function toggleStreams() {
            $("#datatable-mass tr").each(function() {
                if ($(this).hasClass('selected')) {
                    $(this).removeClass('selectedfilter').removeClass('ui-selected').removeClass("selected");
                    if ($(this).find("td:eq(0)").html()) {
                        window.rSelected.splice($.inArray($(this).find("td:eq(0)").html(), window.rSelected), 1);
                    }
                } else {            
                    $(this).addClass('selectedfilter').addClass('ui-selected').addClass("selected");
                    if ($(this).find("td:eq(0)").html()) {
                        window.rSelected.push($(this).find("td:eq(0)").html());
                    }
                }
            });
            $("#selected_count").html(" - " + window.rSelected.length + " selected")
        }
        (function($) {
          $.fn.inputFilter = function(inputFilter) {
            return this.on("input keydown keyup mousedown mouseup select contextmenu drop", function() {
              if (inputFilter(this.value)) {
                this.oldValue = this.value;
                this.oldSelectionStart = this.selectionStart;
                this.oldSelectionEnd = this.selectionEnd;
              } else if (this.hasOwnProperty("oldValue")) {
                this.value = this.oldValue;
                this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
              }
            });
          };
        }(jQuery));
        $(document).ready(function() {
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            var elems = Array.prototype.slice.call(document.querySelectorAll('.js-switch'));
            elems.forEach(function(html) {
                var switchery = new Switchery(html);
                window.rSwitches[$(html).attr("id")] = switchery;
                if (($(html).attr("id") != "reencode_on_edit") && ($(html).attr("id") != "reprocess_tmdb")) {
                    window.rSwitches[$(html).attr("id")].disable();
                }
            });
            $('#server_tree').jstree({ 'core' : {
                'check_callback': function (op, node, parent, position, more) {
                    switch (op) {
                        case 'move_node':
                            if (node.id == "source") { return false; }
                            return true;
                    }
                },
                'data' : <?=json_encode($rServerTree)?>
            }, "plugins" : [ "dnd" ]
            });
            $("#stream_form").submit(function(e){
                
                var sourceTree = makeArrays();
				console.log();
				$("#server_tree_data_node").val(JSON.stringify(sourceTree));
                rPass = false;
                $.each(sourceTree, function(k,v) {
                    if (v.hierarchy == "orgName") {
                        rPass = true;
                    }
                });
                if (rPass == false) {
                    e.preventDefault();
                    toastr.info("Select at least one server.");
                }
                $("#streams").val(JSON.stringify(window.rSelected));
                if (window.rSelected.length == 0) {
                    e.preventDefault();
                    toastr.info("<?=$_["select_at_least_one_episode"]?>");
                }
            });
            $("input[type=checkbox].activate").change(function() {
                if ($(this).is(":checked")) {
                    if ($(this).data("type") == "switch") {
                        window.rSwitches[$(this).data("name")].enable();
                    } else {
                        $("#" + $(this).data("name")).prop("disabled", false);
                        if ($(this).data("name") == "days_to_restart") {
                            $("#time_to_restart").prop("disabled", false);
                        }
                    }
                } else {
                    if ($(this).data("type") == "switch") {
                        window.rSwitches[$(this).data("name")].disable();
                    } else {
                        $("#" + $(this).data("name")).prop("disabled", true);
                        if ($(this).data("name") == "days_to_restart") {
                            $("#time_to_restart").prop("disabled", true);
                        }
                    }
                }
            });
            $(".clockpicker").clockpicker();
            $(document).keypress(function(event){
                if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
            });
            $("#probesize_ondemand").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("#delay_minutes").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("#tv_archive_duration").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("form").attr('autocomplete', 'off');
            rTable = $("#datatable-mass").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                },
                processing: true,
                serverSide: true,
                ajax: {
                    url: "../functions/table_search.php",
                    "data": function(d) {
                        d.id = "episode_list",
                        d.series = getSeries(),
                        d.filter = getFilter()
                    }
                },
                columnDefs: [
                    {"className": "dt-center", "targets": [0,3]}
                ],
                "rowCallback": function(row, data) {
                    if ($.inArray(data[0], window.rSelected) !== -1) {
                        $(row).addClass('selectedfilter').addClass('ui-selected').addClass("selected");
                    }
                },
                pageLength: <?=$rAdminSettings["default_entries"] ?: 10?>
            });
            $('#stream_search').keyup(function(){
                rTable.search($(this).val()).draw();
            })
            $('#show_entries').change(function(){
                rTable.page.len($(this).val()).draw();
            })
            $('#series_id').change(function(){
                rTable.ajax.reload(null, false);
            })
            $('#filter').change(function(){
                rTable.ajax.reload( null, false );
            })
            $("#datatable-mass").selectable({
                filter: 'tr',
                selected: function (event, ui) {
                    if ($(ui.selected).hasClass('selectedfilter')) {
                        $(ui.selected).removeClass('selectedfilter').removeClass('ui-selected').removeClass("selected");
                        window.rSelected.splice($.inArray($(ui.selected).find("td:eq(0)").html(), window.rSelected), 1);
                    } else {            
                        $(ui.selected).addClass('selectedfilter').addClass('ui-selected').addClass("selected");
                        window.rSelected.push($(ui.selected).find("td:eq(0)").html());
                    }
                    $("#selected_count").html(" - " + window.rSelected.length + " selected")
                }
            });
        });
        </script>
  
     
    <!-- jQuery includes-->
    <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script> 
	<script type="text/javascript">
	$.noConflict();
	</script>
    <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/jquery-ui.min.js"></script>
        <script src="../plugins/jOrgChart/jquery.jOrgChart.js"></script>
    <script>
    jQuery(document).ready(function() {
        jQuery("#org").jOrgChart({
            chartElement : '#chart',
            dragAndDrop  : true
        });
    });
    </script>
	
	<script>
	
	function makeArrays()
		{
			var hierarchy = [];

			$("#org li").each(function(){
				var uid = $(this).attr("name");
				var name = $(this).clone().children().remove().end().text();
				var hidSTR = "";
				var hid = $(this).parents("li");
				if(hid.length == 0) //If this object is the root user, substitute id with "orgName" so the DB knows it's the name of organization and not a user
				{
					hidSTR = "orgName";
					var user = new Object();
					user.key = uid;
					user.hierarchy = hidSTR;
					hierarchy.push(user);
				}else{
					for(var i=hid.length-1; i>=0; i--)
					{
						console.log(hid[i]);
						if(i != hid.length-1)
						{
							hidSTR = hidSTR+hid[i].id+".";
						}else{
							hidSTR = hidSTR+""+hid[i].id;
						}
					}
				var user = new Object();
					user.key = uid;
					user.hierarchy = hidSTR;
					hierarchy.push(user);
				}
			});
			console.log(hierarchy);
			//saveArray(hierarchy);
			return hierarchy;

		}
			
				
			jQuery(document).ready(function() {
				$('.nodes').each(function () {
					id = this.id;
					if (id != 0) {
						$(this).find(".delete").addClass(this.id);
					}
				});
				$("body").on('click', '.delete', function () {
					var id = $(this).data('value');
					$('.chart_list').find('#'+id).show();
					$("#add").find('#server_' + id).remove();
					$("#chart").empty();
					jQuery("#org").jOrgChart({
						chartElement: '#chart',
						dragAndDrop: true
					});
				});
				
				$(".add_node").click(function () {
					var name = $(this).html();
					var id = $(this).attr("id");

					$("#add").append('<li class="nodes" id="server_' + id + '" name="' + id + '">' + name + '<p style="cursor: pointer;font-size: 15px; color:red;" class="delete pull-right" data-value="' + id + '" >X</p></li>');

					$("#chart").empty();
					jQuery("#org").jOrgChart({
						chartElement: '#chart',
						dragAndDrop: true
					});
					$(this).hide();
					
					console.log(makeArrays());
				});
				
				/* Custom jQuery for the example */
				$("#show-list").click(function(e){
					e.preventDefault();
					
					$('#list-html').toggle('fast', function(){
						if($(this).is(':visible')){
							$('#show-list').text('Hide underlying list.');
							$(".topbar").fadeTo('fast',0.9);
						}else{
							$('#show-list').text('Show underlying list.');
							$(".topbar").fadeTo('fast',1);                  
						}
					});
				});
				
				$('#list-html').text($('#org').html());
				
				$("#org").bind("DOMSubtreeModified", function() {
					$('#list-html').text('');
					
					$('#list-html').text($('#org').html());
					
					prettyPrint();                
				});
				
				
				
				
			});
		</script>
		
				
  
