<?php 
//require("../layout/header.php");
header('Content-type: text/html; charset=utf-8');

require('../includes/inc_db.php');
include "../functions/functions_xerox.php";
if (isset($_GET["category"])) {
    if (!isset($rCategories[$_GET["category"]])) {
        exit;
    } else {
        $rCategory = $rCategories[$_GET["category"]];
    }
} else {
    $rCategory = null;
}

$rCategories = getCategories("movie");
$vodOpen = "menu-open";
$vodActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  
  <style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}
	
	.dt-button-collection{
		top: 0 !important;
		left: 100% !important;
	}
	
	.dt-button.dropdown-item:hover{
		background-color: #bce9e8 !important;
	}
  </style>
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Movies </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;"> 
                 <li>
                     <?php if (!$detect->isMobile()) { ?>
                     <a href="#" onClick="toggleAuto();" style="margin-right:10px;">
                         <button type="button" class="btn btn-dark waves-effect waves-light btn-sm">
                             <i class="fa fa-sync-alt"></i> <span class="auto-text">Auto-Refresh</span>
                         </button>
                     </a>
                     <?php } else { ?>
                     <a href="javascript:location.reload();" onClick="toggleAuto();" style="margin-right:10px;">
                         <button type="button" class="btn btn-dark waves-effect waves-light btn-sm">
                             <i class="fa fa-sync-alt"></i> Refresh
                         </button>
                     </a>
                     <?php } ?>
                 </li>
                 <li>
                     <a style="margin-right:10px;" href="movie_category.php">
                         <button type="button" class="btn btn-outline-success waves-effect waves-light btn-sm">
                             <i class="fa fa-plus"></i> Create categorie
                         </button>
                     </a>
                 </li>
                 <li>
                     <a style="margin-right:10px;" href="movie.php<?php if($rCategory) { echo "?category=".$rCategory["id"]; }?>">
                         <button type="button" class="btn btn-primary waves-effect waves-light btn-sm">
                             <i class="fa fa-plus"></i> Create Movie
                         </button>
                     </a>
                 </li>
                 <li>
                     <a style="margin-right:10px;" href="movie.php?import">
                         <button type="button" class="btn btn-info waves-effect waves-light btn-sm">
                             <i class="fa fa-plus"></i> Create Movie Mass
                         </button>
                     </a>
                 </li>	
                 <li>
                     <a style="margin-right:10px;" href="movie_mass.php<?php if($rCategory) { echo "?category=".$rCategory["id"]; }?>">
                         <button type="button" class="btn btn-secondary waves-effect waves-light btn-sm">
                             <i class="fa fa-edit"></i> Edit Movie Mass
                         </button>
                     </a>
                 </li>				
				
             </ol>
         
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9">List of Movies</h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <form id="movies_form">
                                    <div class="form-group row mb-4">
                                        <?php if ($rPermissions["is_reseller"]) { ?>
                                        <div class="col-md-3">
                                            <input type="text" class="form-control" id="movies_search" value="" placeholder="<?=$_["search_movies"]?>...">
                                        </div>
                                        <div class="col-md-3">
                                            <select id="movies_category_id" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_categories"]?></option>
                                                <?php foreach ($rCategories as $rCategory) { ?>
                                                <option value="<?=$rCategory["id"]?>"><?=$rCategory["category_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-3">
                                            <select id="movies_server" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_servers"]?></option>
                                                <?php foreach (getStreamingServers() as $rServer) { ?>
                                                <option value="<?=$rServer["id"]?>"<?php if ((isset($_GET["server"])) && ($_GET["server"] == $rServer["id"])) { echo " selected"; } ?>><?=$rServer["server_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <label class="col-md-1 col-form-label text-center" for="movies_show_entries"><?=$_["show"]?></label>
                                        <div class="col-md-2">
                                            <select id="movies_show_entries" class="form-control" data-toggle="select2">
                                                <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo " selected"; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <?php } else { ?>
                                        <div class="col-md-2">
                                            <input type="text" class="form-control" id="movies_search" value="" placeholder="<?=$_["search_movies"]?>...">
                                        </div>
                                        <div class="col-md-3">
                                            <select id="movies_server" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_servers"]?></option>
                                                <?php foreach (getStreamingServers() as $rServer) { ?>
                                                <option value="<?=$rServer["id"]?>"<?php if ((isset($_GET["server"])) && ($_GET["server"] == $rServer["id"])) { echo " selected"; } ?>><?=$rServer["server_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-3">
                                            <select id="movies_category_id" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_categories"]?></option>
                                                <?php foreach ($rCategories as $rCategory) { ?>
                                                <option value="<?=$rCategory["id"]?>"><?=$rCategory["category_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-2">
                                            <select id="movies_filter" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["no_filter"]?></option>
                                                <option value="1"><?=$_["encoded"]?></option>
                                                <option value="2"><?=$_["encoding"]?></option>
                                                <option value="3"><?=$_["down"]?></option>
                                                <option value="4"><?=$_["ready"]?></option>
                                                <option value="5"><?=$_["direct"]?></option>
                                                <option value="6">No Cover/Properties</option>
                                            </select>
                                        </div>
                                        <label class="col-md-1 col-form-label text-center" for="movies_show_entries"><?=$_["show"]?></label>
                                        <div class="col-md-1">
                                            <select id="movies_show_entries" class="form-control" data-toggle="select2">
                                                <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo " selected"; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <?php } ?>
                                    </div>
                                </form>
                                <table id="datatable-streampage"  class="table stripe tableM3U" width="100%">
                                    <thead>
                                        <tr>
                                            <th class="text-center"><?=$_["id"]?></th>
                                            <th>Cover</th>
                                            <th><?=$_["name"]?></th>
                                            <th><?=$_["server"]?></th>
                                            <?php if ($rPermissions["is_admin"]) { ?>
                                            <th class="text-center"><?=$_["status"]?></th>
                                            <?php } ?>
                                            <th>Category</th>
                                            <?php if ($rPermissions["is_admin"]) { ?>
                                            <th class="text-center"><?=$_["clients"]?></th>
                                            <?php } ?>
                                            <th class="text-center">Added</th>
                                            <th class="text-center"><?=$_["stream_info"]?></th>
                                            <?php if ($rPermissions["is_admin"]) { ?>
                                            <th class="text-center"><?=$_["actions"]?></th>
                                            <?php } ?>
                                        </tr>
                                    </thead>
                                    <tbody></tbody>
                                </table>
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
     <script>
        var autoRefresh = true;
        var rClearing = false;
        
        function toggleAuto() {
            if (autoRefresh == true) {
                autoRefresh = false;
                $(".auto-text").html("<?=$_["manual_mode"]?>");
            } else {
                autoRefresh = true;
                $(".auto-text").html("<?=$_["auto_refresh"]?>");
            }
        }
        
        function api(rID, rServerID, rType) {
            if (rType == "delete") {
                if (confirm('<?=$_["movie_delete_confirm"]?>') == false) {
                    return;
                }
            }
            $.getJSON("../functions/api_xerox.php?action=movie&sub=" + rType + "&stream_id=" + rID + "&server_id=" + rServerID, function(data) {
                if (data.result == true) {
                    if (rType == "start") {
                        toastr.success("<?=$_["movie_encode_started"]?>");
                    } else if (rType == "stop") {
                        toastr.success("<?=$_["movie_encode_stopped"]?>");
                    } else if (rType == "delete") {
                        toastr.success("<?=$_["movie_delete_confirmed"]?>");
                    }
                    $.each($('.tooltip'), function (index, element) {
                        $(this).remove();
                    });
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                } else {
                    toastr.warning("<?=$_["error_occured"]?>");
                }
            }).fail(function() {
                toastr.warning("<?=$_["error_occured"]?>");
            });
        }
		
        		
        function player(rID, rContainer) {
            $.magnificPopup.open({
                items: {
                    src: "./player.php?type=movie&id=" + rID + "&container=" + rContainer,
                    type: 'iframe'
                }
            });
        }
        function reloadStreams() {
            if (autoRefresh == true) {
                $('[data-toggle="tooltip"]').tooltip("hide");
                $("#datatable-streampage").DataTable().ajax.reload( null, false );
            }
            setTimeout(reloadStreams, 15000);
        }

        function getCategory() {
            return $("#movies_category_id").val();
        }
        function getFilter() {
            return $("#movies_filter").val();
        }
        function getServer() {
            return $("#movies_server").val();
        }
        function changeZoom() {
            if ($("#datatable-streampage").hasClass("font-large")) {
                $("#datatable-streampage").removeClass("font-large");
                $("#datatable-streampage").addClass("font-normal");
            } else if ($("#datatable-streampage").hasClass("font-normal")) {
                $("#datatable-streampage").removeClass("font-normal");
                $("#datatable-streampage").addClass("font-small");
            } else {
                $("#datatable-streampage").removeClass("font-small");
                $("#datatable-streampage").addClass("font-large");
            }
            $("#datatable-streampage").DataTable().draw();
        }
        function clearFilters() {
            window.rClearing = true;
            $("#movies_search").val("").trigger('change');
            $('#movies_filter').val("").trigger('change');
            $('#movies_server').val("").trigger('change');
            $('#movies_category_id').val("").trigger('change');
            $('#movies_show_entries').val("<?=$rAdminSettings["default_entries"] ?: 10?>").trigger('change');
            window.rClearing = false;
            $('#datatable-streampage').DataTable().search($("#movies_search").val());
            $('#datatable-streampage').DataTable().page.len($('#movies_show_entries').val());
            $("#datatable-streampage").DataTable().page(0).draw('page');
            $('[data-toggle="tooltip"]').tooltip("hide");
            $("#datatable-streampage").DataTable().ajax.reload( null, false );
        }
        $(document).ready(function() {
			$(window).keypress(function(event){
				if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
			});
			
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            $("#datatable-streampage").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                    $('[data-toggle="tooltip"]').tooltip();
                },
                createdRow: function(row, data, index) {
                    $(row).addClass('stream-' + data[0]);
                },
				dom: 'Bfrtip',
                responsive: false,
                processing: true,
                serverSide: true,
				buttons: {
					buttons: [
						{
							text: 'Check All',
							action: function ( e, dt, node, config ) {
								$('.movie_checkbox').prop('checked', true);
								this.innerHTML  == 'UncheckAll'; // disable button
							}
						},
						{
							text: 'Uncheck All',
							action: function ( e, dt, node, config ) {
								$('.movie_checkbox').prop('checked', false);
								this.innerHTML  == 'UncheckAll'; // disable button
							}
						},
						{
							extend: 'collection',
							text: 'Export',
							buttons: [
								'copy',
								'excel',
								'csv',
								'pdf',
								'print'
							]
						},
						{
							extend: 'collection',
							text: 'Mass action',
							buttons: [
								{
									text: 'Encode',
									action: function ( e, dt, node, config ) {
										if($('.movie_checkbox:checkbox:checked').length >0){
											console.log($('.movie_checkbox:checkbox:checked'))
											var checkedVals = $('.movie_checkbox:checkbox:checked').map(function() {
												console.log(this.value);
												console.log($(this).data('server'));
												console.log('------------');
												api(this.value, $(this).data('server'), 'start');
											}).get();
										}
									}
								},
								{
									text: 'Check',
									action: function ( e, dt, node, config ) {
																		
									}
								},
								{
									text: 'TMDB fetch',
									action: function ( e, dt, node, config ) {
										if($('.movie_checkbox:checkbox:checked').length >0){							
											var checkedVals = $('.movie_checkbox:checkbox:checked').map(function() {											 
													$.getJSON("../functions/api_xerox.php?action=fetch_tmdb&type=movie&stream_id=" + this.value + "&server_id=" + $(this).data('server'), function(data) {
														console.log(data);
														if (data.result == true) {
															toastr.success("tmdb properties fetched");
															$.each($('.tooltip'), function (index, element) {
																$(this).remove();
															});
															$('[data-toggle="tooltip"]').tooltip("hide");
															$("#datatable-streampage").DataTable().ajax.reload( null, false );
														} else {
															toastr.warning("<?=$_["error_occured"]?>");
														}
													}).fail(function() {
														toastr.warning("<?=$_["error_occured"]?>");
													});
											}).get();	
										}		
									}
								},
								{
									text: 'Delete',
									action: function ( e, dt, node, config ) {
										if($('.movie_checkbox:checkbox:checked').length >0){
											if (confirm('<?=$_["movie_delete_confirm"]?>') == false) {
													return;
											}
											var checkedVals = $('.movie_checkbox:checkbox:checked').map(function() {											 
													$.getJSON("../functions/api_xerox.php?action=movie&sub=delete&stream_id=" + this.value + "&server_id=" + $(this).data('server'), function(data) {
														if (data.result == true) {
															toastr.success("<?=$_["movie_delete_confirmed"]?>");
															$.each($('.tooltip'), function (index, element) {
																$(this).remove();
															});
															$('[data-toggle="tooltip"]').tooltip("hide");
															$("#datatable-streampage").DataTable().ajax.reload( null, false );
														} else {
															toastr.warning("<?=$_["error_occured"]?>");
														}
													}).fail(function() {
														toastr.warning("<?=$_["error_occured"]?>");
													});
											}).get();	
										}										
									}
								},
							]
						},
					]
				},
                ajax: {
                    url: "../functions/table_search.php",
                    "data": function(d) {
                        d.id = "movies";
                        d.category = getCategory();
                        d.server = getServer();
                        <?php if ($rPermissions["is_admin"]) { ?>
                        d.filter = getFilter();
                        <?php } else { ?>
                        d.filter = 1;
                        <?php } ?>
                    }
                },
				createdRow: function (row, data, dataIndex) {
					if (data[4] == '<button type="button" class="btn btn-block bg-gradient-primary btn-xs">Not Encoded</button>') {
						$(row).css({"background-color": "#fff"})
					}else 
					if (data[4] == '<button type="button" class="btn btn-block bg-gradient-success btn-xs">Encoded</button>') {
						$(row).css({"background-color": "#e4f9d1"})
					}else 
					if (data[4] == '<button type="button" class="btn btn-block bg-gradient-warning btn-xs">Encoding</button>') {
						$(row).css({"background-color": "#F9F09E"})
					}else 
					if (data[4] == '<button type="button" class="btn btn-block bg-gradient-danger btn-xs">Down</button>') {
						$(row).css({"background-color": "#FFBABA "})
					}else 
					if (data[4] == '<button type="button" class="btn btn-block bg-gradient-info btn-xs">Direct</button>') {
						$(row).css({"background-color": "#fff "})
					}
				},
                columnDefs: [
                    <?php if ($rPermissions["is_admin"]) { ?>
                    {"className": "dt-center", "targets": [0,3,4,5,6,7]},
                    {"orderable": false, "targets": [5,6]}
                    <?php } else { ?>
                    {"className": "dt-center", "targets": [0,3]}
                    <?php } ?>
                ],
                order: [[ 0, "desc" ]],
                pageLength: 50,
                stateSave: true
            });
            $("#datatable-streampage").css("width", "100%");
            $('#movies_search').keyup(function(){
                if (!window.rClearing) {
                    $('#datatable-streampage').DataTable().search($(this).val()).draw();
                }
            })
            $('#movies_show_entries').change(function(){
                if (!window.rClearing) {
                    $('#datatable-streampage').DataTable().page.len($(this).val()).draw();
                }
            })
            $('#movies_category_id').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            $('#movies_server').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            $('#movies_filter').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            <?php if (!$detect->isMobile()) { ?>
            setTimeout(reloadStreams, 15000);
            <?php }
            if (!$rAdminSettings["auto_refresh"]) { ?>
            toggleAuto();
            <?php } ?>
            if ($('#movies_search').val().length > 0) {
                $('#datatable-streampage').DataTable().search($('#movies_search').val()).draw();
            }
        });
        
        $(window).bind('beforeunload', function() {
            //formCache.save();
        });
        </script>
  
  
