<?php 
//require("../layout/header.php");
require('../includes/inc_db.php');
include "../functions/functions_xerox.php";


$rCategories = getCategories("series");

$serieOpen = "menu-open";
$serieActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
   
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
		
		<style>
			.dd-list .dd-item .dd-handle {
				background: #f1f5f7;
				border: none;
				padding: 8px 16px;
				height: auto;
				font-weight: 500;
				border-radius: 3px;
				font-size: x-large;
			}
			.dd-list .dd3-handle {
				margin: 0;
				height: 36px!important;
				float: left;
			}
			.dd-list .dd3-content {
				height: auto;
				border: none;
				padding: 8px 16px 8px 46px;
				background: #f1f5f7;
				font-weight: 600;
			}
			.dd-list .dd3-handle:before {
				content: "=";
				font-family: "Material Design Icons";
				color: #adb5bd;
			}


			
		</style>	
  
  <style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}
	
	.dt-button-collection{
		top: 0 !important;
		left: 100% !important;
	}
	
	.dt-button.dropdown-item:hover{
		background-color: #bce9e8 !important;
	}
  </style>
 
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Series </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;">
                   <li style="margin-right:10px;" >
                       <a href="#" onClick="clearFilters();">
                           <button type="button" class="btn btn-warning waves-effect waves-light btn-sm">
                               <i class="fa fa-filter"></i>
                           </button>
                       </a>
                       <a href="#" onClick="changeZoom();">
                           <button type="button" class="btn btn-info waves-effect waves-light btn-sm">
                               <i class="fa fa-search"></i>
                           </button>
                       </a>
                       <?php if (!$detect->isMobile()) { ?>
                       <a href="#" onClick="toggleAuto();">
                           <button type="button" class="btn btn-dark waves-effect waves-light btn-sm">
                               <i class="fa fa-redo"></i> <span class="auto-text"><?=$_["auto_refresh"]?></span>
                           </button>
                       </a>
                       <?php } else { ?>
                       <a href="javascript:location.reload();" onClick="toggleAuto();">
                           <button type="button" class="btn btn-dark waves-effect waves-light btn-sm">
                               <i class="fa fa-redo"></i> <?=$_["refresh"]?>
                           </button>
                       </a>
                       <?php }
                      ?>
                   </li>
				   
				   <li>
                     <a style="margin-right:10px;" href="series_category.php">
                         <button type="button" class="btn btn-outline-success waves-effect waves-light btn-sm">
                             <i class="fa fa-plus"></i> Create categorie
                         </button>
                     </a>
                 </li>
                 <li>
                     <?php if (($rPermissions["is_admin"]) && (hasPermissions("adv", "add_series"))) { ?>
                       <a href="serie.php">
                           <button type="button" class="btn btn-success waves-effect waves-light btn-sm">
                               <i class="fa fa-plus"></i> <?=$_["add_series"]?>
                           </button>
                       </a>
                       <?php } ?>
                 </li>
                 	
                 <li>
                     <a style="margin-right:10px;" href="series_mass.php<?php if($rCategory) { echo "?category=".$rCategory["id"]; }?>">
                         <button type="button" class="btn btn-secondary waves-effect waves-light btn-sm">
                             <i class="fa fa-edit"></i> Edit Series Mass
                         </button>
                     </a>
                 </li>				
                </ol>
				
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9">List of Series</h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
				  
				  
				  <form id="series_form">
                                    <div class="form-group row mb-4">
                                        <div class="col-md-6">
                                            <input type="text" class="form-control" id="series_search" value="" placeholder="<?=$_["search_series"]?>">
                                        </div>
                                        <div class="col-md-3">
                                            <select id="series_category_id" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_categories"]?></option>
                                                <option value="-1"><?=$_["no_tmdb_match"]?></option>
                                                <?php foreach ($rCategories as $rCategory) { ?>
                                                <option value="<?=$rCategory["id"]?>"><?=$rCategory["category_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <label class="col-md-1 col-form-label text-center" for="series_show_entries"><?=$_["show"]?></label>
                                        <div class="col-md-2">
                                            <select id="series_show_entries" class="form-control" data-toggle="select2">
                                                <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo $_["selected"]; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                    </div>
                                </form>
                                <table id="datatable-streampage" class="table stripe table-hover dt-responsive nowrap font-normal" width="100%">
                                    <thead>
                                        <tr>
                                            <th class="text-center"><?=$_["id"]?></th>
                                            <th class="text-center">Cover</th>
                                            <th><?=$_["name"]?></th>
                                            <th><?=$_["category"]?></th>
                                            <th class="text-center"><?=$_["seasons"]?></th>
                                            <th class="text-center"><?=$_["episodes"]?></th>
                                            <th class="text-center"><?=$_["first_aired"]?></th>
                                            <?php if ($rPermissions["is_admin"]) { ?>
                                            <th class="text-center"><?=$_["last_updated"]?></th>
                                            <th class="text-center"><?=$_["actions"]?></th>
                                            <?php } ?>
                                        </tr>
                                    </thead>
                                    <tbody></tbody>
                                </table>
				
				
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
		 <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
  
   
		 
        <script>
        var autoRefresh = true;
        var rClearing = false;
        
        function toggleAuto() {
            if (autoRefresh == true) {
                autoRefresh = false;
                $(".auto-text").html("<?=$_["manual_mode"]?>");
            } else {
                autoRefresh = true;
                $(".auto-text").html("<?=$_["auto_refresh"]?>");
            }
        }
        <?php if ($rPermissions["is_admin"]) { ?>
        function api(rID, rType) {
            if (rType == "delete") {
                if (confirm('<?=$_["are_you_sure_you_want_to_delete_this_series"]?>') == false) {
                    return;
                }
            }
            $.getJSON("../functions/api_xerox.php?action=series&sub=" + rType + "&series_id=" + rID, function(data) {
                if (data.result == true) {
                    if (rType == "delete") {
                        $.toast("<?=$_["series_successfully_deleted"]?>");
                    }
                    $.each($('.tooltip'), function (index, element) {
                        $(this).remove();
                    });
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                } else {
                    $.toast("<?=$_["an_error_occured_while_processing_your_request"]?>");
                }
            }).fail(function() {
                $.toast("<?=$_["an_error_occured_while_processing_your_request"]?>");
            });
        }
        <?php } ?>
        function reloadStreams() {
            if (autoRefresh == true) {
                $('[data-toggle="tooltip"]').tooltip("hide");
                $("#datatable-streampage").DataTable().ajax.reload( null, false );
            }
            setTimeout(reloadStreams, 15000);
        }
        function getCategory() {
            return $("#series_category_id").val();
        }
        function changeZoom() {
            if ($("#datatable-streampage").hasClass("font-large")) {
                $("#datatable-streampage").removeClass("font-large");
                $("#datatable-streampage").addClass("font-normal");
            } else if ($("#datatable-streampage").hasClass("font-normal")) {
                $("#datatable-streampage").removeClass("font-normal");
                $("#datatable-streampage").addClass("font-small");
            } else {
                $("#datatable-streampage").removeClass("font-small");
                $("#datatable-streampage").addClass("font-large");
            }
            $("#datatable-streampage").DataTable().draw();
        }
        function clearFilters() {
            window.rClearing = true;
            $("#series_search").val("").trigger('change');
            $('#series_category_id').val("").trigger('change');
            $('#series_show_entries').val("<?=$rAdminSettings["default_entries"] ?: 10?>").trigger('change');
            window.rClearing = false;
            $('#datatable-streampage').DataTable().search($("#series_search").val());
            $('#datatable-streampage').DataTable().page.len($('#series_show_entries').val());
            $("#datatable-streampage").DataTable().page(0).draw('page');
            $('[data-toggle="tooltip"]').tooltip("hide");
            $("#datatable-streampage").DataTable().ajax.reload( null, false );
        }
        $(document).ready(function() {
			$(window).keypress(function(event){
                if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
            });
            //formCache.init();
            //formCache.fetch();
            
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            $("#datatable-streampage").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                    $('[data-toggle="tooltip"]').tooltip();
                },
                createdRow: function(row, data, index) {
                    $(row).addClass('stream-' + data[0]);
                },
                responsive: true,
                processing: true,
                serverSide: true,
				dom: 'Bfrtip',
				buttons: {
					buttons: [
						{
							text: 'Check All',
							action: function ( e, dt, node, config ) {
								$('.movie_checkbox').prop('checked', true);
								this.innerHTML  == 'UncheckAll'; // disable button
							}
						},
						{
							text: 'Uncheck All',
							action: function ( e, dt, node, config ) {
								$('.movie_checkbox').prop('checked', false);
								this.innerHTML  == 'UncheckAll'; // disable button
							}
						},
						{
							extend: 'collection',
							text: 'Export',
							buttons: [
								'copy',
								'excel',
								'csv',
								'pdf',
								'print'
							]
						},
						{
							extend: 'collection',
							text: 'Mass action',
							buttons: [
								{
									text: 'Encode all episodes',
									action: function ( e, dt, node, config ) {
										if($('.movie_checkbox:checkbox:checked').length >0){
											console.log($('.movie_checkbox:checkbox:checked'))
											var checkedVals = $('.movie_checkbox:checkbox:checked').map(function() {
												console.log(this.value);
											}).get();
										}
									}
								},
								
								{
									text: 'Delete',
									action: function ( e, dt, node, config ) {
										if($('.movie_checkbox:checkbox:checked').length >0){
											if (confirm('<?=$_["movie_delete_confirm"]?>') == false) {
													return;
											}
											var checkedVals = $('.movie_checkbox:checkbox:checked').map(function() {											 													
													$.getJSON("../functions/api_xerox.php?action=series&sub=delete&series_id=" + this.value, function(data) {
														if (data.result == true) {
															$.toast("<?=$_["movie_delete_confirmed"]?>");
															$.each($('.tooltip'), function (index, element) {
																$(this).remove();
															});
															$('[data-toggle="tooltip"]').tooltip("hide");
															$("#datatable-streampage").DataTable().ajax.reload( null, false );
														} else {
															$.toast("<?=$_["error_occured"]?>");
														}
													}).fail(function() {
														$.toast("<?=$_["error_occured"]?>");
													});
											}).get();	
										}										
									}
								},
							]
						},
					]
				},
                ajax: {
                    url: "../functions/table_search.php",
                    "data": function(d) {
                        d.id = "series";
                        d.category = getCategory();
                    }
                },
                columnDefs: [
					{ "className": 'all', "targets": [0, 1, 7] },   
                    <?php if ($rPermissions["is_reseller"]) { ?>
                    {"className": "dt-center", "targets": [0,3,4,5]},
                    <?php } else { ?>
                    {"className": "dt-center", "targets": [0,3,4,5,6,7]},
                    {"orderable": false, "targets": [7]}
                    <?php } ?>
                ],
                order: [[ 0, "desc" ]],
                pageLength: 50,
                stateSave: true
            });
            $("#datatable-streampage").css("width", "100%");
            $('#series_search').keyup(function(){
                if (!window.rClearing) {
                    $('#datatable-streampage').DataTable().search($(this).val()).draw();
                }
            })
            $('#series_show_entries').change(function(){
                if (!window.rClearing) {
                    $('#datatable-streampage').DataTable().page.len($(this).val()).draw();
                }
            })
            $('#series_category_id').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            <?php if (!$detect->isMobile()) { ?>
            setTimeout(reloadStreams, 15000);
            <?php }
            if (!$rAdminSettings["auto_refresh"]) { ?>
            toggleAuto();
            <?php } ?>
            if ($('#series_search').val().length > 0) {
                $('#datatable-streampage').DataTable().search($('#series_search').val()).draw();
            }
        });
        
        $(window).bind('beforeunload', function() {
            //formCache.save();
        });
        </script>