<?php 
//require("../layout/header.php");
require('../includes/inc_db.php');
include "../functions/functions_xerox.php";


if (isset($_POST["reorder"])) {
    $rOrder = json_decode($_POST["episode_order_array"], True);
    if (is_array($rOrder)) {
        foreach ($rOrder as $rSeason => $rEpisodes) {
            $rSort = 0;
            foreach ($rEpisodes as $rStreamID) {
                $rSort ++;
                $db->query("UPDATE `series_episodes` SET `sort` = ".intval($rSort)." WHERE `id` = ".intval($rStreamID).";");
            }
        }
    }
}

if (!isset($_GET["id"])) { exit; }
if (!isset($_GET["season"])) { $season = 1; }else{ $season = $_GET["season"];}
$rSeries = getSerie($_GET["id"]);
if (!$rSeries) { exit; }

$rSeasons = Array();
$result = $db->query("SELECT `series_episodes`.`id`, `series_episodes`.`season_num`, `streams`.`stream_display_name` FROM `series_episodes` LEFT JOIN `streams` ON `streams`.`id` = `series_episodes`.`stream_id` WHERE `series_id` = ".intval($rSeries["id"])." ORDER BY `series_episodes`.`season_num` ASC, `series_episodes`.`sort` ASC;");
if (($result) && ($result->num_rows > 0)) {
    while ($row = $result->fetch_assoc()) {
        $rSeasons[$row["season_num"]][] = Array("id" => $row["id"], "title" => $row["stream_display_name"]);
    }
}

//die( json_encode($rSeasons));

$serieOpen = "menu-open";
$serieActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
   
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
		
		<style>
			.dd-list .dd-item .dd-handle {
				background: #f1f5f7;
				border: none;
				padding: 8px 16px;
				height: auto;
				font-weight: 500;
				border-radius: 3px;
				font-size: x-large;
			}
			.dd-list .dd3-handle {
				margin: 0;
				height: 36px!important;
				float: left;
			}
			.dd-list .dd3-content {
				height: auto;
				border: none;
				padding: 8px 16px 8px 46px;
				background: #f1f5f7;
				font-weight: 600;
			}
			.dd-list .dd3-handle:before {
				content: "=";
				font-family: "Material Design Icons";
				color: #adb5bd;
			}


			
		</style>	
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Episodes </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;">
                   
                </ol>
				
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9">Reorder Series</h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
			
					 <form action="./series_order.php?id=<?=$_GET["id"]?>&season=<?=$_GET["season"]?>" method="POST" id="episode_order_form">
                                    <input type="hidden" id="episode_order_array" name="episode_order_array" value="" />
                                    <input type="hidden" name="reorder" value="<?=$_GET["id"]?>" />
                                    <div id="basicwizard">
                                        <ul class="nav nav-pills bg-light nav-justified form-wizard-header mb-4">
                                            <?php foreach ($rSeasons as $rSeasonNum => $rSeasonArray) { ?>
                                            <li class="nav-item">
                                                <a href="#season-<?=$rSeasonNum?>" data-toggle="tab" id="nav_season-<?=$rSeasonNum?>" class="nav-link rounded-0 pt-2 pb-2 <?=($season == $rSeasonNum)?'active':'';?>"> 
                                                    <span class="d-none d-sm-inline">S<?=sprintf('%02d', $rSeasonNum)?></span>
                                                </a>
                                            </li>
                                            <?php } ?>
                                        </ul>
                                        <div class="tab-content b-0 mb-0 pt-0">
                                            <?php foreach ($rSeasons as $rSeasonNum => $rSeasonArray) { ?>
                                            <div class="tab-pane fade <?=($season == $rSeasonNum)?'active show':'';?>" id="season-<?=$rSeasonNum?>">
                                                <div class="row">
                                                    <div class="col-12">
                                                        <p class="sub-header">
                                                         <?=$_["to_re-order"]?>  <i class="fa fa-chevron-up"></i> <?=$_["and"]?> <i class="fa fa-chevron-down"></i> <?=$_["buttons_to_move_it"]?>
                                                        </p>
                                                        <select multiple id="sort_episode_<?=$rSeasonNum?>" class="form-control" style="min-height:400px;">
                                                        <?php $i = 0; foreach ($rSeasonArray as $rEpisode) { $i ++; ?>
                                                            <option value="<?=$rEpisode["id"]?>"><?=$i?> - <?=$rEpisode["title"]?></option>
                                                        <?php } ?>
                                                        </select>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                                <ul class="list-inline wizard mb-0 add-margin-top-20">
                                                    <li class="list-inline-item">
                                                        <a href="javascript: void(0);" onClick="MoveUp(<?=$rSeasonNum?>)" class="btn btn-purple"><i class="fa fa-chevron-up"></i></a>
                                                        <a href="javascript: void(0);" onClick="MoveDown(<?=$rSeasonNum?>)" class="btn btn-purple"><i class="fa fa-chevron-down"></i></a>
                                                        <a href="javascript: void(0);" onClick="AtoZ(<?=$rSeasonNum?>)" class="btn btn-info"><?=$_["sort_all_a_to_z"]?></a>
                                                    </li>
                                                    <li class="list-inline-item float-right">
                                                        <button type="submit" class="btn btn-primary waves-effect waves-light"><?=$_["save_changes"]?></button>
                                                    </li>
                                                </ul>
                                            </div>
                                            <?php } ?>
                                        </div>
                                    </div> <!-- end #basicwizard-->
                                </form>
					
				
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>

  
    
        <script>
        function AtoZ(rSeason) {
            $("#sort_episode_" + rSeason).append($("#sort_episode_" + rSeason + " option").remove().sort(function(a, b) {
                var at = $(a).text().toUpperCase().split("-").slice(1).join("-").trim()
                var bt = $(b).text().toUpperCase().split("-").slice(1).join("-").trim()
                return (at > bt) ? 1 : ((at < bt) ? -1 : 0);
            }));
        }
        function MoveUp(rSeason) {
            var rSelected = $('#sort_episode_' + rSeason + ' option:selected');
            if (rSelected.length) {
                var rPrevious = rSelected.first().prev()[0];
                if ($(rPrevious).html() != '') {
                    rSelected.first().prev().before(rSelected);
                }
            }
        }
        function MoveDown(rSeason) {
            var rSelected = $('#sort_episode_' + rSeason + ' option:selected');
            if (rSelected.length) {
                rSelected.last().next().after(rSelected);
            }
        }
        $(document).ready(function() {
            $("#episode_order_form").submit(function(e){
                var rOrder = {};
                <?php foreach ($rSeasons as $rSeasonNum => $rSeasonArray) { ?>
                rOrder[<?=$rSeasonNum?>] = [];
                $('#sort_episode_<?=$rSeasonNum?> option').each(function() {
                    if ($(this).val()) {
                        rOrder[<?=$rSeasonNum?>].push($(this).val());
                    }
                });
                <?php } ?>
				
                $("#episode_order_array").val(JSON.stringify(rOrder));
            });
			
			setTimeout(function(){$("#nav_season-<?=$season?>").click();}, 1000);
			
        });
        </script>
		