<?php 
require("../layout/header.php");
$rqtAddApp = "INSERT INTO panel_apps(name,url,tuto,hide) VALUES(:name,:url,:tuto,:hide)";
$stmtAddApp = $pdoPanel->prepare($rqtAddApp);
$trouble = "";
if($_SESSION['admin'] != 1){
    $trouble="notAdmin";
    echo"<script>location.href='../home/dashboard.php'</script>";
}
if($trouble == ""){
    if($_POST){
		try {
        // print_r(trim($_POST);
        $hide = 0;
        if($_POST['hideit']){
            $hide = 1;
        }
        $stmtAddApp->bindParam(':name',trim($_POST['name']));
        $stmtAddApp->bindParam(':url',trim($_POST['url']));
        $stmtAddApp->bindParam(':tuto',$_POST['tuto']);
        $stmtAddApp->bindParam(':hide',$hide);
        if(!($stmtAddApp->execute())){
            $trouble="error";
        }else{
			
            //echo"<script>location.href='../home/dashboard.php?msg=createdApp.php'</script>";
        }
		
		} catch(Exception $e) {
		  echo $e->getMessage();
		}
		$_SESSION['message_add_app'] = true;
            header('Location: manage_apps.php');
    }
}


$adminOpen = "menu-open";
$adminActive = "active";
include('../layout/header_html.php');
?>

  <!-- summernote -->
  <link rel="stylesheet" href="../plugins/summernote/summernote-bs4.min.css">
  
  
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Admin</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">apps</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Add new app</h3>
              </div>
              <!-- /.card-header -->
			  <div class="row" style="margin: auto; margin-top: 2rem;">
				<div class="col-md-12">
				<?php
                if ($trouble == "error")
                    { ?>
                       <div class="alert alert-danger alert-dismissible">
					  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
					  <h5><i class="icon fas fa-check"></i> danger!</h5>
					  Problem during insert data
					</div>
                  <?php  }
                ?>
					
				</div>
			  </div>
              <!-- form start -->			  
              <form id="quickForm" method="post" action="add_apps.php">
                <div class="card-body">
				<div class="row">
					<div class="col-md-5">
						<div class="form-group">
							<label>Name </label>
							<input type="text" class="form-control" name="name" id="name" placeholder="Name of the app" required>
						</div>
					</div>
					<div class="col-md-6">
						<div class="form-group">
							<label>URL </label>
							<input type="text" class="form-control" name="url" id="url" placeholder="http://XXXXXXXXX">
						</div>
					</div>
					<div class="col-md-1">
						<div class="form-group">
							<label>&nbsp; </label>
							<div class="custom-control custom-switch">
							  <input type="checkbox" class="custom-control-input" name="hideit" id="customSwitch1">
							  <label class="custom-control-label" for="customSwitch1">Hide</label>
							</div>
						 </div>
					</div>
					
					  <div class="col-12">
						<div class="form-group">
						  <label>Tuto</label>
						 <textarea id="summernote" name="tuto">
							
						  </textarea>
						</div>
						<!-- /.form-group -->
					  </div>
					
				</div>
					
                 
                <!-- /.card-body -->
                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  </div>
<?php 
	include("../layout/footer.php");
?>

  
  <?php
include("../common/body.php");
?>
  
  
<!-- Summernote -->
<script src="../plugins/summernote/summernote-bs4.min.js"></script>
<script>
  $(function () {
    // Summernote
    $('#summernote').summernote({
    fontSizes: ['12', '14', '16', '18', '24', '36', '48'],
    fontNames:['Arial', 'Arial Black', 'Comic Sans MS', 'Courier New'],
    toolbar: [
    ['style', ['style']],
    ['font', ['bold', 'underline', 'clear']],
    ['fontnames', ['fontname']],
    ['fontsize', ['fontsize']],
    ['color', ['color']],
    ['para', ['ul', 'ol', 'paragraph']],
    ['table', ['table']],
    ['insert', ['link', 'picture', 'video']],
    ['view', ['fullscreen','undo','redo', 'codeview', 'help']],
    ],
    popover: {
  image: [
    ['image', ['resizeFull', 'resizeHalf', 'resizeQuarter', 'resizeNone']],
    ['float', ['floatLeft', 'floatRight', 'floatNone']],
    ['remove', ['removeMedia']]
  ],
  link: [
    ['link', ['linkDialogShow', 'unlink']]
  ],
  table: [
    ['add', ['addRowDown', 'addRowUp', 'addColLeft', 'addColRight']],
    ['delete', ['deleteRow', 'deleteCol', 'deleteTable']],
  ],
  air: [
    ['color', ['color']],
    ['font', ['bold', 'underline', 'clear']],
    ['para', ['ul', 'paragraph']],
    ['table', ['table']],
    ['insert', ['link', 'picture']]
  ]
    },
   
    });

    
  })
</script>

   
</body>
</html>