<?php 
//require("../layout/header.php");

require('../includes/inc_db.php');
include "../functions/functions_xerox.php";



if (isset($_POST["bouquet_order_array"])) {
    set_time_limit(0);
    ini_set('mysql.connect_timeout', 0);
    ini_set('max_execution_time', 0);
    ini_set('default_socket_timeout', 0);
    $rOrder = json_decode($_POST["bouquet_order_array"], True);
    $rSort = 1;
    foreach ($rOrder as $rBouquetID) {
        $db->query("UPDATE `bouquets` SET `bouquet_order` = ".intval($rSort)." WHERE `id` = ".intval($rBouquetID).";");
        $rSort ++;
    }
    if (isset($_POST["confirmReplace"])) {
        $rUsers = getUserBouquets();
        foreach ($rUsers as $rUser) {
            $rBouquet = json_decode($rUser["bouquet"], True);
            $rBouquet = sortArrayByArray($rBouquet, $rOrder);
            $db->query("UPDATE `users` SET `bouquet` = '[".ESC(join(",", $rBouquet))."]' WHERE `id` = ".intval($rUser["id"]).";");
        }
        $rPackages = getPackages();
        foreach ($rPackages as $rPackage) {
            $rBouquet = json_decode($rPackage["bouquets"], True);
            $rBouquet = sortArrayByArray($rBouquet, $rOrder);
            $db->query("UPDATE `packages` SET `bouquets` = '[".ESC(join(",", $rBouquet))."]' WHERE `id` = ".intval($rPackage["id"]).";");
        }
        $_STATUS = 0;
    } else {
        $_STATUS = 1;
    }
}



$bouquetOpen = "menu-open";
$bouquetActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
  <style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}
  </style>
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1><?=$rBouquet["bouquet_name"]?> </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;"> 
					<li class="breadcrumb-item">
                       <a href="bouquets.php">
                            <button type="button" class="btn btn-success waves-effect waves-light btn-sm">
                                <i class="fa fa-pencil-outline"></i>View bouquets
                            </button>
                        </a>
                    </li>
             </ol>
         
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?=$rBouquet["bouquet_name"]?></h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
					
					 <div class="row">
                    <div class="col-xl-12">
                        <?php if ((isset($_STATUS)) && ($_STATUS == 0)) { ?>
                        <div class="alert alert-success show" role="alert">
                            Bouquet order has taken effect and all users and packages have been modified to utilise the new bouquet order.
                        </div>
                        <?php } else if ((isset($_STATUS)) && ($_STATUS == 1)) { ?>
                        <div class="alert alert-success show" role="alert">
                            Bouquet order has taken effect, any new users and packages will use this order.
                        </div>
                        <?php } ?>
                        <div class="card">
                            <div class="card-body">
                                <form action="./bouquet_sort.php" method="POST" id="bouquet_sort_form">
                                    <input type="hidden" id="bouquet_order_array" name="bouquet_order_array" value="" />
                                    <div id="basicwizard">
                                        <ul class="nav nav-pills bg-light nav-justified form-wizard-header mb-4">
                                            <li class="nav-item">
                                                <a href="#order-stream" data-toggle="tab" class="nav-link rounded-0 pt-2 pb-2 active"> 
                                                    <i class="fa fa-flower-tulip-outline mr-1"></i>
                                                    <span class="d-none d-sm-inline"><?=$_["bouquet_order"]?></span>
                                                </a>
                                            </li>
                                        </ul>
                                        <div class="tab-content b-0 mb-0 pt-0">
                                            <div class="tab-pane fade show active" id="order-stream">
                                                <div class="row">
                                                    <div class="col-12">
                                                        <p class="sub-header">
                                                            <?=$_["bouquet_sort_text"]?>
                                                        </p>
                                                        <select multiple id="sort_bouquet" class="form-control" style="min-height:400px;">
                                                            <?php foreach (getBouquets() as $rBouquet) { ?>
                                                            <option value="<?=$rBouquet["id"]?>"><?=$rBouquet["bouquet_name"]?></option>
                                                            <?php } ?>
                                                        </select>
                                                        <div class="custom-control custom-checkbox add-margin-top-20">
															<input type="checkbox" class="custom-control-input" name="confirmReplace" id="confirmReplace">
															<label class="custom-control-label" for="confirmReplace">Replace bouquet order for all users and packages retrospectively. This can take a while.</label>
														</div>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                                <ul class="list-inline wizard mb-0 add-margin-top-20">
                                                    <li class="list-inline-item">
                                                        <a href="javascript: void(0);" onClick="MoveUp()" class="btn btn-primary"><i class="fa fa-chevron-up"></i></a>
                                                        <a href="javascript: void(0);" onClick="MoveDown()" class="btn btn-primary"><i class="fa fa-chevron-down"></i></a>
                                                        <a href="javascript: void(0);" onClick="MoveTop()" class="btn btn-danger"><i class="fa fa-angle-double-up"></i></a>
                                                        <a href="javascript: void(0);" onClick="MoveBottom()" class="btn btn-danger"><i class="fa fa-angle-double-down"></i></a>
                                                        <a href="javascript: void(0);" onClick="AtoZ()" class="btn btn-info"><?=$_["a_to_z"]?></a>
                                                    </li>
                                                    <li class="list-inline-item float-right">
                                                        <button type="submit" class="btn btn-primary waves-effect waves-light"><?=$_["save_changes"]?></button>
                                                    </li>
                                                </ul>
                                            </div>
                                        </div>
                                    </div> <!-- end #basicwizard-->
                                </form>
                            </div> <!-- end card-body -->
                        </div> <!-- end card-->
                    </div> <!-- end col -->
                </div>

					
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
 
 <script>
        function AtoZ() {
            $("#sort_bouquet").append($("#sort_bouquet option").remove().sort(function(a, b) {
                var at = $(a).text().toUpperCase(), bt = $(b).text().toUpperCase();
                return (at > bt) ? 1 : ((at < bt) ? -1 : 0);
            }));
        }
        function MoveUp() {
            var rSelected = $('#sort_bouquet option:selected');
            if (rSelected.length) {
                var rPrevious = rSelected.first().prev()[0];
                if ($(rPrevious).html() != '') {
                    rSelected.first().prev().before(rSelected);
                }
            }
        }
        function MoveDown() {
            var rSelected = $('#sort_bouquet option:selected');
            if (rSelected.length) {
                rSelected.last().next().after(rSelected);
            }
        }
        function MoveTop() {
            var rSelected = $('#sort_bouquet option:selected');
            if (rSelected.length) {
                rSelected.prependTo($('#sort_bouquet'));
            }
        }
        function MoveBottom() {
            var rSelected = $('#sort_bouquet option:selected');
            if (rSelected.length) {
                rSelected.appendTo($('#sort_bouquet'));
            }
        }
        
        $(document).ready(function() {
            $('.select2').select2({width: '100%'});
            $("#bouquet_sort_form").submit(function(e){
                rOrder = [];
                $('#sort_bouquet option').each(function() {
                    rOrder.push($(this).val());
                });
                $("#bouquet_order_array").val(JSON.stringify(rOrder));
            });
        });
        </script>
    
  
  