<?php 
include("../layout/header.php");
if(isset($_GET['msg'])){
    if($_GET['msg']=="ticketClosed"){
        echo '<script>
                            setTimeout(function() {
                                Swal.fire({
                                    title: "Success",
                                    text: "Complaint successfully closed",
                                    icon: "Success"
                                }).then(function(){
                                    window.location.href = "complaints_history.php";
                                });
                            }, 1000);
                        </script>';
}
if($_GET['msg']=="ticketCloseError"){
    echo '<script>
                        setTimeout(function() {
                            Swal.fire({
                                title: "Error",
                                text: "Can\'t close the complaint",
                                icon: "Error"
                            }).then(function(){
                                window.location.href = "complaints_history.php";
                            });
                        }, 1000);
                    </script>';
}
if($_GET['msg']=="ticketCreated"){
    echo '<script>
                        setTimeout(function() {
                            Swal.fire({
                                title: "Success",
                                text: "Complaint successfully created",
                                icon: "success"
                            }).then(function(){
                                window.location.href = "complaints_history.php";
                            });
                        }, 1000);
                    </script>';
}if($_GET['msg']=="ticketDeleted"){
    echo '<script>
                        setTimeout(function() {
                            Swal.fire({
                                title: "Success",
                                text: "Complaint successfully deleted",
                                icon: "success"
                            }).then(function(){
                                window.location.href = "complaints_history.php";
                            });
                        }, 1000);
                    </script>';
}
if($_GET['msg']=="ticketDeletedError"){
    echo '<script>
                        setTimeout(function() {
                            Swal.fire({
                                title: "Error",
                                text: "Can\'t delete the complaint",
                                icon: "Error"
                            }).then(function(){
                                window.location.href = "complaints_history.php";
                            });
                        }, 1000);
                    </script>';
}

}

$complaintOpen = "menu-open";
$complaintActive = "active";
include("../layout/header_html.php");
?>
 
<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Complaints History </h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Complain</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
	
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header">
                <h3 class="card-title">Complaints History </h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table id="example1" class="table table-bordered table-striped tableComplaints">
                  <thead>
                  <tr>
                    <th class='no-sort'>
                        Status
                    </th>
                    <th class='no-sort'>
                        Username
                    </th>
                    <th class='no-sort'>
                        Title
                    </th>
                    <th class='no-sort'>
                        Last Reply
                    </th>
                    <th class='no-sort'>
                        Options
                    </th>
                  </tr>
                  </thead>
                   <tbody>
                       
                        </tbody>
                  
                </table>
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>


<?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
<script>
$(document).ready(function(){
    $('.tableComplaints').DataTable({
            "columnDefs": [
                { targets: 'no-sort', orderable: false }
            ],
            language: {
                paginate: {
                    previous: "<i class='mdi mdi-chevron-left'>",
                    next: "<i class='mdi mdi-chevron-right'>",
                },
                infoFiltered: ""
            },
            responsive: false,
            processing: true,
            serverSide: true,
            ajax: {
                url: "../common/getData.php?type=complaints",
                "data": function (d) {
                }
            },

        });
})

</script>

</body>
</html>