<?php 
require('../layout/header.php');
if($_POST){
    try{
        $trouble = "";
        $sqlTicket = "INSERT INTO panel_complaints(member_id,title,status,admin_read,user_read) VALUES(:member_id,:title,1,0,1)";
        $sqlInfoTicket = "INSERT INTO panel_complaints_messages(complaint_id,admin_reply,message,url_pub,username,date) VALUES(:tId,0,:message,:url,:username,UNIX_TIMESTAMP())";
        $member_id = $_SESSION['id'];
        $message = trim($_POST['message']);
        $title = trim($_POST['title']);
        $url = trim($_POST['url']);
        $username = trim($_POST['username']);
        $stmtTicket = $pdoPanel->prepare($sqlTicket);
        $stmtInfoTicket = $pdoPanel->prepare($sqlInfoTicket);
        $stmtTicket->bindParam(":member_id",$member_id);
        $stmtTicket->bindParam(":title",$title);
        if($stmtTicket->execute()){
            $lastId = $pdoPanel->lastInsertId();
            $stmtInfoTicket->bindParam(":tId",$lastId);
            $stmtInfoTicket->bindParam(":message",$message);
            $stmtInfoTicket->bindParam(":url",$url);
            $stmtInfoTicket->bindParam(":username",$username);

            if($stmtInfoTicket->execute()){
                echo'<script>window.location.href = "./complaints_history.php?msg=ticketCreated";</script>';
            }else{
                $trouble = "Something went wrong";
            }
        }else{
            $trouble = "Something went wrong";
        }
    }catch(Exception $e) {
        var_dump($e->getMessage());
    }


}

$complaintOpen = "menu-open";
$complaintActive = "active";
require('../layout/header_html.php');
?>


  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Complaint</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Complaint</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Create complaint</h3>
              </div> 
              <!-- /.card-header -->
              <!-- form start -->
			  <div class="row" style="margin: auto; margin-top: 2rem;">
				<div class="col-md-12">
				</div>
			  </div>
			  
              <form action="create_complaint.php" method="POST">
				<div class="card-body">
					<div class="row">
						<div class="col-md-4">
							<div class="form-group">
								<label>Title</label>
								<input type="text" class="form-control" id="title" name="title" placeholder="Title of the ticket" required>
							</div>
						</div>
						<div class="col-md-4">
							<div class="form-group">
								<label>URL Pub</label>
								<input type="text" class="form-control" id="url" name="url" placeholder="Url of the pub">
							</div>
						</div>
						<div class="col-md-4">
							<div class="form-group">
								<label>Username / Mac Address</label>
								<input type="text" class="form-control" id="username" name="username" placeholder="Username or Mac created for the test">
							</div>
						</div>
						<div class="col-md-12">
							<div class="form-group">
								<label>Message</label>
								<textarea name="message" class="form-control" id="message" cols="30" rows="10"></textarea>
							</div>
						</div>
					</div>
				</div>
					
					<!-- /.card-body -->
					<div class="card-footer">
					  <button type="submit" class="btn btn-primary">Submit</button>
					</div>
					
                    
                  </form>
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  </div>
<?php 
	include("../layout/footer.php");
?>

<?php 
require("../common/body.php");
?>



</body>
</html>