<?php 
   //require("../layout/header.php");
   require('../includes/inc_db.php');
   include "../functions/functions_xerox.php";
   
  $mapLegends = mapLegends();
  
  //die(json_encode($mapLegends));
    
   $liveOpen = "menu-open";
   $liveActive = "active";
   
   include('../layout/header_html.php');
   ?>
<!-- DataTables -->
<link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
<link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
<link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
<!-- Select2 -->
<link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
<link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
<link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
<link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
<link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
<link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
<link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
<link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
<link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
<style>

	.mapael .map {
            position: relative;
        }

        .mapael .mapTooltip {
            position: absolute;
            background-color: #fff;
            moz-opacity: 0.70;
            opacity: 0.70;
            filter: alpha(opacity=70);
            border-radius: 10px;
            padding: 10px;
            z-index: 1000;
            max-width: 200px;
            display: none;
            color: #343434;
        }
		
		.stats{
			position: absolute;
			right: 25px;
			bottom: 25px;
			top: 0;
			background: rgba(26,34,41,.8);
			z-index: 999999;
			overflow: scroll;
		}

</style>

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
<!-- Content Header (Page header) -->
<section class="content-header">
   <div class="container-fluid">
      <div class="row mb-2">
         <div class="col-sm-4">
            <h1><?=$_["live_connections"]?> </h1>
         </div>
         
      </div>
   </div>
   <!-- /.container-fluid -->
</section>
<!-- Main content -->
	<div id="world-map-markers" style="position:relative;">
		<div class="map"></div>
		<div class="stats">
		
            <!-- Widget: user widget style 2 -->
            <div class="card card-widget widget-user-2" style="background-color: #ffffff08;">
              <!-- Add the bg color to the header using any of the bg-* classes -->
              <div class="widget-user-header text-white" style="background-color: #ffffff08;">
                
                <!-- /.widget-user-image -->
                <h5 class="">Statistique</h5>
              </div>
              <div class="card-footer p-0">
                <ul class="nav flex-column">
					<?php if(!empty($mapLegends)){
						foreach($mapLegends as $item){
					?>
						<li class="nav-item">
							<a href="javascript::void(0);" class="nav-link">
								<img src="data:image/png;base64,<?=getCountryFlag($item['valueName'])?>" width="30px">&nbsp;&nbsp;&nbsp; <i style="color: <?=$item['attrs']['fill']?>" class="fa fa-arrow-right"></i> &nbsp; <?=$item['valueName']?> &nbsp;&nbsp;<span class="float-right badge bg- mt-1 text-white" ><?=$item['value']?></span>
							</a>
						</li>
					<?php
						}
						
					}
					?>
                  
                 
				</ul>
              </div>
            </div>
            <!-- /.widget-user -->
          
		<div>
	</div>
</div>
<!-- /.content-wrapper -->
<?php 
   include("../layout/footer.php");
   ?>
<?php
   include("../common/body.php");
   ?>
<!-- Plugins js-->

<script src="../plugins/jquery-mousewheel/jquery.mousewheel.js"></script>
<script src="../plugins/raphael/raphael.min.js"></script>
<script src="../plugins/jquery-mapael/jquery.mapael.min.js"></script>
<script src="../plugins/jquery-mapael/maps/world_countries.js"></script>

<script>
	var areas = jQuery.parseJSON ('<?php echo json_encode($mapLegends); ?>');
	console.log(areas);
	$('#world-map-markers').mapael({
    map: {
      name: 'world_countries',
      zoom: {
        enabled: true,
        maxLevel: 10
      }
    },
	  areas: areas  ,      
  })

</script>
