<?php 
//require("../layout/header.php");

require('../includes/inc_db.php');
include "../functions/functions_xerox.php";

if($_SESSION['admin'] == 0){
	header('Location: dashboard2.php');
}
  
  $mapLegends = mapLegends();
  
  
if ($rAdminSettings["dark_mode"]) {
	$rColours = Array(1 => Array("secondary", "#7e8e9d"), 2 => Array("secondary", "#7e8e9d"), 3 => Array("secondary", "#7e8e9d"), 4 => Array("secondary", "#7e8e9d"));
} else {
	$rColours = Array(1 => Array("purple", "#675db7"), 2 => Array("success", "#23b397"), 3 => Array("pink", "#e36498"), 4 => Array("info", "#56C3D6"));
}


$dashboardOpen = "menu-open";
$dashboardActive = "active";

include('../layout/header_html.php');
?>
	<style>
		.header-title {
			font-size: 1rem;
			margin: 0 0 7px 0;
		}
		.sub-header {
			margin-bottom: 24px;
			color: #98a6ad;
		}
		
		
		.card-box{
			margin: 10px; 
			padding: 10px;
			box-shadow: 0 0 1px rgb(0 0 0 / 13%), 0 1px 3px rgb(0 0 0 / 20%);
		}
	</style>
	
	<style>

	.mapael .map {
            position: relative;
        }

        .mapael .mapTooltip {
            position: absolute;
            background-color: #fff;
            moz-opacity: 0.70;
            opacity: 0.70;
            filter: alpha(opacity=70);
            border-radius: 10px;
            padding: 10px;
            z-index: 1000;
            max-width: 200px;
            display: none;
            color: #343434;
        }
		
		.stats{
			position: absolute;
			right: 25px;
			bottom: 25px;
			top: 0;
			background: rgba(26,34,41,.8);
			z-index: 999999;
			overflow: scroll;
		}

</style>

<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Dashboard </h1>
          </div>
          <div class="col-sm-8">
          
			
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header">
				<!-- start page title -->
                
              </div>
              <!-- /.card-header -->
              <div class="card-body">				
				<?php if (hasPermissions("adv", "index")) { ?>
                   
				
				<div class="col-md-12">
            <div class="card card-primary card-outline card-outline-tabs">
              <div class="card-header p-0 border-bottom-0">
                <ul class="nav nav-tabs dashboard-tabs" id="custom-tabs-four-tab" role="tablist">
                  <li class="nav-item">
                    <a class="nav-link active" data-id="home" id="custom-tabs-four-home-tab" data-toggle="pill" href="#server_home" role="tab" aria-controls="custom-tabs-four-home" aria-selected="true">
						<?=$_["overview"]?>
					</a>
                  </li>
				  
				  <?php foreach ($rServers as $rServer) { ?>
                  <li class="nav-item">
                    <a class="nav-link" id="server_li_<?=$rServer['id']?>" data-id="<?=$rServer['id']?>" data-toggle="pill" href="#server_<?=$rServer['id']?>" role="tab" aria-controls="server_<?=$rServer['id']?>" aria-selected="false">
						<?=$rServer["server_name"]?>
					</a>
                  </li>
                  <?php } ?>
                </ul>
              </div>
              <div class="card-body">
                <div class="tab-content" id="custom-tabs-four-tabContent">
                  <div class="tab-pane fade show active" id="server_home" role="tabpanel" aria-labelledby="custom-tabs-four-home-tab">
                      <div class="row">
							<div class="col-12 col-sm-6 col-md-3 active-connections">
								<?php if (hasPermissions("adv", "live_connections")) { ?>
									<a href="../servers/live_connections.php">
								<?php } ?>
								<div class="info-box">
								  <span class="info-box-icon bg-info elevation-1"><i class="fas fa-bolt"></i></span>
								  <div class="info-box-content">
									<span class="info-box-text"><?=$_["open_connections"]?></span>
									<span class="info-box-number entry">
									  0
									</span>
								  </div>
								  <!-- /.info-box-content -->
								</div>
								<!-- /.info-box -->
								<?php if (hasPermissions("adv", "live_connections")) { ?>
								</a>
								<?php } ?>
							</div>
							<div class="col-12 col-sm-6 col-md-3 online-users">
								<?php if (hasPermissions("adv", "live_connections")) { ?>
									<a href="../servers/live_connections.php">
								<?php } ?>
								<div class="info-box">
								  <span class="info-box-icon bg-warning elevation-1"><i class="fas fa-users"></i></span>
								  <div class="info-box-content">
									<span class="info-box-text"><?=$_["online_users"]?></span>
									<span class="info-box-number entry">
									  0
									</span>
								  </div>
								  <!-- /.info-box-content -->
								</div>
								<!-- /.info-box -->
								<?php if (hasPermissions("adv", "live_connections")) { ?>
								</a>
								<?php } ?>
							</div>
							<div class="col-12 col-sm-6 col-md-3 active-streams">
								<?php if (hasPermissions("adv", "streams")) { ?>
									<a href="../servers/live_connections.php">
								<?php } ?>
								<div class="info-box">
								  <span class="info-box-icon bg-success elevation-1"><i class="fas fa-play"></i></span>
								  <div class="info-box-content">
									<span class="info-box-text"><?=$_["online_streams"]?></span>
									<span class="info-box-number entry">
									  0
									</span>
								  </div>
								  <!-- /.info-box-content -->
								</div>
								<!-- /.info-box -->
								<?php if (hasPermissions("adv", "streams")) { ?>
								</a>
								<?php } ?>
							</div>
							<div class="col-12 col-sm-6 col-md-3 offline-streams">
								<?php if (hasPermissions("adv", "streams")) { ?>
									<a href="../servers/live_connections.php">
								<?php } ?>
								<div class="info-box">
								  <span class="info-box-icon bg-danger elevation-1"><i class="fas fa-pause"></i></span>
								  <div class="info-box-content">
									<span class="info-box-text"><?=$_["offline_streams"]?></span>
									<span class="info-box-number entry">
									  0
									</span>
								  </div>
								  <!-- /.info-box-content -->
								</div>
								<!-- /.info-box -->
								<?php if (hasPermissions("adv", "streams")) { ?>
								</a>
								<?php } ?>
							</div>
							
							
							<?php if (($rSettings["save_closed_connection"]) && ($rAdminSettings["dashboard_stats"])) { ?>
							<div class="col-xl-12">
								<!-- Portlet card -->
								<div class="card">
									<div class="card-body">
										<div class="card-widgets">
											<a href="javascript: setPeriod('week');">
												<button type="button" class="btn btn-info waves-effect waves-light btn-xs">Week</button>
											</a>
											<a href="javascript: setPeriod('day');">
												<button type="button" class="btn btn-info waves-effect waves-light btn-xs">Day</button>
											</a>
											<a href="javascript: setPeriod('hour');">
												<button type="button" class="btn btn-info waves-effect waves-light btn-xs">Hour</button>
											</a>
										</div>
										<h4 class="header-title mb-0">Connections</h4>
										<div id="statistics-collapse" class="collapse pt-3 show" dir="ltr">
											<div id="statistics" class="apex-charts"></div>
										</div> <!-- collapsed end -->
									</div> <!-- end card-body -->
								</div> <!-- end card-->
							</div> <!-- end col-->
							<?php }
							
							
							$i = 0; foreach ($rServers as $rServer) { $i ++; if ($i == 5) { $i = 1; } ?>
							<div class="col-xl-3 col-md-6">
								<div class="card-header bg-<?=$rColours[$i][0]?> py-3 text-white">
									<?php if (hasPermissions("adv", "live_connections")) { ?>
									<div class="float-right">
										<a href="../servers/live_connections.php?server_id=<?=$rServer["id"]?>" class="arrow-none card-drop">
											<i class="fa fa-play"></i>
										</a>
									</div>
									<?php } ?>
									<h5 class="card-title mb-0 text-white"><?=$rServer["server_name"]?></h5>
								</div>
								<div class="card-header py-3 ">
									<div class="row">
										<div class="col-md-4" align="center">
											<h4 class="header-title"><?=$_["conns"]?></h4>
											<p class="sub-header" id="s_<?=$rServer["id"]?>__conns">0</p>
										</div>
										<div class="col-md-4" align="center">
											<h4 class="header-title"><?=$_["users"]?></h4>
											<p class="sub-header" id="s_<?=$rServer["id"]?>_users">0</p>
										</div>
										<div class="col-md-4" align="center">
											<h4 class="header-title"><?=$_["online"]?></h4>
											<p class="sub-header" id="s_<?=$rServer["id"]?>_online">0</p>
										</div>
									</div>
									<div class="row" style="margin-bottom:-20px;">
										<div class="col-md-4" align="center">
											<h4 class="header-title"><?=$_["input"]?></h4>
											<p class="sub-header" id="s_<?=$rServer["id"]?>_input">0 Mbps</p>
										</div>
										<div class="col-md-4" align="center">
											<h4 class="header-title"><?=$_["output"]?></h4>
											<p class="sub-header" id="s_<?=$rServer["id"]?>_output">0 Mbps</p>
										</div>
										<div class="col-md-4" align="center">
											<h4 class="header-title"><?=$_["uptime"]?></h4>
											<p class="sub-header" id="s_<?=$rServer["id"]?>_uptime">0d 0h</p>
										</div>
									</div>
								</div>
								<div class="card-box mt-3">
									<div class="row">
                                        <div class="col-md-6" align="center">
                                            <a href="./process_monitor.php?server=<?=$rServer["id"]?>">
                                                <h4 class="header-title"><?=$_["cpu_usage"]?></h4>
                                                <input id="s_<?=$rServer["id"]?>_cpu" data-plugin="knob" data-width="64" data-height="64" data-fgColor="<?=$rColours[$i][1]?>" data-bgColor="#e8e7f4" value="0" data-skin="tron" data-angleOffset="180" data-readOnly=true data-thickness=".15"/>
                                            </a>
                                        </div>
                                        <div class="col-md-6" align="center">
                                            <a href="./process_monitor.php?server=<?=$rServer["id"]?>&mem">
                                                <h4 class="header-title"><?=$_["mem_usage"]?></h4>
                                                <input id="s_<?=$rServer["id"]?>_mem" data-plugin="knob" data-width="64" data-height="64" data-fgColor="<?=$rColours[$i][1]?>" data-bgColor="#e8e7f4" value="0" data-skin="tron" data-angleOffset="180" data-readOnly=true data-thickness=".15"/>
                                            </a>
                                        </div>
									</div>
								</div>
							</div>
							<?php } ?>
                        </div>
					 
                  </div>
				  <?php foreach ($rServers as $rServer) { ?>
                  <div class="tab-pane fade" id="server_<?=$rServer['id']?>" role="tabpanel" aria-labelledby="server_li_<?=$rServer['id']?>">
						
						<div class="row tab-pane-server">
								<div class="col-md-6 col-xl-3">
									<div class="card-box active-connections">
										<div class="row">
											<div class="col-6">
												<div class="avatar-sm bg-soft-purple rounded">
													<i class="fe-zap avatar-title font-22 text-purple"></i>
												</div>
											</div>
											<div class="col-6">
												<div class="text-right">
													<h3 class="text-dark my-1"><span data-plugin="counterup" class="entry">0</span></h3>
													<p class="text-muted mb-1 text-truncate"><?=$_["open_connections"]?></p>
												</div>
											</div>
										</div>
										<div class="mt-3">
											<h6 class="text-uppercase"><?=$_["total_connections"]?> <span class="float-right entry-percentage">0</span></h6>
											<div class="progress progress-sm m-0">
												<div class="progress-bar bg-purple" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">
													<span class="sr-only">0%</span>
												</div>
											</div>
										</div>
									</div> <!-- end card-box-->
								</div> <!-- end col -->

								<div class="col-md-6 col-xl-3">
									<div class="card-box online-users">
										<div class="row">
											<div class="col-6">
												<div class="avatar-sm bg-soft-success rounded">
													<i class="fe-users avatar-title font-22 text-success"></i>
												</div>
											</div>
											<div class="col-6">
												<div class="text-right">
													<h3 class="text-dark my-1"><span data-plugin="counterup" class="entry">0</span></h3>
													<p class="text-muted mb-1 text-truncate"><?=$_["online_users"]?></p>
												</div>
											</div>
										</div>
										<div class="mt-3">
											<h6 class="text-uppercase"><?=$_["total_active"]?> <span class="float-right entry-percentage">0</span></h6>
											<div class="progress progress-sm m-0">
												<div class="progress-bar bg-success" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">
												
													<span class="sr-only">0%</span>
												</div>
											</div>
										</div>
									</div> <!-- end card-box-->
								</div> <!-- end col -->
								
								<div class="col-md-6 col-xl-3">
									<div class="card-box input-flow">
										<div class="row">
											<div class="col-6">
												<div class="avatar-sm bg-soft-primary rounded">
													<i class="fe-trending-down avatar-title font-22 text-primary"></i>
												</div>
											</div>
											<div class="col-6">
												<div class="text-right">
													<h3 class="text-dark my-1"><span data-plugin="counterup" class="entry">0</span> <small>Mbps</small></h3>
													<p class="text-muted mb-1 text-truncate"><?=$_["input_flow"]?></p>
												</div>
											</div>
										</div>
										<div class="mt-3">
											<h6 class="text-uppercase"><?=$_["network_load"]?> <span class="float-right entry-percentage">0%</span></h6>
											<div class="progress progress-sm m-0">											
												<div class="progress-bar bg-primary" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">											
													<span class="sr-only">0%</span>
												</div>
											</div>
										</div>
									</div> <!-- end card-box-->
								</div> <!-- end col -->

								<div class="col-md-6 col-xl-3">
									<div class="card-box output-flow">
										<div class="row">
											<div class="col-6">
												<div class="avatar-sm bg-soft-info rounded">
													<i class="fe-trending-up avatar-title font-22 text-info"></i>
												</div>
											</div>
											<div class="col-6">
												<div class="text-right">
													<h3 class="text-dark my-1"><span data-plugin="counterup" class="entry">0</span> <small>Mbps</small></h3>
													<p class="text-muted mb-1 text-truncate"><?=$_["output_flow"]?></p>
												</div>
											</div>
										</div>
										<div class="mt-3">
											<h6 class="text-uppercase"><?=$_["network_load"]?> <span class="float-right entry-percentage">0%</span></h6>
											<div class="progress progress-sm m-0">
												<div class="progress-bar bg-info" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">
													<span class="sr-only">0%</span>
												</div>
											</div>
										</div>
									</div> <!-- end card-box-->
								</div> <!-- end col -->
								
								<div class="col-md-6 col-xl-3">
									<div class="card-box active-streams">
										<div class="row">
											<div class="col-6">
												<div class="avatar-sm bg-soft-purple rounded">
													<i class="fe-arrow-up-right avatar-title font-22 text-purple"></i>
												</div>
											</div>
											<div class="col-6">
												<a href="javascript:void(0);" onClick="onlineStreams()">
												<div class="text-right">
													<h3 class="text-dark my-1"><span data-plugin="counterup" class="entry">0</span></h3>
													<p class="text-muted mb-1 text-truncate"><?=$_["online_streams"]?></p>
												</div>
												</a>
											</div>
										</div>
										<a href="javascript:void(0);" onClick="offlineStreams()">
										<div class="mt-3">
											<h6 class="text-uppercase"><?=$_["offline_streams"]?> <span class="float-right entry-percentage">0</span></h6>
											<div class="progress progress-sm m-0">
												<div class="progress-bar bg-purple" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">
													<span class="sr-only">0%</span>
												</div>
											</div>
										</div>
										</a>
									</div> <!-- end card-box-->
								</div> <!-- end col -->

								<div class="col-md-6 col-xl-3">
									<div class="card-box cpu-usage">
										<div class="row">
											<div class="col-6">
												<div class="avatar-sm bg-soft-success rounded">
													<i class="fe-cpu avatar-title font-22 text-success"></i>
												</div>
											</div>
											<div class="col-6">
												<div class="text-right">
													<h3 class="text-dark my-1"><span data-plugin="counterup" class="entry">0</span><small>%</small></h3>
													<p class="text-muted mb-1 text-truncate"><?=$_["cpu_usage"]?></p>
												</div>
											</div>
										</div>
										<div class="mt-3">
											<h6 class="text-uppercase">&nbsp;</h6>
											<div class="progress progress-sm m-0">
												<div class="progress-bar bg-success" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">
													<span class="sr-only">0%</span>
												</div>
											</div>
										</div>
									</div> <!-- end card-box-->
								</div> <!-- end col -->

								<div class="col-md-6 col-xl-3">
									<div class="card-box mem-usage">
										<div class="row">
											<div class="col-6">
												<div class="avatar-sm bg-soft-primary rounded">
													<i class="fe-terminal avatar-title font-22 text-primary"></i>
												</div>
											</div>
											<div class="col-6">
												<div class="text-right">
													<h3 class="text-dark my-1"><span data-plugin="counterup" class="entry">0</span><small>%</small></h3>
													<p class="text-muted mb-1 text-truncate"><?=$_["mem_usage"]?></p>
												</div>
											</div>
										</div>
										<div class="mt-3">
											<h6 class="text-uppercase">&nbsp;</h6>
											<div class="progress progress-sm m-0">
												<div class="progress-bar bg-primary" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">
												
													<span class="sr-only">0%</span>
												</div>
											</div>
										</div>
									</div> <!-- end card-box-->
								</div> <!-- end col -->
							   
								<div class="col-md-6 col-xl-3">
									<div class="card-box uptime">
										<div class="row">
											<div class="col-6">
												<div class="avatar-sm bg-soft-info rounded">
													<i class="fe-power avatar-title font-22 text-info"></i>
												</div>
												
											</div>
											<div class="col-6">
												<div class="text-right">
													<h3 class="text-dark my-1 entry">--</h3>
													<p class="text-muted mb-1 text-truncate"><?=$_["system_uptime"]?></p>
												</div>
											</div>
										</div>
										<div class="mt-3">
											<h6 class="text-uppercase">&nbsp;</span></h6>
											<div class="progress-sm m-0"></div>
										</div>
									</div> <!-- end card-box-->
								</div> <!-- end col -->

							</div>
					</div>
				  
				  <?php } ?>
                  
                </div>
              </div>
              <!-- /.card -->
            </div>
          
		  </div>
				
				
                <!-- end row -->
				<?php } ?> 

					
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->		  
		   </div>
		   
		   <div class="col-md-12">
		   <div class="card">
              <div class="card-header">
				<!-- start page title -->
                <h3>Live connection</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">	
						<!-- Main content -->
	<div id="world-map-markers" style="position:relative;">
		<div class="map"></div>
		<div class="stats">
		
            <!-- Widget: user widget style 2 -->
            <div class="card card-widget widget-user-2" style="background-color: #ffffff08;">
              <!-- Add the bg color to the header using any of the bg-* classes -->
              <div class="widget-user-header text-white" style="background-color: #ffffff08;">
                
                <!-- /.widget-user-image -->
                <h5 class="">Statistique</h5>
              </div>
              <div class="card-footer p-0">
                <ul class="nav flex-column">
					<?php if(!empty($mapLegends)){
						foreach($mapLegends as $item){
					?>
						<li class="nav-item">
							<a href="javascript::void(0);" class="nav-link">
								<img src="data:image/png;base64,<?=getCountryFlag($item['valueName'])?>" width="30px">&nbsp;&nbsp;&nbsp; <i style="color: <?=$item['attrs']['fill']?>" class="fa fa-arrow-right"></i> &nbsp; <?=$item['valueName']?> &nbsp;&nbsp;<span class="float-right badge bg- mt-1 text-white" ><?=$item['value']?></span>
							</a>
						</li>
					<?php
						}
						
					}
					?>
                  
                 
				</ul>
              </div>
            </div>
            <!-- /.widget-user -->
          
		<div>
	</div>
</div>
		   
		   </div>
		   </div>
		   </div>
        <!-- /.row -->
		

		
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/jquery-knob/jquery.knob.min.js"></script>
        <script src="../plugins/libs/peity/jquery.peity.min.js"></script>
		<script src="../plugins/libs/apexcharts/apexcharts.min.js"></script>
		
       
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

		 <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
  
  
  <script src="../plugins/js/jquery.number.min.js"></script>
  <script src="../plugins/js/js/app.js"></script>
	<script>
        rServerID = "home";
		rChart = null;
		rDates = null;
		rOptions = null;
        
        function offlineStreams() {
            window.location.href = "../streams/streams.php?filter=2&server=" + window.rServerID;
        }
        
        function onlineStreams() {
            window.location.href = "../streams/streams.php?filter=1&server=" + window.rServerID;
        }
		
        function getStats(auto=true) {
            var rStart = Date.now();
            if (window.rServerID == "home") {
                rURL = "../functions/api_xerox.php?action=stats";
            } else {
                rURL = "../functions/api_xerox.php?action=stats&server_id=" + window.rServerID;
            }
            $.getJSON(rURL, function(data) {// Open Connections
				console.log(data);
                var rCapacity = Math.ceil((data.open_connections / data.total_connections) * 100);
                if (isNaN(rCapacity)) { rCapacity = 0; }
                $('#server_'+window.rServerID).find(".active-connections .entry").html($.number(data.open_connections, 0));
                $('#server_'+window.rServerID).find(".active-connections .entry-percentage").html($.number(data.total_connections, 0));
                $('#server_'+window.rServerID).find(".active-connections .progress-bar").prop("aria-valuenow", rCapacity);
                $('#server_'+window.rServerID).find(".active-connections .progress-bar").css("width", rCapacity.toString() + "%");
                $('#server_'+window.rServerID).find(".active-connections .sr-only").html(rCapacity.toString() + "%");
                // Online Users
                var rCapacity = Math.ceil((data.online_users / data.total_users) * 100);
                if (isNaN(rCapacity)) { rCapacity = 0; }
                $('#server_'+window.rServerID).find('server_'+window.rServerID).find(".online-users .entry").html($.number(data.online_users, 0));
                $('#server_'+window.rServerID).find('server_'+window.rServerID).find(".online-users .entry-percentage").html($.number(data.total_users, 0));
                $('#server_'+window.rServerID).find('server_'+window.rServerID).find(".online-users .progress-bar").prop("aria-valuenow", rCapacity);
                $('#server_'+window.rServerID).find('server_'+window.rServerID).find(".online-users .progress-bar").css("width", rCapacity.toString() + "%");
                $('#server_'+window.rServerID).find('server_'+window.rServerID).find(".online-users .sr-only").html(rCapacity.toString() + "%");
                // Network Load - Input
                var rCapacity = Math.ceil((Math.ceil(data.bytes_received) / data.network_guaranteed_speed) * 100);
                if (isNaN(rCapacity)) { rCapacity = 0; }
                $('#server_'+window.rServerID).find(".input-flow .entry").html($.number(Math.ceil(data.bytes_received), 0));
                $('#server_'+window.rServerID).find(".input-flow .entry-percentage").html(rCapacity.toString() + "%");
                $('#server_'+window.rServerID).find(".input-flow .progress-bar").prop("aria-valuenow", rCapacity);
                $('#server_'+window.rServerID).find(".input-flow .progress-bar").css("width", rCapacity.toString() + "%");
                $('#server_'+window.rServerID).find(".input-flow .sr-only").html(rCapacity.toString() + "%");
                // Network Load - Output
                var rCapacity = Math.ceil((Math.ceil(data.bytes_sent) / data.network_guaranteed_speed) * 100);
                if (isNaN(rCapacity)) { rCapacity = 0; }
                $('#server_'+window.rServerID).find(".output-flow .entry").html($.number(Math.ceil(data.bytes_sent), 0));
                $('#server_'+window.rServerID).find(".output-flow .entry-percentage").html(rCapacity.toString() + "%");
                $('#server_'+window.rServerID).find(".output-flow .progress-bar").prop("aria-valuenow", rCapacity);
                $('#server_'+window.rServerID).find(".output-flow .progress-bar").css("width", rCapacity.toString() + "%");
                $('#server_'+window.rServerID).find(".output-flow .sr-only").html(rCapacity.toString() + "%");
                // Active Streams
                var rCapacity = Math.ceil((data.total_running_streams / (data.offline_streams + data.total_running_streams)) * 100);
                if (isNaN(rCapacity)) { rCapacity = 0; }
                $('#server_'+window.rServerID).find(".active-streams .entry").html($.number(data.total_running_streams, 0));
                $('#server_'+window.rServerID).find(".active-streams .entry-percentage").html($.number(data.offline_streams, 0));
                $('#server_'+window.rServerID).find(".active-streams .progress-bar").prop("aria-valuenow", rCapacity);
                $('#server_'+window.rServerID).find(".active-streams .progress-bar").css("width", rCapacity.toString() + "%");
                $('#server_'+window.rServerID).find(".active-streams .sr-only").html(rCapacity.toString() + "%");
				$(".offline-streams .entry").html($.number(data.offline_streams, 0));
                // CPU Usage
                $('#server_'+window.rServerID).find(".cpu-usage .entry").html(data.cpu);
                $('#server_'+window.rServerID).find(".cpu-usage .entry-percentage").html(data.cpu.toString() + "%");
                $('#server_'+window.rServerID).find(".cpu-usage .progress-bar").prop("aria-valuenow", data.cpu);
                $('#server_'+window.rServerID).find(".cpu-usage .progress-bar").css("width", data.cpu.toString() + "%");
                $('#server_'+window.rServerID).find(".cpu-usage .sr-only").html(data.cpu.toString() + "%");
                // Memory Usage
                $('#server_'+window.rServerID).find(".mem-usage .entry").html(data.mem);
                $('#server_'+window.rServerID).find(".mem-usage .entry-percentage").html(data.mem.toString() + "%");
                $('#server_'+window.rServerID).find(".mem-usage .progress-bar").prop("aria-valuenow", data.mem);
                $('#server_'+window.rServerID).find(".mem-usage .progress-bar").css("width", data.mem.toString() + "%");
                $('#server_'+window.rServerID).find(".mem-usage .sr-only").html(data.mem.toString() + "%");
                // Uptime
				if (data.uptime) {
					$('#server_'+window.rServerID).find(".uptime .entry").html(data.uptime.split(" ").slice(0,2).join(" "));
				}
				// Per Server
				$(data.servers).each(function(i) {
					$("#s_" + data.servers[i].server_id + "_conns").html($.number(data.servers[i].open_connections, 0));
					$("#s_" + data.servers[i].server_id + "_users").html($.number(data.servers[i].online_users, 0));
					$("#s_" + data.servers[i].server_id + "_online").html($.number(data.servers[i].total_running_streams, 0));
					$("#s_" + data.servers[i].server_id + "_input").html($.number(Math.ceil(data.servers[i].bytes_received), 0) + " Mbps");
					$("#s_" + data.servers[i].server_id + "_output").html($.number(Math.ceil(data.servers[i].bytes_sent), 0) + " Mbps");
					$("#s_" + data.servers[i].server_id + "_cpu").val(data.servers[i].cpu).trigger('change');
					$("#s_" + data.servers[i].server_id + "_mem").val(data.servers[i].mem).trigger('change');
					if (data.servers[i].uptime) {
						$("#s_" + data.servers[i].server_id + "_uptime").html(data.servers[i].uptime.split(" ").slice(0,2).join(" "));
					}
				});
                if (auto) {
                    if (Date.now() - rStart < 1000) {
                        setTimeout(getStats, 1000 - (Date.now() - rStart));
                    } else {
                        getStats();
                    }
                }
            }).fail(function() {
                if (auto) {
                    setTimeout(getStats, 1000);
                }
            });
        }
        
        $('.dashboard-tabs .nav-link').on('click', function (e) {
            window.rServerID = $(e.target).data("id");
            getStats(false);
            /*$(".nav-link").each(function() {
                $(this).removeClass("active");
            });*/
            //$(e.target).addClass("active");
            /*if (window.rServerID == "home") {
                if (!$("#server-home").is(":visible")) {
                    $("#server-tab").hide();
                    $("#server-home").show();
                }
            } else {
                if (!$("#server-tab").is(":visible")) {
                    $("#server-home").hide();
                    $("#server-tab").show();
                }
            }*/
        });
		
		<?php if (($rSettings["save_closed_connection"]) && ($rAdminSettings["dashboard_stats"])) { ?>
		function setPeriod(rPeriod) {
			if ((window.rDates[rPeriod][0]) && (window.rDates[rPeriod][1])) {
				window.rOptions["xaxis"]["min"] = window.rDates[rPeriod][0]*1000;
				window.rOptions["xaxis"]["max"] = window.rDates[rPeriod][1]*1000;
				window.rChart.updateOptions(window.rOptions);
				$(".apexcharts-zoom-in-icon").trigger('click');
				$(".apexcharts-zoom-out-icon").trigger('click');
			} else {
				window.rOptions["xaxis"]["min"] = undefined;
				window.rOptions["xaxis"]["max"] = undefined;
				window.rChart.updateOptions(window.rOptions);
			}
		}
        
		function getChart() {
			rURL = "../functions/api_xerox.php?action=chart_stats";
			$.getJSON(rURL, function(rStatistics) {
				window.rDates = rStatistics["dates"];
				window.rOptions = {
					chart: {
						height: 380,
						type: "area",
						stacked: false,
						zoom: {
							type: 'x',
							enabled: true,
							autoScaleYaxis: true
						}
					},
					colors: ["#56c2d6"],
					dataLabels: {
						enabled: false
					},
					stroke: {
						width: [2],
						curve: "smooth"
					},
					series: [{
						name: "Open Connections",
						data: rStatistics["data"]["conns"]
					}],
					fill: {
						type: "gradient", 
						gradient: {
							opacityFrom: .6,
							opacityTo: .8
						}
					},
					xaxis: {
						type: "datetime",
						min: window.rDates['day'][0]*1000,
						max: window.rDates['day'][1]*1000
					},
					tooltip: {
					  y: {
						formatter: function(value, { series, seriesIndex, dataPointIndex, w }) {
						  return parseInt(value)
						}
					  }
					}
				};
				(window.rChart = new ApexCharts(document.querySelector("#statistics"), window.rOptions)).render();
				$(".apexcharts-zoom-in-icon").trigger('click');
				$(".apexcharts-zoom-out-icon").trigger('click');
			});
		}
		<?php } ?>
        $(document).ready(function() {
            getStats();
			<?php if (($rSettings["save_closed_connection"]) && ($rAdminSettings["dashboard_stats"])) { ?>
			getChart();
			<?php } ?>
        });
        </script>
    
	
<script src="../plugins/jquery-mousewheel/jquery.mousewheel.js"></script>
<script src="../plugins/raphael/raphael.min.js"></script>
<script src="../plugins/jquery-mapael/jquery.mapael.min.js"></script>
<script src="../plugins/jquery-mapael/maps/world_countries.js"></script>

<script>
	var areas = jQuery.parseJSON ('<?php echo json_encode($mapLegends); ?>');
	console.log(areas);
	$('#world-map-markers').mapael({
    map: {
      name: 'world_countries',
      zoom: {
        enabled: true,
        maxLevel: 10
      }
    },
	  areas: areas  ,      
  })

</script>
	
	 