<?php 
require('../layout/header.php');

$logOpen = "menu-open";
$logActive = "active";
require('../layout/header_html.php');
?>


  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Recent Activity</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Logs</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Recent Activity</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
			  <div class="row" style="margin-top: 2rem;">
				<div class="col-md-12">
					<div class="timeline">
						 <?php 
                          if($_SESSION['admin'] == 0){
                                  $rResult = $db->query("SELECT `u`.`username`, `r`.`owner`, `r`.`date`, `r`.`type` FROM `reg_userlog` AS `r` INNER JOIN `reg_users` AS `u` ON `r`.`owner` = `u`.`id` WHERE `r`.`owner` IN (".join(",", array_keys(getRegisteredUsers($_SESSION["id"]))).") ORDER BY `r`.`date` DESC LIMIT 1000;");
                                }
                          if($_SESSION['admin'] == 1){
                            $rResult = $db->query("SELECT `u`.`username`, `r`.`owner`, `r`.`date`, `r`.`type` FROM `reg_userlog` AS `r` INNER JOIN `reg_users` AS `u` ON `r`.`owner` = `u`.`id` ORDER BY `r`.`date` DESC LIMIT 1000;");
                          }
                                  if (($rResult) && ($rResult->num_rows > 0)) {
                                      while ($rRow = $rResult->fetch_assoc()) { 
                                        
                         ?>
						<div>
							<i class="fas fa-user bg-green"></i>
							<div class="timeline-item">
							  <span class="time"><i class="fas fa-clock"></i> <?=date("Y-m-d H:i:s", $rRow["date"])?></span>
							  <h3 class="timeline-header no-border"><a href="javascript:void(0)"><?=$rRow["username"]?></a> <?=$rRow["type"]?></h3>
							</div>
						</div>
						
						<?php }
                        } ?>
					 </div>
				</div>
			  </div>
			  
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
<?php 
	include("../layout/footer.php");
?>
