<?php 
require("../layout/header.php");
if($_SESSION['admin'] != 1){
	echo'<script>window.location.href = "../home/dashboard.php?msg=notAllowed";</script>';
}
$rqtBouquet = "SELECT bouquets.id, bouquet_name, BD.is_adult FROM bouquets 
		LEFT JOIN panel.bouquets_details AS BD ON BD.bouquet_id = bouquets.id
	WHERE bouquet_name NOT LIKE 'DONT%' AND bouquet_name != '.' ORDER BY bouquets.id ASC";
    $stmtBouquet = $pdo->prepare($rqtBouquet);
    $stmtBouquet->execute();
    $rsBouquet = $stmtBouquet->fetchAll(PDO::FETCH_ASSOC);

$packageOpen = "menu-open";
$packageActive = "active";	
 
include('../layout/header_html.php');
?>

<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  <!--<link rel="stylesheet" href="https://cdn.datatables.net/1.10.23/css/jquery.dataTables.min.css">-->
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- Bootstrap4 Duallistbox -->
  <link rel="stylesheet" href="../plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Packages </h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Packages list</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header">
                <h3 class="card-title">Packages</h3>
              </div>
              <!-- /.card-header -->
				<div class="card-body">
					<form id="quickForm" method="post" action="store.php">
						<div class="row">
						
							<div class="col-md-6">							
								<div class="card card-danger">
								  <div class="card-header">
									<h3 class="card-title">Packages details</h3>
								  </div>
								  <div class="card-body">
									<div class="form-group">
									<label>Name</label>
									<input type="text" class="form-control" id="name" name="name" required>
								</div>
								<div class="form-group">
									<label>Max connections</label>
									<input type="number" min="1" value="1" class="form-control" id="max_connexion" name="max_connexion" required>
								</div>
								<div class="row">
									<div class="col-sm-3">
										<label>type</label>
										<div class="form-check">
										  <input class="form-check-input" type="checkbox" name="is_trial" checked="">
										  <label class="form-check-label">Is trial</label>
										</div>
									</div>
									<div class="col-sm-3">
										<label>Credits</label>
										<input type="number" min="0" step="0.1"  class="form-control" id="credit" name="credit" value="0">
									</div>
									<div class="col-sm-3">
										<label>Duration</label>
										<input type="number" min="0" class="form-control" id="duration" name="duration" value="0">
									</div>
									<div class="col-sm-3">
										<label>Duration type</label>
										<select class="form-control select2" name="type" id="type" style="width: 100%;">
											<option value="years">Years</option>
											<option selected value="Months">Months</option>
											<option value="Days">Days</option>
											<option value="hours">Hours</option>
										</select>
									</div>
								</div>
							
								  </div>
								  <!-- /.card-body -->
								</div>
								
							</div>
							
							
							<div class="col-md-6">	
								<div class="card card-danger">
								  <div class="card-header">
									<h3 class="card-title">Member groups</h3>
								  </div>
								  <div class="card-body">
									<div class="form-group">
								  <select class="duallistbox" name="grouptouse[]" multiple="multiple" id="keepRenderingSort_Groups" >
										<?php
											$result = getMembersGroup();
											if(!empty($result)){
												foreach($result as $row){ ?>
													<option value="<?=$row['group_id']; ?>"><?=$row['group_name']; ?></option>
											<?php }
											}
										?>
								  </select>
								</div>
								
							
								  </div>
								  <!-- /.card-body -->
								</div>
								
							</div>
							<div class="col-md-12">	
								<div class="card card-danger">
								  <div class="card-header">
									<h3 class="card-title">Bouquet management</h3>
								  </div>
								  <div class="card-body">
									<div class="form-group">
								  <select class="duallistbox" name="toUse[]" multiple="multiple" id="keepRenderingSort_to" >
									
										<?php
											if(!empty($rsBouquet)){
												foreach($rsBouquet as $row){ ?>
													<option value="<?=$row['id']; ?>" ><?=$row['bouquet_name']; ?></option>
											<?php }
											}
										?>
								  </select>
								</div>
							
								  </div>
								   <!-- /.card-body -->
									<div class="card-footer">
									  <button type="submit" class="btn btn-primary">Submit</button>
									</div>
								</div>							
								
							</div>
						</div>		
               
					</form>
				</div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
 
	
<?php 
	include("../layout/footer.php");
	include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
<!-- Bootstrap4 Duallistbox -->
<script src="../plugins/bootstrap4-duallistbox/jquery.bootstrap-duallistbox.min.js"></script>
  <script>
 


$(document).ready(function(){
	
		/*$.ajax({
            url: '../user/bouquet_editor.php',
            type: 'post',
            data: {
                bouquets: []
            },
            success: function (response) {
				//Bootstrap Duallistbox
				$('.duallistbox').bootstrapDualListbox({
					nonSelectedListLabel: 'Non-selected',
					selectedListLabel: 'Selected',
				})
                $("#keepRenderingSort_to").children().remove().end()
                
                response = JSON.parse(response)
				console.log(response);
				
				response['out'].forEach(element => {
                    $('#keepRenderingSort_to').append(element);
                })
                response['in'].forEach(element => {
                    $('#keepRenderingSort_to').append(element);
                })
                
				//Bootstrap Duallistbox
				$('.duallistbox').bootstrapDualListbox('refresh', true)
                
            }
        })*/
		$('.duallistbox').bootstrapDualListbox({
					nonSelectedListLabel: 'Non-selected',
					selectedListLabel: 'Selected',
				})
		
				
})

</script>

</body>
</html>