<?php 
//require("../layout/header.php");
require('../includes/inc_db.php');
include "../functions/functions_xerox.php";

$rCategories = getCategories("radio");

$radioOpen = "menu-open";
$radioActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
   
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
		
		<style>
			.dd-list .dd-item .dd-handle {
				background: #f1f5f7;
				border: none;
				padding: 8px 16px;
				height: auto;
				font-weight: 500;
				border-radius: 3px;
				font-size: x-large;
			}
			.dd-list .dd3-handle {
				margin: 0;
				height: 36px!important;
				float: left;
			}
			.dd-list .dd3-content {
				height: auto;
				border: none;
				padding: 8px 16px 8px 46px;
				background: #f1f5f7;
				font-weight: 600;
			}
			.dd-list .dd3-handle:before {
				content: "=";
				font-family: "Material Design Icons";
				color: #adb5bd;
			}


			
		</style>	
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Radio </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;">
					<li>
                        <a href="#" onClick="clearFilters();">
                            <button type="button" class="btn btn-warning waves-effect waves-light btn-sm">
                                <i class="fa fa-filter"></i>
                            </button>
                        </a>
                        <a href="#" onClick="changeZoom();">
                            <button type="button" class="btn btn-info waves-effect waves-light btn-sm">
                                <i class="fa fa-search"></i>
                            </button>
                        </a>
                        <?php if (!$detect->isMobile()) { ?>
                        <a href="#" onClick="toggleAuto();">
                            <button type="button" class="btn btn-dark waves-effect waves-light btn-sm">
                                <span class="auto-text"><i class="fa fa-sync-alt"></i>  Auto-Refresh</span>
                            </button>
                        </a>
                        <?php } else { ?>
                        <a href="javascript:location.reload();" onClick="toggleAuto();">
                            <button type="button" class="btn btn-dark waves-effect waves-light btn-sm">
                                <i class="fa fa-sync-alt"></i> Refresh
                            </button>
                        </a>
                        <?php }
                        if (($rPermissions["is_admin"]) && (hasPermissions("adv", "add_radio"))) { ?>
                        <a href="radio.php">
                            <button type="button" class="btn btn-success waves-effect waves-light btn-sm">
                                <i class="fa fa-plus"></i> Add Station
                            </button>
                        </a>
                        <?php } ?>
                    </li>
            </ol>
				
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9">Radio Stations</h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
			
					 <form id="station_form">
                                    <div class="form-group row mb-4">
                                        <?php if ($rPermissions["is_reseller"]) { ?>
                                        <div class="col-md-3">
                                            <input type="text" class="form-control" id="station_search" value="" placeholder="Search Stations...">
                                        </div>
                                        <div class="col-md-3">
                                            <select id="station_category_id" class="form-control" data-toggle="select2">
                                                <option value="" selected>All Categories</option>
                                                <?php foreach ($rCategories as $rCategory) { ?>
                                                <option value="<?=$rCategory["id"]?>"<?php if ((isset($_GET["category"])) && ($_GET["category"] == $rCategory["id"])) { echo " selected"; } ?>><?=$rCategory["category_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-3">
                                            <select id="station_server_id" class="form-control" data-toggle="select2">
                                                <option value="" selected>All Servers</option>
                                                <?php foreach (getStreamingServers() as $rServer) { ?>
                                                <option value="<?=$rServer["id"]?>"<?php if ((isset($_GET["server"])) && ($_GET["server"] == $rServer["id"])) { echo " selected"; } ?>><?=$rServer["server_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <label class="col-md-1 col-form-label text-center" for="station_show_entries">Show</label>
                                        <div class="col-md-2">
                                            <select id="station_show_entries" class="form-control" data-toggle="select2">
                                                <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo " selected"; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <?php } else { ?>
                                        <div class="col-md-2">
                                            <input type="text" class="form-control" id="station_search" value="" placeholder="Search Streams...">
                                        </div>
                                        <div class="col-md-3">
                                            <select id="station_server_id" class="form-control" data-toggle="select2">
                                                <option value="" selected>All Servers</option>
                                                <?php foreach (getStreamingServers() as $rServer) { ?>
                                                <option value="<?=$rServer["id"]?>"<?php if ((isset($_GET["server"])) && ($_GET["server"] == $rServer["id"])) { echo " selected"; } ?>><?=$rServer["server_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-3">
                                            <select id="station_category_id" class="form-control" data-toggle="select2">
                                                <option value="" selected>All Categories</option>
                                                <?php foreach ($rCategories as $rCategory) { ?>
                                                <option value="<?=$rCategory["id"]?>"<?php if ((isset($_GET["category"])) && ($_GET["category"] == $rCategory["id"])) { echo " selected"; } ?>><?=$rCategory["category_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-2">
                                            <select id="station_filter" class="form-control" data-toggle="select2">
                                                <option value=""<?php if (!isset($_GET["filter"])) { echo " selected"; } ?>>No Filter</option>
                                                <option value="1"<?php if ((isset($_GET["filter"])) && ($_GET["filter"] == 1)) { echo " selected"; } ?>>Online</option>
                                                <option value="2"<?php if ((isset($_GET["filter"])) && ($_GET["filter"] == 2)) { echo " selected"; } ?>>Down</option>
                                                <option value="3"<?php if ((isset($_GET["filter"])) && ($_GET["filter"] == 3)) { echo " selected"; } ?>>Stopped</option>
                                                <option value="4"<?php if ((isset($_GET["filter"])) && ($_GET["filter"] == 4)) { echo " selected"; } ?>>Starting</option>
                                                <option value="5"<?php if ((isset($_GET["filter"])) && ($_GET["filter"] == 5)) { echo " selected"; } ?>>On Demand</option>
                                                <option value="6"<?php if ((isset($_GET["filter"])) && ($_GET["filter"] == 6)) { echo " selected"; } ?>>Direct</option>
                                            </select>
                                        </div>
                                        <label class="col-md-1 col-form-label text-center" for="station_show_entries">Show</label>
                                        <div class="col-md-1">
                                            <select id="station_show_entries" class="form-control" data-toggle="select2">
                                                <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo " selected"; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <?php } ?>
                                    </div>
                                </form>
                                <table id="datatable-streampage" class="table dt-responsive nowrap font-normal">
                                    <thead>
                                        <tr>
                                            <th class="text-center">ID</th>
                                            <th>Name</th>
                                            <th>Source</th>
                                            <?php if ($rPermissions["is_admin"]) { ?>
                                            <th class="text-center">Clients</th>
                                            <th class="text-center">Uptime</th>
                                            <th class="text-center">Actions</th>
                                            <?php } ?>
                                            <th class="text-center">Stream Info</th>
                                        </tr>
                                    </thead>
                                    <tbody></tbody>
                                </table>
								
				
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
		 <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
  
     
        <script>
        var autoRefresh = true;
        var rClearing = false;
        
        function toggleAuto() {
            if (autoRefresh == true) {
                autoRefresh = false;
                $(".auto-text").html("Manual Mode");
            } else {
                autoRefresh = true;
                $(".auto-text").html("Auto-Refresh");
            }
        }
        
        function api(rID, rServerID, rType) {
            if (rType == "delete") {
                if (confirm('Are you sure you want to delete this station?') == false) {
                    return;
                }
            }
            $.getJSON("../functions/api_xerox.php?action=stream&sub=" + rType + "&stream_id=" + rID + "&server_id=" + rServerID, function(data) {
                if (data.result == true) {
                    if (rType == "start") {
                        $.toast("Station successfully started. It will take a minute or so before the station becomes available.");
                    } else if (rType == "stop") {
                        $.toast("Station successfully stopped.");
                    } else if (rType == "restart") {
                        $.toast("Station successfully restarted. It will take a minute or so before the station becomes available.");
                    } else if (rType == "delete") {
                        $.toast("Station successfully deleted.");
                    }
                    $.each($('.tooltip'), function (index, element) {
                        $(this).remove();
                    });
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                } else {
                    $.toast("An error occured while processing your request.");
                }
            }).fail(function() {
                $.toast("An error occured while processing your request.");
            });
        }
        function reloadStreams() {
            if (autoRefresh == true) {
                $('[data-toggle="tooltip"]').tooltip("hide");
                $("#datatable-streampage").DataTable().ajax.reload( null, false );
            }
            setTimeout(reloadStreams, 5000);
        }

        function getCategory() {
            return $("#station_category_id").val();
        }
        function getFilter() {
            return $("#station_filter").val();
        }
        function getServer() {
            return $("#station_server_id").val();
        }
        function changeZoom() {
            if ($("#datatable-streampage").hasClass("font-large")) {
                $("#datatable-streampage").removeClass("font-large");
                $("#datatable-streampage").addClass("font-normal");
            } else if ($("#datatable-streampage").hasClass("font-normal")) {
                $("#datatable-streampage").removeClass("font-normal");
                $("#datatable-streampage").addClass("font-small");
            } else {
                $("#datatable-streampage").removeClass("font-small");
                $("#datatable-streampage").addClass("font-large");
            }
            $("#datatable-streampage").draw();
        }
        function clearFilters() {
            window.rClearing = true;
            $("#station_search").val("").trigger('change');
            $('#station_filter').val("").trigger('change');
            $('#station_server_id').val("").trigger('change');
            $('#station_category_id').val("").trigger('change');
            $('#station_show_entries').val("<?=$rAdminSettings["default_entries"] ?: 10?>").trigger('change');
            window.rClearing = false;
            $('#datatable-streampage').DataTable().search($("#station_search").val());
            $('#datatable-streampage').DataTable().page.len($('#station_show_entries').val());
            $("#datatable-streampage").DataTable().page(0).draw('page');
            $('[data-toggle="tooltip"]').tooltip("hide");
            $("#datatable-streampage").DataTable().ajax.reload( null, false );
        }
        $(document).ready(function() {
			$(window).keypress(function(event){
				if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
			});
            
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            $("#datatable-streampage").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                    $('[data-toggle="tooltip"]').tooltip();
                },
                createdRow: function(row, data, index) {
                    $(row).addClass('stream-' + data[0]);
                },
                responsive: true,
                processing: true,
                serverSide: true,
                ajax: {
                    url: "../functions/table_search.php",
                    "data": function(d) {
                        d.id = "radios",
                        d.category = getCategory();
                        <?php if ($rPermissions["is_admin"]) { ?>
                        d.filter = getFilter();
                        <?php } else { ?>
                        d.filter = 1;
                        <?php } ?>
                        d.server = getServer();
                    }
                },
                columnDefs: [
                    <?php if ($rPermissions["is_admin"]) { ?>
                    {"className": "dt-center", "targets": [0,3,4,5,6]},
                    {"orderable": false, "targets": [5]}
                    <?php } else { ?>
                    {"className": "dt-center", "targets": [0,3]}
                    <?php } ?>
                ],
                order: [[ 0, "desc" ]],
                pageLength: <?=$rAdminSettings["default_entries"] ?: 10?>,
                lengthMenu: [10, 25, 50, 250, 500, 1000],
                stateSave: true
            });
            $("#datatable-streampage").css("width", "100%");
            $('#station_search').keyup(function(){
                if (!window.rClearing) {
                    $('#datatable-streampage').DataTable().search($(this).val()).draw();
                }
            })
            $('#station_show_entries').change(function(){
                if (!window.rClearing) {
                    $('#datatable-streampage').DataTable().page.len($(this).val()).draw();
                }
            })
            $('#station_category_id').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            $('#station_server_id').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            $('#station_filter').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            <?php if (!$detect->isMobile()) { ?>
            setTimeout(reloadStreams, 5000);
            <?php }
            if (!$rAdminSettings["auto_refresh"]) { ?>
            toggleAuto();
            <?php } ?>
            if ($('#station_search').val().length > 0) {
                $('#datatable-streampage').DataTable().search($('#station_search').val()).draw();
            }
        });
        
        </script>
    