<?php 
//require("../layout/header.php");

require('../includes/inc_db.php');
include "../functions/functions_xerox.php";



$resellerOpen = "menu-open";
$resellerActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
   
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
 
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1><?=$_["groups"]?> </h1>
          </div>
          <div class="col-sm-8">
          <?php if (hasPermissions("adv", "add_group")) { ?>
			<ol class="breadcrumb m-0" style="float: right;"> 
					 <li>
                                        <a href="group.php" style="margin-right:10px;">
                                            <button type="button" class="btn btn-success waves-effect waves-light btn-sm">
                                                <i class="fa fa-plus"></i> <?=$_["add_group"]?>
                                            </button>
                                        </a>
                                    </li>
             </ol>
         
							<?php } ?>
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?=$_["groups"]?></h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
					
					
                <div class="row">
                    <div class="col-12">
                        <div class="card">
                            <div class="card-body" style="overflow-x:auto;">
                                <table id="datatable" class="table dt-responsive nowrap">
                                    <thead>
                                        <tr>
                                            <th class="text-center"><?=$_["id"]?></th>
                                            <th><?=$_["group_name"]?></th>
                                            <th class="text-center"><?=$_["is_admin"]?></th>
                                            <th class="text-center"><?=$_["is_reseller"]?></th>
                                            <th class="text-center"><?=$_["is_banned"]?></th>
                                            <th class="text-center"><?=$_["actions"]?></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <?php foreach (getMemberGroups() as $rGroup) { ?>
                                        <tr id="group-<?=$rGroup["group_id"]?>">
                                            <td class="text-center"><?=$rGroup["group_id"]?></td>
                                            <td><?=$rGroup["group_name"]?></td>
                                            <td class="text-center">
                                                <div class="custom-control custom-checkbox mt-1">
                                                    <input disabled data-id="<?=$rGroup["group_id"]?>" data-name="is_admin" type="checkbox" class="custom-control-input" id="is_admin_<?=$rGroup["group_id"]?>" name="is_admin"<?php if ($rGroup["is_admin"]) { echo " checked"; } ?>>
                                                    <label class="custom-control-label" for="(is_admin_<?=$rGroup["group_id"]?>"></label>
                                                </div>
                                            </td>
                                            <td class="text-center">
                                                <div class="custom-control custom-checkbox mt-1">
                                                    <input disabled data-id="<?=$rGroup["group_id"]?>" data-name="is_reseller" type="checkbox" class="custom-control-input" id="is_reseller_<?=$rGroup["group_id"]?>" name="is_reseller"<?php if ($rGroup["is_reseller"]) { echo " checked"; } ?>>
                                                    <label class="custom-control-label" for="is_reseller_<?=$rGroup["group_id"]?>"></label>
                                                </div>
                                            </td>
                                            <td class="text-center">
                                                <div class="custom-control custom-checkbox mt-1">
                                                    <input disabled data-id="<?=$rGroup["group_id"]?>" data-name="is_banned" type="checkbox" class="custom-control-input" id="is_banned_<?=$rGroup["group_id"]?>" name="is_banned"<?php if ($rGroup["is_banned"]) { echo " checked"; } ?>>
                                                    <label class="custom-control-label" for="is_banned_<?=$rGroup["group_id"]?>"></label>
                                                </div>
                                            </td>
                                            <td class="text-center">
                                                <div class="btn-group">
                                                    <?php if (hasPermissions("adv", "edit_group")) { ?>
                                                    <a href="./group.php?id=<?=$rGroup["group_id"]?>"><button type="button" data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["edit_group"]?>" class="btn btn-light waves-effect waves-light btn-xs"><i class="fa fa-pencil-alt"></i></button></a>
                                                    <?php if ($rGroup["can_delete"]) { ?>
                                                    <button type="button" data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["delete_group"]?>" class="btn btn-light waves-effect waves-light btn-xs" onClick="api(<?=$rGroup["group_id"]?>, 'delete');"><i class="fa fa-times"></i></button>
                                                    <?php }
                                                    } ?>
                                                </div>
                                            </td>
                                        </tr>
                                        <?php } ?>
                                    </tbody>
                                </table>
                            </div> <!-- end card body-->
                        </div> <!-- end card -->
                    </div><!-- end col-->
                </div>
					
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
   
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
		 <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
     
        <script>
        function api(rID, rType) {
            if (rType == "delete") {
                if (confirm('<?=$_["group_delete_confirm"]?>') == false) {
                    return;
                }
            }
            $.getJSON("..functions//api_xerox.php?action=group&sub=" + rType + "&group_id=" + rID, function(data) {
                if (data.result === true) {
                    if (rType == "delete") {
                        $("#group-" + rID).remove();
                        $.toast("<?=$_["group_deleted"]?>");
                    }
                    $.each($('.tooltip'), function (index, element) {
                        $(this).remove();
                    });
                    $('[data-toggle="tooltip"]').tooltip();
                } else {
                    $.toast("<?=$_["error_occured"]?>");
                }
            });
        }
        $(document).ready(function() {
            $("#datatable").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                },
                responsive: false,
                paging: false,
                bInfo: false
            });
            $("#datatable").css("width", "100%");
        });
        </script>

    