<?php
	
try{	
	//header('Content-type: application/json; charset=UTF-8');
	//header('Content-type: multipart/form-data;');
	error_reporting(32767);
	ini_set('display_errors', 0);
	$hashkey = "DW5vqW58D";
	$dns = "http://s16tv.co:80";
	include 'config.php';
	
	$pdoPanel = DBcnx();
	$content = file_get_contents('php://input');
	$_POST['json2'] = str_replace('json=', '', $content);

	if (isset($_POST['json'])) {
		$json = $_POST['json'];	
		$json = str_replace(['!', ')', '('], ['+', '/', '='], $json);
		$json = base64_decode($json);
		
		$json = xorIt($json, $hashkey, 1);
	}
	else { 
		$res = [
						"status" => 99,
						"message" =>  "Server is down, please try again later.",
						"expire" => "0 days",
						"user_agent" => $_SERVER['HTTP_USER_AGENT'],
						"osd" => @$json['osd_test'],
						"code_id" => ''
					]; 
	}
	
    //file_put_contents('log.txt', $json . PHP_EOL, FILE_APPEND);
	$json = json_decode($json, true);	
	if(!is_array($json)){
		$res = [
					"status" => 99,
					"message" =>  "Server is down, please try again later.",
					"expire" => "0 days",
					"user_agent" => $_SERVER['HTTP_USER_AGENT'],
						"osd" => @$json['osd_test'],
					"code_id" => ''
				];
	}
	
	$mode = trim(htmlspecialchars(strip_tags($json['mode'])));
	$userCode = trim(htmlspecialchars(strip_tags($json['code'])));
	$mac = trim(htmlspecialchars(strip_tags($json['mac'])));
	$serial = trim(htmlspecialchars(strip_tags($json['sn'])));
	$chipid = trim(htmlspecialchars(strip_tags($json['chipid'])));
	
	$res = [];
	switch ($mode) {
		case "active":
			$res = activate($userCode, $mac, $serial);
			break;
		case "category":
			$cat_type = trim(htmlspecialchars(strip_tags($json['cat_type'])));
			$res = getLives($cat_type);
			
			break;
		case 'channel':
			$checkMacSerial = checkMacSerial($mac, $serial);
			if(empty($checkMacSerial)){						
				$res =	[
					"status" => 99,
					"message" =>  "Server is down, please try again later.",
					"expire" => "0 days",
					"user_agent" => $_SERVER['HTTP_USER_AGENT'],
						"osd" => @$json['osd_test'],
					"code_id" => $userCode
				];
			}
			else{
				$bouquet = trim(htmlspecialchars(strip_tags($json['cat_id'])));
				$lenght = trim(htmlspecialchars(strip_tags($json['lenght'])));
				$from = trim(htmlspecialchars(strip_tags($json['from'])));
				$channels = getChannelBouquet($bouquet, $lenght, $from);
				$res = [];
					if(!empty($channels)){
						foreach($channels as $item){
							//$details = json_decode($item['url'], true);	
							$url = $dns."/".$checkMacSerial[0]['username'].'/'.$checkMacSerial[0]['password'].'/'.$item['id'];
							$item['url'] = $url;							
							$res[] = $item;
						}
					}
			}
			break;
		case 'movie':
			
			$checkMacSerial = checkMacSerial($mac, $serial);
			if(empty($checkMacSerial)){						
				$res = [
					"status" => 99,
					"message" =>  "Server is down, please try again later.",
					"expire" => "0 days",
					"user_agent" => $_SERVER['HTTP_USER_AGENT'],
						"osd" => @$json['osd_test'],
					"code_id" => $userCode
				];
			}
			else{
				if (array_key_exists("cat_id",$json)){
					$cat_id = trim(htmlspecialchars(strip_tags($json['cat_id'])));
					$lenght = trim(htmlspecialchars(strip_tags($json['lenght'])));
					$from = trim(htmlspecialchars(strip_tags($json['from'])));
					$movies = getMovies($cat_id, $lenght, $from);
					$res = [];
					if(!empty($movies)){
						foreach($movies as $item){
							$details = json_decode($item['movie_propeties'], true);
							
							$arr = [
								'id' => $item['id'],
								'name' => $item['stream_display_name'],
								'category_id' => $item['category_id'],
								'logo' => @$details['movie_image'],
								'order' => $item['order'],
								'genre' => str_replace(', ', '/', @$details['genre']),
								'year' => date('Y', strtotime(@$details['releasedate'])),
								'date' => @$details['releasedate'],
								'rate' => @$details['rating'],
								'order' => $item['order'],
							];
							
							$res[] = $arr;
						}
					}
			
				}
				else{
					$id = trim(htmlspecialchars(strip_tags($json['id'])));
					$info = getMovieInfo($id);
					if(!empty($info)){
						foreach($info as $item){
							$details = json_decode($item['movie_propeties'], true);							
							//$url = json_decode($item['stream_source'], true);		
							$format = json_decode($item['target_container'], true);
							$url = $dns."/movie/".$checkMacSerial[0]['username'].'/'.$checkMacSerial[0]['password'].'/'.$item['id'].'.'.@$format[0];
											
							$res = [
								'id' => $item['id'],
								'name' => $item['stream_display_name'],
								'category_id' => $item['category_id'],
								'logo' => @$details['movie_image'],
								'genre' => str_replace(', ', '/', @$details['genre']),
								'year' => date('Y', strtotime(@$details['releasedate'])),
								'date' => @$details['releasedate'],
								'rate' => @$details['rating'],
								'actors' => str_replace(', ', '/', @$details['actors']),
								'url' => $url,
								'trailerLink' => @$details['youtube_trailer'],
								'description' => @$details['description'],
								'order' => $item['order'],
							];
							
						}
					}
				}
				
			}
			
			
			break;
			
		case 'series':
			
			$checkMacSerial = checkMacSerial($mac, $serial);
			if(empty($checkMacSerial)){						
				$res =	[
					"status" => 99,
					"message" =>  "Server is down, please try again later.",
					"expire" => "0 days",
					"user_agent" => $_SERVER['HTTP_USER_AGENT'],
						"osd" => @$json['osd_test'],
					"code_id" => $userCode
				];
			}
			else{
				if (array_key_exists("cat_id",$json)){
					$cat_id = trim(htmlspecialchars(strip_tags($json['cat_id'])));
					$lenght = trim(htmlspecialchars(strip_tags($json['lenght'])));
					$from = trim(htmlspecialchars(strip_tags($json['from'])));
					$movies = getSeries($cat_id, $lenght, $from);
					$res = [];
					if(!empty($movies)){
						foreach($movies as $item){							
							$arr = [
								'id' => $item['id'],
								'name' => $item['title'],
								'category_id' => $item['category_id'],
								'logo' => $item['cover'],
								'order' => $item['order'],
								'genre' => str_replace(', ', '/', $item['genre']),
								'year' => date('Y', strtotime($item['releaseDate'])),
								'date' => $item['releaseDate'],
							];
							
							$res[] = $arr;
						}
					}
			
				}
				
				
			}
			break;
		case 'episode':
			$checkMacSerial = checkMacSerial($mac, $serial);
			if(empty($checkMacSerial)){						
				$res =	[
					"status" => 99,
					"message" =>  "Server is down, please try again later.",
					"expire" => "0 days",
					"user_agent" => $_SERVER['HTTP_USER_AGENT'],
						"osd" => @$json['osd_test'],
					"code_id" => $userCode
				];
			}
			else{
				$series_id = trim(htmlspecialchars(strip_tags($json['series_id'])));			
				$episodes = getSerieEpisode($series_id);
				$res = [];
				if(!empty($episodes)){
					foreach($episodes as $item){	
						$format = json_decode($item['target_container'], true);
						$url = $dns."/series/".$checkMacSerial[0]['username'].'/'.$checkMacSerial[0]['password'].'/'.$item['id'].'.'.@$format[0];
						$arr = [
							'id' => $item['id'],
							'name' => $item['stream_display_name'],
							'order' => $item['sort'],
							'season' => $item['season_num'],
							'url' => $url,
						];
						
						$res[] = $arr;
					}
				}
				
			}
			break;
		default:
			$res = [
					"status" => 99,
					"message" =>  "Server is down, please try again later.",
					"expire" => "0 days",
					"user_agent" => $_SERVER['HTTP_USER_AGENT'],
						"osd" => @$json['osd_test'],
					"code_id" => $userCode
				];
	}
	
	$json_crypted = xorIt(json_encode($res), $hashkey, 0);	
	die(base64_encode($json_crypted));
	
	die(json_encode($res));
		 
		
}catch(Exception $e){
	//die($e->getMessage());
	$res = [
					"status" => 99,
					"message" =>  "Server is down, please try again later.",
					"expire" => "0 days",
					"user_agent" => $_SERVER['HTTP_USER_AGENT'],
						"osd" => "",
					"code_id" => $userCode
				];
	$json_crypted = xorIt(json_encode($res), $hashkey, 0);
	
	die(base64_encode($json_crypted));
}

