<?php 
require('../layout/header.php');

if($_POST){
	try{
    $trouble = "";
    $sqlTicket = "INSERT INTO tickets(member_id,title,status,admin_read,user_read) VALUES(:member_id,:title,1,0,1)";
    $sqlTicketExtra = "INSERT INTO ticket_extra(ticket_id, step1, step2, step3,step4) VALUES(:ticket, :step1, :step2, :step3, :step4)";
    $sqlInfoTicket = "INSERT INTO tickets_replies(ticket_id,admin_reply,message,date) VALUES(:tId,0,:message,UNIX_TIMESTAMP())";
    $member_id = $_SESSION['id'];
    $message = trim($_POST['message']);
    $title = trim($_POST['title']);
    $step1 = (isset($_POST['step1']))?$_POST['step1']:'';
    $step2 = (isset($_POST['step2']))?$_POST['step2']:'';
    $step3 = (isset($_POST['step3']))?$_POST['step3']:'';
    $step4 = (isset($_POST['step4']))?$_POST['step4']:'';
	
    $stmtTicket = $pdo->prepare($sqlTicket);
    $stmtInfoTicket = $pdo->prepare($sqlInfoTicket);
    $stmtTicket->bindParam(":member_id",$member_id);
    $stmtTicket->bindParam(":title",$title);
	
    if($stmtTicket->execute()){
        $lastId = $pdo->lastInsertId();
		
		$stmtTicket = $pdoPanel->prepare($sqlTicketExtra);
		$stmtTicket->bindParam(":ticket",$lastId);
		$stmtTicket->bindParam(":step1",$step1);
		$stmtTicket->bindParam(":step2",$step2);
		$stmtTicket->bindParam(":step3",$step3);
		$stmtTicket->bindParam(":step4",$step4);
		$stmtTicket->execute();
		
        $stmtInfoTicket->bindParam(":tId",$lastId);
        $stmtInfoTicket->bindParam(":message",$message);
        if($stmtInfoTicket->execute()){
			$_SESSION['messageTicket'] = "ticketCreated";
            echo'<script>window.location.href = "./tickets_history.php?msg=ticketCreated";</script>';
        }else{
            $trouble = "Something went wrong";
			echo '<script>
						setTimeout(function() {
							Swal.fire({
								title: "Message !",
								text: "Something went wrong",
								icon: "danger"
							}).then(function() {
								//window.location = window.location.pathname;
							});

						}, 1000);
					</script>';
        }
    }
	else{
        $trouble = "Something went wrong";
		echo '<script>
						setTimeout(function() {
							Swal.fire({
								title: "Message !",
								text: "Something went wrong",
								icon: "danger"
							}).then(function() {
								//window.location = window.location.pathname;
							});

						}, 1000);
					</script>';
    }
	
	
	}catch(Exception $e){
		die($e->getMessage());
	}
	echo '<script>
						setTimeout(function() {
							Swal.fire({
								title: "Message !",
								text: "Tickets created successfully!!",
								icon: "success"
							}).then(function() {
								//window.location = window.location.pathname;
							});

						}, 1000);
					</script>';
}


$bouquets = getBouquetsByType('live');

//die(json_encode($bouquets));

$ticketOpen = "menu-open";
$ticketActive = "active";

require('../layout/header_html.php');
?>

  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Tickets</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Tools</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Create new ticket</h3>
              </div> 
              <!-- /.card-header -->
              <!-- form start -->
			  <div class="row" style="margin: auto; margin-top: 2rem;">
				<div class="col-md-12">
				</div>
			  </div>
			  
              <form id="quickForm" method="post" action="create_ticket.php">
                <div class="card-body">
				<div class="row">
					<div class="col-md-6">
						<div class="form-group">
							<label>Type</label>							
							<select class="form-control" name="title" id="title" required>
							  <option selected="true" disabled="disabled">Select ticket type</option>
							  <option value="technical">Technical</option>
							  <option value="support">Support</option>
							  <option value="commercial">Commercial</option>
							  
							</select>
						</div>
					</div>	
					<div class="col-md-6">
						<div class="form-group">
							<label>Title</label>							
							<select class="form-control" name="step1" id="step1" required>
							  <option value="live">Live</option>
							  <option value="movie">VOD</option>
							  <option value="series">Series</option>
							  <option value="time shift">Time shift</option>
							</select>
						</div>
					</div>	
					<div class="col-md-6">
						<div class="form-group">
							<label>Bouquet</label>							
							<select class="form-control selectwithsearch" name="step2" id="step_bouquet" data-live-search="true">
							  <?php 
								
								if(!empty($bouquets)){
									foreach($bouquets as $bouquet){
										echo '<option value="'.$bouquet['category_name'].'">'.$bouquet['category_name'].'</option>';
									}
								}else{
									echo '<option>empty</option>';
								}
							  ?>
							</select>
						</div>
					</div>
					<div class="col-md-6" >
						<div class="form-group">
							<label>Channel</label>							
							<select class="form-control selectwithsearch" name="step3" id="step_channel" data-live-search="true">
							  
							</select>
						</div>
					</div>	
									
					  <div class="col-12">
						<div class="form-group">
						  <label>Message</label>
						  <textarea class="form-control form-control-lg" name="message" id="summernote"  rows="3" required></textarea>
						</div>
						<!-- /.form-group -->
					  </div>					
				</div>			
                 
                <!-- /.card-body -->
                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  </div>
<?php 
	include("../layout/footer.php");
?>

<?php 
require("../common/body.php");
?>

<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
<script>
	
	$(document).ready(function(){
		$(".selectwithsearch").select2({ theme: 'bootstrap4'});
	})

	$("#step1").parent().parent().hide();
	$("#step_bouquet").parent().parent().hide();
	$("#step_channel").parent().parent().hide();
	$("#step1").change();
	
	$("#title").on('change', function(){
		let optionSelected = $(this).find("option:selected").val();
		console.log(optionSelected);
	$("#step1").parent().parent().show();
		$("#step_bouquet").find('option').remove().end();
			$("#step_channel").find('option').remove().end();
			$("#step1").find('option').remove().end();
			$("#step_bouquet").parent().parent().hide();
			$("#step_channel").parent().parent().hide();
			
		if(optionSelected == "technical") {
			 $('#step1').append(new Option('live', 'live'));
			 $('#step1').append(new Option('movie', 'movie'));
			 $('#step1').append(new Option('series', 'series'));
			 $('#step1').append(new Option('time shift', 'time shift'));
		}
		else if(optionSelected == "support"){
			 $('#step1').append(new Option('request', 'request'));
			 
			
		}else{
			$('#step1').append(new Option('request credit', 'request credit'));
			$('#step1').append(new Option('autre', 'autre'));
		}
		$("#step1").change();
	})
	
	$("#step1").on('change', function(){
		let optionSelected = $(this).find("option:selected").val();
		console.log(optionSelected);
		if((optionSelected == "request credit") || (optionSelected == "autre")){
			$("#step_bouquet").find('option').remove().end();
			$("#step_channel").find('option').remove().end();
			$("#step_bouquet").parent().parent().hide();
			$("#step_channel").parent().parent().hide();
		}
		else if((optionSelected == "live") || (optionSelected == "series")|| (optionSelected == "movie")|| (optionSelected == "time shift")){
			$("#step_bouquet").find('option').remove().end();
			$("#step_bouquet").parent().parent().show();
			$("#step_channel").find('option').remove().end();
			$("#step_channel").parent().parent().hide();
			$.ajax({
				url: '../common/getData.php?type=bouquets&cat='+optionSelected,
				type: 'GET',
				success: function (response) {
					$("#step_bouquet").find('option').remove().end();
					 response = JSON.parse(response)
					 response.forEach(element => {
						 $('#step_bouquet').append(new Option(element.category_name, element.category_name));
					 })
					 $("#step_bouquet").change();
				}
			})
		}else{
			$("#step_bouquet").find('option').remove().end();
			$("#step_bouquet").parent().parent().show();
			$("#step_channel").find('option').remove().end();
			$("#step_channel").parent().parent().hide();
			 $('#step_bouquet').append(new Option('live', 'live'));
			 $('#step_bouquet').append(new Option('movie', 'movie'));
			 $('#step_bouquet').append(new Option('series', 'series'));
		}
		
		$("#step_bouquet").change();
		
	})
	
	$("#step_bouquet").on('change', function(){
		let optionSelected = $(this).find("option:selected").val();
		let optionSelectedFirst = $("#step1").find("option:selected").val();
		console.log(optionSelected);
		
			$("#step_channel").find('option').remove().end();
			$("#step_channel").parent().parent().show();
		if((optionSelectedFirst == "live") || (optionSelectedFirst == "series")|| (optionSelectedFirst == "movie")|| (optionSelectedFirst == "time shift")){
			$.ajax({
				url: '../common/getData.php?type=channels&cat='+optionSelected,
				type: 'GET',
				success: function (response) {
					$("#step_channel").find('option').remove().end();
					 response = JSON.parse(response)
					 response.forEach(element => {
						 $('#step_channel').append(new Option(element.stream_display_name, element.stream_display_name));
					 })
				}
			})
		}else{
			$("#step_channel").parent().parent().hide();
		}
	})
</script>

<!-- Summernote -->
<script src="../plugins/summernote/summernote-bs4.min.js"></script>


<script>
$(document).ready(function(){
    $('#summernote').summernote({
    fontSizes: ['12', '14', '16', '18', '24', '36', '48'],
    fontNames:['Arial', 'Arial Black', 'Comic Sans MS', 'Courier New'],
    toolbar: [
    ['style', ['style']],
    ['font', ['bold', 'underline', 'clear']],
    ['fontnames', ['fontname']],
    ['fontsize', ['fontsize']],
    ['color', ['color']],
    ['para', ['ul', 'ol', 'paragraph']],
    ['table', ['table']],
    ['insert', ['link', 'picture', 'video']],
    ['view', ['fullscreen','undo','redo', 'codeview', 'help']],
    ],
    popover: {
  image: [
    ['image', ['resizeFull', 'resizeHalf', 'resizeQuarter', 'resizeNone']],
    ['float', ['floatLeft', 'floatRight', 'floatNone']],
    ['remove', ['removeMedia']]
  ],
  link: [
    ['link', ['linkDialogShow', 'unlink']]
  ],
  table: [
    ['add', ['addRowDown', 'addRowUp', 'addColLeft', 'addColRight']],
    ['delete', ['deleteRow', 'deleteCol', 'deleteTable']],
  ],
  air: [
    ['color', ['color']],
    ['font', ['bold', 'underline', 'clear']],
    ['para', ['ul', 'paragraph']],
    ['table', ['table']],
    ['insert', ['link', 'picture']]
  ]
    },
    });

})

</script>


</body>
</html>