<?php
include("../layout/header.php");
if($_GET){
    $stmtTicket = $pdo->prepare("SELECT * FROM tickets WHERE id=:id");
    $stmtTicket->bindParam(":id",trim($_GET['id']));
    $stmtTicket->execute();
    $rsTicket = $stmtTicket->fetchAll(PDO::FETCH_ASSOC);
    if(count($rsTicket)>0){
        $rqtUpdate = "UPDATE tickets SET admin_read = :adR, user_read = :usR WHERE id = :id";
        $stmtUpdate = $pdo->prepare($rqtUpdate);
        $userRead = $rsTicket[0]["user_read"]; 
        $adminRead = $rsTicket[0]["admin_read"];
        if($_SESSION['admin']){
            $adminRead = 1;
        }else{
			$userRead = 1;
		}
        $stmtUpdate->bindParam(":adR",$adminRead);
        $stmtUpdate->bindParam(":usR",$userRead);
        $stmtUpdate->bindParam(":id",trim($_GET['id']));
        $stmtUpdate->execute();
        $stmtUsername = $pdo->prepare("SELECT username FROM reg_users WHERE id=:id");
        $stmtUsername->bindParam(":id",$rsTicket[0]['member_id']);
        $stmtUsername->execute();
        $rsUsername = $stmtUsername->fetchAll(PDO::FETCH_ASSOC);
        $stmtInfoTicket = $pdo->prepare("SELECT * FROM tickets_replies WHERE ticket_id = :tId ORDER BY id ASC");
        $stmtInfoTicket->bindParam(":tId",$_GET['id']);
        $stmtInfoTicket->execute();
        $rsInfoTicket = $stmtInfoTicket->fetchAll(PDO::FETCH_ASSOC);
        $admin_reply = "";
        $date_ticket ="";
        $string_date_ticket ="";
        $admin = 0;
    }else{
        echo"<script>location.replace('tickets_history.php')</script>";
    }
    

}else{
    echo"<script>location.replace('tickets_history.php')</script>";
}

$ticketOpen = "menu-open";
$ticketActive = "active";
include("../layout/header_html.php");
?>

<style>      

        ::-webkit-scrollbar {
            width: 5px;
        }

        ::-webkit-scrollbar-track {
            width: 5px;
            background: #f5f5f5;
        }

        ::-webkit-scrollbar-thumb {
            width: 1em;
            background-color: #ddd;
            outline: 1px solid slategrey;
            border-radius: 1rem;
        }

        .text-small {
            font-size: 0.9rem;
        }

        .messages-box,
        .chat-box {
            height: 510px;
          overflow-y: scroll;
        }

        .rounded-lg {
            border-radius: 0.5rem;
        }

        input::placeholder {
            font-size: 0.9rem;
            color: #999;
        }
        .bluePanel{
            background-color: #66b3ff !important;
        }
        .adminPanel{
            background-color: #70ef6e  !important;
        }
		
		.edit-msg{
			cursor:pointer;
			display: -webkit-inline-box;
		}
		
		.deleteMSG{
			text-align: right;
			width: 100%;
			cursor: pointer;
		}
		/*.edit-msg::after{
			font-family: FontAwesome;
			content: "X";
			 opacity:0;
		}
		.edit-msg:hover::after{
			 opacity:1;
		}*/
    </style>
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Tickets </h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">ticket</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
	
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header">
                <h3 class="card-title"><?php echo $rsTicket[0]['title'].' --- '.$rsTicket[0]['step1'].' --- '.$rsTicket[0]['step2'].' --- '.$rsTicket[0]['step3'].' --- '.$rsTicket[0]['step4']; ?></h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
<div class="main-panel">
    <div class="">
        <div class="card">
            <div class="card-body">
                <input type="hidden" name="idTicket" id="idTicket" value="<?php echo trim($_GET['id']); ?>">
                
                <div class="col-12 px-0">
                <div class="chat-box bg-white" id="block_msgs">
                    <?php 
                        foreach($rsInfoTicket as $row){
                            if($row['admin_reply'] == 1){
                                ?>
                                <div class="media  mb-3"  style="width: max-content;min-width: 50%;">
                                <img src="/images/logoveep.png" alt="Admin" width="50" >
                                    <div class="media-body ml-3" style="display: grid; ">
                                        <div class="d-flex">
											<label>Admin</label>
											<?php if($_SESSION['admin']){ ?>
												<label data-id="<?php echo $row['id']; ?>" class="deleteMSG">X</label><?php } ?>
										</div>
                                        <div class="bg-light adminPanel rounded py-2 px-3 mb-2 edit-msg" style="color: white !important;" 
							<?php if($_SESSION['admin']){ ?>onClick="editMSG(this)" <?php } ?>  data-id="<?php echo $row['id']; ?>">
                                            <p class="text-small mb-0 text-white msg_text" id="msg_<?=$row['id']; ?>"><?php echo $row['message']; ?></p>
                                        </div>
                                        <p class="small text-muted"><?php  echo date("d-m-Y (H:i)",$row['date']); ?></p>
                                    </div>
                                </div>
                                <?php
                            }if($row['admin_reply'] == 0){
                                ?>
                                <div class="media ml-auto mb-3" style="width: max-content;min-width: 50%;">
                                    <div class="media-body">
                                    <?php echo $rsUsername[0]['username']; ?>

                                        <div class="bg-primary bluePanel rounded py-2 px-3 mb-2">
                                            <p class="text-small mb-0 text-white"><?php echo $row['message']; ?></p>
                                        </div>
                                        <p class="small text-muted"><?php  echo date("d-m-Y (H:i)",$row['date']); ?></p>
                                    </div>
                                </div>
                                <?php
                            }
                            
                        }
                    ?>
                </div>
                <?php if($rsTicket[0]['status'] != 0): ?>
                    <div class="input-group">
                        <textarea placeholder="Type a message" aria-describedby="button-addon2"
                            class="form-control rounded py-4" id="message"></textarea>
                        <div class="input-group-append">
                            <button id="button-addon2" onclick="sendTicketAnswer()" type="button" class="btn btn-default"> <i class="fas fa-paper-plane"></i></button>
                        </div>
                    </div>
                <?php endif; ?>
                </div>
            </div>
        </div>
    </div>
</div>

 </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  <div class="modal fade" tabindex="-1" id="editMSGTXT" role="dialog" aria-labelledby="extendLabel" aria-hidden="true" style="display: none;" data-id="">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" >Modifier reponse</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
                <div class="modal-body" >
					<input type="hidden" name="msg_id" id="msg_id" value="">
                     <div class="input-group mb-3">
                        <textarea placeholder="Type a message" aria-describedby="button-addon2"
                            class="form-control rounded py-4" id="messagetxt"></textarea>
                        <div class="input-group-append">
                            <button onclick="editTicketAnswer()" type="button" class="btn btn-default"> <i class="fas fa-paper-plane"></i></button>
                        </div>
                    </div>
                </div>
            </div><!-- /.modal-content -->
        </div>
    </div><!-- /.modal-dialog -->
    
 
  
<?php 
	include("../layout/footer.php");
?>
<?php
require("../common/body.php");
?>
<script>
    function sendTicketAnswer() {
        let message = $('#message').val();
        let ticketId = $('#idTicket').val();
		if(message != ''){
			$.ajax({
				url: 'send_ticket.php',
				type: 'POST',
				data: {
					id: ticketId,
					message: message,
					type: 1
				}, // On fait passer nos variables, exactement comme en GET, au script more_com.php
				success: function (response) {
					response = JSON.parse(response)
					if (response['good'] === 1) {
						append(response['admin'],response['username'],response['message'],response['date'],response['reply_id'])
						$('#message').val("")
						$('#message').summernote('reset');
						
						$("#block_msgs").scrollTop($("#block_msgs")[0].scrollHeight);
						
					} else {
						console.log("NOK")

					}
				}
			});
		}
        
    } 
	
    function editTicketAnswer() {
        let message = $('#messagetxt').val();
        let ticketId = $('#msg_id').val();
        $.ajax({
            url: 'send_ticket.php',
            type: 'POST',
            data: {
                id: ticketId,
                message: message,
				type: 2
            }, // On fait passer nos variables, exactement comme en GET, au script more_com.php
            success: function (response) {
                response = JSON.parse(response)
				console.log(response);
				$('#editMSGTXT').modal('hide');
                if (response['good'] === 1) {
                    
					$("#msg_"+ticketId).text(message)
                    $('#messagetxt').val("")
                    
                } else {
                    console.log("NOK")

                }
            }
        });
    } 
    function format_date(date) {
        month=date.getMonth();
        month=month+1; //javascript date goes from 0 to 11
        if (month<10) month="0"+month; //adding the prefix

        year=date.getFullYear();
        day=date.getDate();
        hour=date.getHours();
        minutes=date.getMinutes();
        seconds=date.getSeconds();

        return day+"-"+month+"-"+year+" ("+hour+":"+minutes+")";

    }
    
	function append(admin,username,message,date, reply_id){
        let selector = $('.chat-box ');
        let formatedDate = format_date(new Date(date*1000));
        let div =""
        if(admin == 1){
            div = '<div class="media w-50 mb-3"><img src="/images/logoveep.png" alt="Admin" width="50"><div class="media-body ml-3" style="display: grid;"> Admin <div class="bg-light adminPanel rounded py-2 px-3 mb-2 edit-msg" onClick="editMSG(this)" data-msg="'+message+'" data-id="'+reply_id+'"> <p class="text-small mb-0 text-white">'+message+'</p></div><p class="small text-muted">'+formatedDate+'</p></div></div>'
                                
                                    
        }
        if(admin == 0){
            div = '<div class="media w-50 ml-auto mb-3"><div class="media-body">'+username+'<div class="bg-primary bluePanel rounded py-2 px-3 mb-2"><p class="text-small mb-0 text-white">'+message+'</p></div> <p class="small text-muted">'+formatedDate+'</p> </div> </div>'
        }
        selector.append(div);
    }
	
	function editMSG(self)
	{
		console.log($(self).text());
		console.log($(self));
		$("#messagetxt").val($(self).text())
		$("#msg_id").val($(self).data('id'))
		
		$('#editMSGTXT').modal('show');
	}
	
	
</script>

<!-- Summernote -->
<script src="../plugins/summernote/summernote-bs4.min.js"></script>


<script>
$(document).ready(function(){
	
	$('.deleteMSG').on('click', function(){
		var self = this;
		var id = $(this).data('id');
		var r = confirm("Are you sure ");
		if (r == true) {
		  $.ajax({
            url: '../common/getData.php?type=delete_msg&q='+id,
            type: 'GET',
            success: function (response) {
                response = JSON.parse(response)
				console.log(response);
				console.log($(self).parent().parent().parent());
                $(self).parent().parent().parent().remove();
            }
        });
		} 
	})
	
	
	$("#block_msgs").scrollTop($("#block_msgs")[0].scrollHeight);
    $('#message').summernote({
    fontSizes: ['12', '14', '16', '18', '24', '36', '48'],
    fontNames:['Arial', 'Arial Black', 'Comic Sans MS', 'Courier New'],
    toolbar: [
    ['style', ['style']],
    ['font', ['bold', 'underline', 'clear']],
    ['fontnames', ['fontname']],
    ['fontsize', ['fontsize']],
    ['insert', ['picture']],
    ['view', ['fullscreen','undo','redo', 'codeview', 'help']],
    ],
    popover: {
  image: [
    ['image', ['resizeFull', 'resizeHalf', 'resizeQuarter', 'resizeNone']],
    ['float', ['floatLeft', 'floatRight', 'floatNone']],
    ['remove', ['removeMedia']]
  ],
  link: [
    ['link', ['linkDialogShow', 'unlink']]
  ],
  table: [
    ['add', ['addRowDown', 'addRowUp', 'addColLeft', 'addColRight']],
    ['delete', ['deleteRow', 'deleteCol', 'deleteTable']],
  ],
  air: [
    ['color', ['color']],
    ['font', ['bold', 'underline', 'clear']],
    ['para', ['ul', 'paragraph']],
    ['table', ['table']],
    ['insert', ['link', 'picture']]
  ]
    },
    });

})

</script>
