<?php 
include('../layout/header.php');

$rqt = "UPDATE reg_users SET reseller_dns = :dns WHERE id=:id";
$stmt = $pdo->prepare($rqt);
$DNS = $_SESSION['dns'];
if($_POST){
    try{
        $stmt->bindParam(":dns",$_POST['dns']);
        $stmt->bindParam(":id",$_SESSION['id']);
        $stmt->execute();  
        $DNS = $_POST['dns'];
		
		$_SESSION['dns'] = $DNS;
		echo '<script>
            setTimeout(function() {
                Swal.fire({
                    title: "DNS !",
                    text: "DNS changed",
                    icon: "success"
                }).then(function() {
                    //window.location = window.location.pathname;
                });

            }, 1000);
        </script>';
    }catch(Exception $e) {
        var_dump($e->getMessage());
    }
}


$toolOpen = "menu-open";
$toolActive = "active";
include('../layout/header_html.php');
?>

 <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Template</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Tools</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Manage DNS</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
			  <div class="row" style="margin: auto; margin-top: 2rem;">
				<div class="col-md-12">
					 
				</div>
			  </div>
			  
              <form id="quickForm" method="post" action="change_dns.php">
                <div class="card-body">
				<div class="row">
					<div class="col-md-12">
						<div class="form-group">
							<label>DNS</label>
							<input name="dns" class="form-control" id="dns" value="<?php echo $DNS; ?>">
							<small style="color:#ffc107;">&nbsp;&nbsp;You can put your own domain name for manage your own brand.</small>							
						</div>
					</div>
					
				</div>                
                <!-- /.card-body -->
                <div class="card-footer">
                  <button type="submit" name="submitForm" id="submitForm"  class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
<?php 
	include("../layout/footer.php");
?>