<?php 
include('../layout/header.php');
$rqtBouquet = "SELECT id, bouquet_name FROM bouquets WHERE bouquet_name NOT LIKE 'DONT TOUCH%'";
$stmtBouquet = $pdo->prepare($rqtBouquet);
$stmtBouquet->execute();
$resultBouquet = $stmtBouquet->fetchAll();
if($_POST){
    $rqtInsert="INSERT INTO panel_templates(user_id,template_name,bouquets) VALUES(:userid, :bouquet_name, :bouquets_id)";
    $insertStmt = $pdoPanel->prepare($rqtInsert);
    $bouquetsToUse = "[".implode(',',$_POST['toUse'])."]";
	
    $insertStmt->execute([
        'userid' => $_SESSION['id'],
        'bouquet_name' => $_POST['nameBouquet'],
        'bouquets_id' => $bouquetsToUse
    ]);
	$_SESSION['message'] = "template created";
	header('Location: liste_template.php');
}


$toolOpen = "menu-open";
$toolActive = "active";
include('../layout/header_html.php');
?>

  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- Toastr -->
  <link rel="stylesheet" href="../plugins/toastr/toastr.min.css">
  <!-- Bootstrap4 Duallistbox -->
  <link rel="stylesheet" href="../plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Template</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Tools</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Create template</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
			  <div class="row" style="margin: auto; margin-top: 2rem;">
				<div class="col-md-12">
					<div class="alert alert-success alert-dismissible">
					  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
					  <h5><i class="icon fas fa-check"></i> Info!</h5>
					  You can create preferential templates that you put to your customers with specific bouquets.
					</div>
				</div>
			  </div>
			  
              <form id="quickForm" method="post" action="create_template.php">
                <div class="card-body">
				<div class="row">
					<div class="col-md-6">
						<div class="form-group">
							<label>Template's name</label>
							<input type="text" class="form-control form-control-lg" name="nameBouquet" id="nameBouquet" value="" required>  
						</div>
					</div>
					
					  <div class="col-12">
						<div class="form-group">
						  <label>Bouquets</label>
						  <select class="duallistbox" name="toUse[]" multiple="multiple" id="keepRenderingSort_to" required>
							<?php 
                                        foreach($resultBouquet as $row){
                                            echo "<option value='".$row['id']."'>".$row['bouquet_name']."</option>";
                                        }
                                        ?>
						  </select>
						</div>
						<!-- /.form-group -->
					  </div>
					
				</div>
					
                 
                <!-- /.card-body -->
                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  </div>
<?php 
	include("../layout/footer.php");
?>

<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
<!-- Bootstrap4 Duallistbox -->
<script src="../plugins/bootstrap4-duallistbox/jquery.bootstrap-duallistbox.min.js"></script>

<!-- jquery-validation -->
<script src="../plugins/jquery-validation/jquery.validate.min.js"></script>
<script src="../plugins/jquery-validation/additional-methods.min.js"></script>
<!-- SweetAlert2 -->
<script src="../plugins/sweetalert2/sweetalert2.min.js"></script>
<!-- Toastr -->
<script src="../plugins/toastr/toastr.min.js"></script>
<script>
	
	/*$(document).Toasts('create', {
        class: 'bg-success',
        title: 'Info',
        subtitle: '',
        body: 'You can create preferential templates that you put to your customers with specific bouquets.'
      })*/
	
	//Bootstrap Duallistbox
	$('.duallistbox').bootstrapDualListbox({
		nonSelectedListLabel: 'Non-selected',
		selectedListLabel: 'Selected',
	})
</script>


</body>
</html>