<?php 
include("../layout/header.php");
error_reporting(E_ALL);
if($_POST){
    $rqtUpdate = "UPDATE panel_templates SET template_name = :name, bouquets = :idBouquets WHERE id = :id";
    $stmt = $pdoPanel->prepare($rqtUpdate);
    $bouquetsToUse = "[".implode(',',$_POST['toUse'])."]";
    $stmt->bindParam(":name", $_POST['nameBouquet']);
    $stmt->bindParam(':idBouquets',$bouquetsToUse);
    $stmt->bindParam(':id',$_POST['idTemplate']);
    $stmt->execute();
    // header('Location: liste_mag.php?send_message=ligneSupprime&id='.$id);
	$_SESSION['message_edit_template'] = "template edited";
    echo"<script>location.replace('liste_template.php')</script>";
}else{
    if($_GET){
    if (isset($_GET['id'])) {
        $rqtBouquet = "SELECT id, bouquet_name FROM bouquets WHERE bouquet_name NOT LIKE 'DONT TOUCH%'";
        $rqtNameBouquet = "SELECT bouquet_name FROM bouquets WHERE id = :idbouquet";
        $stmtNameBouquet = $pdo->prepare($rqtNameBouquet);
        $stmtBouquet = $pdo->prepare($rqtBouquet);
        $stmtBouquet->execute();
        $resultBouquet = $stmtBouquet->fetchAll();
        if ($_SESSION['admin'] != 1) {
            $rqt = "SELECT id, template_name, bouquets FROM panel_templates WHERE user_id = :id AND id = :idpackage";
            $stmt = $pdoPanel->prepare($rqt);
            $stmt->bindParam(":id", $_SESSION['id']);
            $stmt->bindParam(":idpackage", $_GET['id']);
            $stmt->execute();
            $rs=$stmt->fetchAll(PDO::FETCH_ASSOC);
        } else {
            $rqt = "SELECT id, template_name, bouquets FROM panel_templates WHERE id = :idpackage";
            $stmt = $pdoPanel->prepare($rqt);
            $stmt->bindParam(":idpackage", $_GET['id']);
            $stmt->execute();
            $rs=$stmt->fetchAll(PDO::FETCH_ASSOC);
        }
        // var_dump($rs);
    }
    } else {
        echo"<script>location.replace('index.php')</script>";
    }
}


$toolOpen = "menu-open";
$toolActive = "active";
include("../layout/header_html.php");
?>



  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- Toastr -->
  <link rel="stylesheet" href="../plugins/toastr/toastr.min.css">
  <!-- Bootstrap4 Duallistbox -->
  <link rel="stylesheet" href="../plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Tempalte</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Tools</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">MODIFICATION OF A TEMPLATE</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->			  
              <form id="quickForm" method="post" action="editTemplate.php">
			  <input type="text" name="idTemplate" hidden value="<?php echo $rs[0]['id']; ?>">
                <div class="card-body">
				<div class="row">
					<div class="col-md-6">
						<div class="form-group">
							<label>Template's name</label>
							<input type="text" class="form-control form-control-lg" name="nameBouquet" id="nameBouquet" value="<?php echo $rs[0]['template_name']; ?>" required>  
						</div>
					</div>
					
					  <div class="col-12">
						<div class="form-group">
						  <label>Bouquets</label>
						  <select class="duallistbox" name="toUse[]" multiple="multiple" id="keepRenderingSort_to" required>
							<?php 										
										foreach ($resultBouquet as $row) {
												if (in_array($row['id'], json_decode($rs[0]['bouquets']))){
													echo "<option value='".$row['id']."' selected>".$row['bouquet_name']."</option>";
												}else{
													echo "<option value='".$row['id']."'>".$row['bouquet_name']."</option>";
												}
											}
											?>
                                        ?>
						  </select>
						</div>
						<!-- /.form-group -->
					  </div>
					
				</div>
					
                 
                <!-- /.card-body -->
                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
<?php 
	include("../layout/footer.php");
?>

<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
<!-- Bootstrap4 Duallistbox -->
<script src="../plugins/bootstrap4-duallistbox/jquery.bootstrap-duallistbox.min.js"></script>

<!-- jquery-validation -->
<script src="../plugins/jquery-validation/jquery.validate.min.js"></script>
<script src="../plugins/jquery-validation/additional-methods.min.js"></script>
<!-- SweetAlert2 -->
<script src="../plugins/sweetalert2/sweetalert2.min.js"></script>
<!-- Toastr -->
<script src="../plugins/toastr/toastr.min.js"></script>
<script>
	
	/*$(document).Toasts('create', {
        class: 'bg-success',
        title: 'Info',
        subtitle: '',
        body: 'You can create preferential templates that you put to your customers with specific bouquets.'
      })*/
	
	//Bootstrap Duallistbox
	$('.duallistbox').bootstrapDualListbox({
		nonSelectedListLabel: 'Non-selected',
		selectedListLabel: 'Selected',
	})
</script>


</body>
</html>