<?php 
//require("../layout/header.php");

require('../includes/inc_db.php');
include "../functions/functions_xerox.php";

$rProfiles = getTranscodeProfiles();

$transcodeOpen = "menu-open";
$transcodeActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
  <style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}
	
  </style>
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1><?=$_["transcode_profiles"]?> </h1>
          </div>
          <div class="col-sm-8">
          <?php if (hasPermissions("adv", "tprofile")) { ?>
			<ol class="breadcrumb m-0" style="float: right;"> 
					<li class="breadcrumb-item">
                       <a href="profile.php">
                           <button type="button" class="btn btn-success waves-effect waves-light btn-sm">
                               <i class="fa fa-plus"></i> <?=$_["add_profile"]?>
                           </button>
                       </a>
                    </li>
             </ol>
         <?php } ?>
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?=$_["transcode_profiles"]?></h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
					
					 <div class="row">
                    <div class="col-12">
                        <div class="card">
                            <div class="card-body" style="overflow-x:auto;">
                                <table id="datatable" class="table dt-responsive nowrap">
                                    <thead>
                                        <tr>
                                            <th class="text-center"><?=$_["id"]?></th>
                                            <th><?=$_["profile_name"]?></th>
                                            <th><?=$_["options"]?></th>
                                            <th class="text-center"><?=$_["actions"]?></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <?php foreach ($rProfiles as $rProfile) {
                                        ?>
                                        <tr id="profile-<?=$rProfile["profile_id"]?>">
                                            <td class="text-center"><?=$rProfile["profile_id"]?></td>
                                            <td><?=$rProfile["profile_name"]?></td>
                                            <td><?=(strlen($rProfile["profile_options"]) > 100 ? substr($rProfile["profile_options"],0,100)."..." : $rProfile["profile_options"])?></td>
                                            <td class="text-center">
												<?php if (hasPermissions("adv", "edit_tprofile")) { ?>
                                                <div class="btn-group">
                                                    <a href="./profile.php?id=<?=$rProfile["profile_id"]?>"><button type="button" class="btn btn-info waves-effect waves-light btn-xs"><i class="fa fa-edit"></i></button></a>
                                                    <button type="button" class="btn btn-danger waves-effect waves-light btn-xs" onClick="api(<?=$rProfile["profile_id"]?>, 'delete');"><i class="fa fa-minus"></i></button>
												</div>
                                                <?php } else { echo "--"; } ?>
                                            </td>
                                        </tr>
                                        <?php } ?>
                                    </tbody>
                                </table>

                            </div> <!-- end card body-->
                        </div> <!-- end card -->
                    </div><!-- end col-->
                </div>
			   <!-- end row-->

					
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>

     
	  <script>
        function api(rID, rType) {
            if (rType == "delete") {
                if (confirm('<?=$_["profile_delete_confirm"]?>') == false) {
                    return;
                }
            }
            $.getJSON("../functions/api_xerox.php?action=profile&sub=" + rType + "&profile_id=" + rID, function(data) {
                if (data.result === true) {
                    if (rType == "delete") {
                        $("#profile-" + rID).remove();
                        toastr.success("<?=$_["profile_deleted"]?>");
                    }
                    $.each($('.tooltip'), function (index, element) {
                        $(this).remove();
                    });
                    $('[data-toggle="tooltip"]').tooltip();
                } else {
                    toastr.warning("<?=$_["error_occured"]?>");
                }
            });
        }
        
        $(document).ready(function() {
            $("#datatable").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                },
                responsive: true,
				dom: 'lBfrtip',
				buttons: [
					{extend: 'copy', className: 'btn-sm'},
					{extend: 'csv', className: 'btn-sm'},
					{extend: 'excel', className: 'btn-sm'},
					{extend: 'pdf', className: 'btn-sm'},
					{extend: 'print', className: 'btn-sm'}
				],
               
            });
            $("#datatable").css("width", "100%");
        });
        </script>
	 
     