<?php
ini_set("memory_limit", -1);
include('../layout/header.php');
function randomKey($length = 16) 
{
	Global $pdoPanel;
    $alphabet = 'ABCDEFGHJKMNPQRSTUVWXYZabcdefghjkmnopqrstuvwxyz0123456789';
    $pass = array();
    $alphaLength = strlen($alphabet) - 1;
    for ($i = 0; $i < $length; $i++) {
        $n = rand(0, $alphaLength);
        $pass[] = $alphabet[$n];
    }
	
    return implode($pass);
}

if($_POST){
	$username = randomKey(16);
	$password = randomKey(16);
	$name = $_POST['name'];
	$note = $_POST['note'];
	$codeId = $_POST['code_id'];
	$Identifian="SELECT * FROM active_code WHERE id= :id;";
    $stmtCode = $pdoPanel->prepare($Identifian);
	$stmtCode->bindParam(":id",$codeId);
	$stmtCode->execute();
	$resultCode = $stmtCode->fetchAll(PDO::FETCH_ASSOC);
	//die(json_encode($resultCode));
	if(count($resultCode) == 1){
		$client = $resultCode[0];		
		
		$isTrial = $client['is_trial'];
		$dateCreated = date("Y-m-d H:i:s");
		$package = getPackageBouquet($client['package_id']);
		$bouquets = (!empty($package))?$package['bouquets']:'[]';
		$bouquetsToUse = $bouquets;
		
		$timeEnd = $client['date_activate'];
		$dateCreated = strtotime($dateCreated);
		$rqtCreateUser = "INSERT INTO users (member_id,username,password,exp_date,reseller_notes,bouquet,bouquet_all,max_connections,is_restreamer,is_mag,is_e2,is_trial,created_at,created_by,name,forced_country,country_lock_date,package_id)
			VALUES(:member_id,:username,:password,:exp_date,:reseller,:bouquet,:bouquet_all,1,0,:mag,:e2,:is_trial,:created_at,:created_by,:name,:coutry_lock,:lock_date,:pack)";
$rqtCreateUser = "INSERT INTO users
		   (member_id,username,password,exp_date,   reseller_notes,bouquet,max_connections,is_restreamer,is_mag,is_e2,is_trial,created_at,created_by, forced_country) 
	VALUES(:member_id,:username,:password,:exp_date,:reseller,    :bouquet,1,0,                          :mag,	  :e2,:is_trial,:created_at,:created_by, :coutry_lock)";

$rqtCreateUserExtra = "INSERT INTO users_extra(user_id, name, country_lock_date, package_id) VALUE(:user,:name,:countryClockDate, :package)";
	
		
		$mag = 0;
		$e2 = 0;
		
		
		$countryLock = ($client['forced_country'] == "aut")?'':$client['forced_country'];
		$countryLockDate = ($client['forced_country'] == "aut")?date('Y-m-d',strtotime('+2 day')):null;
	
		try{
			$stmtCreate = $pdo->prepare($rqtCreateUser);
			$stmtCreate->bindParam(":member_id",$client['member_id']);
			$stmtCreate->bindParam(":username",$username);
			$stmtCreate->bindParam(":password",$password);
			$stmtCreate->bindParam(":exp_date",$timeEnd);
			$stmtCreate->bindParam(":reseller", $note);
			$stmtCreate->bindParam(":bouquet", $bouquetsToUse);
			//$stmtCreate->bindParam(":bouquet_all",$bouquetsToUse);
			$stmtCreate->bindParam(":mag",$mag);
			$stmtCreate->bindParam(":e2",$e2);
			$stmtCreate->bindParam(":is_trial",$client['is_trial']);
			$stmtCreate->bindParam(":created_at",$dateCreated);
			$stmtCreate->bindParam(":created_by",$client['member_id']);
			//$stmtCreate->bindParam(":name", $name);
			$stmtCreate->bindParam(":coutry_lock",$countryLock);
			//$stmtCreate->bindParam(":lock_date",$countryLockDate);
			//$stmtCreate->bindParam(":pack",$client['package_id']);
			$res = $stmtCreate->execute();
			
			$user_id = $pdo->lastInsertId();
			
			$lastInserted = $pdo->lastInsertId();
			$stmtCreateExtra = $pdoPanel->prepare($rqtCreateUserExtra);
			$stmtCreateExtra->bindParam(":user",$lastInserted);
			$stmtCreateExtra->bindParam(":name",$name);
			$stmtCreateExtra->bindParam(":countryClockDate", $countryLockDate);
			$stmtCreateExtra->bindParam(":package",$client['package_id']);
			$stmtCreateExtra->execute();
			
			$rqtOutput = "INSERT INTO user_output(user_id,access_output_id) VALUES(:id,:idoutput)";
			$stmtOutput = $pdo->prepare($rqtOutput);
			$stmtOutput->bindParam(':id',$lastInserted);
			$stmtOutput->bindValue(':idoutput',1);
			$stmtOutput->execute();
			$stmtOutput->bindParam(':id',$lastInserted);
			$stmtOutput->bindValue(':idoutput',2);
			$stmtOutput->execute();
			$stmtOutput->bindParam(':id',$lastInserted);
			$stmtOutput->bindValue(':idoutput',3);
			$stmtOutput->execute();
			
			 $Status = "INSERT INTO code_event_users(code_id, user_id) VALUES({$codeId}, {$lastInserted}) ";
			 $stmtupdate = $pdoPanel->prepare($Status);
			 $stmtupdate->execute();
			 
		 } catch (PDOException $e) {
			die( $e->getMessage ());
		}
		$_SESSION['lastUserId'] = $user_id;
		 header('Location: liste_ligne.php');
	}else{
		 header('Location: instance_code.php');
	}
		
}else{
	 header('Location: instance_code.php');
}


?>