<?php 
require('../includes/inc_db.php');
require('../functions/function.php');
error_reporting(E_ALL);
$rqt = "SELECT username,exp_date, bouquet,member_id,pair_id FROM users WHERE id = :id";
$rqtModifyBouquet = "UPDATE users SET exp_date = :exp_date, is_trial = '0' WHERE id = :id";
$rqtModifyBouquetExtrat = "UPDATE users_extra SET  package_id = :pack_id WHERE user_id = :id";
$rqtRegUserCredit = "UPDATE reg_users SET credits = :credits WHERE id = :id";
$rqtPackage = "SELECT package_name,official_credits, official_duration,official_duration_in,is_trial FROM packages WHERE id=:id";
$stmtPackage = $pdo->prepare($rqtPackage);
$stmt=$pdo->prepare($rqt);
$stmtModify=$pdo->prepare($rqtModifyBouquet);
$stmtModifyExtras=$pdoPanel->prepare($rqtModifyBouquetExtrat);
$stmtCredit=$pdo->prepare($rqtRegUserCredit);

$return = array('status' => 0,'callback'=> "" );
if(!isset($_SESSION['username'])){
    exit();
}
if(isset($_POST)){
    $idUser = $_POST['user'];
	
	//die(json_encode($idUser));
   
   // $idUser = $_POST['user'];
    $return['callback'] = $_POST['callback'];
    
    if(isset($_POST['package'])){
        $idPackage = trim($_POST['package']);
        $idPackage = filter_var($idPackage,FILTER_SANITIZE_NUMBER_INT);
        $stmtPackage->bindParam(":id",$idPackage);
        $stmtPackage->execute();
        $rsPackage = $stmtPackage->fetchAll(PDO::FETCH_ASSOC);
        if($rsPackage[0]['is_trial'] == 1){
            echo(json_encode($return));
            exit();
        }
        
         $time = '+ '.$rsPackage[0]['official_duration'].' '.$rsPackage[0]['official_duration_in'];
         $now = time();
         
		 
		 if(is_array($idUser)){
			 foreach($idUser as $id):
			 $stmt->bindParam(':id',$id);
			 $stmt->execute();
			 $rs=$stmt->fetchAll(PDO::FETCH_ASSOC);
			 
				if($rs[0]['exp_date'] >= $now)
					 $exp_date = date("Y-m-d H:i:s",$rs[0]['exp_date']);
				 if($rs[0]['exp_date'] < $now)
					 $exp_date = date("Y-m-d H:i:s",$now);
				 $date_exp = date("Y-m-d H:i:s",strtotime($exp_date. $time));
				 $timestamp = strtotime($date_exp);
			 
			 $stmtModify->bindParam(":id",$id);
			 $stmtModify->bindParam(":exp_date",$timestamp);
			 
			 $stmtModifyExtras->bindParam(":id",$id);
			 $stmtModifyExtras->bindParam(":pack_id",$idPackage);
			 $stmtModifyExtras->execute();
			 if($stmtModify->execute()){
				 if($rs[0]['pair_id'] != NULL){
					 $stmtModify->bindParam(":id",$rs[0]['pair_id']);
					 $stmtModify->bindParam(":exp_date",$timestamp);
					 $stmtModifyExtras->bindParam(":id",$id);
					 $stmtModifyExtras->bindParam(":pack_id",$idPackage);
					 $stmtModifyExtras->execute();
					 $stmtModify->execute();
				 }
				 				 
			 }else{
				 $return["status"] = 0;
			 }
			 endforeach;
		 }
        
                
    }else{
        $return["status"] = 0;
    }
    echo(json_encode($return));
}