<?php 
require("../layout/header.php");

if(isset($_SESSION['trialCount'])){
	unset($_SESSION['trialCount']);
	echo '<script>
        setTimeout(function() {
            Swal.fire({
                title: "error",
                text: "vous avez deppasé le nombre limit de trial",
                icon: "error"
            }).then(function(){
                //window.location.href = "liste_ligne.php";
            });
        }, 1000);
    </script>';
}
if(isset($_SESSION['creditInsuffisant'])){
	unset($_SESSION['creditInsuffisant']);
	echo '<script>
        setTimeout(function() {
            Swal.fire({
                title: "error",
                text: "Credit insuffisant",
                icon: "error"
            }).then(function(){
                //window.location.href = "liste_ligne.php";
            });
        }, 1000);
    </script>';
}
$userOpen = "menu-open";
$userActive = "active";

		$rQuery = "SELECT ac.*, ru.username, p.package_name FROM panel.active_code AS ac 
				LEFT JOIN xtream_iptvpro.reg_users AS ru ON ru.id = ac.member_id 
				LEFT JOIN xtream_iptvpro.packages AS p ON p.id = ac.package_id
				WHERE  user_id IS NULL AND ac.type=0 ORDER BY ac.id DESC;";		
		$stmt = $db2->prepare($rQuery);
		//$stmtCount->bind_param(":id", $_SESSION['id']);			
		$stmt->execute();
		$rResult = $stmt->get_result();
		$stmt->close();
		
		$rqtBouquet = "SELECT id,template_name,bouquets FROM panel_templates WHERE user_id = :id";
		$stmtBouquet = $pdoPanel->prepare($rqtBouquet);
		$stmtBouquet->bindParam(":id",$_SESSION['id']);
		$stmtBouquet->execute();
		$resultBouquet = $stmtBouquet->fetchAll(PDO::FETCH_ASSOC);
		
		$rqtNbCode = "SELECT COUNT(*) as nb FROM active_code WHERE member_id = :member_id AND is_trial = 1";
		$stmtCount = $pdoPanel->prepare($rqtNbCode);
		$stmtCount->bindParam(":member_id", $_SESSION['id']);
		$stmtCount->execute();
		$resultCount = $stmtCount->fetchAll(PDO::FETCH_ASSOC);
		
		$countTrialCode = $resultCount[0]['nb'];
		
							
$country=file_get_contents("../c.json");
$country=json_decode($country,true);
 
include('../layout/header_html.php');
?>

<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Instance code </h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><button type="button" class="btn btn-outline-info btn-sm btn-block btn-flat" data-target="#instanceModal" data-toggle="modal"><i class="fa fa-plus"></i> Add active code</button>
				</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header">
                <h3 class="card-title">Instance code</h3>
				<div style="float:right;">
					
					<div class="form-group">
						<select name="pack" class="form-control" id="revendeur_id">
							<option value="0">All</option>
							<?php $revendeurs = getAllRevendeurs();
								if(count($revendeurs)>0){
									foreach($revendeurs as $item){ ?>
										<option value="<?=$item['username']?>"><?=$item['username']?></option>
								<?php }
								}
							?>
						</select>
					</div>
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
			                 
                <table id="example1" class="table stripe tableM3U" width="100%">
                  <thead>
                  <tr>
                    <th>
                        Active code
                    </th>
                    <th>
                        PIN
                    </th>
                    <th>
                        Serial number
                    </th>
                    <th>
                        Revendeur
                    </th>
                    <th>
                        Package
                    </th>
                    <th>
                        Date creation
                    </th>
                    <th class='no-sort'>
                        Options
                    </th>
                  </tr>
                  </thead>    
					<tbody id="all_code">
						<?php 
						if (($rResult) && ($rResult->num_rows > 0)) {
							while ($rRow = $rResult->fetch_assoc()) { 
							
								/*$packageName = "";
								$rqtPackage = "SELECT package_name FROM packages WHERE id = :id";
								$stmtpackage = $pdo->prepare($rqtPackage);
								$stmtpackage->bindParam(':id', $rRow['package_id']);
								$stmtpackage->execute();
								$resultPackage = $stmtpackage->fetchAll(PDO::FETCH_ASSOC);
								if($resultPackage){
									$packageName = $resultPackage[0]['package_name'];
								}*/
							?>
								<tr <?php if($rRow['status'] == -3) echo 'style="background-color:#fb5555 !important;"';?> class="for_revendeur_<?=$rRow['member_id']?>">
									<td><?=$rRow['code']; ?></td>
									<td><?=$rRow['pin']; ?></td>
									<td><?=$rRow['serial_number']; ?></td>
									<td><?=$rRow['username']; ?></td>
									<td><?=$rRow['package_name']; ?></td>
									<td><?=date('Y-m-d', $rRow['date_create']); ?></td>
									<td><div class="btn-group">
											<button type="button" class="btn  dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i class="fas fa-cogs"></i></button>
											<div class="dropdown-menu">
												<a href="javascript:void(0)" data-id="<?=$rRow['id']; ?>" class="dropdown-item activate_code">Activate</a>
												<a href="./code_status.php?code=<?=$rRow['id'];?>&status=-3" class="dropdown-item">Disable</a>
												<?php if($rRow['status'] == -3){ ?>
												<a href="./code_status.php?code=<?=$rRow['id'];?>&status=1" class="dropdown-item">Reset blockage</a>
												<?php } ?>
											</div>
										</div>
									</td>
								</tr>
						<?php	}
						}
						?>
					</tbody>
				</table>
              
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
	<div class="modal fade" id="instanceModal" tabindex="-1" role="dialog" aria-labelledby="extendLabel" aria-hidden="true" style="display: none;" data-id="">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">Instance code</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
				<form action="add_instance_code.php" method="post" id="add_code">
                <div class="modal-body">					
					<div class="row">
						<div class="col-md-12">
							<label>Nombre d'instance code </label>
							<input type="number" min="1" name="count" id="countCode" value="" class="form-control" required>
						</div>
						<div class="col-md-12">
							<div class="form-group">
								<label>Package</label>
								<select name="pack" class="form-control" id="pack" required>
									<?php
											$array = getPackagesCreate();
											if(!empty($array)){
												echo'<option value="" disabled selected data-trial="0">--Please choose a package--</option>';
												foreach($array as $row){
													$bouquets = str_replace('"',"",$row['bouquets']);
													if(!($_GET)){
														echo'<option value="'.$row['id'].'" data-trial="'.$row['is_trial'].'" data-bouquets="'.$bouquets.'" data-duration="'.$row['timeExtend'].'" data-cost="'.$row['official_credits'].'" id="'.$row['id'].'">'.$row['package_name'].' / '.$row['official_credits'].' credits</option>';
													}
													if($_GET['tok'] == "unlimited"){
														if(intval($row['official_credits']) == 1){
															echo'<option value="'.$row['id'].'" data-bouquets="'.$bouquets.'" data-duration="'.$row['timeExtend'].'" data-cost="'.$row['official_credits'].'" id="'.$row['id'].'">'.$row['package_name'].' / 0 credit   </option>';
														}
													}
												}
											}else{
												echo'<option value="no">No Package available</option>';
											}
										?>
								</select>
							</div>					
						</div>
						<div class="col-md-12" id="templateDiv">
							<div class="form-group">
								<label>Country Lock</label>
								<div class="custom-control custom-switch" style="    float: right;">
								  <input type="checkbox" class="custom-control-input" name="auto" checked id="customSwitch1">
								  <label class="custom-control-label" for="customSwitch1">Auto</label>
								</div>
								<select name="coutry_lock" class="form-control" id="coutry_lock" required>
									<?php
				
									foreach ($country as $key => $value) {
									$sel="";
									if($value["code"]=="FR")$sel="selected ";
										echo '<option '.$sel.'value="'.$value["code"].'">'.$value["name"].'</option>';
										# code...
									}
									?>
								</select>
							</div>					
						</div>
						
						<div class="col-md-12" id="templateDiv">
							<div class="form-group">
								<label>Revendeur</label>
								<input type="text" name="revendeur" id="revendeur" value="" class="form-control">
							</div>					
						</div>
					</div>
                </div>
				<div class="modal-footer justify-content-between">
				  <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
				  <button type="button" class="btn btn-primary" id="add_code_submit">Create</button>
				</div>
				</form>
            </div><!-- /.modal-content -->
        </div>
    </div><!-- /.modal-dialog -->

	
	<div class="modal fade" id="activateModal" tabindex="-1" role="dialog" aria-labelledby="extendLabel" aria-hidden="true" style="display: none;" data-id="">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">Instance code</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
				<form action="activate_code.php" method="post">
					<input type="hidden" name="code_id" value="" id="code_id">
                <div class="modal-body">					
					<div class="row">
						
						<div class="col-md-6 ">
							<div class="form-group">
								<label>Name</label>
								<input type="text" class="form-control" id="name" name="name" >
							</div>					
						</div>
						<div class="col-md-6 ">
							<div class="form-group">
								<label>Note</label>
								<input type="text" class="form-control" id="note" name="note" >
							</div>					
						</div>
						
					</div>
                </div>
				<div class="modal-footer justify-content-between">
				  <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
				  <button type="submit" class="btn btn-primary" onClick="this.form.submit();this.disabled=true; this.innerText ='Sending…';">Activate</button>
				</div>
				</form>
            </div><!-- /.modal-content -->
        </div>
    </div><!-- /.modal-dialog -->

 
<?php 
	include("../layout/footer.php");
	include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  <script>
  
	    function makeid() {
            let text = "";
            const possible = "ABCDEFGHJKMNPQRSTUVWXYZabcdefghjkmnopqrstuvwxyz0123456789";

            for (let i = 0; i < 16; i++)
                text += possible.charAt(Math.floor(Math.random() * possible.length));

            return text;
        }


$(document).ready(function(){
	$maxTrial = "<?=$_SESSION['trial_disp'];?>";
	console.log($maxTrial);
	
	$("#add_code_submit").on('click', function(){
		$('#add_code_submit').prop('disabled', true);
		var nb = $("#countCode").val();
		let optionSelected = $("#pack").find("option:selected");
        console.log(optionSelected.val());
        let trial = parseInt(optionSelected.data('trial'));
		console.log('------')
		console.log(trial);
		console.log(nb);
		console.log($maxTrial);
		if(optionSelected.val() == ""){
			alert('select package')
			$('#add_code_submit').prop('disabled', false);
			return false;
		}
		if(nb == ""){
			alert('select nombre de code ')
			$('#add_code_submit').prop('disabled', false);
			return false;
		}
		//return false;
		if(trial == 1){
			if(parseInt($maxTrial)<nb){
				console.log("11111111111111");
				Swal.fire({
                  title: "Warning",
                  text: "you have exceeded the trial instance code limit,  it must be under "+ $maxTrial,
                  type: "warning",                   
              });	
				$('#add_code_submit').prop('disabled', false);
			}else{
				console.log("2222222");
				$("#add_code").submit();
			}
		}else{
			$("#add_code").submit();
		}
		
		return false;
	})
	
	$('.activate_code').on('click', function(){
		var username = makeid();
	    var password = makeid();
		$("#user").val(username);
		$("#pass").val(password);
		var id = $(this).data('id');
		
		$("#code_id").val(id);
		$("#activateModal").modal('show');
	})
	
	$("#pack").change(function () {
        
        let optionSelected = $(this).find("option:selected");
        console.log(optionSelected);
        let trial = parseInt(optionSelected.data('trial'));
        console.log(trial);
		/*if(trial == 1)
			$("#countCode").attr('max',  $maxTrial);
        else
			$("#countCode").removeAttr('max');
			
		// Get DOM reference
			var input = document.getElementById("countCode");
			// Add event listener
			input.addEventListener("input", function(e){
				// Clear any old status
				this.setCustomValidity("");	  
				// Check for invalid state(s)
				if(this.validity.rangeOverflow){
					//this.setCustomValidity("you have exceeded the trial instance code limit,  it must be under "+ $maxTrial);
				}
			});*/
    })
	
    let tablem3u = $('.tableM3U').DataTable({            
			"responsive": true,
			 dom: 'Bfrtip',
			"scrollX": true,
		    "searching": true,
			//"pageLength": 10,
			//"buttons": ["csv", "excel", "pdf"],
			"buttons" : [ {
					extend : 'excel',
					exportOptions: {
						columns: [ 0, 1, 2, 3, 4, 5 ]
					}
				},
				{
					extend: 'pdfHtml5',
					exportOptions: {
						columns: [ 0, 1, 2, 3, 4, 5]
					}
				},
			],
			"aoColumns": [
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': false}

            ], 
			"columnDefs": [
				//Responsive classes        
				{ className: 'all', targets: 0 },         
				{ className: 'all', targets: 6 },       
			],
            processing: true,
            /*ajax: {
                url: "../common/getData.php?type=instance_code",
                "data": function (d) {
					console.log(d);
                },
				
            },*/
			
        });
		
	$("#revendeur_id").on('change', function(){
		var id = this.value;
		console.log(id);
		
		if(id == 0){
			tablem3u.columns( 3 ).search('').draw();
		}else{
			tablem3u.columns( 3 ).search( this.value ).draw();
		}
	}) 
		
})

</script>

</body>
</html>