<?php
include('../layout/header.php');

function randomKey($length = 16) {
    $alphabet = '0123456789';
    $pass = array();
    $alphaLength = strlen($alphabet) - 1;
    for ($i = 0; $i < $length; $i++) {
        $n = rand(0, $alphaLength);
        $pass[] = $alphabet[$n];
    }
    return implode($pass);
}

function randomKeyAlpha($length = 16) {
    $alphabet = 'ABCDEFGHJKMNPQRSTUVWXYZabcdefghjkmnopqrstuvwxyz0123456789';
    $pass = array();
    $alphaLength = strlen($alphabet) - 1;
    for ($i = 0; $i < $length; $i++) {
        $n = rand(0, $alphaLength);
        $pass[] = $alphabet[$n];
    }
    return implode($pass);
}
//START SQL QUERIES


	//START SQL QUERIES
	$rqt = "SELECT * FROM packages WHERE id != 28 ORDER BY package_name DESC";
	$rqtBouquetOffi = "SELECT id, bouquet_name FROM bouquets WHERE bouquet_name NOT LIKE 'DONT TOUCH%'";
	$rqtExiste = "SELECT id FROM users WHERE username = :username";
	$userbyid = "SELECT exp_date FROM users WHERE id = :id";
	$rqtMentoring = "SELECT id,username,exp_date,is_mag, is_e2, e2.mac e2Mac, from_base64(mag.mac) magMac FROM users LEFT JOIN enigma2_devices e2 ON id = e2.user_id LEFT JOIN mag_devices mag ON id=mag.user_id WHERE id = :id";
	$rqtMentoringUpdate = "UPDATE users SET exp_date = :expdate WHERE id = :id";
	$rqtCreateUser = "INSERT INTO users
		   (member_id,username,password,exp_date,   reseller_notes,bouquet,max_connections,is_restreamer,is_mag,is_e2,is_trial,created_at,created_by, forced_country) 
	VALUES(:member_id,:username,:password,:exp_date,:reseller,    :bouquet,:max_connections,0,           :mag,	  :e2,:is_trial,:created_at,:created_by, :coutry_lock)";
	$rqtCreateUserExtra = "INSERT INTO users_extra(user_id, name, country_lock_date, package_id) VALUE(:user,:name, '".date('Y-m-d')."', :package)";
	
	$rqtCreateE2 = "INSERT INTO enigma2_devices(mac,user_id,last_updated,watchdog_timeout,lock_device,telnet_enable,ftp_enable,ssh_enable,rc) 
	VALUES(:mac,:user_id,'0','0','0','1','1','1','1')";
	$rqtCreateMag = "INSERT INTO mag_devices(user_id,mac,lock_device) VALUES(:id,:mac,0)";
	$rqtRegUserCredit = "UPDATE reg_users SET credits = :credits WHERE id = :id";
	$rqtGetBouquet = "SELECT bouquets FROM panel_templates WHERE id = :id";
	$rqtCheckMac = "SELECT mag_id,user_id FROM mag_devices WHERE mac = :mac";
	$rqtCheckMacUpdate = "UPDATE mag_devices SET user_id = :user WHERE user_id = :old_id";
	$rqtCheckE2 = "SELECT device_id FROM enigma2_devices WHERE mac = :mac";
	$rqtCheckE2Update = "UPDATE enigma2_devices SET user_id = :user WHERE user_id = :old_id";
	$rqtRegUser = "INSERT INTO reg_userlog(owner,username,password,date,type) VALUES(:owner,:username,:password,:date,:type)";
	$rqtOutput = "INSERT INTO user_output(user_id,access_output_id) VALUES(:id,:idoutput)";
	$rqtBouquet = "SELECT id,template_name,bouquets FROM panel_templates WHERE user_id = :id";
	$rqtGetInfoPackage = "SELECT package_name,official_credits,is_trial, is_official, trial_duration,groups, trial_duration_in, official_duration,official_duration_in, bouquets FROM packages WHERE id = :id";
	
	$rqtDisableOld = "UPDATE users SET enabled = 0, admin_enabled  = 0 WHERE id = :old_id";
	
	//$rqtCreateCode=$BDD->prepare('INSERT INTO active_code(code, users_id, date_create, status, member_id) VALUES(?, ?, ?, ?, ?)');
	$rqtCreateCode='INSERT INTO active_code(code, pin, user_id, date_create,date_activate, status, member_id, package_id, forced_country, is_trial) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)';

	$codeNewGen=randomKey(16);
	$pinNewGen=randomKey(4);
	//END SQL QUERIES

	$unlimited = 0;
	$stmtDisableOld = $pdo->prepare($rqtDisableOld);
	
	$stmtOutput = $pdo->prepare($rqtOutput);
	$stmtRegUser = $pdo->prepare($rqtRegUser);
	
	$username = "";
	$password = "";
	$username = randomKeyAlpha(16);
	$password = randomKeyAlpha(16);
	$remove = array("[","]");
	$trialAllowed = intval($_SESSION['trial']);
	$mag = 0;
	$e2 = 0;
	$type = "LINE";
	
	$usertoswitch = $_POST['usertoswitch'];
	$user = checkClient($usertoswitch);
	if(!is_null($user)){
		$trouble="";
		if($user['is_mag'] == "1"){
			$mag = 1;
			$e2 = 0;
			$type="MAG";
		}
		if($user['is_e2'] == "1"){
			$mag = 0;
			$e2 = 1;
			$type="E2";
		}
				
			if($trouble == ""){
				$stmtCreate = $pdo->prepare($rqtCreateUser);
				$stmtCreate->bindParam(":member_id",$user['member_id']);
				$stmtCreate->bindParam(":username",$username);
				$stmtCreate->bindParam(":password",$password);
				$stmtCreate->bindParam(":exp_date",$user['exp_date']);
				$stmtCreate->bindParam(":reseller",$user['reseller_notes']);
				$stmtCreate->bindParam(":bouquet",$user['bouquet']);
				$stmtCreate->bindParam(":max_connections",$user['max_connections']);
				$stmtCreate->bindParam(":mag",$mag);
				$stmtCreate->bindParam(":e2",$e2);
				$stmtCreate->bindParam(":is_trial",$user['is_trial']);
				$stmtCreate->bindParam(":created_at",$user['created_at']);
				$stmtCreate->bindParam(":created_by",$user['created_by']);
				$stmtCreate->bindParam(":coutry_lock",$user['forced_country']);
				
				
				if($e2 == 1 && $mag == 0){					
					if($stmtCreate->execute()){
						$lastInserted = $pdo->lastInsertId();
						$stmtE2 = $pdo->prepare($rqtCheckE2Update);
						$mac = strtoupper($_POST['macAdress']);
						$stmtE2->bindParam(':old_id',$user['id']);
						$stmtE2->bindParam(':user_id',$lastInserted);
						$stmtE2->execute();						
					}
					
				}
				else if($mag == 1 && $e2 == 0){
					
					if($stmtCreate->execute()){
						$lastInserted = $pdo->lastInsertId();						
						$stmtMag = $pdo->prepare($rqtCheckMacUpdate);
						$stmtMag->bindParam(':user',$lastInserted);
						$stmtMag->bindParam(':old_id',$user['id']);
						$stmtMag->execute();
						
						$rqt = "INSERT INTO mag_devices_details(user_id, secure) VALUES(:user, 0)";
						$stmtt = $pdoPanel->prepare($rqt);
						$stmtt->bindParam(":user",$lastInserted);
					}
				}
				
				else if($mag ==0 && $e2 == 0){
					if($stmtCreate->execute()){
						$lastInserted = $pdo->lastInsertId();							
						$creationInstance=$pdoPanel->prepare($rqtCreateCode);						
						$creationInstance->execute(array($codeNewGen, $pinNewGen, $lastInserted, time(),  time(), 1, $user['member_id'],$user['pkid'], $user['forced_country'], $user['is_trial']));
					
					}
				}
				
				if($trouble == ""){
					
					$stmtCreateExtra = $pdoPanel->prepare($rqtCreateUserExtra);
					$stmtCreateExtra->bindParam(":user",$lastInserted);
					$stmtCreateExtra->bindParam(":name",$user['username']);
					$stmtCreateExtra->bindParam(":package",$user['pkid']);
					$stmtCreateExtra->execute();					
					
					$stmtDisableOld->bindParam(':old_id', $user['id']);
					$stmtDisableOld->execute();
					
					$stmtOutput->bindParam(':id',$lastInserted);
					$stmtOutput->bindValue(':idoutput',1);
					$stmtOutput->execute();
					$stmtOutput->bindParam(':id',$lastInserted);
					$stmtOutput->bindValue(':idoutput',2);
					$stmtOutput->execute();
					$stmtOutput->bindParam(':id',$lastInserted);
					$stmtOutput->bindValue(':idoutput',3);
					$stmtOutput->execute();
					
					//$user = $username;
					if($mag == 1 || $e2 == 1){
						$username = strtoupper(base64_encode($user['mac']));
					}
					
					$dateCreated = date("Y-m-d H:i:s");
					$dateCreated = strtotime($dateCreated);
					$typeTowrite = '[<b>UserPanel SWICH</b> -> <u>New '.$type.'</u>] Username : '.$username.' original user '. $user['id'];
					$stmtRegUser->bindParam(':owner',$user['member_id']);
					$stmtRegUser->bindParam(':username',$username);
					$stmtRegUser->bindParam(':password',$password);
					$stmtRegUser->bindParam(':date',$dateCreated);
					$stmtRegUser->bindParam(':type',$typeTowrite);
					$stmtRegUser->execute();
				}
				
				
						
			}
			
		
	}
	
	
	$_SESSION['lastUserId'] = $lastInserted;
		if($trouble == ""){
			if( $type == "LINE")
				echo'<script>window.location.href = "./liste_ligne.php";</script>';
			else if ($type == "E2")
				echo'<script>window.location.href = "./liste_e2.php";</script>';
			else
				echo'<script>window.location.href = "./liste_mag.php";</script>';
		}
	
	
