<?php 
require("../layout/header.php");

if (isset($_POST["submit_series"])) {
    
	
	
	if (isset($_POST["edit"])) {
        $rArray = getStream($_POST["edit"]);
        unset($rArray["id"]);
    } else {
        $rArray = Array("title" => "", "category_id" => "", "cover" => "","genre" => "", "plot" => "", "cast" => "", "rating" => 0, "director" => "", "releaseDate" => "", "last_modified" => 0, "seasons" => "", "backdrop_path" => "", "youtube_trailer" => "");
    }
	if (isset($_POST["title"])) {
        $rArray["title"] = $_POST["title"];
        unset($_POST["title"]);
    } else {
        $rArray["title"] = 0;
    }
    
    if (isset($_POST["category_id"])) {
        $rArray["category_id"] = $_POST["category_id"];
        unset($_POST["category_id"]);
    } else {
        $rArray["category_id"] = "";
    }
    if (isset($_POST["cover"])) {
        $rArray["cover"] = $_POST["cover"];
        unset($_POST["cover"]);
    } else {
        $rArray["cover"] = "";
    }
    if (isset($_POST["genre"])) {
        $rArray["genre"] = $_POST["genre"];
        unset($_POST["genre"]);
    } else {
        $rArray["genre"] = "";
    }
    if (isset($_POST["plot"])) {
        $rArray["plot"] = $_POST["plot"];
        unset($_POST["plot"]);
    } else {
        $rArray["plot"] = "";
    }
    if (isset($_POST["cast"])) {
        $rArray["cast"] = $_POST["cast"];
        unset($_POST["cast"]);
    } else {
        $rArray["cast"] = "";
    }
    if (isset($_POST["rating"])) {
        $rArray["rating"] = intval($_POST["rating"]);
        unset($_POST["rating"]);
    } else {
        $rArray["rating"] = 0;
    }
	if (isset($_POST["director"])) {
        $rArray["director"] = $_POST["director"];
        unset($_POST["director"]);
    } else {
        $rArray["director"] = 0;
    }
	if (isset($_POST["releaseDate"])) {
        $rArray["releaseDate"] = ($_POST["releaseDate"]);
        unset($_POST["releaseDate"]);
    } else {
        $rArray["releaseDate"] = "";
    }
	if (isset($_POST["last_modified"])) {
        $rArray["last_modified"] = intval($_POST["last_modified"]);
        unset($_POST["last_modified"]);
    } else {
        $rArray["last_modified"] = 0;
    }
	if (isset($_POST["seasons"])) {
        $rArray["seasons"] = ($_POST["seasons"]);
        unset($_POST["seasons"]);
    } else {
        $rArray["seasons"] = 0;
    }
	if (isset($_POST["backdrop_path"])) {
        $rArray["backdrop_path"] = ($_POST["backdrop_path"]);
        unset($_POST["backdrop_path"]);
    } else {
        $rArray["backdrop_path"] = "";
    }
	if (isset($_POST["youtube_trailer"])) {
        $rArray["youtube_trailer"] = ($_POST["youtube_trailer"]);
        unset($_POST["youtube_trailer"]);
    } else {
        $rArray["youtube_trailer"] = "";
    }
	
    foreach($_POST as $rKey => $rValue) {
        if (isset($rArray[$rKey])) {
            $rArray[$rKey] = $rValue;
        }
    }
	
	
	
    $rCols = "`".implode('`,`', array_keys($rArray))."`";
    foreach (array_values($rArray) as $rValue) {
        isset($rValues) ? $rValues .= ',' : $rValues = '';
        if (is_array($rValue)) {
            $rValue = json_encode($rValue);
        }
        if (is_null($rValue)) {
            $rValues .= 'NULL';
        } else {
            $rValues .= '\''.$db->real_escape_string($rValue).'\'';
        }
    }
    if (isset($_POST["edit"])) {
        $rCols = "`id`,".$rCols;
        $rValues = $_POST["edit"].",".$rValues;
    }
	
	//print_r($rCols);
	//print_r($rValues);
	
	
    $rQuery = "REPLACE INTO `series`(".$rCols.") VALUES(".$rValues.");";
    //print_r($rQuery);
	//exit;
	if ($db->query($rQuery)) {
        if (isset($_POST["edit"])) {
            $rInsertID = intval($_POST["edit"]);
        } else {
            $rInsertID = $db->insert_id;
        }
    }
	if (isset($rInsertID)) {
		$_STATUS = 0;
    } else {
        $_STATUS = 1;
    }
    if (!isset($_GET["id"])) {
        $_GET["id"] = $rInsertID;
    }
	}

$serieOpen = "menu-open";
$serieActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
		<style>
			.dd-list .dd-item .dd-handle {
				background: #f1f5f7;
				border: none;
				padding: 8px 16px;
				height: auto;
				font-weight: 500;
				border-radius: 3px;
				font-size: x-large;
			}
			.dd-list .dd3-handle {
				margin: 0;
				height: 36px!important;
				float: left;
			}
			.dd-list .dd3-content {
				height: auto;
				border: none;
				padding: 8px 16px 8px 46px;
				background: #f1f5f7;
				font-weight: 600;
			}
			.dd-list .dd3-handle:before {
				content: "=";
				font-family: "Material Design Icons";
				color: #adb5bd;
			}


			
		</style>	
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Series </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;">
                    
                </ol>
				
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?php if (isset($rSeries)) { echo "Edit"; } else { echo "Add"; } ?> VOD</h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
				 
				 <!-- end page title --> 
                <div class="row">
                    <div class="col-xl-12">
                        <?php if ((isset($_STATUS)) && ($_STATUS == 0)) { ?>
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            Series operation was completed successfully.
                        </div>
                        <?php } else if ((isset($_STATUS)) && ($_STATUS > 0)) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            There was an error performing this operation! Please check the form entry and try again.
                        </div>
                        <?php } ?>
                        <div class="card">
                            <div class="card-body">
                                <form action="addseries.php<?php if (isset($_GET["id"])) { echo "?id=".$_GET["id"]; } ?>" method="POST" id="Series_form">
                                    <?php if (isset($rSeries)) { ?>
                                    <input type="hidden" name="edit" value="<?=$rSeries["id"]?>" />
                                    <?php } ?>
                                    
                                    <div id="basicwizard">

                                            <div class="tab-pane" id="stream-details">
                                                <div class="row">
                                                    <div class="col-12">
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="title">Title</label>
                                                            <div class="col-md-8">
                                                                <input type="text" required class="form-control" id="title" name="title" value="<?php if (isset($rSeries)) { echo $rSeries["title"]; } ?>">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="category_id">Category Name</label>
                                                            <div class="col-md-8">
                                                                <select name="category_id" id="category_id" class="form-control" data-toggle="select2">
																    <option value="">No Category</option>
                                                                    <?php foreach (getCategories("series") as $rCategory) { ?>
                                                                    <option <?php if (isset($rSeries)) { if (intval($rSeries["category_id"]) == intval($rCategory["id"])) { echo "selected "; } } else if ((isset($_GET["category"])) && ($_GET["category"] == $rCategory["id"])) { echo "selected "; } ?>value="<?=$rCategory["id"]?>"><?=$rCategory["category_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="stream_icon">Cover</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="cover" name="cover" value="<?php if (isset($rSeries)) { echo $rSeries["cover"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_propeties">Genre</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="genre" name="genre" value="<?php if (isset($rSeries)) { echo $rSeries["genre"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="target_container">Plot</label>
                                                            <div class="col-md-8">
                                                                <textarea class="form-control" id="plot" name="plot" rows="3" ><?php if (isset($rSeries)) { echo $rSeries["plot"]; } ?></textarea>
                                                           </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="notes">Cast</label>
                                                            <div class="col-md-8">
                                                                <textarea id="cast" name="cast" class="form-control" rows="3" placeholder=""><?php if (isset($rSeries)) { echo $rSeries["cast"]; } ?></textarea>
                                                            </div>
                                                        </div>
														
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_propeties">Rating</label>
                                                            <div class="col-md-8">
                                                                <input type="number" class="form-control" id="rating" name="rating" value="<?php if (isset($rSeries)) { echo $rSeries["rating"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_propeties">Director</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="director" name="director" value="<?php if (isset($rSeries)) { echo $rSeries["director"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_propeties">Release Date</label>
                                                            <div class="col-md-8">
                                                                <input type="date" class="form-control" id="releaseDate" name="releaseDate" value="<?php if (isset($rSeries)) { echo $rSeries["releaseDate"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_propeties">Last Modified</label>
                                                            <div class="col-md-8">
                                                                <input type="date" class="form-control" id="last_modified" name="last_modified" value="<?php if (isset($rSeries)) { echo $rSeries["last_modified"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_propeties">Seasons</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="seasons" name="seasons" value="<?php if (isset($rSeries)) { echo $rSeries["seasons"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_propeties">Back Drop Path</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="backdrop_path" name="backdrop_path" value="<?php if (isset($rSeries)) { echo $rSeries["backdrop_path"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_propeties">Youtube Trailer</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="youtube_trailer" name="youtube_trailer" value="<?php if (isset($rSeries)) { echo $rSeries["youtube_trailer"]; } ?>">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-8">
														<center>
														<button id="submit_series" type="submit" name="submit_series" class="btn btn-primary">Save</button>
														</center>
														</div>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                            </div>

                                    </div> <!-- end #basicwizard-->
                                </form>

                            </div> <!-- end card-body -->
                        </div> <!-- end card-->
                    </div> <!-- end col -->
                </div>
            </div> <!-- end container -->
				
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
	
		