<?php 
//require("../layout/header.php");
require('../includes/inc_db.php');
include "../functions/functions_xerox.php";




$serieOpen = "menu-open";
$serieActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
   
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
		
		<style>
			.dd-list .dd-item .dd-handle {
				background: #f1f5f7;
				border: none;
				padding: 8px 16px;
				height: auto;
				font-weight: 500;
				border-radius: 3px;
				font-size: x-large;
			}
			.dd-list .dd3-handle {
				margin: 0;
				height: 36px!important;
				float: left;
			}
			.dd-list .dd3-content {
				height: auto;
				border: none;
				padding: 8px 16px 8px 46px;
				background: #f1f5f7;
				font-weight: 600;
			}
			.dd-list .dd3-handle:before {
				content: "=";
				font-family: "Material Design Icons";
				color: #adb5bd;
			}


			
		</style>	  
  <style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}
	
	.dt-button-collection{
		top: 0 !important;
		left: 100% !important;
	}
	
	.dt-button.dropdown-item:hover{
		background-color: #bce9e8 !important;
	}
  </style>
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Episodes </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;">
					<li>
                       <a href="#" onClick="clearFilters();">
                           <button type="button" class="btn btn-warning waves-effect waves-light btn-sm">
                               <i class="fa fa-filter"></i>
                           </button>
                       </a>
                       <a href="#" onClick="changeZoom();">
                           <button type="button" class="btn btn-info waves-effect waves-light btn-sm">
                               <i class="fa fa-search"></i>
                           </button>
                       </a>
                       <?php if (!$detect->isMobile()) { ?>
                       <a href="#" onClick="toggleAuto();">
                           <button type="button" class="btn btn-dark waves-effect waves-light btn-sm">
                               <i class="fa fa-sync-alt"></i> <span class="auto-text"><?=$_["auto_refresh"]?></span>
                           </button>
                       </a>
                       <?php } else { ?>
                       <a href="javascript:location.reload();" onClick="toggleAuto();">
                           <button type="button" class="btn btn-dark waves-effect waves-light btn-sm">
                               <i class="fa fa-sync-alt"></i> <?=$_["refresh"]?>
                           </button>
                       </a>
                       <?php }
						if (hasPermissions("adv", "add_episode")) { ?>
                       <a href="#" onClick="showModal()">
                           <button type="button" class="btn btn-success waves-effect waves-light btn-sm">
                               <i class="fa fa-plus"></i> <?=$_["add_episode"]?>
                           </button>
                       </a>
						 <li>
							 <a style="margin-right:10px;" href="episodes_mass.php<?php if($rCategory) { echo "?category=".$rCategory["id"]; }?>">
								 <button type="button" class="btn btn-secondary waves-effect waves-light btn-sm">
									 <i class="fa fa-edit"></i> Edit Episodes Mass
								 </button>
							 </a>
						 </li>	
						<?php } ?>
                   </li>
            </ol>
				
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?=$_["episodes"]?></h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
				
					 <form id="episodes_form">
                                    <div class="form-group row mb-4">
                                        <?php if ($rPermissions["is_reseller"]) { ?>
                                        <div class="col-md-3">
                                            <input type="text" class="form-control" id="episodes_search" value="" placeholder="<?=$_["search_episodes"]?>...">
                                        </div>
                                        <div class="col-md-3">
                                            <select id="episodes_server" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_servers"]?></option>
                                                <?php foreach (getStreamingServers() as $rServer) { ?>
                                                <option value="<?=$rServer["id"]?>"<?php if ((isset($_GET["server"])) && ($_GET["server"] == $rServer["id"])) { echo " selected"; } ?>><?=$rServer["server_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-3">
                                            <select id="episodes_series" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_series"]?></option>
                                                <?php foreach (getSeriesList() as $rSeriesArr) { ?>
                                                <option value="<?=$rSeriesArr["id"]?>"<?php if ((isset($_GET["series"])) && ($_GET["series"] == $rSeriesArr["id"])) { echo " selected"; } ?>><?=$rSeriesArr["title"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <label class="col-md-1 col-form-label text-center" for="episodes_show_entries"><?=$_["show"]?></label>
                                        <div class="col-md-2">
                                            <select id="episodes_show_entries" class="form-control" data-toggle="select2">
                                                <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo " selected"; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <?php } else { ?>
                                        <div class="col-md-2">
                                            <input type="text" class="form-control" id="episodes_search" value="" placeholder="<?=$_["search_episodes"]?>...">
                                        </div>
                                        <div class="col-md-3">
                                            <select id="episodes_server" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_servers"]?></option>
                                                <?php foreach (getStreamingServers() as $rServer) { ?>
                                                <option value="<?=$rServer["id"]?>"<?php if ((isset($_GET["server"])) && ($_GET["server"] == $rServer["id"])) { echo " selected"; } ?>><?=$rServer["server_name"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-3">
                                            <select id="episodes_series" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["all_series"]?></option>
                                                <?php foreach (getSeriesList() as $rSeriesArr) { ?>
                                                <option value="<?=$rSeriesArr["id"]?>"<?php if ((isset($_GET["series"])) && ($_GET["series"] == $rSeriesArr["id"])) { echo " selected"; } ?>><?=$rSeriesArr["title"]?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <div class="col-md-2">
                                            <select id="episodes_filter" class="form-control" data-toggle="select2">
                                                <option value="" selected><?=$_["no_filter"]?></option>
                                                <option value="1"><?=$_["encoded"]?></option>
                                                <option value="2"><?=$_["encoding"]?></option>
                                                <option value="3"><?=$_["down"]?></option>
                                                <option value="4"><?=$_["ready"]?></option>
                                                <option value="5"><?=$_["direct"]?></option>
                                            </select>
                                        </div>
                                        <label class="col-md-1 col-form-label text-center" for="episodes_show_entries"><?=$_["show"]?></label>
                                        <div class="col-md-1">
                                            <select id="episodes_show_entries" class="form-control" data-toggle="select2">
                                                <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo " selected"; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                        <?php } ?>
                                    </div>
                                </form>
                                <table id="datatable-streampage" class="table stripe table-hover dt-responsive nowrap font-normal" width="100%">
                                    <thead>
                                        <tr>
                                            <th class="text-center"><?=$_["id"]?></th>
                                            <th>Cover</th>
                                            <th><?=$_["name"]?></th>
                                            <th><?=$_["server"]?></th>
                                            <?php if ($rPermissions["is_admin"]) { ?>
                                            <th class="text-center"><?=$_["clients"]?></th>
                                            <th class="text-center"><?=$_["status"]?></th>
                                            <?php } ?>
                                            <th class="text-center"><?=$_["stream_info"]?></th>
                                            <?php if ($rPermissions["is_admin"]) { ?>
                                            <th class="text-center"><?=$_["actions"]?></th>
                                            <?php } ?>
                                        </tr>
                                    </thead>
                                    <tbody></tbody>
                                </table>
				
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

             <div class="modal fade addModal" role="dialog" aria-labelledby="addLabel" aria-hidden="true" style="display: none;" data-username="" data-password="">
            <div class="modal-dialog modal-dialog-centered">
                <div class="modal-content">
                    <div class="modal-header">
                        <h4 class="modal-title" id="addModal"><?=$_["select_series"]?>:</h4>
                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    </div>
                    <div class="modal-body">
                        <div class="col-12">
                            <select id="add_series_id" class="form-control" data-toggle="select2">
                                <?php foreach (getSeriesList() as $rSeries) { ?>
                                <option value="<?=$rSeries["id"]?>"><?=$rSeries["title"]?></option>
                                <?php } ?>
                            </select>
                        </div>
                        <div class="col-12 add-margin-top-20">
                            <div class="input-group">
                                <div class="input-group-append" style="width:100%">
                                    <button style="width:50%" class="btn btn-success waves-effect waves-light" type="button" onClick="addEpisode();"><i class="fa fa-plus-circle-outline"></i> <?=$_["add_episode"]?></button>
                                    <button style="width:50%" class="btn btn-info waves-effect waves-light" type="button" onClick="addEpisodes();"><i class="fa fa-plus-circle-multiple-outline"></i> <?=$_["multiple_episodes"]?></button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div><!-- /.modal-content -->
            </div><!-- /.modal-dialog -->
        </div><!-- /.modal -->
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
		 <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
  
     
        <script>
        var autoRefresh = true;
        var rClearing = false;
        
        function toggleAuto() {
            if (autoRefresh == true) {
                autoRefresh = false;
                $(".auto-text").html("Manual Mode");
            } else {
                autoRefresh = true;
                $(".auto-text").html("Auto-Refresh");
            }
        }
        
        function api(rID, rServerID, rType) {
            if (rType == "delete") {
                if (confirm('<?=$_["episode_delete_confirm"]?>') == false) {
                    return;
                }
            }
            $.getJSON("../functions/api_xerox.php?action=episode&sub=" + rType + "&stream_id=" + rID + "&server_id=" + rServerID, function(data) {
                if (data.result == true) {
                    if (rType == "start") {
                        toastr.success("<?=$_["episode_encoding_start"]?>");
                    } else if (rType == "stop") {
                        toastr.success("<?=$_["episode_encoding_stop"]?>");
                    } else if (rType == "delete") {
                        toastr.success("<?=$_["episode_deleted"]?>");
                    }
                    $.each($('.tooltip'), function (index, element) {
                        $(this).remove();
                    });
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                } else {
                    toastr.warning("<?=$_["error_occured"]?>");
                }
            }).fail(function() {
                toastr.warning("<?=$_["error_occured"]?>");
            });
        }
        function player(rID, rContainer) {
            $.magnificPopup.open({
                items: {
                    src: "../functions/player.php?type=series&id=" + rID + "&container=" + rContainer,
                    type: 'iframe'
                }
            });
        }
        function reloadStreams() {
            if (autoRefresh == true) {
                $('[data-toggle="tooltip"]').tooltip("hide");
                $("#datatable-streampage").DataTable().ajax.reload( null, false );
            }
            setTimeout(reloadStreams, 15000);
        }

        function getSeries() {
            return $("#episodes_series").val();
        }
        function getFilter() {
            return $("#episodes_filter").val();
        }
        function getServer() {
            return $("#episodes_server").val();
        }
        function changeZoom() {
            if ($("#datatable-streampage").hasClass("font-large")) {
                $("#datatable-streampage").removeClass("font-large");
                $("#datatable-streampage").addClass("font-normal");
            } else if ($("#datatable-streampage").hasClass("font-normal")) {
                $("#datatable-streampage").removeClass("font-normal");
                $("#datatable-streampage").addClass("font-small");
            } else {
                $("#datatable-streampage").removeClass("font-small");
                $("#datatable-streampage").addClass("font-large");
            }
            $("#datatable-streampage").DataTable().draw();
        }
        function clearFilters() {
            window.rClearing = true;
            $("#episodes_search").val("").trigger('change');
            $('#episodes_filter').val("").trigger('change');
            $('#episodes_server').val("").trigger('change');
            $('#episodes_series').val("").trigger('change');
            $('#episodes_show_entries').val("<?=$rAdminSettings["default_entries"] ?: 10?>").trigger('change');
            window.rClearing = false;
            $('#datatable-streampage').DataTable().search($("#episodes_search").val());
            $('#datatable-streampage').DataTable().page.len($('#episodes_show_entries').val());
            $("#datatable-streampage").DataTable().page(0).draw('page');
            $('[data-toggle="tooltip"]').tooltip("hide");
            $("#datatable-streampage").DataTable().ajax.reload( null, false );
        }
        function showModal() {
            $('.addModal').modal('show');
        }
        function addEpisode() {
            window.location.href = "episode.php?sid=" + $("#add_series_id").val();
        }
        function addEpisodes() {
            window.location.href = "episode.php?sid=" + $("#add_series_id").val() + "&multi";
        }
        $(document).ready(function() {
			$(window).keypress(function(event){
				if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
			});
            
            
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            $("#datatable-streampage").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                    $('[data-toggle="tooltip"]').tooltip();
                },
				createdRow: function (row, data, dataIndex) {
                    $(row).addClass('stream-' + data[0]);
					if (data[5] == '<button type="button" class="btn btn-block bg-gradient-primary btn-xs">Not Encoded</button>') {
						$(row).css({"background-color": "#fff"})
					}else 
					if (data[5] == '<button type="button" class="btn btn-block bg-gradient-success btn-xs">Encoded</button>') {
						$(row).css({"background-color": "#e4f9d1"})
					}else 
					if (data[5] == '<button type="button" class="btn btn-block bg-gradient-warning btn-xs">Encoding</button>') {
						$(row).css({"background-color": "#F9F09E"})
					}else 
					if (data[5] == '<button type="button" class="btn btn-block bg-gradient-danger btn-xs">Down</button>') {
						$(row).css({"background-color": "#FFBABA "})
					}else 
					if (data[5] == '<button type="button" class="btn btn-block bg-gradient-info btn-xs">Direct</button>') {
						$(row).css({"background-color": "#fff "})
					}
				},
                responsive: true,
                processing: true,
                serverSide: true,
				dom: 'Bfrtip',
				buttons: {
					buttons: [
						{
							text: 'Check All',
							action: function ( e, dt, node, config ) {
								$('.movie_checkbox').prop('checked', true);
								this.innerHTML  == 'UncheckAll'; // disable button
							}
						},
						{
							text: 'Uncheck All',
							action: function ( e, dt, node, config ) {
								$('.movie_checkbox').prop('checked', false);
								this.innerHTML  == 'UncheckAll'; // disable button
							}
						},
						{
							extend: 'collection',
							text: 'Export',
							buttons: [
								'copy',
								'excel',
								'csv',
								'pdf',
								'print'
							]
						},
						{
							extend: 'collection',
							text: 'Mass action',
							buttons: [
								{
									text: 'Encode episodes',
									action: function ( e, dt, node, config ) {
										if($('.movie_checkbox:checkbox:checked').length >0){
											console.log($('.movie_checkbox:checkbox:checked'))
											var checkedVals = $('.movie_checkbox:checkbox:checked').map(function() {
												console.log(this.value);
												api(this.value, $(this).data('server'), 'start')
											}).get();
										}
									}
								},
								
								{
									text: 'Delete',
									action: function ( e, dt, node, config ) {
										if($('.movie_checkbox:checkbox:checked').length >0){
											if (confirm('<?=$_["movie_delete_confirm"]?>') == false) {
													return;
											}
											var checkedVals = $('.movie_checkbox:checkbox:checked').map(function() {	
													$.getJSON("../functions/api_xerox.php?action=episode&sub=delete&stream_id=" + this.value+"&server_id=" + $(this).data('server'), function(data) {
														if (data.result == true) {
															toastr.success("<?=$_["movie_delete_confirmed"]?>");
															$.each($('.tooltip'), function (index, element) {
																$(this).remove();
															});
															
														} else {
															toastr.warning("<?=$_["error_occured"]?>");
														}
													}).fail(function() {
														toastr.warning("<?=$_["error_occured"]?>");
													});
											}).get();	
											$('[data-toggle="tooltip"]').tooltip("hide");
											$("#datatable-streampage").DataTable().ajax.reload( null, false );
										}	else{
											toastr.info("Select some streams");
										}									
									}
								},
							]
						},
					]
				},
               
                ajax: {
                    url: "../functions/table_search.php",
                    "data": function(d) {
                        d.id = "episodes";
                        d.series = getSeries();
                        d.server = getServer();
                        <?php if ($rPermissions["is_admin"]) { ?>
                        d.filter = getFilter();
                        <?php } else { ?>
                        d.filter = 1;
                        <?php } ?>
                    }
                },
                columnDefs: [
                    <?php if ($rPermissions["is_admin"]) { ?>
                    {"className": "dt-center", "targets": [0,3,4,5,6,7]},
                    {"orderable": false, "targets": [5,6]}
                    <?php } else { ?>
                    {"className": "dt-center", "targets": [0,3]}
                    <?php } ?>
                ],
                order: [[ 0, "desc" ]],
                pageLength: 50,
                stateSave: true
            });
            $("#datatable-streampage").css("width", "100%");
            $('#episodes_search').keyup(function(){
                if (!window.rClearing) {
                    $('#datatable-streampage').DataTable().search($(this).val()).draw();
                }
            })
            $('#episodes_show_entries').change(function(){
                if (!window.rClearing) {
                    $('#datatable-streampage').DataTable().page.len($(this).val()).draw();
                }
            })
            $('#episodes_series').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            $('#episodes_server').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            $('#episodes_filter').change(function(){
                if (!window.rClearing) {
                    $('[data-toggle="tooltip"]').tooltip("hide");
                    $("#datatable-streampage").DataTable().ajax.reload( null, false );
                }
            })
            <?php if (!$detect->isMobile()) { ?>
            setTimeout(reloadStreams, 15000);
            <?php }
            if (!$rAdminSettings["auto_refresh"]) { ?>
            toggleAuto();
            <?php } ?>
            if ($('#episodes_search').val().length > 0) {
                $('#datatable-streampage').DataTable().search($('#episodes_search').val()).draw();
            }
        });
        
        $(window).bind('beforeunload', function() {
            //formCache.save();
        });
        </script>
      