<?php 
//require("../layout/header.php");
header('Content-type: text/html; charset=utf-8');
require('../includes/inc_db.php');
include "../functions/functions_xerox.php";


$rCategories = getCategories("movie");
$rTranscodeProfiles = getTranscodeProfiles();

if (isset($_POST["submit_movie"])) {
	include "../functions/tmdb.php";
        if (strlen($rAdminSettings["tmdb_language"]) > 0) {
            $rTMDB = new TMDB($rSettings["tmdb_api_key"]);
        } else {
            $rTMDB = new TMDB($rSettings["tmdb_api_key"]);
        }
		
    set_time_limit(0);
    ini_set('mysql.connect_timeout', 0);
    ini_set('max_execution_time', 0);
    ini_set('default_socket_timeout', 0);
    if (isset($_POST["edit"])) {
		if (!hasPermissions("adv", "edit_movie")) { exit; }
        $rArray = getStream($_POST["edit"]);
        unset($rArray["id"]);
    } else {
		if (!hasPermissions("adv", "add_movie")) { exit; }
        $rArray = Array("movie_symlink" => 0, "type" => 2, "target_container" => Array("mp4"), "added" => time(), "read_native" => 0, "stream_all" => 0, "redirect_stream" => 1, "direct_source" => 0, "gen_timestamps" => 1, "transcode_attributes" => Array(), "stream_display_name" => "", "stream_source" => Array(), "movie_subtitles" => Array(), "category_id" => 0, "stream_icon" => "", "notes" => "", "custom_sid" => "", "custom_ffmpeg" => "", "transcode_profile_id" => 0, "enable_transcode" => 0, "auto_restart" => "[]", "allow_record" => 0, "rtmp_output" => 0, "epg_id" => null, "channel_id" => null, "epg_lang" => null, "tv_archive_server_id" => 0, "tv_archive_duration" => 0, "delay_minutes" => 0, "external_push" => Array(), "probesize_ondemand" => 256000);
    }
    $rArray["stream_display_name"] = $_POST["stream_display_name"];
    if (strlen($_POST["movie_subtitles"]) > 0) {
        $rSplit = explode(":", $_POST["movie_subtitles"]);
        $rArray["movie_subtitles"] = Array("files" => Array($rSplit[2]), "names" => Array("Subtitles"), "charset" => Array("UTF-8"), "location" => intval($rSplit[1]));
    } else {
        $rArray["movie_subtitles"] = Array();
    }
    $rArray["notes"] = $_POST["notes"];
    if (isset($_POST["target_container"])) {
        $rArray["target_container"] = Array($_POST["target_container"]);
    }
    $rArray["category_id"] = $_POST["category_id"];
    if (isset($_POST["custom_sid"])) {
        $rArray["custom_sid"] = $_POST["custom_sid"];
    }
    $rArray["transcode_profile_id"] = $_POST["transcode_profile_id"];
    if (!$rArray["transcode_profile_id"]) {
        $rArray["transcode_profile_id"] = 0;
    }
    if ($rArray["transcode_profile_id"] > 0) {
        $rArray["enable_transcode"] = 1;
    }
    if (isset($_POST["read_native"])) {
        $rArray["read_native"] = 1;
        unset($_POST["read_native"]);
    } else {
        $rArray["read_native"] = 0;
    }
    if (isset($_POST["movie_symlink"])) {
        $rArray["movie_symlink"] = 1;
        unset($_POST["movie_symlink"]);
    } else {
        $rArray["movie_symlink"] = 0;
    }
    if (isset($_POST["direct_source"])) {
        $rArray["direct_source"] = 1;
        unset($_POST["direct_source"]);
    } else {
        $rArray["direct_source"] = 0;
    }
    if (isset($_POST["movie_image"])) {
        $rArray["stream_icon"] = $_POST["movie_image"];
        unset($_POST["movie_image"]);
    } else {
        $rArray["stream_icon"] = "";
    }
    if (isset($_POST["remove_subtitles"])) {
        $rArray["remove_subtitles"] = 1;
        unset($_POST["remove_subtitles"]);
    } else {
        $rArray["remove_subtitles"] = 0;
    }
	if (isset($_POST["restart_on_edit"])) {
		$rRestart = true;
		unset($_POST["restart_on_edit"]);
	} else {
		$rRestart = false;
	}
    $rBouquets = $_POST["bouquets"];
    unset($_POST["bouquets"]);
    $rImportStreams = Array();
   
    if (!empty($_FILES['m3u_file']['tmp_name'])) {
		if (!hasPermissions("adv", "import_movies")) { exit; }
        $rStreamDatabase = Array();
        $result = $db->query("SELECT `stream_source` FROM `streams` WHERE `type` = 2;");
        if (($result) && ($result->num_rows > 0)) {
            while ($row = $result->fetch_assoc()) {
                foreach (json_decode($row["stream_source"], True) as $rSource) {
                    if (strlen($rSource) > 0) {
                        $rStreamDatabase[] = $rSource;
                    }
                }
            }
        }
        $rFile = '';
        if ((!empty($_FILES['m3u_file']['tmp_name'])) && (strtolower(pathinfo($_FILES['m3u_file']['name'], PATHINFO_EXTENSION)) == "m3u")) {
            $rFile = file_get_contents($_FILES['m3u_file']['tmp_name']);
        }
        preg_match_all('/(?P<tag>#EXTINF:[-1,0])|(?:(?P<prop_key>[-a-z]+)=\"(?P<prop_val>[^"]+)")|(?<name>,[^\r\n]+)|(?<url>http[^\s]*:\/\/.*\/.*)/', $rFile, $rMatches);
        $rResults = [];
        $rIndex = -1;
        for ($i = 0; $i < count($rMatches[0]); $i++) {
            $rItem = $rMatches[0][$i];
            if (!empty($rMatches['tag'][$i])) {
                ++$rIndex;
            } elseif (!empty($rMatches['prop_key'][$i])) {
                $rResults[$rIndex][$rMatches['prop_key'][$i]] = trim($rMatches['prop_val'][$i]);
            } elseif (!empty($rMatches['name'][$i])) {
                $rResults[$rIndex]['name'] = trim(substr($rItem, 1));
            } elseif (!empty($rMatches['url'][$i])) {
                $rResults[$rIndex]['url'] = str_replace(" ", "%20", trim($rItem));
            }
        }
        foreach ($rResults as $rResult) {
			if (!in_array($rResult["url"], $rStreamDatabase)) {
                $rPathInfo = pathinfo($rResult["url"]);
				$filmName = $rResult["name"] ?: "";
				$movie_propeties = [];
				$stream_icon = $rResult["tvg-logo"] ?: "";
				$properties = $rTMDB->searchMovie($filmName);
				if(!empty($properties)){
					$movie_propeties = (array)$properties[0]->_data;
					$filmName = $properties[0]->_data['original_title'];
					$stream_icon = $properties[0]->_data['poster_path'];					
				}					
                $rImportArray = Array("stream_source" => Array($rResult["url"]), "stream_icon" => $stream_icon, "stream_display_name" => $filmName, 
						"movie_propeties" => $movie_propeties, "async" => true, "target_container" => Array($rPathInfo["extension"]));
                $rImportStreams[] = $rImportArray;
                
			}
        }
    } 
	else if (!empty($_POST["import_folder"])) {
		if (!hasPermissions("adv", "import_movies")) { exit; }
        $rStreamDatabase = Array();
        $result = $db->query("SELECT `stream_source` FROM `streams` WHERE `type` = 2;");
        if (($result) && ($result->num_rows > 0)) {
            while ($row = $result->fetch_assoc()) {
                foreach (json_decode($row["stream_source"], True) as $rSource) {
                    if (strlen($rSource) > 0) {
                        $rStreamDatabase[] = $rSource;
                    }
                }
            }
        }
        $rParts = explode(":", $_POST["import_folder"]);
        if (is_numeric($rParts[1])) {
            if (isset($_POST["scan_recursive"])) {
                $rFiles = scanRecursive(intval($rParts[1]), $rParts[2].'/', Array("mp4", "mkv", "avi", "mpg", "flv")); // Only these containers are accepted.
            } else {
                $rFiles = Array();
                foreach (listDir(intval($rParts[1]), rtrim($rParts[2].'/'), Array("mp4", "mkv", "avi", "mpg", "flv"))["files"] as $rFile) {
                    $rFiles[] = rtrim($rParts[2], "/")."/".$rFile;
                }
            }
			
            foreach ($rFiles as $rFile) {
                $rFilePath = "s:".intval($rParts[1]).":".$rFile;
                if (!in_array($rFilePath, $rStreamDatabase)) {
                    $rPathInfo = pathinfo($rFile);
					$filmName = $rPathInfo["filename"];
					$movie_propeties = [];
					$stream_icon = "";
					$properties = $rTMDB->searchMovie($filmName);
					$property = [];
					if(!empty($properties)){
						$movie_propeties = (array)$properties[0]->_data;
						$rResult = (array)$properties[0]->_data;
						$filmName = $properties[0]->_data['original_title'];
						$stream_icon = "https://image.tmdb.org/t/p/w600_and_h900_bestv2".$properties[0]->_data['poster_path'];
						
						 $rTMDBURL = "https://www.themoviedb.org/movie/".$rResult['id'];
						 
						 $rTitle = $rResult['title'];
						if ($rResult['release_date']) {
							$rTitle .= " (" .substr($rResult['release_date'],0 , 4).")";
						}
						$filmName = $rTitle;
						
						$rCast = "";
						$rMemberID = 0;
						foreach($rResult['credits']['cast'] as $cast){
							$rMemberID++;
							if ($rMemberID <= 5) {
								if (strlen($rCast) > 0) {
									$rCast .= ", ";
								}
								$rCast .= $cast['name'];
							}
						}
						
						$rGenres = "";
						$rGenreID = 0;
						foreach($rResult['genres'] as $genre){
							$rGenreID += 1;
							if ($rGenreID <= 3) {
								if (strlen($rGenres) > 0) {
									$rGenres .= ", ";
								}
								$rGenres .= $genre['name'];
							}
						}
						$director = "";
						foreach($rResult['credits']['crew'] as $crew){
							if ($crew['department'] == "Directing") {
								$director = $crew['name'];
							}
						}
						
						$plot = $rResult['overview'];
						if (strlen($rResult['production_countries']) > 0) {
							$country =  $rResult['production_countries'][0]->name;
						}
						$rating = $rResult['vote_average'];
						 
						$rSeconds = $rResult["runtime"]*60;
						$property = Array("tmdb_url" => $rTMDBURL, "tmdb_id" => $rResult['id'], "name" => $rTitle,
							"o_name" => $rResult["original_title"], "cover_big" => "https://image.tmdb.org/t/p/w600_and_h900_bestv2".$rResult["backdrop_path"], 
							"movie_image" => "https://image.tmdb.org/t/p/w600_and_h900_bestv2".$rResult["poster_path"], 
							"releasedate" => $rResult["release_date"], "episode_run_time" => $rSeconds, "youtube_trailer" => $rResult["trailer"],
							"director" => $director, "actors" => $rCast, "cast" => $rCast, "description" => $rResult["overview"], "plot" => $rResult["overview"], 
							"age" => "", "mpaa_rating" => "", "rating_count_kinopoisk" => 0, "country" => $country, "genre" => $rGenres, "backdrop_path" => Array("https://image.tmdb.org/t/p/w600_and_h900_bestv2".$rResult["backdrop_path"]), 
							"duration_secs" => $rSeconds, "duration" => sprintf('%02d:%02d:%02d', ($rSeconds/3600),($rSeconds/60%60), $rSeconds%60), "video" => Array(), "audio" => Array(),
							"bitrate" => 0, "rating" => $rating, "original_language" => $rResult["original_language"]);
							
						
					}
                    $rImportArray = Array("stream_source" => Array($rFilePath), "stream_icon" => $stream_icon, "stream_display_name" => $filmName, 
						"movie_propeties" => $property, "async" => true, "target_container" => Array($rPathInfo["extension"]));
                    $rImportStreams[] = $rImportArray;
                }
            }
        }
    } 
	else {
        $rImportArray = Array("stream_source" => Array($_POST["stream_source"]), "stream_icon" => $rArray["stream_icon"], "stream_display_name" => $rArray["stream_display_name"], "movie_propeties" => Array(), "async" => false);
        if (strlen($_POST["tmdb_id"]) > 0) {
            $rTMDBURL = "https://www.themoviedb.org/movie/".$_POST["tmdb_id"];
        } else {
            $rTMDBURL = "";
        }
        if ($rAdminSettings["download_images"]) {
            $_POST["movie_image"] = downloadImage($_POST["movie_image"]);
            $_POST["backdrop_path"] = downloadImage($_POST["backdrop_path"]);
        }
        $rSeconds = intval($_POST["episode_run_time"]) * 60;
        $rImportArray["movie_propeties"] = Array("tmdb_url" => $rTMDBURL, "tmdb_id" => $_POST["tmdb_id"], "name" => $rArray["stream_display_name"], "o_name" => $rArray["stream_display_name"], "cover_big" => $_POST["movie_image"], "movie_image" => $_POST["movie_image"], "releasedate" => $_POST["releasedate"], "episode_run_time" => $_POST["episode_run_time"], "youtube_trailer" => $_POST["youtube_trailer"], "director" => $_POST["director"], "actors" => $_POST["cast"], "cast" => $_POST["cast"], "description" => $_POST["plot"], "plot" => $_POST["plot"], "age" => "", "mpaa_rating" => "", "rating_count_kinopoisk" => 0, "country" => $_POST["country"], "genre" => $_POST["genre"], "backdrop_path" => Array($_POST["backdrop_path"]), "duration_secs" => $rSeconds, "duration" => sprintf('%02d:%02d:%02d', ($rSeconds/3600),($rSeconds/60%60), $rSeconds%60), "video" => Array(), "audio" => Array(), "bitrate" => 0, "rating" => $_POST["rating"], "original_language" => $_POST["original_language"]);
        if (strlen($rImportArray["movie_propeties"]["backdrop_path"][0]) == 0) {
            unset($rImportArray["movie_propeties"]["backdrop_path"]);
        }
		if (isset($_POST["edit"])) {
			$rImportStreams[] = $rImportArray;
		} else {
			$rResult = $db->query("SELECT COUNT(`id`) AS `count` FROM `streams` WHERE `stream_display_name` = '".ESC($rImportArray["stream_display_name"])."' AND `type` = 2;");
			if ($rResult->fetch_assoc()["count"] == 0) {
				$rImportStreams[] = $rImportArray;
			} else {
				$_STATUS = 2;
				$rMovie = array_merge($rArray, $rImportArray);
			}
		}
    }
	
    if (count($rImportStreams) > 0) {
        $rRestartIDs = Array();
		
        foreach ($rImportStreams as $rImportStream) {//$rImportStream['stream_display_name']
			
            $rImportArray = $rArray;
            foreach (array_keys($rImportStream) as $rKey) {
				$rImportArray[$rKey] = $rImportStream[$rKey];
            }
            $rImportArray["order"] = getNextOrder();
			//die(json_encode($rImportArray));
            $rSync = $rImportArray["async"];
            unset($rImportArray["async"]);
            $rCols = "`".ESC(implode('`,`', array_keys($rImportArray)))."`";
            $rValues = null;
            foreach (array_values($rImportArray) as $rValue) {
                isset($rValues) ? $rValues .= ',' : $rValues = '';
                if (is_array($rValue)) {
                    $rValue = json_encode($rValue);
                }
                if (is_null($rValue)) {
                    $rValues .= 'NULL';
                } else {
                    $rValues .= '\''.ESC($rValue).'\'';
                }
            }
            if (isset($_POST["edit"])) {
                $rCols = "`id`,".$rCols;
                $rValues = ESC($_POST["edit"]).",".$rValues;
            }
            $rQuery = "REPLACE INTO `streams`(".$rCols.") VALUES(".$rValues.");";
            if ($db->query($rQuery)) {
                if (isset($_POST["edit"])) {
                    $rInsertID = intval($_POST["edit"]);
                } else {
                    $rInsertID = $db->insert_id;
                }
                $rStreamExists = Array();
                if (isset($_POST["edit"])) {
                    $result = $db->query("SELECT `server_stream_id`, `server_id` FROM `streams_sys` WHERE `stream_id` = ".intval($rInsertID).";");
                    if (($result) && ($result->num_rows > 0)) {
                        while ($row = $result->fetch_assoc()) {
                            $rStreamExists[intval($row["server_id"])] = intval($row["server_stream_id"]);
                        }
                    }
                }
                if (isset($_POST["loadbalancer"])) {
                    $rStreamsAdded = Array();
                   // $rServerTree = json_decode($_POST["server_tree_data"], True);
                    $rServerTree = $_POST["loadbalancer"];
                    foreach ($rServerTree as $rServer) {
                            $rServerID = intval($rServer);
                            $rStreamsAdded[] = $rServerID;
                            $rParent = "NULL";
                            if (isset($rStreamExists[$rServerID])) {
                                $db->query("UPDATE `streams_sys` SET `parent_id` = ".$rParent.", `on_demand` = 0 WHERE `server_stream_id` = ".$rStreamExists[$rServerID].";");
                            } else {
                                $db->query("INSERT INTO `streams_sys`(`stream_id`, `server_id`, `parent_id`, `on_demand`) VALUES(".intval($rInsertID).", ".$rServerID.", ".$rParent.", 0);");
                            }
                    }
                    foreach ($rStreamExists as $rServerID => $rDBID) {
                        if (!in_array($rServerID, $rStreamsAdded)) {
                            $db->query("DELETE FROM `streams_sys` WHERE `server_stream_id` = ".$rDBID.";");
                        }
                    }
                }
                if ($rRestart) {
                    $rRestartIDs[] = $rInsertID;
                }
                foreach ($rBouquets as $rBouquet) {
                    addToBouquet("stream", $rBouquet, $rInsertID);
                }
                foreach (getBouquets() as $rBouquet) {
                    if (!in_array($rBouquet["id"], $rBouquets)) {
                        removeFromBouquet("stream", $rBouquet["id"], $rInsertID);
                    }
                }
                if ($rSync) {
                    // Sync TMDb in background.
                    $db->query("INSERT INTO `tmdb_async`(`type`, `stream_id`) VALUES(1, ".intval($rInsertID).");");
                }
            }
        }
        scanBouquets();
        if ($rRestart) {
            APIRequest(Array("action" => "vod", "sub" => "start", "stream_ids" => $rRestartIDs));
        }
        if (isset($_FILES["m3u_file"])) {
            header("Location: ./movies.php?successedit");exit;
        } else if (!isset($_GET["id"])) {
            header("Location: ./movie.php?successedit&id=".$rInsertID); exit;
        }
    } else {
        if (!isset($_STATUS)) {
			$_STATUS = 3;
            $rMovie = $rArray;
		}
    }

}

$rServerTree = Array();
$rServerTree[] = Array("id" => "source", "parent" => "#", "text" => "<strong>".$_["stream_source"]."</strong>", "icon" => "fa fa-youtube", "state" => Array("opened" => true));
if (isset($_GET["id"])) {
    if ((isset($_GET["import"])) OR (!hasPermissions("adv", "edit_movie"))) { exit; }
    $rMovie = getStream($_GET["id"]);
	$result = $db->query("SELECT `server_stream_id`, `server_id` FROM `streams_sys` WHERE `stream_id` = ".intval($_GET["id"]).";");
    if (($result) && ($result->num_rows > 0)) {
        while ($row = $result->fetch_assoc()) {
            $rStreamExists[intval($row["server_id"])] = intval($row["server_stream_id"]);
        }
    }
	
	
    if ((!$rMovie) or ($rMovie["type"] <> 2)) {
        exit;
    }
    $rMovie["properties"] = json_decode($rMovie["movie_propeties"], True);
	
    $rStreamSys = getStreamSys($_GET["id"]);
    foreach ($rServers as $rServer) {
        if (isset($rStreamSys[intval($rServer["id"])])) {
            if ($rStreamSys[intval($rServer["id"])]["parent_id"] <> 0) {
                $rParent = intval($rStreamSys[intval($rServer["id"])]["parent_id"]);
            } else {
                $rParent = "source";
            }
        } else {
            $rParent = "#";
        }
        $rServerTree[] = Array("id" => $rServer["id"], "parent" => $rParent, "text" => $rServer["server_name"], "icon" => "fa fa-server", "state" => Array("opened" => true));
    }
} else {
	if (!hasPermissions("adv", "add_movie")) { exit; }
    foreach ($rServers as $rServer) {
        $rServerTree[] = Array("id" => $rServer["id"], "parent" => "#", "text" => $rServer["server_name"], "icon" => "fa fa-server", "state" => Array("opened" => true));
    }
}

$vodOpen = "menu-open";
$vodActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
  <style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}
	.select2-container--bootstrap4 .select2-selection--multiple .select2-selection__choice{
		background: #e3dcdc;
	}
  
  </style>
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Movies </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;"> 
                 <li>
                                        <a href="movies.php<?php if (isset($_GET["category"])) { echo "?category=".$_GET["category"]; } ?>">
                                            <button type="button" class="btn btn-primary waves-effect waves-light btn-sm">
                                                <?=$_["view_movies"]?>
                                            </button>
                                        </a>
                                        <?php if (!isset($_GET["import"])) { ?>
                                        <a href="movie.php?import">
                                            <button type="button" class="btn btn-info waves-effect waves-light btn-sm">
                                                <?=$_["import_multiple"]?>
                                            </button>
                                        </a>
                                        <?php } else { ?>
                                        <a href="./movie.php">
                                            <button type="button" class="btn btn-info waves-effect waves-light btn-sm">
                                                <?=$_["add_single"]?>
                                            </button>
                                        </a>
                                        <?php } ?>
				</li>
             </ol>
         
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?php if (isset($rMovie["id"])) { echo $rMovie["stream_display_name"].' &nbsp;<button type="button" class="btn btn-outline-info waves-effect waves-light btn-xs" onClick="player('.$rMovie["id"].', \''.json_decode($rMovie["target_container"], True)[0].'\');"><i class="fa fa-play"></i></button>'; } else if (isset($_GET["import"])) { echo $_["import_movies"]; } else { echo $_["add_movie"]; } ?></h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
			  <div class="row">
                    <div class="col-xl-12">
                        <?php if ((isset($_STATUS)) && ($_STATUS == 0)) {
							if (!$rSettings["sucessedit"]) { ?>
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <?=$_["movies_info_1"]?>
                        </div>
						<?php } else { ?>
                    <script type="text/javascript">
  					swal("", '<?=$_["movies_info_1"]?>', "success");
  					</script>
                        <?php } } else if ((isset($_STATUS)) && ($_STATUS == 1)) { if (!$rSettings["sucessedit"]) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <?=$_["movies_info_2"]?>
                        </div>
						<?php } else { ?>
                    <script type="text/javascript">
  					swal("", '<?=$_["movies_info_2"]?>', "warning");
  					</script>
                        <?php } } else if ((isset($_STATUS)) && ($_STATUS == 2)) { if (!$rSettings["sucessedit"]) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <?=$_["movies_info_3"]?>
                        </div>
						<?php } else { ?>
                    <script type="text/javascript">
  					swal("", '<?=$_["movies_info_3"]?>', "warning");
  					</script>
                        <?php } } else if ((isset($_STATUS)) && ($_STATUS == 3)) { if (!$rSettings["sucessedit"]) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <?=$_["movies_info_4"]?>
                        </div>
                        <?php } else { ?>
                    <script type="text/javascript">
  					swal("", '<?=$_["movies_info_4"]?>', "warning");
  					</script>
                        <?php } }
                        
						if (isset($rMovie["id"])) { ?>
                        <div class="card text-xs-center">
                            <div class="table">
                                <table id="datatable-list" class="table stripe table-borderless mb-0">
                                    <thead class="bg-light">
                                        <tr>
                                            <th></th>
                                            <th></th>
                                            <th></th>
                                            <th><?=$_["server"]?></th>
                                            <th><?=$_["status"]?></th>
                                            <th>Category</th>
                                            <th><?=$_["clients"]?></th>
                                            <th></th>
                                            <th></th>
                                            <th><?=$_["actions"]?></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <td colspan="7" class="text-center"><?=$_["loading_movie_information"]?>...</td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        <?php $rEncodeErrors = getEncodeErrors($rMovie["id"]);
                        foreach ($rEncodeErrors as $rServerID => $rEncodeError) { ?>
                        <div class="alert alert-warning alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <strong><?=$_["error_on_server"]?> - <?=$rServers[$rServerID]["server_name"]?></strong><br/>
                            <?=str_replace("\n", "<br/>", $rEncodeError)?>
                        </div>
                        <?php } 
						} ?>
                       
                    </div> <!-- end col -->
                </div>
			  <form <?php if(isset($_GET["import"])) { echo " enctype=\"multipart/form-data\""; } ?> action="movie.php<?php if (isset($_GET["import"])) { echo "?import"; } else if (isset($_GET["id"])) { echo "?id=".$_GET["id"]; } ?>" method="POST" id="stream_form" data-parsley-validate="">
                                    <?php if (isset($rMovie["id"])) { ?>
                                    <input type="hidden" name="edit" value="<?=$rMovie["id"]?>" />
                                    <?php } ?>
                                    <!--<input type="text" id="tmdb_id" name="tmdb_id" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["tmdb_id"]); } ?>" />-->
                                    <input type="hidden" name="server_tree_data" id="server_tree_data" value="" />
					<div class="row">
						
						<div class="col-md-6">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title"><?=$_["details"]?></h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										 <div class="row">
                                                    <div class="col-12">
                                                        <?php if (!isset($_GET["import"])) { 
															$original_language = 'fr';
															if(isset($rMovie)){
																$original_language = $rMovie['properties']['original_language'];
															}
															//die($original_language);
														?>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="stream_display_name"><?=$_["movie_name"]?></label>
                                                            <div class="col-md-3">
                                                                <select class="form-control select select2" id="stream_tmdb_language" data-select2-id="lang" tabindex="-1" aria-hidden="true">
																	<option value="en" <?=($original_language == "en")?'selected': ''?>>
																		English
																	</option>
																	<option value="it" <?=($original_language == "it")?'selected': ''?>>
																		Italian
																	</option>
																	<option value="de" <?=($original_language == "de")?'selected': ''?>>
																		German
																	</option>
																	<option value="el" <?=($original_language == "el")?'selected': ''?>>
																		Greek
																	</option>
																	<option value="es" <?=($original_language == "es")?'selected': ''?>>
																		Spanish
																	</option>
																	<option value="tr" <?=($original_language == "tr")?'selected': ''?>>
																		Turkish
																	</option>
																	<option value="fr" <?=($original_language == "fr")?'selected': ''?>>
																		French
																	</option>
																	<option value="nl" <?=($original_language == "nl")?'selected': ''?>>
																		Dutch
																	</option>
																	<option value="ar" <?=($original_language == "ar")?'selected': ''?>>
																		Arabic
																	</option>
																	<option value="pt" <?=($original_language == "pt")?'selected': ''?>>
																		Portuguese
																	</option>
																	<option value="pl" <?=($original_language == "pl")?'selected': ''?>>
																		Poland
																	</option>
																	<option value="sv" <?=($original_language == "sv")?'selected': ''?>>
																		Swedish
																	</option>
																	<option value="hu" <?=($original_language == "hu")?'selected': ''?>>
																		Hungarian
																	</option>
																	<option value="hi" <?=($original_language == "hi")?'selected': ''?>>
																		Hindi
																	</option>
																</select>
                                                            </div>
                                                            <div class="col-md-5">
                                                                
																<div class="input-group">
																  <input type="text" class="form-control " id="stream_search_id" name="stream_search_id" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]['tmdb_id']); } ?>" >
																  <span class="input-group-append">
																	<button type="button" class="btn btn-info btn-flat search_tmdb" >Search</button>
																  </span>
																</div>
															</div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" ></label>
															<div class="col-md-8">
																<div class="input-group">
																	<input type="text" class="form-control " id="stream_display_name" name="stream_display_name" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["stream_display_name"]); } ?>" required data-parsley-trigger="change">
																	<span class="input-group-append">
																	<button type="button" class="btn btn-info btn-flat search_tmdb_name" >Search</button>
																  </span>
																</div>
															</div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="tmdb_search"><?=$_["tmdb_results"]?></label>
                                                            <div class="col-md-8">
                                                                <select id="tmdb_search" class="form-control" data-toggle="select2"></select>
                                                            </div>
                                                        </div>
                                                        
														<?php

                                                        if (isset($rMovie)) {
															
															
															 @header('Content-Type: text/html; charset=utf-8');
                                                             //$response="بسم الله الرحمن الرحيم";  
                                                              $rMovieSource= iconv('windows-1256', 'utf-8', ($rMovieSource)); 
                                                             
															
															
															
                                                            $rMovieSource = json_decode($rMovie["stream_source"], True)[0];
                                                        } else {
                                                            $rMovieSource = "";
                                                        } ?>
                                                        <div class="form-group row mb-4 stream-url">
                                                            <label class="col-md-4 col-form-label" for="stream_source"><?=$_["movie_path_or_url"]?></label>
                                                            <div class="col-md-8 input-group">
                                                                <input type="text" id="stream_source" name="stream_source" class="form-control" value="<?=$rMovieSource?>" required data-parsley-trigger="change">
                                                                <div class="input-group-append">
                                                                    <a href="#file-browser" id="filebrowser" class="btn btn-primary waves-effect waves-light"><i class="fa fa-folder-open"></i></a>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <?php } else { ?>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="import_type"><?=$_["type"]?></label>
                                                            <div class="col-md-8">
                                                                <div class="custom-control custom-radio mt-1">
                                                                    <span>
                                                                        <input type="radio" id="import_type_1" name="customRadio" class="custom-control-input" checked>
                                                                        <label class="custom-control-label" for="import_type_1"><?=$_["m3u"]?></label>
                                                                    </span>
                                                                    <span style="padding-left:50px;">
                                                                        <input type="radio" id="import_type_2" name="customRadio" class="custom-control-input">
                                                                        <label class="custom-control-label" for="import_type_2"><?=$_["folder"]?></label>
                                                                    </span>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div id="import_m3uf_toggle">
                                                            <div class="form-group row mb-4">
                                                                <label class="col-md-4 col-form-label" for="m3u_file"><?=$_["m3u_file"]?></label>
                                                                <div class="col-md-8">
                                                                    <input type="file" id="m3u_file" name="m3u_file" />
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div id="import_folder_toggle" style="display:none;">
                                                            <div class="form-group row mb-4">
                                                                <label class="col-md-4 col-form-label" for="import_folder"><?=$_["folder"]?></label>
                                                                <div class="col-md-8 input-group">
                                                                    <input type="text" id="import_folder" name="import_folder" class="form-control" value="<?=$rMovieSource?>">
                                                                    <div class="input-group-append">
                                                                        <a href="#file-browser" id="filebrowser" class="btn btn-primary waves-effect waves-light"><i class="fa fa-folder-open"></i></a>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                            <div class="form-group row mb-4">
                                                                <label class="col-md-4 col-form-label" for="scan_recursive"><?=$_["scan_recursively"]?></label>
                                                                <div class="col-md-2">
                                                                    <input name="scan_recursive" id="scan_recursive" type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <?php } ?>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="category_id"><?=$_["category_name"]?></label>
                                                            <div class="col-md-8">
                                                                <select name="category_id" id="category_id" class="form-control" data-toggle="select2">
                                                                    <?php foreach ($rCategories as $rCategory) { ?>
                                                                    <option <?php if (isset($rMovie)) { if (intval($rMovie["category_id"]) == intval($rCategory["id"])) { echo "selected "; } } else if ((isset($_GET["category"])) && ($_GET["category"] == $rCategory["id"])) { echo "selected "; } ?>value="<?=$rCategory["id"]?>"><?=$rCategory["category_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="bouquets"><?=$_["add_to_bouquets"]?></label>
                                                            <div class="col-md-8">
                                                                <select name="bouquets[]" id="bouquets" class="form-control select2-multiple" data-toggle="select2" multiple="multiple" data-placeholder="<?=$_["choose"]?>...">
                                                                    <?php foreach (getBouquets() as $rBouquet) { ?>
                                                                    <option <?php if (isset($rMovie)) { if (in_array($rMovie["id"], json_decode($rBouquet["bouquet_channels"], True))) { echo "selected "; } } ?>value="<?=$rBouquet["id"]?>"><?=$rBouquet["bouquet_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="notes"><?=$_["notes"]?></label>
                                                            <div class="col-md-8">
                                                                <textarea id="notes" name="notes" class="form-control" rows="3" placeholder=""><?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["notes"]); } ?></textarea>
                                                            </div>
                                                        </div>
														
														 <div class="row">
															<div class="col-12">
																<div class="form-group row mb-4">
																	<label class="col-md-4 col-form-label" for="servers"><?=$_["server_tree"]?></label>
																	<div class="col-md-8">
																		<select id="servers" class="form-control select2" name="loadbalancer[]" multiple data-toggle="select2" required>
																			<?php foreach (getStreamingServers() as $rServer) { ?>
																			<option value="<?=$rServer["id"]?>"
																			<?php if ((isset($_GET["id"])) && (in_array($rServer["id"], array_keys($rStreamSys)))) { echo " selected"; } ?>><?=htmlspecialchars($rServer["server_name"])?></option>
																			<?php } ?>
																		</select>
																	</div>
																</div>
																<div class="form-group row mb-4">
																	<label class="col-md-4 col-form-label" for="restart_on_edit"><?php if (isset($rMovie)) { ?><?=$_["reprocess_on_edit"]?><?php } else { ?><?=$_["process_movie"]?><?php } ?></label>
																	<div class="col-md-2">
																		<input name="restart_on_edit" id="restart_on_edit" type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
																	</div>
																</div>
															</div> <!-- end col -->
														</div> <!-- end row -->
														
														<div class="row">
                                                    <div class="col-12">
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="direct_source"><?=$_["direct_source"]?> <i data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["episode_tooltip_1"]?>" class="fa fa-info-circle"></i></label>
                                                            <div class="col-md-2">
                                                                <input name="direct_source" id="direct_source" type="checkbox" <?php if (isset($rMovie)) { if ($rMovie["direct_source"] == 1) { echo "checked "; } } ?>data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                            <label class="col-md-4 col-form-label" for="read_native"><?=$_["native_frames"]?></label>
                                                            <div class="col-md-2">
                                                                <input name="read_native" id="read_native" type="checkbox" <?php if (isset($rMovie)) { if ($rMovie["read_native"] == 1) { echo "checked "; } } ?>data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_symlink"><?=$_["create_symlink"]?> <i data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["episode_tooltip_2"]?>" class="fa fa-info-circle"></i></label>
                                                            <div class="col-md-2">
                                                                <input name="movie_symlink" id="movie_symlink" type="checkbox" <?php if (isset($rMovie)) { if ($rMovie["movie_symlink"] == 1) { echo "checked "; } } else echo "checked "; ?>data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                            <?php if (!isset($_GET["import"])) { ?>
                                                            <label class="col-md-4 col-form-label" for="custom_sid"><?=$_["custom_channel_sid"]?> <i data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["episode_tooltip_5"]?>" class="fa fa-info-circle"></i></label>
                                                            <div class="col-md-2">
                                                                <input type="text" class="form-control" id="custom_sid" name="custom_sid" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["custom_sid"]); } ?>">
                                                            </div>
                                                            <?php } else { ?>
                                                            <label class="col-md-4 col-form-label" for="remove_subtitles"><?=$_["remove_existing_subtitles"]?> <i data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["episode_tooltip_3"]?>" class="fa fa-info-circle"></i></label>
                                                            <div class="col-md-2">
                                                                <input name="remove_subtitles" id="remove_subtitles" type="checkbox" <?php if (isset($rMovie)) { if ($rMovie["remove_subtitles"] == 1) { echo "checked "; } } ?>data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                            <?php } ?>
                                                        </div>
                                                        <?php if (!isset($_GET["import"])) {
                                                        $rSubFile = "";
                                                        if (isset($rMovie)) {
                                                            $rSubData = json_decode($rMovie["movie_subtitles"], True);
                                                            if (isset($rSubData["location"])) {
                                                                $rSubFile = "s:".$rSubData["location"].":".$rSubData["files"][0];
                                                            }
                                                        }
                                                        ?>
                                                        <div class="form-group row mb-4 stream-url">
                                                            <label class="col-md-4 col-form-label" for="movie_subtitles"><?=$_["subtitle_location"]?> <i data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["episode_tooltip_6"]?>" class="fa fa-info-circle"></i></label>
                                                            <div class="col-md-8 input-group">
                                                                <input type="text" id="movie_subtitles" name="movie_subtitles" class="form-control" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rSubFile); } ?>">
                                                                <div class="input-group-append">
                                                                    <a href="#file-browser" id="filebrowser-sub" class="btn btn-primary waves-effect waves-light"><i class="fa fa-folder-open"></i></a>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <?php } ?>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="transcode_profile_id"><?=$_["transcoding_profile"]?> <i data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["episode_tooltip_7"]?>" class="fa fa-info-circle"></i></label>
                                                            <div class="col-md-8">
                                                                <select name="transcode_profile_id" id="transcode_profile_id" class="form-control" data-toggle="select2">
                                                                    <option <?php if (isset($rMovie)) { if (intval($rMovie["transcode_profile_id"]) == 0) { echo "selected "; } } ?>value="0"><?=$_["transcoding_disabled"]?></option>
                                                                    <?php foreach ($rTranscodeProfiles as $rProfile) { ?>
                                                                    <option <?php if (isset($rMovie)) { if (intval($rMovie["transcode_profile_id"]) == intval($rProfile["profile_id"])) { echo "selected "; } } ?>value="<?=$rProfile["profile_id"]?>"><?=$rProfile["profile_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <?php if (!isset($_GET["import"])) { ?>
                                                            <label class="col-md-4 col-form-label" for="target_container"><?=$_["target_container"]?> <i data-toggle="tooltip" data-placement="top" title="" data-original-title="<?=$_["episode_tooltip_4"]?>" class="fa fa-info-circle"></i></label>
                                                            <div class="col-md-2">
                                                                <select name="target_container" id="target_container" class="form-control" data-toggle="select2">
                                                                    <?php foreach (Array("mp4", "mkv", "avi", "mpg", "flv") as $rContainer) { ?>
                                                                    <option <?php if (isset($rMovie)) { if (json_decode($rMovie["target_container"], True)[0] == $rContainer) { echo "selected "; } } ?>value="<?=$rContainer?>"><?=$rContainer?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                            <label class="col-md-4 col-form-label" for="remove_subtitles"><?=$_["remove_existing_subtitles"]?> <i data-toggle="tooltip" data-placement="top" title="" data-original-title=<?=$_["episode_tooltip_3"]?>" class="fa fa-info-circle"></i></label>
                                                            <div class="col-md-2">
                                                                <input name="remove_subtitles" id="remove_subtitles" type="checkbox" <?php if (isset($rMovie)) { if ($rMovie["remove_subtitles"] == 1) { echo "checked "; } } ?>data-plugin="switchery" class="js-switch" data-color="#039cfd"/>
                                                            </div>
                                                            <?php } ?>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <?php if (isset($_GET["id"])) { ?>
                                                            <label class="col-md-4 col-form-label" for="Movie_Added">Movie Added</label>
                                                            <div class="col-md-8">
                                                                <input name="movie_added" id="Movie_Added" type="date" value="<?php if (isset($rMovie)) { echo date('Y-m-d', ($rMovie["added"]));} ?>" class="form-control datetimepicker-input"/>
                                                            </div>
                                                            <?php } ?>
                                                        </div>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                                
														
														
														
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
                        <?php if (!isset($_GET["import"])) { ?>
						<div class="col-md-6">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title"><?=$_["information"]?></h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="movie-information" style="display:block">
                                                <div class="row">
                                                    <div class="col-12">
                                                        <div class="form-group row mb-2">
															<div class="col-md-5">															
																<img src="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["stream_icon"]); } ?>" id="movie_img_src" class="img-thumbnail" style="<?php if (!isset($rMovie)) { echo 'display:none;'; }?>" >
															</div>
														</div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="movie_image"><?=$_["poster_url"]?></label>
                                                            <div class="col-md-8 input-group">
                                                                <input type="text" class="form-control" id="movie_image" name="movie_image" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["stream_icon"]); } ?>">
                                                                <div class="input-group-append">
                                                                    <a href="javascript:void(0)" onClick="openImage(this)" class="btn btn-primary waves-effect waves-light"><i class="fa fa-eye"></i></a>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-2">
															<div class="col-md-6">															
																<img src="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["backdrop_path"][0]); } ?>" id="backdrop_path_src" class="img-thumbnail" style="<?php if (!isset($rMovie)) { echo 'display:none;'; }?>" >
															</div>
														</div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="backdrop_path"><?=$_["backdrop_url"]?></label>
                                                            <div class="col-md-8 input-group">
                                                                <input type="text" class="form-control" id="backdrop_path" name="backdrop_path" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["backdrop_path"][0]); } ?>">
                                                                <div class="input-group-append">
                                                                    <a href="javascript:void(0)" onClick="openImage(this)" class="btn btn-primary waves-effect waves-light"><i class="fa fa-eye"></i></a>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="plot"><?=$_["plot"]?></label>
                                                            <div class="col-md-8">
                                                                <textarea rows="6" class="form-control" id="plot" name="plot"><?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["plot"]); } ?></textarea>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="cast"><?=$_["cast"]?></label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="cast" name="cast" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["cast"]); } ?>">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="director"><?=$_["director"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="director" name="director" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["director"]); } ?>">
                                                            </div>
                                                            <label class="col-md-2 col-form-label" for="genre"><?=$_["genres"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="genre" name="genre" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["genre"]); } ?>">
                                                                <input type="hidden" class="form-control" id="original_language" name="original_language" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["original_language"]); } ?>">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="releasedate"><?=$_["release_date"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="releasedate" name="releasedate" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["releasedate"]); } ?>">
                                                            </div>
                                                            <label class="col-md-2 col-form-label" for="episode_run_time"><?=$_["runtime"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="episode_run_time" name="episode_run_time" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["episode_run_time"]); } ?>">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="youtube_trailer"><?=$_["youtube_trailer"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="youtube_trailer" name="youtube_trailer" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["youtube_trailer"]); } ?>">
                                                            </div>
                                                            <label class="col-md-2 col-form-label" for="rating"><?=$_["rating"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="rating" name="rating" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["rating"]); } ?>">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="country"><?=$_["country"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="country" name="country" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["country"]); } ?>">
                                                            </div>
															<label class="col-md-2 col-form-label" for="tmdb_id"><?=$_["tmdb_id"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="tmdb_id" name="tmdb_id" value="<?php if (isset($rMovie)) { echo htmlspecialchars($rMovie["properties"]["tmdb_id"]); } ?>">
                                                            </div>
                                                        </div>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						<?php } ?>
						
						<div class="col-sm-12 text-right">
							<input name="submit_movie" type="submit" class="btn btn-primary" value="<?php if (isset($_GET["id"])) echo "EDIT"; else echo "ADD" ?>">
						</div>
																					
						<div id="file-browser" class="mfp-hide white-popup-block">
                                    <div class="col-12">
                                        <div class="form-group row mb-4">
                                            <label class="col-md-4 col-form-label" for="server_id"><?=$_["server_name"]?></label>
                                            <div class="col-md-8">
                                                <select id="server_id" class="form-control" data-toggle="select2">
                                                    <?php foreach (getStreamingServers() as $rServer) { ?>
                                                    <option value="<?=$rServer["id"]?>"<?php if ((isset($_GET["server"])) && ($_GET["server"] == $rServer["id"])) { echo " selected"; } ?>><?=htmlspecialchars($rServer["server_name"])?></option>
                                                    <?php } ?>
                                                </select>
                                            </div>
                                        </div>
                                        <div class="form-group row mb-4">
                                            <label class="col-md-4 col-form-label" for="current_path"><?=$_["current_path"]?></label>
                                            <div class="col-md-8 input-group">
                                                <input type="text" id="current_path" name="current_path" class="form-control" value="/">
                                                <div class="input-group-append">
                                                    <button class="btn btn-primary waves-effect waves-light" type="button" id="changeDir"><i class="fa fa-chevron-right"></i></button>
                                                </div>
                                            </div>
                                        </div>
                                        <?php if (!isset($_GET["import"])) { ?>
                                        <div class="form-group row mb-4">
                                            <label class="col-md-4 col-form-label" for="search"><?=$_["search_directory"]?></label>
                                            <div class="col-md-8 input-group">
                                                <input type="text" id="search" name="search" class="form-control" placeholder="<?=$_["filter_files"]?>...">
                                                <div class="input-group-append">
                                                    <button class="btn btn-warning waves-effect waves-light" type="button" onClick="clearSearch()"><i class="fa fa-minus"></i></button>
                                                    <button class="btn btn-primary waves-effect waves-light" type="button" id="doSearch"><i class="fa fa-search"></i></button>
                                                </div>
                                            </div>
                                        </div>
                                        <?php } ?>
                                        <div class="form-group row mb-4">
                                            <div class="col-md-6">
                                                <table id="datatable" class="table stripe">
                                                    <thead>
                                                        <tr>
                                                            <th width="20px"></th>
                                                            <th><?=$_["directory"]?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody></tbody>
                                                </table>
                                            </div>
                                            <div class="col-md-6">
                                                <table id="datatable-files" class="table stripe">
                                                    <thead>
                                                        <tr>
                                                            <th width="20px"></th>
                                                            <th><?=$_["filename"]?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody></tbody>
                                                </table>
                                            </div>
                                        </div>
                                        <?php if (isset($_GET["import"])) { ?>
                                        <div class="float-right">
                                            <input id="select_folder" type="button" class="btn btn-info" value="<?=$_["select"]?>" />
                                        </div>
                                        <?php } ?>
                                    </div> <!-- end col -->
                                </div>
                           
					</div>
				</form>
				
			  
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>

        <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
  
   
        <script>
        var changeTitle = false;
        var rSwitches = [];
        
        (function($) {
          $.fn.inputFilter = function(inputFilter) {
            return this.on("input keydown keyup mousedown mouseup select contextmenu drop", function() {
              if (inputFilter(this.value)) {
                this.oldValue = this.value;
                this.oldSelectionStart = this.selectionStart;
                this.oldSelectionEnd = this.selectionEnd;
              } else if (this.hasOwnProperty("oldValue")) {
                this.value = this.oldValue;
                this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
              }
            });
          };
        }(jQuery));
        
        function api(rID, rServerID, rType) {
            if (rType == "delete") {
                if (confirm('<?=$_["movie_delete_confirm"]?>') == false) {
                    return;
                }
            }
            $.getJSON("../functions/api_xerox.php?action=movie&sub=" + rType + "&stream_id=" + rID + "&server_id=" + rServerID, function(data) {
                if (data.result == true) {
                    if (rType == "start") {
                        toastr.success("<?=$_["movie_encode_started"]?>");
                    } else if (rType == "stop") {
                        toastr.success("<?=$_["movie_encode_stopped"]?>");
                    } else if (rType == "delete") {
                        $("#movie-" + rID + "-" + rServerID).remove();
                        toastr.success("<?=$_["movie_delete_confirmed"]?>");
                    }
                    $.each($('.tooltip'), function (index, element) {
                        $(this).remove();
                    });
                    $("#datatable-list").DataTable().ajax.reload( null, false );
                } else {
                    toastr.warning("<?=$_["error_occured"]?>");
                }
            }).fail(function() {
                toastr.warning("<?=$_["error_occured"]?>");
            });
        }
        function selectDirectory(elem) {
            window.currentDirectory += elem + "/";
            $("#current_path").val(window.currentDirectory);
            $("#changeDir").click();
        }
        function selectParent() {
            $("#current_path").val(window.currentDirectory.split("/").slice(0,-2).join("/") + "/");
            $("#changeDir").click();
        }
        function selectFile(rFile) {
            if ($filterType == 1) {
                $("#stream_source").val("s:" + $("#server_id").val() + ":" + window.currentDirectory + rFile);
                var rExtension = rFile.substr((rFile.lastIndexOf('.')+1));
                if ($("#target_container option[value='" + rExtension + "']").length > 0) {
                    $("#target_container").val(rExtension).trigger('change');
                }
            } else {
                $("#movie_subtitles").val("s:" + $("#server_id").val() + ":" + window.currentDirectory + rFile);
            }
            $.magnificPopup.close();
        }
        function openImage(elem) {
            rPath = $(elem).parent().parent().find("input").val();
            if (rPath.length > 0) {
                if (rPath.substring(0,1) == ".") {
                    window.open('<?=getURL()?>' + rPath.substring(1, rPath.length));
                } else if (rPath.substring(0,1) == "/") {
                    window.open('<?=getURL()?>' + rPath);
                } else {
                    window.open(rPath);
                }
            }
        }
        function reloadStream() {
            $("#datatable-list").DataTable().ajax.reload( null, false );
            setTimeout(reloadStream, 5000);
        }
        function clearSearch() {
            $("#search").val("");
            $("#doSearch").click();
        }
        function player(rID, rContainer) {
            $.magnificPopup.open({
                items: {
                    src: "player.php?type=movie&id=" + rID + "&container=" + rContainer,
                    type: 'iframe'
                }
            });
        }
        function setSwitch(switchElement, checkedBool) {
            if((checkedBool && !switchElement.isChecked()) || (!checkedBool && switchElement.isChecked())) {
                switchElement.setPosition(true);
                switchElement.handleOnchange(true);
            }
        }
		
		function setProperties(data){
			window.changeTitle = true;
            rTitle = data.data.title;
            if (data.data.release_date) {
                rTitle += " (" + data.data.release_date.substr(0, 4) + ")";
            }
            $("#stream_search_id").val(data.data.id);
            $("#stream_display_name").val(rTitle);
            $("#movie_image").val("");
			$("#movie_img_src").hide();
			$("#backdrop_path_src").hide();
            if (data.data.poster_path.length > 0) {
                $("#movie_image").val("https://image.tmdb.org/t/p/w600_and_h900_bestv2" + data.data.poster_path);
                $("#movie_img_src").attr("src", "https://image.tmdb.org/t/p/w600_and_h900_bestv2" + data.data.poster_path);
				$("#movie_img_src").show();
            }
            $("#backdrop_path").val("");
            if (data.data.backdrop_path.length > 0) {
                $("#backdrop_path").val("https://image.tmdb.org/t/p/w1280" + data.data.backdrop_path);
                $("#backdrop_path_src").attr("src", "https://image.tmdb.org/t/p/w600_and_h900_bestv2" + data.data.backdrop_path);
				$("#backdrop_path_src").show();
            }
            $("#releasedate").val(data.data.release_date);
            $("#episode_run_time").val(data.data.runtime);
            $("#youtube_trailer").val("");
            if (data.data.trailer) {
                $("#youtube_trailer").val(data.data.trailer);
            }
            rCast = "";
            rMemberID = 0;
            $(data.data.credits.cast).each(function(id, member) {
                rMemberID += 1;
                if (rMemberID <= 5) {
                    if (rCast.length > 0) {
                        rCast += ", ";
                    }
                    rCast += member.name;
                }
            });
            $("#cast").val(rCast);
            rGenres = "";
            rGenreID = 0;
            $(data.data.genres).each(function(id, genre) {
                rGenreID += 1;
                if (rGenreID <= 3) {
                    if (rGenres.length > 0) {
                        rGenres += ", ";
                    }
                    rGenres += genre.name;
                }
            });
            $("#genre").val(rGenres);
            $("#director").val("");
            $(data.data.credits.crew).each(function(id, member) {
                if (member.department == "Directing") {
                    $("#director").val(member.name);
                    return true;
                }
            });
            $("#country").val("");
            $("#plot").val(data.data.overview);
            $("#original_language").val(data.data.original_language);
            if (data.data.production_countries.length > 0) {
                $("#country").val(data.data.production_countries[0].name);
            }
            $("#rating").val(data.data.vote_average);
            $("#tmdb_id").val(data.data.id);
		}
		
        $(document).ready(function() {
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            $filterType = 1;
			
            $("#datatable").DataTable({
                responsive: true,
                paging: false,
                bInfo: false,
                searching: false,
                scrollY: "250px",
                columnDefs: [
                    {"className": "dt-center", "targets": [0]},
                ],
                "language": {
                    "emptyTable": ""
                }
            });
            
            $("#datatable-files").DataTable({
                responsive: true,
                paging: false,
                bInfo: false,
                searching: true,
                scrollY: "250px",
                columnDefs: [
                    {"className": "dt-center", "targets": [0]},
                ],
                "language": {
                    "emptyTable": "<?=$_["no_compatible_file"]?>"
                }
            });
            
            $("#doSearch").click(function() {
                $('#datatable-files').DataTable().search($("#search").val()).draw();
            })
            
            var elems = Array.prototype.slice.call(document.querySelectorAll('.js-switch'));
            elems.forEach(function(html) {
              var switchery = new Switchery(html);
              window.rSwitches[$(html).attr("id")] = switchery;
            });
            
            $("#select_folder").click(function() {
                $("#import_folder").val("s:" + $("#server_id").val() + ":" + window.currentDirectory);
                $.magnificPopup.close();
            });
            
            $("#changeDir").click(function() {
                $("#search").val("");
                window.currentDirectory = $("#current_path").val();
                if (window.currentDirectory.substr(-1) != "/") {
                    window.currentDirectory += "/";
                }
                $("#current_path").val(window.currentDirectory);
                $("#datatable").DataTable().clear();
                $("#datatable").DataTable().row.add(["", "<?=$_["loading"]?>..."]);
                $("#datatable").DataTable().draw(true);
                $("#datatable-files").DataTable().clear();
                $("#datatable-files").DataTable().row.add(["", "<?=$_["please_wait"]?>..."]);
                $("#datatable-files").DataTable().draw(true);
                if ($filterType == 1) {
                    rFilter = "video";
                } else {
                    rFilter = "subs";
                }
				//console.log(rFilter);
				//console.log("../functions/api_xerox.php?action=listdir&dir=" + window.currentDirectory + "&server=" + $("#server_id").val() + "&filter=" + rFilter);
                $.getJSON("../functions/api_xerox.php?action=listdir&dir=" + window.currentDirectory + "&server=" + $("#server_id").val() + "&filter=" + rFilter, function(data) {
					
					console.log(data);
					$("#datatable").DataTable().clear();
                    $("#datatable-files").DataTable().clear();
                    if (window.currentDirectory != "/") {
                        $("#datatable").DataTable().row.add(["<i class='fa fa-angle-double-left'></i>", "<?=$_["parent_directory"]?>"]);
                    }
                    if (data.result == true) {
                        $(data.data.dirs).each(function(id, dir) {
                            $("#datatable").DataTable().row.add(["<i class='fa fa-folder-open'></i>", dir]);
                        });
                        $("#datatable").DataTable().draw(true);
                        $(data.data.files).each(function(id, dir) {
                            $("#datatable-files").DataTable().row.add(["<i class='fa fa-file-video'></i>", dir]);
                        });
                        $("#datatable-files").DataTable().draw(true);
                    }
                });
            });
            
            $('#datatable').on('click', 'tbody > tr', function() {
                if ($(this).find("td").eq(1).html() == "<?=$_["parent_directory"]?>") {
                    selectParent();
                } else {
                    selectDirectory($(this).find("td").eq(1).html());
                }
            });
            $('#datatable-files').on('click', 'tbody > tr', function() {
                selectFile($(this).find("td").eq(1).html());
            });
            
            $('#server_tree').jstree({ 'core' : {
                'check_callback': function (op, node, parent, position, more) {
                    switch (op) {
                        case 'move_node':
                            if (node.id == "source") { return false; }
                            return true;
                    }
                },
                'data' : <?=json_encode($rServerTree)?>
            }, "plugins" : [ "dnd" ]
            });
            
            $("#stream_form").submit(function(e){
                <?php if (!isset($_GET["import"])) { ?>
                if ($("#stream_display_name").val().length == 0) {
                    e.preventDefault();
                    toastr.info("<?=$_["enter_movie_name"]?>");
                }
                if ($("#stream_source").val().length == 0) {
                    e.preventDefault();
                    toastr.info("<?=$_["enter_movie_source"]?>");
                }
                <?php } else { ?>
                if (($("#m3u_file").val().length == 0) && ($("#import_folder").val().length == 0)) {
                    e.preventDefault();
                    toastr.info("<?=$_["select_m3u_file"]?>");
                }
                <?php } ?>
				
				$('#loader_spinner').show();
                $("#server_tree_data").val(JSON.stringify($('#server_tree').jstree(true).get_json('#', {flat:true})));
            });
            
            $("#filebrowser").magnificPopup({
                type: 'inline',
                preloader: false,
                focus: '#server_id',
                callbacks: {
                    beforeOpen: function() {
                        if ($(window).width() < 830) {
                            this.st.focus = false;
                        } else {
                            this.st.focus = '#server_id';
                        }
                    }
                }
            });
            $("#filebrowser-sub").magnificPopup({
                type: 'inline',
                preloader: false,
                focus: '#server_id',
                callbacks: {
                    beforeOpen: function() {
                        if ($(window).width() < 830) {
                            this.st.focus = false;
                        } else {
                            this.st.focus = '#server_id';
                        }
                    }
                }
            });
            
            $("#filebrowser").on("mfpOpen", function() {
                clearSearch();
				$filterType = 1;
                $($.fn.dataTable.tables(true)).css('width', '100%');
                $($.fn.dataTable.tables(true)).DataTable().columns.adjust().draw();
            });
            $("#filebrowser-sub").on("mfpOpen", function() {
				$filterType = 0;
                clearSearch();
                $($.fn.dataTable.tables(true)).css('width', '100%');
                $($.fn.dataTable.tables(true)).DataTable().columns.adjust().draw();
            });
            
            $(document).keypress(function(event){
                if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
            });
            
            $("#server_id").change(function() {
                $("#current_path").val("/");
                $("#changeDir").click();
            });
            
            $("#direct_source").change(function() {
                evaluateDirectSource();
            });
            $("#movie_symlink").change(function() {
                evaluateSymlink();
            });
            
            function evaluateDirectSource() {
                $(["movie_symlink", "read_native", "transcode_profile_id", "target_container", "remove_subtitles", "movie_subtitles"]).each(function(rID, rElement) {
                    if ($(rElement)) {
                        if ($("#direct_source").is(":checked")) {
                            if (window.rSwitches[rElement]) {
                                setSwitch(window.rSwitches[rElement], false);
                                window.rSwitches[rElement].disable();
                            } else {
                                $("#" + rElement).prop("disabled", true);
                            }
                        } else {
                            if (window.rSwitches[rElement]) {
                                window.rSwitches[rElement].enable();
                            } else {
                                $("#" + rElement).prop("disabled", false);
                            }
                        }
                    }
                });
            }
            function evaluateSymlink() {
                $(["direct_source", "read_native", "transcode_profile_id"]).each(function(rID, rElement) {
                    if ($(rElement)) {
                        if ($("#movie_symlink").is(":checked")) {
                            if (window.rSwitches[rElement]) {
                                setSwitch(window.rSwitches[rElement], false);
                                window.rSwitches[rElement].disable();
                            } else {
                                $("#" + rElement).prop("disabled", true);
                            }
                        } else {
                            if (window.rSwitches[rElement]) {
                                window.rSwitches[rElement].enable();
                            } else {
                                $("#" + rElement).prop("disabled", false);
                            }
                        }
                    }
                });
            }
			
			$("#stream_tmdb_language").on('change', function(){
				$(".search_tmdb").click();
			})
            
            $(".search_tmdb_name").on('click', function() {
                if (!window.changeTitle) {
                    $("#tmdb_search").empty().trigger('change');
                    if (($("#stream_display_name").val().length > 0) ){
						var text = $("#stream_display_name").val();
						console.log("../functions/api_xerox.php?action=tmdb_search&type=movie&term=" + text+"&language="+ $("#stream_tmdb_language").val());
                        $.getJSON("../functions/api_xerox.php?action=tmdb_search&type=movie&term=" + text+"&language="+ $("#stream_tmdb_language").val(), function(data) {
							
                            if (data.result == true) {
                                if (data.data.length > 0) {
                                    //newOption = new Option("<?=$_["found_results"]?>".replace('{num}', data.data.length), -1, true, true);
									newOption = new Option("<?=$_["found_"]?>" + data.data.length + "<?=$_["_results"]?>", -1, true, true);
                                } else {
                                    newOption = new Option("<?=$_["no_results_found"]?>", -1, true, true);
                                }
                                $("#tmdb_search").append(newOption).trigger('change');
                                $(data.data).each(function(id, item) {
                                    if (item.release_date.length > 0) {
                                        rTitle = item.title + " (" + item.release_date.substring(0, 4) + ")";
                                    } else {
                                        rTitle = item.title;
                                    }
                                    newOption = new Option(rTitle, item.id, true, true);
                                    $("#tmdb_search").append(newOption);
                                });
                            } else {
                                newOption = new Option("<?=$_["no_results_found"]?>", -1, true, true);
                            }
                            $("#tmdb_search").val(-1).trigger('change');
                        });
                    }
                } else {
                    window.changeTitle = false;
                }
            });
            
			$(".search_tmdb").on('click', function() {
                if (($("#stream_search_id").val()) && ($("#stream_search_id").val() > -1)) {
                    $.getJSON("../functions/api_xerox.php?action=tmdb&type=movie&id=" + $("#stream_search_id").val()+"&language="+ $("#stream_tmdb_language").val(), function(data) {
                        if (data.result == true) {
							console.log(data);
                            setProperties(data);
                        }
                    });
                }
            });
			
			$("#tmdb_search").change(function() {
                if (($("#tmdb_search").val()) && ($("#tmdb_search").val() > -1)) {
                    $.getJSON("../functions/api_xerox.php?action=tmdb&type=movie&id=" + $("#tmdb_search").val()+"&language="+ $("#stream_tmdb_language").val(), function(data) {
                        if (data.result == true) {
							console.log(data);
                            setProperties(data);
							
                        }
                    });
                }
            });
            
            <?php if (isset($rMovie["id"])) { ?>
            $("#datatable-list").DataTable({
                ordering: false,
                paging: false,
                searching: false,
                processing: true,
                serverSide: true,
                bInfo: false,
                ajax: {
                    url: "../functions//table_search.php",
                    "data": function(d) {
                        d.id = "movies";
                        d.stream_id = <?=$rMovie["id"]?>;
                    }
                },
                columnDefs: [
                    {"className": "dt-center", "targets": [3,4,5,6,9]},
                    {"visible": false, "targets": [0,1,2,7,8]}
                ],
            });
            setTimeout(reloadStream, 5000);
            $("#stream_display_name").trigger('change');
            <?php } ?>
            
            $("#import_type_1").click(function() {
                $("#import_m3uf_toggle").show();
                $("#import_folder_toggle").hide();
            });
            $("#import_type_2").click(function() {
                $("#import_m3uf_toggle").hide();
                $("#import_folder_toggle").show();
            });
            
            $("#runtime").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("form").attr('autocomplete', 'off');
            
            $("#changeDir").click();
            evaluateDirectSource();
            evaluateSymlink();
        });
        </script>
		
		
		
  
