<?php 
//require("../layout/header.php");
require('../includes/inc_db.php');
include "../functions/functions_xerox.php";


$rCategories = getCategories("series");

if (isset($_POST["submit_series"])) {
    if (isset($_POST["edit"])) {
		if (!hasPermissions("adv", "edit_series")) { exit; }
        $rArray = getSerie($_POST["edit"]);
        unset($rArray["id"]);
    } else {
		if (!hasPermissions("adv", "add_series")) { exit; }
        $rArray = Array("title" => "", "category_id" => "", "episode_run_time" => 0, "tmdb_id" => 0, "cover" => "","genre" => "", "plot" => "", "cast" => "", "rating" => 0, "director" => "", "releaseDate" => "", "last_modified" => time(), "seasons" => Array(), "backdrop_path" => Array(), "youtube_trailer" => "");
    }
    if ($rAdminSettings["download_images"]) {
        $_POST["cover"] = downloadImage($_POST["cover"]);
        $_POST["backdrop_path"] = downloadImage($_POST["backdrop_path"]);
    }
    $rBouquets = $_POST["bouquets"];
    unset($_POST["bouquets"]);
    if (strlen($_POST["backdrop_path"]) == 0) {
        $rArray["backdrop_path"] = Array();
    } else {
        $rArray["backdrop_path"] = Array($_POST["backdrop_path"]);
    }
    unset($_POST["backdrop_path"]);
    $rArray["cover"] = $rArray["cover"];
    $rArray["cover_big"] = $rArray["backdrop_path"];
    foreach($_POST as $rKey => $rValue) {
        if (isset($rArray[$rKey])) {
            $rArray[$rKey] = $rValue;
        }
    }
    $rCols = "`".ESC(implode('`,`', array_keys($rArray)))."`";
    $rValues = null;
    foreach (array_values($rArray) as $rValue) {
        isset($rValues) ? $rValues .= ',' : $rValues = '';
        if (is_array($rValue)) {
            $rValue = json_encode($rValue);
        }
        if (is_null($rValue)) {
            $rValues .= 'NULL';
        } else {
            $rValues .= '\''.ESC($rValue).'\'';
        }
    }
    if (isset($_POST["edit"])) {
        $rCols = "`id`,".$rCols;
        $rValues = ESC($_POST["edit"]).",".$rValues;
    }
    $rQuery = "REPLACE INTO `series`(".$rCols.") VALUES(".$rValues.");";
	//die($rQuery);
    if ($db->query($rQuery)) {
        if (isset($_POST["edit"])) {
            $rInsertID = intval($_POST["edit"]);
        } else {
            $rInsertID = $db->insert_id;
        }
        updateSeries(intval($rInsertID));
        foreach ($rBouquets as $rBouquet) {
            addToBouquet("series", $rBouquet, $rInsertID);
        }
        foreach (getBouquets() as $rBouquet) {
            if (!in_array($rBouquet["id"], $rBouquets)) {
                removeFromBouquet("series", $rBouquet["id"], $rInsertID);
            }
        }
        scanBouquets();
    }
    
	if (isset($rInsertID)) {
		 if (isset($_POST["edit"])) {
			  $msg = "successedit";
		 }else{
			  $msg = "successadd";
		 }
		 if (strpos($_POST["submit_series"], 'new') == false) {
			header("Location: ./serie.php?{$msg}&id=".$rInsertID); exit;
		 } else {
			 header("Location: ./serie.php?{$msg}"); exit;
		 }
    } else {
        $_STATUS = 1;
    }
	
	//die('status =>'.$_STATUS);
}

if (isset($_GET["id"])) {
    $rSeries = getSerie($_GET["id"]);
    if ((!$rSeries) OR (!hasPermissions("adv", "edit_series"))) {
        exit;
    }
} else if (!hasPermissions("adv", "add_series")) { exit; }


$serieOpen = "menu-open";
$serieActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
   
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
		
		<style>
			.dd-list .dd-item .dd-handle {
				background: #f1f5f7;
				border: none;
				padding: 8px 16px;
				height: auto;
				font-weight: 500;
				border-radius: 3px;
				font-size: x-large;
			}
			.dd-list .dd3-handle {
				margin: 0;
				height: 36px!important;
				float: left;
			}
			.dd-list .dd3-content {
				height: auto;
				border: none;
				padding: 8px 16px 8px 46px;
				background: #f1f5f7;
				font-weight: 600;
			}
			.dd-list .dd3-handle:before {
				content: "=";
				font-family: "Material Design Icons";
				color: #adb5bd;
			}


			
		</style>	
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Series </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;">
					<li>
						<a href="series.php"><li class="breadcrumb-item"><i class="fa fa-backspace"></i> <?=$_["back_to_series"]?></li></a>
					
					</li>
					
					
            </ol>
				
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9">Serie</h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
			
					<div class="row">
                    <div class="col-xl-12">
                        <?php if ((isset($_STATUS)) && ($_STATUS == 0)) { if (!$rSettings["sucessedit"]) { ?>
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <?=$_["series_operation"]?>
                        </div>
						<?php } else { ?>
                    <script type="text/javascript">
  					swal("", '<?=$_["series_operation"]?>', "success");
  					</script>
                        <?php } } else if ((isset($_STATUS)) && ($_STATUS > 0)) { if (!$rSettings["sucessedit"]) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <?=$_["generic_fail"]?>
                        </div>
                        <?php } else { ?>
                    <script type="text/javascript">
  					swal("", '<?=$_["generic_fail"]?>', "warning");
  					</script>
                        <?php } } ?>
						
						<?php  if (isset($_GET["successedit"])) { ?>
						<div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <?=$_["series_operation"]?> 
                        </div>
						<?php } ?>
						<?php  if (isset($_GET["successadd"])) { ?>
						<div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <?=$_["series_operation"]?>
                        </div>
						<?php } ?>
                        <div class="card">
                            <div class="card-body">
                                <form action="./serie.php<?php if (isset($_GET["id"])) { echo "?id=".$_GET["id"]; } ?>" method="POST" id="series_form" data-parsley-validate="">
                                    <?php if (isset($rSeries)) { ?>
                                    <input type="hidden" name="edit" value="<?=$rSeries["id"]?>" />
                                    <?php } ?>
                                    <!--<input type="hidden" id="tmdb_id" name="tmdb_id" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["tmdb_id"]); } ?>" />-->
									
					<div class="row">
						
						<div class="col-md-6">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title"><?=$_["details"]?></h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										<div class="row">
                                            <div class="col-12">
                                                
												
												 <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="stream_display_name"><?=$_["series_name"]?></label>
                                                            <div class="col-md-3">
															<?php
															$original_language = 'en';
															if(isset($rSeries)){
																$original_language = $rSeries['properties']['original_language'];
															}
															?>
                                                                <select class="form-control select select2" id="stream_tmdb_language" data-select2-id="lang" tabindex="-1" aria-hidden="true">
																	<option value="en" <?=($original_language == "en")?'selected': ''?>>
																		English
																	</option>
																	<option value="it" <?=($original_language == "it")?'selected': ''?>>
																		Italian
																	</option>
																	<option value="de" <?=($original_language == "de")?'selected': ''?>>
																		German
																	</option>
																	<option value="el" <?=($original_language == "el")?'selected': ''?>>
																		Greek
																	</option>
																	<option value="es" <?=($original_language == "es")?'selected': ''?>>
																		Spanish
																	</option>
																	<option value="tr" <?=($original_language == "tr")?'selected': ''?>>
																		Turkish
																	</option>
																	<option value="fr" <?=($original_language == "fr")?'selected': ''?>>
																		French
																	</option>
																	<option value="nl" <?=($original_language == "nl")?'selected': ''?>>
																		Dutch
																	</option>
																	<option value="ar" <?=($original_language == "ar")?'selected': ''?>>
																		Arabic
																	</option>
																	<option value="pt" <?=($original_language == "pt")?'selected': ''?>>
																		Portuguese
																	</option>
																	<option value="pl" <?=($original_language == "pl")?'selected': ''?>>
																		Poland
																	</option>
																	<option value="sv" <?=($original_language == "sv")?'selected': ''?>>
																		Swedish
																	</option>
																	<option value="hu" <?=($original_language == "hu")?'selected': ''?>>
																		Hungarian
																	</option>
																	<option value="hi" <?=($original_language == "hi")?'selected': ''?>>
																		Hindi
																	</option>
																</select>
                                                            </div>
                                                            <div class="col-md-5">
                                                                
																<div class="input-group">
																  <input type="text" class="form-control " id="stream_search_id" name="stream_search_id" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["properties"]['tmdb_id']); } ?>" >
																  <span class="input-group-append">
																	<button type="button" class="btn btn-info btn-flat search_tmdb" >Search</button>
																  </span>
																</div>
															</div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" ></label>
															<div class="col-md-8">
																<div class="input-group">
																	<input type="text" class="form-control " id="title" name="title" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["title"]); } ?>" required data-parsley-trigger="change">
																	<span class="input-group-append">
																	<button type="button" class="btn btn-info btn-flat search_tmdb_name" >Search</button>
																  </span>
																</div>
															</div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="tmdb_search"><?=$_["tmdb_results"]?></label>
                                                            <div class="col-md-8">
                                                                <select id="tmdb_search" class="form-control" data-toggle="select2"></select>
                                                            </div>
                                                        </div>
                                                        
                                                <div class="form-group row mb-4">
                                                    <label class="col-md-4 col-form-label" for="category_id"><?=$_["category_name"]?></label>
                                                    <div class="col-md-8">
                                                        <select name="category_id" id="category_id" class="form-control" data-toggle="select2">
                                                            <?php foreach ($rCategories as $rCategory) { ?>
                                                           <option <?php if (isset($rSeries)) { if (intval($rSeries["category_id"]) == intval($rCategory["id"])) { echo "selected "; } } else if ((isset($_GET["category"])) && ($_GET["category"] == $rCategory["id"])) { echo "selected "; } ?>value="<?=$rCategory["id"]?>"><?=$rCategory["category_name"]?></option>
                                                             <?php } ?>
                                                        </select>
                                                    </div>
                                                </div>
                                                <div class="form-group row mb-4">
                                                    <label class="col-md-4 col-form-label" for="bouquets"><?=$_["add_to_bouquets"]?></label>
                                                    <div class="col-md-8">
                                                        <select name="bouquets[]" id="bouquets" class="form-control select2-multiple" data-toggle="select2" multiple="multiple" data-placeholder="<?=$_["choose"]?>">
                                                            <?php foreach (getBouquets() as $rBouquet) { ?>
                                                            <option <?php if (isset($rSeries)) { if (in_array($rSeries["id"], json_decode($rBouquet["bouquet_series"], True))) { echo "selected "; } } ?>value="<?=$rBouquet["id"]?>"><?=htmlspecialchars($rBouquet["bouquet_name"])?></option>
                                                            <?php } ?>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div> <!-- end col -->
                                        </div> <!-- end row -->
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						<div class="col-md-6">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title"><?=$_["information"]?></h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										<div class="row">
                                             <div class="col-12">
													
                                                        <div class="form-group row mb-2">
															<div class="col-md-6">															
																<img src="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["cover"]); } ?>" id="movie_img_src" class="img-thumbnail" style="<?php if (!isset($rSeries)) { echo 'display:none;'; }?>" >
															</div>
														</div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="cover"><?=$_["poster_url"]?></label>
                                                            <div class="col-md-8 input-group">
                                                                <input type="text" class="form-control" id="cover" name="cover" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["cover"]); } ?>">
                                                                <div class="input-group-append">
                                                                    <a href="javascript:void(0)" onClick="openImage(this)" class="btn btn-primary waves-effect waves-light"><i class="fa fa-eye"></i></a>
                                                                </div>
                                                            </div>
                                                        </div>														
                                                        <div class="form-group row mb-2">
															<div class="col-md-6">															
																<img src="<?php if (isset($rSeries)) { echo htmlspecialchars(json_decode($rSeries["backdrop_path"])[0]); } ?>" id="backdrop_path_src" class="img-thumbnail" style="<?php if (!isset($rSeries)) { echo 'display:none;'; }?>" >
															</div>
														</div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="backdrop_path"><?=$_["backdrop_url"]?></label>
                                                            <div class="col-md-8 input-group">
                                                                <input type="text" class="form-control" id="backdrop_path" name="backdrop_path" value="<?php if (isset($rSeries)) { echo htmlspecialchars(json_decode($rSeries["backdrop_path"], True)[0]); } ?>">
                                                                <div class="input-group-append">
                                                                    <a href="javascript:void(0)" onClick="openImage(this)" class="btn btn-primary waves-effect waves-light"><i class="fa fa-eye"></i></a>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="plot"><?=$_["plot"]?></label>
                                                            <div class="col-md-8">
                                                                <textarea rows="6" class="form-control" id="plot" name="plot"><?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["plot"]); } ?></textarea>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="cast"><?=$_["cast"]?></label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="cast" name="cast" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["cast"]); } ?>">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="director"><?=$_["director"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="director" name="director" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["director"]); } ?>">
                                                            </div>
                                                            <label class="col-md-2 col-form-label" for="genre"><?=$_["genres"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="genre" name="genre" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["genre"]); } ?>">
																<input type="hidden" class="form-control" id="original_language" name="original_language" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rMovie["properties"]["original_language"]); } ?>">
                                                            
															</div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="releaseDate"><?=$_["release_date"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="releaseDate" name="releaseDate" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["releaseDate"]); } ?>">
                                                            </div>
                                                            <label class="col-md-2 col-form-label" for="episode_run_time"><?=$_["runtime"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="episode_run_time" name="episode_run_time" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["episode_run_time"]); } ?>">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="youtube_trailer"><?=$_["youtube_trailer"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="youtube_trailer" name="youtube_trailer" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["youtube_trailer"]); } ?>">
                                                            </div>
                                                            <label class="col-md-2 col-form-label" for="rating"><?=$_["rating"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="rating" name="rating" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["rating"]); } ?>">
                                                            </div>
					                                    </div>
														<div class="form-group row mb-4">
															<label class="col-md-4 col-form-label" for="tmdb_id"><?=$_["tmdb_id"]?></label>
                                                            <div class="col-md-3">
                                                                <input type="text" class="form-control" id="tmdb_id" name="tmdb_id" value="<?php if (isset($rSeries)) { echo htmlspecialchars($rSeries["tmdb_id"]); } ?>">
                                                            </div>
                                                        </div>
                                                    </div> <!-- end col -->
                                              
                                        </div> <!-- end row -->
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						<div class="col-md-12" id="seasons_table" style="display:none">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">Other Seasons</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="seasons-details" style="display:block">
										<div class="row">
                                              <div class="table">
													<table id="datatable_seasons" class="table table-borderless mb-0">
														<thead class="bg-light">
															<tr>
																<th>Season</th>
																<th>Season name</th>
																<th>Episodes</th>
																<th>Overview</th>
																<th>Air Date</th>
																<th>Poster</th>
															</tr>
														</thead>
														<tbody>
															
														</tbody>
													</table>
												</div>                                              
                                        </div> <!-- end row -->
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						
						
						</div>
						
						
						<div class="col-sm-12 text-right">
							<input name="submit_series" type="submit" class="btn btn-primary" value="<?php if (isset($rSeries)) { echo $_["edit"]; } else { echo "Save"; } ?> & Create new" />
							<input name="submit_series" type="submit" class="btn btn-primary" value="<?php if (isset($rSeries)) { echo $_["edit"]; } else { echo "Save"; } ?>" />
						</div>
						
						</div>
                                   
                                </form>
                            </div> <!-- end card-body -->
                        </div> <!-- end card-->
                    </div> <!-- end col -->
                </div>
					 
				
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
		 <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
  
     <script>
        var changeTitle = false;
        
        (function($) {
          $.fn.inputFilter = function(inputFilter) {
            return this.on("input keydown keyup mousedown mouseup select contextmenu drop", function() {
              if (inputFilter(this.value)) {
                this.oldValue = this.value;
                this.oldSelectionStart = this.selectionStart;
                this.oldSelectionEnd = this.selectionEnd;
              } else if (this.hasOwnProperty("oldValue")) {
                this.value = this.oldValue;
                this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
              }
            });
          };
        }(jQuery));
        function openImage(elem) {
            rPath = $(elem).parent().parent().find("input").val();
            if (rPath.length > 0) {
                if (rPath.substring(0,1) == ".") {
                    window.open('<?=getURL()?>' + rPath.substring(1, rPath.length));
                } else if (rPath.substring(0,1) == "/") {
                    window.open('<?=getURL()?>' + rPath);
                } else {
                    window.open(rPath);
                }
            }
        }
        
		function setProperties(data){
			console.log(data);
			if (data.result == true) {
                            window.changeTitle = true;
                            $("#title").val(data.data.name);
                            $("#cover").val("");
							$("#movie_img_src").hide();
							$("#backdrop_path_src").hide();
							$("#stream_search_id").val(data.data.id);
							$("#original_language").val(data.data.original_language);
                            if (data.data.poster_path.length > 0) {
                                $("#cover").val("https://image.tmdb.org/t/p/w600_and_h900_bestv2" + data.data.poster_path);
                                $("#movie_img_src").attr("src", "https://image.tmdb.org/t/p/w600_and_h900_bestv2" + data.data.poster_path);
								$("#movie_img_src").show();
                            }
                            $("#backdrop_path").val("");
                            if (data.data.backdrop_path.length > 0) {
                                $("#backdrop_path").val("https://image.tmdb.org/t/p/w1280" + data.data.backdrop_path);
                                $("#backdrop_path_src").attr("src", "https://image.tmdb.org/t/p/w600_and_h900_bestv2" + data.data.backdrop_path);
								$("#backdrop_path_src").show();
                            }
                            $("#releaseDate").val(data.data.first_air_date);
                            $("#episode_run_time").val(data.data.episode_run_time[0]);
                            $("#youtube_trailer").val("");
                            if (data.data.trailer) {
                                $("#youtube_trailer").val(data.data.trailer);
                            }
                            rCast = "";
                            rMemberID = 0;
                            $(data.data.credits.cast).each(function(id, member) {
                                rMemberID += 1;
                                if (rMemberID <= 5) {
                                    if (rCast.length > 0) {
                                        rCast += ", ";
                                    }
                                    rCast += member.name;
                                }
                            });
                            $("#cast").val(rCast);
                            rGenres = "";
                            rGenreID = 0;
                            $(data.data.genres).each(function(id, genre) {
                                rGenreID += 1;
                                if (rGenreID <= 3) {
                                    if (rGenres.length > 0) {
                                        rGenres += ", ";
                                    }
                                    rGenres += genre.name;
                                }
                            });
                            $("#genre").val(rGenres);
                            $("#director").val("");
                            $(data.data.credits.crew).each(function(id, member) {
                                if (member.department == "Directing") {
                                    $("#director").val(member.name);
                                    return true;
                                }
                            });
							$("#seasons_table").show();
							$("#datatable_seasons > tbody").html("");
                            $(data.data.seasons).each(function(id, season) {
								var html = '<tr>'
											+'<td>'+season.id+'</td>'
											+'<td>'+season.name+'</td>'
											+'<td>'+season.episode_count+'</td>'
											+'<td>'+season.overview+'</td>'
											+'<td>'+season.air_date+'</td>'
											+'<td>'+season.poster_path+'</td>'
								
										+'</tr>';
								$("#datatable_seasons").append(html);
                            });
                            $("#plot").val(data.data.overview);
                            $("#rating").val(data.data.vote_average);
                            $("#tmdb_id").val($("#stream_search_id").val());
                        }
		}
		
		$(document).ready(function() {
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            
            var elems = Array.prototype.slice.call(document.querySelectorAll('.js-switch'));
            elems.forEach(function(html) {
              var switchery = new Switchery(html);
            });
            
            $("#series_form").submit(function(e){
                if ($("#title").val().length == 0) {
                    e.preventDefault();
                    toastr.info("<?=$_["enter_a_series_name"]?>");
                }
				
				$('#loader_spinner').show();
            });
            
            $(window).keypress(function(event){
                if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
            });
            
            $(".search_tmdb_name").on('click', function() {
                if (!window.changeTitle) {
                    $("#tmdb_search").empty().trigger('change');
                    if ($("#title").val().length > 0) {
                        $.getJSON("../functions/api_xerox.php?action=tmdb_search&type=series&term=" + $("#title").val()+"&language="+ $("#stream_tmdb_language").val(), function(data) {
							
                            if (data.result == true) {
                                if (data.data.length > 0) {
                                    newOption = new Option("<?=$_["found_"]?>" + data.data.length + "<?=$_["_results"]?>", -1, true, true);
                                } else {
                                    newOption = new Option("<?=$_["no_results_found"]?>", -1, true, true);
                                }
                                $("#tmdb_search").append(newOption).trigger('change');
                                $(data.data).each(function(id, item) {
                                    if (item.first_air_date.length > 0) {
                                        rTitle = item.name + " (" + item.first_air_date.substring(0, 4) + ")";
                                    } else {
                                        rTitle = item.name;
                                    }
                                    newOption = new Option(rTitle, item.id, true, true);
                                    $("#tmdb_search").append(newOption);
                                });
                            } else {
                                newOption = new Option("<?=$_["no_results_found"]?>", -1, true, true);
                            }
                            $("#tmdb_search").val(-1).trigger('change');
                        });
                    }
                } else {
                    window.changeTitle = false;
                }
            });
			
			$(".search_tmdb").on('click', function() {
                if (($("#stream_search_id").val()) && ($("#stream_search_id").val() > -1)) {
                    $.getJSON("../functions/api_xerox.php?action=tmdb&type=series&id=" + $("#stream_search_id").val()+"&language="+ $("#stream_tmdb_language").val(), function(data) {
						
                        if (data.result == true) {
                            setProperties(data);
                        }
                    });
                }
            });
			
            $("#tmdb_search").change(function() {
                if (($("#tmdb_search").val()) && ($("#tmdb_search").val() > -1)) {
                    $.getJSON("../functions/api_xerox.php?action=tmdb&type=series&id=" + $("#tmdb_search").val()+"&language="+ $("#stream_tmdb_language").val(), function(data) {
                        if (data.result == true) {
                            setProperties(data);
							
                        }
                    });
                }
            });
            
            $("#episode_run_time").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("form").attr('autocomplete', 'off');
            
            <?php if (isset($rSeries)) { ?>
            $("#title").trigger("change");
            <?php } ?>
        });
        </script>
    
		
      