<?php 
require("../layout/header.php");
$rqtGetAppInfo = "SELECT * FROM panel_apps WHERE id=:id";
$rqtAddApp = "UPDATE panel_apps SET name=:name,url=:url,tuto=:tuto,hide=:hide WHERE id=:id";
$stmtAddApp = $pdoPanel->prepare($rqtAddApp);
$trouble = "";
if($_SESSION['admin'] != 1){
    $trouble="notAdmin";
    echo"<script>location.href='dashboard.php'</script>";
}
if(isset($_GET['id'])){
    $stmtGetApp = $pdoPanel->prepare($rqtGetAppInfo);
    $id = trim($_GET['id']);
    $id = filter_var($id,FILTER_SANITIZE_NUMBER_INT);
    $stmtGetApp->bindParam(":id",$id);
    $stmtGetApp->execute();
    $rs=$stmtGetApp->fetchAll();
}
if($_POST){

        // print_r(trim($_POST);
        $hide = 0;
        if($_POST['hideit'] == 1){
            $hide = 1;
        }
        $id = trim($_POST['idApp']);
        $id = filter_var($id,FILTER_SANITIZE_NUMBER_INT);
        $name = trim($_POST['name']);
        $name = filter_var($name,FILTER_SANITIZE_STRING);
        $url = trim($_POST['url']);
        $url = filter_var($url,FILTER_SANITIZE_URL);
        $tuto = trim($_POST['tuto']);
        // $tuto = filter_var($tuto,FILTER_SANITIZE_SPECIAL_CHARS);
        $stmtAddApp->bindParam(':name',trim($name));
        $stmtAddApp->bindParam(':url',trim($url));
        $stmtAddApp->bindParam(':tuto',$tuto);
        $stmtAddApp->bindParam(':hide',$hide);
        $stmtAddApp->bindParam(':id',$id);

        if(!($stmtAddApp->execute())){
            $trouble="error";
            echo"<script>location.href='manage_apps.php?msg=errorEditApp'</script>";
        }else{
            echo"<script>location.href='manage_apps.php?msg=editedApp'</script>";
        }

}

$adminOpen = "menu-open";
$adminActive = "active";
include('../layout/header_html.php');
?>
  <!-- summernote -->
  <link rel="stylesheet" href="../plugins/summernote/summernote-bs4.min.css"> 
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Admin</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">apps</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Edit app</h3>
              </div>
              <!-- /.card-header -->
			  <div class="row" style="margin: auto; margin-top: 2rem;">
				<div class="col-md-12">
				<?php
                if ($trouble == "error")
                    { ?>
                       <div class="alert alert-danger alert-dismissible">
					  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
					  <h5><i class="icon fas fa-check"></i> danger!</h5>
					  Problem during insert data
					</div>
                  <?php  }
                ?>
					
				</div>
			  </div>
              <!-- form start -->			  
              <form id="quickForm" method="post" action="edit_app.php">
                <input hidden id='idApp' name='idApp' value='<?php if(count($rs)>0){echo $rs[0]['id'];} ?>'>
                <div class="card-body">
				<div class="row">
					<div class="col-md-5">
						<div class="form-group">
							<label>Name </label>
							<input type="text" class="form-control" name="name" id="name" value="<?php if(count($rs)>0){echo $rs[0]['name'];} ?>" placeholder="Name of the app" required>
						</div>
					</div>
					<div class="col-md-6">
						<div class="form-group">
							<label>URL </label>
							<input type="text" class="form-control" name="url" id="url" value="<?php if(count($rs)>0){echo $rs[0]['url'];} ?>" placeholder="http://XXXXXXXXX">
						</div>
					</div>
					<div class="col-md-1">
						<div class="form-group">
							<label>&nbsp; </label>
							<div class="custom-control custom-switch">
							  <input type="checkbox" class="custom-control-input" name="hideit" <?php if(count($rs)>0){if($rs[0]['hide'] == 1){ echo "checked";}} ?> id="customSwitch1">
							  <label class="custom-control-label" for="customSwitch1">Hide</label>
							</div>
						 </div>
					</div>
					
					  <div class="col-12">
						<div class="form-group">
						  <label>Tuto</label>
						 <textarea id="summernote" name="tuto">
							<?php if(count($rs)>0){echo $rs[0]['tuto'];} ?>
						  </textarea>
						</div>
						<!-- /.form-group -->
					  </div>
					
				</div>
					
                 
                <!-- /.card-body -->
                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  </div>
<?php 
	include("../layout/footer.php");
?>


<?php
include("../common/body.php");
?>
<!-- Summernote -->
<script src="../plugins/summernote/summernote-bs4.min.js"></script>
<script>
$(document).ready(function(){
    $('#summernote').summernote({
    fontSizes: ['12', '14', '16', '18', '24', '36', '48'],
    fontNames:['Arial', 'Arial Black', 'Comic Sans MS', 'Courier New'],
    toolbar: [
    ['style', ['style']],
    ['font', ['bold', 'underline', 'clear']],
    ['fontnames', ['fontname']],
    ['fontsize', ['fontsize']],
    ['color', ['color']],
    ['para', ['ul', 'ol', 'paragraph']],
    ['table', ['table']],
    ['insert', ['link', 'picture', 'video']],
    ['view', ['fullscreen','undo','redo', 'codeview', 'help']],
    ],
    popover: {
  image: [
    ['image', ['resizeFull', 'resizeHalf', 'resizeQuarter', 'resizeNone']],
    ['float', ['floatLeft', 'floatRight', 'floatNone']],
    ['remove', ['removeMedia']]
  ],
  link: [
    ['link', ['linkDialogShow', 'unlink']]
  ],
  table: [
    ['add', ['addRowDown', 'addRowUp', 'addColLeft', 'addColRight']],
    ['delete', ['deleteRow', 'deleteCol', 'deleteTable']],
  ],
  air: [
    ['color', ['color']],
    ['font', ['bold', 'underline', 'clear']],
    ['para', ['ul', 'paragraph']],
    ['table', ['table']],
    ['insert', ['link', 'picture']]
  ]
    },
    });

})

</script>

   
</body>
</html>