<?php 
require("../layout/header.php");



include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Users </h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Users line</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header">
                <h3 class="card-title">List of line users</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table id="example1" class="table table-bordered table-striped tableUnlimited" width="100%">
                  <thead>
                  <tr>
                    <th class='no-sort'>
                        Options
                    </th>
                    <th class='no-sort'>
                        Status
                    </th>
                    <th>
                        Credentials
                    </th>
                    <th>
                        Expire Date
                    </th>
                    <th>
                        Name
                    </th>
                    <th class='no-sort'>
                        Owner / Notes
                    </th>
                  </tr>
                  </thead>
                  
                  
                </table>
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            
		 
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
<script>
$(document).ready(function(){
    $('.tableUnlimited').DataTable({
            "order": [[1, "desc" ]],
            "cache": true,
            "bProcessing": true,
            "bServerSide": true,
            "bDestroy": true,
			"responsive": true,
			"scrollX": true,
			"aoColumns": [
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': true},
                {'sClass': 'center', 'bSortable': false}

            ],
			"columnDefs": [
				//Responsive classes
				{ className: 'all', targets: 0 },       
				{ className: 'all', targets: 1 },
				{ className: 'all', targets: 2 },
				{ className: 'all', targets: 3 },       
				{ className: 'all', targets: 4 },       
				{ className: 'all', targets: 5 },        
			],
            processing: true,
            ajax: {
                url: "../common/getData.php?type=unlimited",
                "data": function (d) {
                }
            },

        });
})
</script>
