<?php 
include("../layout/header.php");

$resellerOpen = "menu-open";
$resellerActive = "active";
$id = $_GET['id'];

$totalMoney = getUserCreditSum($id) * getUserCreditMoneyPrice($id);
$totalPaye = getUserCreditMoneySum($id);
$restMoney = $totalMoney - $totalPaye;
include("../layout/header_html.php");
?>
    
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Subresellers </h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">resellers</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
			
          <div class="col-md-6 col-sm-12 col-lg-3 col-12">
            <!-- small box -->
            <div class="small-box bg-info">
              <div class="inner">
                <h3 class="credits"><?php echo getRegisteredUserCredit($id);  ?><sup style="font-size: 20px"> /<?=getUserCreditMoneyPrice($id)?></sup></h3>

                <p>Credits</p>
              </div>
              <div class="icon">
                <i class="ion ion-social-euro"></i>
              </div>
              
            </div>
          </div>
          <div class="col-md-6 col-sm-12 col-lg-3 col-12">
            <!-- small box -->
            <div class="small-box bg-warning">
              <div class="inner">
                <h3 class="credits"><?php echo $totalMoney;?><sup style="font-size: 20px"><?php echo $_SESSION['currency']; ?></sup></h3>

                <p>Money total</p>
              </div>
              <div class="icon">
                <i class="ion ion-social-euro"></i>
              </div>
              
            </div>
          </div>
          <div class="col-md-6 col-sm-12 col-lg-3 col-12">
            <!-- small box -->
            <div class="small-box bg-success">
              <div class="inner">
                <h3 class="credits"><?php echo $totalPaye; ?><sup style="font-size: 20px"><?php echo $_SESSION['currency']; ?></sup></h3>

                <p>Total payé</p>
              </div>
              <div class="icon">
                <i class="ion ion-social-euro"></i>
              </div>
              
            </div>
          </div>
          <div class="col-md-6 col-sm-12 col-lg-3 col-12">
            <!-- small box -->
            <div class="small-box bg-danger">
              <div class="inner">
                <h3 class="credits"><?php echo $restMoney; ?><sup style="font-size: 20px"><?php echo $_SESSION['currency']; ?></sup></h3>

                <p>Reste à payer</p>
              </div>
              <div class="icon">
                <i class="ion ion-social-euro"></i>
              </div>
              
            </div>
          </div>
         
			
        </div>
        <!-- /.row -->
		<div class="row">
		 <div class="col-md-6">
			 <div class="card">
              <div class="card-header">
                <h3 class="card-title">Credits Logs</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table id="example1" class="table table-bordered table-striped tableCredit" width="100%">
                  <thead>
                  <tr>
                    <th class='no-sort'>
                                From
                            </th>
                            <th class='no-sort'>
                                To
                            </th>
                            <th class='no-sort'>
                                Date
                            </th>
                            <th class='no-sort'>
                                Amount
                            </th>
                            <th class='no-sort'>
                                Reason
                            </th>
                  </tr>
                  </thead>
                   <tbody>
                       
                        </tbody>
                  
                </table>
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		   </div>
		
		 <div class="col-md-6">
			 <div class="card">
              <div class="card-header">
                <h3 class="card-title">Money Logs</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table id="example1" class="table table-bordered table-striped tableMoney" width="100%">
                  <thead>
                  <tr>
                    <th class='no-sort'>
                                From
                            </th>
                            <th class='no-sort'>
                                To
                            </th>
                            <th class='no-sort'>
                                Date
                            </th>
                            <th class='no-sort'>
                                Amount
                            </th>
                            <th class='no-sort'>
                                Reason
                            </th>
                  </tr>
                  </thead>
                   <tbody>
                       
                        </tbody>
                  
                </table>
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		   </div>
		
		</div>
        <!-- /.row -->
       
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  <?php 
include("../layout/footer.php");
?>
  
  
  <script src="../plugins/js/jquery.number.min.js"></script>

<?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
<script>
$(document).ready(function(){
    $('.tableCredit').DataTable({
            "order": [[0, "asc" ]], 
            "columnDefs": [
				//Responsive classes
				{ className: 'all', targets: 0 },       
				{ className: 'all', targets: 1 },
				{ className: 'all', targets: 2 },
				{ className: 'all', targets: 3 },       
				{ className: 'all', targets: 4 },        
			],
			"responsive": true,
			"scrollX": true,
		    "searching": true,
			"pageLength": 10,
            
            processing: true,
            ajax: {
                url: "../common/getData.php?type=credits_log_by_user&user=<?=$id?>",
                "data": function (d) {
                }
            },

        });
    $('.tableMoney').DataTable({
            "order": [[0, "asc" ]], 
            "columnDefs": [
				//Responsive classes
				{ className: 'all', targets: 0 },       
				{ className: 'all', targets: 1 },
				{ className: 'all', targets: 2 },
				{ className: 'all', targets: 3 },       
				{ className: 'all', targets: 4 },        
			],
			"responsive": true,
			"scrollX": true,
		    "searching": true,
			"pageLength": 10,
            
            processing: true,
            ajax: {
                url: "../common/getData.php?type=money_log_by_user&user=<?=$id?>",
                "data": function (d) {
                }
            },

        });
})

</script>

   
</body>
</html>
