<?php 
//require("../layout/header.php");
require('../includes/inc_db.php');
include "../functions/functions_xerox.php";


$rCategories = getCategories("live");
$rTranscodeProfiles = getTranscodeProfiles();

if (isset($_POST["submit_stream"])) {
    if (isset($_POST["edit"])) {
		if (!hasPermissions("adv", "edit_cchannel")) { exit; }
        $rArray = getStream($_POST["edit"]);
        unset($rArray["id"]);
    } else {
		if (!hasPermissions("adv", "create_channel")) { exit; }
        $rArray = Array("type" => 3, "added" => time(), "read_native" => 1, "stream_all" => 1, "redirect_stream" => 0, "direct_source" => 0, "gen_timestamps" => 1, "transcode_attributes" => Array(), "stream_display_name" => "", "stream_source" => Array(), "category_id" => 0, "stream_icon" => "", "notes" => "", "custom_sid" => "", "custom_ffmpeg" => "", "custom_map" => "", "transcode_profile_id" => 0, "enable_transcode" => 0, "auto_restart" => "[]", "allow_record" => 0, "rtmp_output" => 0, "epg_id" => null, "channel_id" => null, "epg_lang" => null, "tv_archive_server_id" => 0, "tv_archive_duration" => 0, "delay_minutes" => 0, "external_push" => "", "probesize_ondemand" => 128000, "pids_create_channel" => Array(), "created_channel_location" => 0, "cchannel_rsources" => Array(), "series_no" => 0);
    }
    $rArary["transcode_profile_id"] = $_POST["transcode_profile_id"];
    if (!$rArray["transcode_profile_id"]) {
        $rArray["transcode_profile_id"] = 0;
    }
	if (isset($_POST["restart_on_edit"])) {
		$rRestart = true;
		unset($_POST["restart_on_edit"]);
	} else {
		$rRestart = false;
	}
    $rArray["movie_propeties"] = Array("type" => intval($_POST["channel_type"]));
    if (intval($_POST["channel_type"]) == 0) {
        $rPlaylist = generateSeriesPlaylist($_POST["series_no"]);
        if ($rPlaylist["success"]) {
            $rArray["created_channel_location"] = $rPlaylist["server_id"];
            $rArray["stream_source"] = $rPlaylist["sources"];
            $rArray["series_no"] = intval($_POST["series_no"]);
            unset($_POST["created_channel_location"]);
        } else {
            $_STATUS = 2;
        }
    } else {
        $rArray["created_channel_location"] = intval($_POST["created_channel_location"]);
        $rArray["stream_source"] = $_POST["video_files"];
        $rArray["series_no"] = 0;
    }
    $rArray["cchannel_rsources"] = Array();
    $rBouquets = $_POST["bouquets"];
    unset($_POST["bouquets"]);
    foreach($_POST as $rKey => $rValue) {
        if (isset($rArray[$rKey])) {
            $rArray[$rKey] = $rValue;
        }
    }
    if (count($rArray["stream_source"]) > 0) {
        if ($rAdminSettings["download_images"]) {
            $rArray["stream_icon"] = downloadImage($rArray["stream_icon"]);
        }
        $rArray["order"] = getNextOrder();
        $rCols = ESC("`".implode('`,`', array_keys($rArray))."`");
        $rValues = null;
        foreach (array_values($rArray) as $rValue) {
            isset($rValues) ? $rValues .= ',' : $rValues = '';
            if (is_array($rValue)) {
                $rValue = json_encode($rValue);
            }
            if (is_null($rValue)) {
                $rValues .= 'NULL';
            } else {
                $rValues .= '\''.ESC($rValue).'\'';
            }
        }
        if (isset($_POST["edit"])) {
            $rCols = "`id`,".$rCols;
            $rValues = ESC($_POST["edit"]).",".$rValues;
        }
        $rQuery = "REPLACE INTO `streams`(".$rCols.") VALUES(".$rValues.");";
        if ($db->query($rQuery)) {
            if (isset($_POST["edit"])) {
                $rInsertID = intval($_POST["edit"]);
            } else {
                $rInsertID = $db->insert_id;
            }
        }
        if (isset($rInsertID)) {
            $rStreamExists = Array();
            if (isset($_POST["edit"])) {
                $result = $db->query("SELECT `server_stream_id`, `server_id` FROM `streams_sys` WHERE `stream_id` = ".intval($rInsertID).";");
                if (($result) && ($result->num_rows > 0)) {
                    while ($row = $result->fetch_assoc()) {
                        $rStreamExists[intval($row["server_id"])] = intval($row["server_stream_id"]);
                    }
                }
            }
            if (isset($_POST["server_tree_data"])) {
                $rStreamsAdded = Array();
                $rServerTree = json_decode($_POST["server_tree_data"], True);
                foreach ($rServerTree as $rServer) {
                    if ($rServer["parent"] <> "#") {
                        $rServerID = intval($rServer["id"]);
                        $rStreamsAdded[] = $rServerID;
                        if ($rServer["parent"] == "source") {
                            $rParent = "NULL";
                        } else {
                            $rParent = intval($rServer["parent"]);
                        }
                        if (isset($rStreamExists[$rServerID])) {
                            $db->query("UPDATE `streams_sys` SET `parent_id` = ".$rParent." WHERE `server_stream_id` = ".$rStreamExists[$rServerID].";");
                        } else {
                            $db->query("INSERT INTO `streams_sys`(`stream_id`, `server_id`, `parent_id`, `on_demand`) VALUES(".intval($rInsertID).", ".$rServerID.", ".$rParent.", 0);");
                        }
                    }
                }
                foreach ($rStreamExists as $rServerID => $rDBID) {
                    if (!in_array($rServerID, $rStreamsAdded)) {
                        $db->query("DELETE FROM `streams_sys` WHERE `server_stream_id` = ".$rDBID.";");
                    }
                }
            }
            if ($rRestart) {
                APIRequest(Array("action" => "stream", "sub" => "start", "stream_ids" => Array($rInsertID)));
            }
            foreach ($rBouquets as $rBouquet) {
                addToBouquet("stream", $rBouquet, $rInsertID);
            }
            if (isset($_POST["edit"])) {
                foreach (getBouquets() as $rBouquet) {
                    if (!in_array($rBouquet["id"], $rBouquets)) {
                        removeFromBouquet("stream", $rBouquet["id"], $rInsertID);
                    }
                }
            }
            if (count($rBouquets) > 0) {
                scanBouquets();
            }
            $_STATUS = 0;
            header("Location: ./created_channel.php?id=".$rInsertID); exit;
        } else {
            $_STATUS = 1;
            $rStream = $rArray;
        }
    } else {
		if (!isset($_STATUS)) {
			$_STATUS = 1;
            $rStream = $rArray;
		}
    }
}

$rServerTree = Array();
$rServerTree[] = Array("id" => "source", "parent" => "#", "text" => "<strong>Stream Source</strong>", "icon" => "fa fa-youtube", "state" => Array("opened" => true));

if (isset($_GET["id"])) {
	if (!hasPermissions("adv", "edit_cchannel")) { exit; }
    $rChannel = getStream($_GET["id"]);
    if ((!$rChannel) or ($rChannel["type"] <> 3)) {
        exit;
    }
    $rProperties = json_decode($rChannel["movie_propeties"], True);
    if (!$rProperties) {
        if ($rChannel["series_no"] > 0) {
            $rProperties = Array("type" => 0);
        } else {
            $rProperties = Array("type" => 1);
        }
    }
    $rChannelSys = getStreamSys($_GET["id"]);
    foreach ($rServers as $rServer) {
        if (isset($rChannelSys[intval($rServer["id"])])) {
            if ($rChannelSys[intval($rServer["id"])]["parent_id"] <> 0) {
                $rParent = intval($rChannelSys[intval($rServer["id"])]["parent_id"]);
            } else {
                $rParent = "source";
            }
        } else {
            $rParent = "#";
        }
        $rServerTree[] = Array("id" => $rServer["id"], "parent" => $rParent, "text" => $rServer["server_name"], "icon" => "fa fa-server", "state" => Array("opened" => true));
    }
} else {
	if (!hasPermissions("adv", "create_channel")) { exit; }
    foreach ($rServers as $rServer) {
        $rServerTree[] = Array("id" => $rServer["id"], "parent" => "#", "text" => $rServer["server_name"], "icon" => "fa fa-server", "state" => Array("opened" => true));
    }
}


$channelOpen = "menu-open";
$channelActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
   
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <link href="../plugins/libs/switchery/switchery.min.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/clockpicker/bootstrap-clockpicker.min.css" rel="stylesheet" type="text/css" />
		  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
		
        <link href="../plugins/libs/magnific-popup/magnific-popup.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/libs/treeview/style.css" rel="stylesheet" type="text/css" />
        <link href="../plugins/css/app.css" rel="stylesheet" type="text/css" />
		
		
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Streams </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;">
					<li>
                        <a href="./streams.php?filter=8">
                            <button type="button" class="btn btn-primary waves-effect waves-light btn-sm">
                                View Channels
                            </button>
                        </a>
                    </li>
            </ol>
				
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?php if (isset($rChannel)) { echo $rChannel["stream_display_name"].' &nbsp;<button type="button" class="btn btn-outline-info waves-effect waves-light btn-xs" onClick="player('.$rChannel["id"].', \''.json_decode($rChannel["target_container"], True)[0].'\');"><i class="fa fa-play"></i></button>'; } else { echo "Create Channel"; } ?></h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
			 
				<div class="row">
                    <div class="col-xl-12">
                        <?php if (count($rTranscodeProfiles) == 0) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            You need at least one transcoding profile available to create a channel.
                        </div>
                        <?php }
                        if ((isset($_STATUS)) && ($_STATUS == 0)) { ?>
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            Channel operation was completed successfully.
                        </div>
                        <?php } else if ((isset($_STATUS)) && ($_STATUS == 1)) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            There was an error performing this operation! Please check the form entry and try again.
                        </div>
                        <?php } else if ((isset($_STATUS)) && ($_STATUS ==  2)) { ?>
                        <div class="alert alert-danger alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            The series you have selected has sources from multiple servers, please select a series that all hosted on one server.
                        </div>
                        <?php }
                        if (isset($rChannel)) { ?>
                        <div class="card text-xs-center">
                            <div class="table">
                                <table id="datatable-list" class="table table-borderless mb-0" style="width:100%">
                                    <thead class="bg-light">
                                        <tr>
                                            <th></th>
                                            <th></th>
                                            <th></th>
                                            <th>Source</th>
                                            <th>Clients</th>
                                            <th>Uptime</th>
                                            <th>Actions</th>
                                            <th></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <td colspan="8" class="text-center">Loading channel information...</td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                       
					   <?php $rEncodeErrors = getEncodeErrors($rChannel["id"]);
                        foreach ($rEncodeErrors as $rServerID => $rEncodeError) { ?>
                        <div class="alert alert-warning alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            <strong>Error on Server - <?=$rServers[$rServerID]["server_name"]?></strong><br/>
                            <?=str_replace("\n", "<br/>", $rEncodeError)?>
                        </div>
                        <?php } } ?>
                        <div class="card">
                            <div class="card-body">
                                <form action="./created_channel.php<?php if (isset($_GET["id"])) { echo "?id=".$_GET["id"]; } ?>" method="POST" id="stream_form" data-parsley-validate="">
                                    <?php if (isset($rChannel)) { ?>
                                    <input type="hidden" name="edit" value="<?=$rChannel["id"]?>" />
                                    <?php } ?>
                                    <input type="hidden" name="created_channel_location" id="created_channel_location" value="<?php if (isset($rChannel)) { echo $rChannel["created_channel_location"]; } ?>" />
                                    <input type="hidden" name="video_files" id="video_files" value="" />
                                    <input type="hidden" name="server_tree_data" id="server_tree_data" value="" />
                                    
																															
					<div class="row">						
						<div class="col-md-6">
						<div class="col-md-12">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">Details</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										     <div class="row">
												<div class="col-12">
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="channel_type">Selection Type</label>
                                                            <div class="col-md-8">
                                                                <select name="channel_type" id="channel_type" class="form-control select2" data-toggle="select2">
                                                                    <?php foreach (Array(0 => "Series", 1 => "File Browser", 2 => "VOD Selection") as $rID => $rType) { ?>
                                                                    <option <?php if (isset($rChannel)) { if ($rProperties["type"] == $rID) { echo "selected "; } } ?>value="<?=$rID?>"><?=$rType?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4" id="series_nav">
                                                            <label class="col-md-4 col-form-label" for="series_no">24/7 Series</label>
                                                            <div class="col-md-8">
                                                                <select name="series_no" id="series_no" class="form-control select2" data-toggle="select2">
                                                                    <option value="0">Select a series...</option>
                                                                    <?php foreach (getSeries() as $rSeries) { ?>
                                                                    <option <?php if (isset($rChannel)) { if (intval($rChannel["series_no"]) == intval($rSeries["id"])) { echo "selected "; } } ?>value="<?=$rSeries["id"]?>"><?=$rSeries["title"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="stream_display_name">Channel Name</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="stream_display_name" name="stream_display_name" value="<?php if (isset($rChannel)) { echo htmlspecialchars($rChannel["stream_display_name"]); } ?>" required data-parsley-trigger="change">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="category_id">Category Name</label>
                                                            <div class="col-md-8">
                                                                <select name="category_id" id="category_id" class="form-control select2" data-toggle="select2">
                                                                    <?php foreach ($rCategories as $rCategory) { ?>
                                                                    <option <?php if (isset($rChannel)) { if (intval($rChannel["category_id"]) == intval($rCategory["id"])) { echo "selected "; } } else if ((isset($_GET["category"])) && ($_GET["category"] == $rCategory["id"])) { echo "selected "; } ?>value="<?=$rCategory["id"]?>"><?=$rCategory["category_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="transcode_profile_id">Transcoding Profile</label>
                                                            <div class="col-md-8">
                                                                <select name="transcode_profile_id" id="transcode_profile_id" class="form-control select2" data-toggle="select2">
                                                                    <?php foreach ($rTranscodeProfiles as $rProfile) { ?>
                                                                    <option <?php if (isset($rChannel)) { if (intval($rChannel["transcode_profile_id"]) == intval($rProfile["profile_id"])) { echo "selected "; } } ?>value="<?=$rProfile["profile_id"]?>"><?=$rProfile["profile_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="bouquets">Add To Bouquets</label>
                                                            <div class="col-md-8">
                                                                <select name="bouquets[]" id="bouquets" class="form-control select2-multiple select2" data-toggle="select2" multiple="multiple" data-placeholder="Choose...">
                                                                    <?php foreach (getBouquets() as $rBouquet) { ?>
                                                                    <option <?php if (isset($rChannel)) { if (in_array($rChannel["id"], json_decode($rBouquet["bouquet_channels"], True))) { echo "selected "; } } ?>value="<?=$rBouquet["id"]?>"><?=$rBouquet["bouquet_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="stream_icon">Stream Logo URL</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="stream_icon" name="stream_icon" value="<?php if (isset($rChannel)) { echo htmlspecialchars($rChannel["stream_icon"]); } ?>">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="notes">Notes</label>
                                                            <div class="col-md-8">
                                                                <textarea id="notes" name="notes" class="form-control" rows="3" placeholder=""><?php if (isset($rChannel)) { echo htmlspecialchars($rChannel["notes"]); } ?></textarea>
                                                            </div>
                                                        </div>
                                                    </div> <!-- end col -->
                                                
                                             </div> <!-- end row -->
                                           
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						</div>
						
						<div class="col-md-6">
						
						<div class="col-md-12" id="selection_nav">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">Selection</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										     <div class="row">
												<div class="col-12">
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="server_idc">Server Name</label>
                                                            <div class="col-md-8">
                                                                <select id="server_idc" class="form-control select2" data-toggle="select2">
                                                                    <?php foreach (getStreamingServers() as $rServer) { ?>
                                                                    <option value="<?=$rServer["id"]?>"<?php if (isset($rChannel) && ($rChannel["created_channel_location"] == $rServer["id"])) { echo " selected"; } ?>><?=$rServer["server_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="category_name">Category / Series</label>
                                                            <div class="col-md-8">
                                                                <select id="category_idv" class="form-control select2" data-toggle="select2">
                                                                    <option value="" selected>No Filter</option>
                                                                    <?php foreach (getCategories("movie") as $rCategory) { ?>
                                                                    <option value="0:<?=$rCategory["id"]?>"><?=$rCategory["category_name"]?></option>
                                                                    <?php }
                                                                    foreach (getSeriesList() as $rSeries) { ?>
                                                                    <option value="1:<?=$rSeries["id"]?>"><?=$rSeries["title"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="vod_search">Search</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="vod_search" value="">
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <table id="datatable-vod" class="table font-normal" style="width:100%">
                                                                <thead>
                                                                    <tr>
                                                                        <th class="text-center">Actions</th>
                                                                        <th>Name</th>
                                                                        <th class="text-center">ID</th>
                                                                    </tr>
                                                                </thead>
                                                                <tbody></tbody>
                                                            </table>
                                                        </div>
                                                    </div> <!-- end col -->
                                                
                                             </div> <!-- end row -->
                                           
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						<div class="col-md-12" id="review_nav">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">Review</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										     <div class="row">
                                                    <div class="col-12">
                                                        <div class="form-group row mb-4 stream-url">
                                                            <div class="col-md-12">
                                                                <select multiple id="review_sort" name="review_sort" class="form-control multiple_select" style="min-height:400px;">
                                                                <?php if ((isset($rChannel)) && (in_array(intval($rProperties["type"]), Array(2)))) { foreach (json_decode($rChannel["stream_source"], True) as $rSource) { ?>
                                                                    <option value="<?=$rSource?>"><?=$rSource?></option>
                                                                <?php } } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                                <ul class="list-inline wizard mb-0">
                                                    <li class="list-inline-item">
                                                        <a href="javascript: void(0);" onClick="MoveUp('review')" class="btn btn-purple"><i class="fa fa-chevron-up"></i></a>
                                                        <a href="javascript: void(0);" onClick="MoveDown('review')" class="btn btn-purple"><i class="fa fa-chevron-down"></i></a>
                                                        <a href="javascript: void(0);" onClick="AtoZ('review')" class="btn btn-info">A to Z</a>
                                                    </li>
                                                    <li class="next list-inline-item float-right">
                                                        <a href="javascript: void(0);" class="btn btn-secondary">Next</a>
                                                    </li>
                                                </ul>
                                           
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						<div class="col-md-12" id="videos_nav">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">Video</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										     <div class="row">
                                                    <div class="col-12">
                                                        <div class="form-group row mb-4 stream-url">
                                                            <label class="col-md-3 col-form-label" for="import_folder">Import Folder</label>
                                                            <div class="col-md-9 input-group">
                                                                <input type="text" id="import_folder" name="import_folder" readonly class="form-control" value="<?php if (isset($rChannel)) { echo htmlspecialchars($rServers[$rChannel["created_channel_location"]]["server_name"]); } ?>">
                                                                <div class="input-group-append">
                                                                    <a href="#file-browser" id="filebrowser" class="btn btn-primary waves-effect waves-light"><i class="fa fa-folder-open"></i></a>
                                                                </div>
                                                            </div>
                                                            <div class="col-md-12 add-margin-top-20">
                                                                <select multiple id="videos_sort" name="videos_sort" class="form-control multiple_select" style="min-height:400px;">
                                                                <?php if ((isset($rChannel)) && (in_array(intval($rProperties["type"]), Array(1)))) { foreach (json_decode($rChannel["stream_source"], True) as $rSource) { ?>
                                                                    <option value="<?=$rSource?>"><?=$rSource?></option>
                                                                <?php } } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                    </div> <!-- end col -->
                                                
												</div> <!-- end row -->
                                                <ul class="list-inline wizard mb-0">
                                                    <li class="list-inline-item">
                                                        <a href="javascript: void(0);" onClick="MoveUp('videos')" class="btn btn-purple"><i class="fa fa-chevron-up"></i></a>
                                                        <a href="javascript: void(0);" onClick="MoveDown('videos')" class="btn btn-purple"><i class="fa fa-chevron-down"></i></a>
                                                        <a href="javascript: void(0);" onClick="Remove('videos')" class="btn btn-warning"><i class="fa fa-times-circle"></i></a>
                                                        <a href="javascript: void(0);" onClick="AtoZ('videos')" class="btn btn-info">A to Z</a>
                                                    </li>
                                                    <li class="next list-inline-item float-right">
                                                        <a href="javascript: void(0);" class="btn btn-secondary">Next</a>
                                                    </li>
                                                </ul>
                                           
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						<!-- servers source tree -->
						<div class="col-md-12">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">Servers</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										     <div class="row">
                                                    <div class="col-12">																
																<ul id="org" style="display:none">											
																	<li>Source
																		<ul id="add"></ul>
																	</li>
																</ul>
																<div id="chart" class="orgChart"></div>
																
																<div class="text-center jOrgChart chart_list mt-3">
																	<?php foreach($rServers as $rServerItem) { ?>
																		<div id="<?=$rServerItem["id"]?>" class="add_node node">
																			<div><span class="fa fa-server"></span></div>
																			<div><?=$rServerItem["server_name"]?></div>
																		</div>													
																	<?php } ?>                                               						
																	
																</div>
                                                        <div class="form-group row mb-4">
                                                            <div class="col-md-1"></div>
                                                            <label class="col-md-3 col-form-label" for="on_demand">On Demand</label>
                                                            <div class="col-md-8">
                                                                <select disabled id="on_demand" name="on_demand[]" class="form-control select2-multiple" data-toggle="select2" multiple="multiple" data-placeholder="Choose ...">
                                                                    <?php foreach($rServers as $rServerItem) { ?>
                                                                        <option value="<?=$rServerItem["id"]?>"><?=$rServerItem["server_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="tv_archive_server_id" name="c_tv_archive_server_id">
                                                                <label></label>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="tv_archive_server_id">Timeshift Server</label>
                                                            <div class="col-md-8">
                                                                <select disabled name="tv_archive_server_id" id="tv_archive_server_id" class="form-control" data-toggle="select2">
                                                                    <option value="">Timeshift Disabled</option>
                                                                    <?php foreach ($rServers as $rServer) { ?>
                                                                    <option value="<?=$rServer["id"]?>"><?=$rServer["server_name"]?></option>
                                                                    <?php } ?>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        <div class="form-group row mb-4">
                                                            <div class="checkbox checkbox-single col-md-1 checkbox-offset checkbox-primary">
                                                                <input type="checkbox" class="activate" data-name="tv_archive_duration" name="c_tv_archive_duration">
                                                                <label></label>
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="tv_archive_duration">Timeshift Days</label>
                                                            <div class="col-md-3">
                                                                <input disabled type="text" class="form-control" id="tv_archive_duration" name="tv_archive_duration" value="0" />
                                                            </div>
                                                            <label class="col-md-3 col-form-label" for="restart_on_edit">Restart on Edit</label>
                                                            <div class="col-md-2">
                                                                <input name="restart_on_edit" id="restart_on_edit" type="checkbox" data-plugin="switchery" class="js-switch" data-color="#039cfd" checked />
                                                            </div>
                                                        </div>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                                 
											 
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						</div>
						
						
						
						<div class="col-sm-12 text-right">
							<input name="submit_stream" type="submit" class="btn btn-primary" value="Edit Streams" />
						</div>
						
					</div>
									
									
									
								</form>
                                
								<div id="file-browser" class="mfp-hide white-popup-block">
                                    <div class="col-12">
                                        <div class="form-group row mb-4">
                                            <label class="col-md-4 col-form-label" for="server_id">Server Name</label>
                                            <div class="col-md-8">
                                                <select id="server_id" class="form-control select2" data-toggle="select2">
                                                    <?php foreach (getStreamingServers() as $rServer) { ?>
                                                    <option value="<?=$rServer["id"]?>"<?php if (isset($rChannel) && ($rChannel["created_channel_location"] == $rServer["id"])) { echo " selected"; } ?>><?=$rServer["server_name"]?></option>
                                                    <?php } ?>
                                                </select>
                                            </div>
                                        </div>
                                        <div class="form-group row mb-4">
                                            <label class="col-md-4 col-form-label" for="current_path">Current Path</label>
                                            <div class="col-md-8 input-group">
                                                <input type="text" id="current_path" name="current_path" class="form-control" value="/">
                                                <div class="input-group-append">
                                                    <button class="btn btn-primary waves-effect waves-light" type="button" id="changeDir"><i class="fa fa-chevron-right"></i></button>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="form-group row mb-4">
                                            <div class="col-md-6">
                                                <table id="datatable" class="table">
                                                    <thead>
                                                        <tr>
                                                            <th width="20px"></th>
                                                            <th>Directory</th>
                                                        </tr>
                                                    </thead>
                                                    <tbody></tbody>
                                                </table>
                                            </div>
                                            <div class="col-md-6">
                                                <table id="datatable-files" class="table">
                                                    <thead>
                                                        <tr>
                                                            <th width="20px"></th>
                                                            <th>Filename</th>
                                                        </tr>
                                                    </thead>
                                                    <tbody></tbody>
                                                </table>
                                            </div>
                                        </div>
                                        <div class="float-right">
                                            <input id="select_folder" type="button" class="btn btn-info" value="Add This Directory" />
                                        </div>
                                    </div> <!-- end col -->
                                </div>
                            
							</div> <!-- end card-body -->
                        </div> <!-- end card-->
                    </div> <!-- end col -->
                </div>
			 
			 
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
		 <script src="../plugins/libs/magnific-popup/jquery.magnific-popup.min.js"></script>

  <script src="../plugins/libs/switchery/switchery.min.js"></script>
  
        <script src="../plugins/libs/clockpicker/bootstrap-clockpicker.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
        <!-- Plugins js-->
        <script src="../plugins/twitter-bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>

        <!-- Tree view js -->
        <script src="../plugins/treeview/jstree.min.js"></script>
        <script src="../plugins/pages/treeview.init.js"></script>
        <script src="../plugins/pages/form-wizard.init.js"></script>
  
      
          
        <script>
        var changeTitle = false;
        var rSwitches = [];
        var rChannels = {};
                
        <?php if ((isset($rChannel)) && ($rProperties["type"] == 2)) { ?>
        var rSelection = <?=json_encode(getSelections(json_decode($rChannel["stream_source"], True)))?>;
        <?php } else { ?>
        var rSelection = [];
        <?php } ?>
        
        function AtoZ(rType) {
            $("#" + rType + "_sort").append($("#" + rType + "_sort option").remove().sort(function(a, b) {
                var at = $(a).text().toUpperCase().split("/").pop(), bt = $(b).text().toUpperCase().split("/").pop();
                return (at > bt) ? 1 : ((at < bt) ? -1 : 0);
            }));
        }
        function MoveUp(rType) {
            var rSelected = $('#' + rType + '_sort option:selected');
            if (rSelected.length) {
                var rPrevious = rSelected.first().prev()[0];
                if ($(rPrevious).html() != '') {
                    rSelected.first().prev().before(rSelected);
                }
            }
        }
        function MoveDown(rType) {
            var rSelected = $('#' + rType + '_sort option:selected');
            if (rSelected.length) {
                rSelected.last().next().after(rSelected);
            }
        }
        function Remove(rType) {
            var rSelected = $('#' + rType + '_sort option:selected');
            if (rSelected.length) {
                rSelected.remove();
            }
        }
        function getCategory() {
            return $("#category_idv").val();
        }
        function getServer() {
            return $("#server_idc").val();
        }
        (function($) {
          $.fn.inputFilter = function(inputFilter) {
            return this.on("input keydown keyup mousedown mouseup select contextmenu drop", function() {
              if (inputFilter(this.value)) {
                this.oldValue = this.value;
                this.oldSelectionStart = this.selectionStart;
                this.oldSelectionEnd = this.selectionEnd;
              } else if (this.hasOwnProperty("oldValue")) {
                this.value = this.oldValue;
                this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
              }
            });
          };
        }(jQuery));
        
        function toggleSelection(rID) {
            var rIndex = rSelection.indexOf(parseInt(rID));
            if (rIndex > -1) {
                rSelection = jQuery.grep(rSelection, function(rValue) {
                    return parseInt(rValue) != parseInt(rID);
                });
            } else {
                rSelection.push(parseInt(rID));
            }
            $("#datatable-vod").DataTable().ajax.reload(null, false);
            reviewSelection();
        }
        
        function reviewSelection() {
            $.post("../functions/api_xerox.php?action=review_selection", {"data": rSelection}, function(rData) {
                if (rData.result === true) {
                    var rActiveStreams = [];
                    $(rData.streams).each(function(rIndex) {
                        rStreamSource = $.parseJSON(rData.streams[rIndex]["stream_source"])[0].replace("s:" + $("#server_idc").val() + ":", "");
                        rActiveStreams.push(rStreamSource);
                        rExt = rStreamSource.split('.').pop().toLowerCase();
                        if ((["mp4", "mkv", "mov", "avi", "mpg", "mpeg", "flv", "wmv"].includes(rExt)) && ($("#review_sort option[value='" + rStreamSource.replace("'", "\\'") + "']").length == 0)) {
                            $("#review_sort").append(new Option(rStreamSource, rStreamSource));
                        }
                    });
                    $("#review_sort option").each(function() {
                        if (!rActiveStreams.includes($(this).val())) {
                            $(this).remove();
                        }
                    });
                }
            }, "json");
        }
        
        function api(rID, rServerID, rType) {
            if (rType == "delete") {
                if (confirm('Are you sure you want to delete this channel?') == false) {
                    return;
                }
            }
            $.getJSON("../functions/api_xerox.php?action=stream&sub=" + rType + "&stream_id=" + rID + "&server_id=" + rServerID, function(data) {
                if (data.result == true) {
                    if (rType == "start") {
                        toastr.success("Channel successfully started. It will take a minute or so before the channel becomes available.");
                    } else if (rType == "restart") {
                        toastr.success("Channel successfully restarted. It will take a minute or so before the channel becomes available.");
                    } else if (rType == "stop") {
                        toastr.success("Channel successfully stopped.");
                    } else if (rType == "delete") {
                        toastr.success("Channel successfully deleted.");
                    }
                    $.each($('.tooltip'), function (index, element) {
                        $(this).remove();
                    });
                    $("#datatable-list").DataTable().ajax.reload( null, false );
                } else {
                    toastr.warning("An error occured while processing your request.");
                }
            }).fail(function() {
                toastr.warning("An error occured while processing your request.");
            });
        }
        function selectDirectory(elem) {
            window.currentDirectory += elem + "/";
            $("#current_path").val(window.currentDirectory);
            $("#changeDir").click();
        }
        function selectParent() {
            $("#current_path").val(window.currentDirectory.split("/").slice(0,-2).join("/") + "/");
            $("#changeDir").click();
        }
        function reloadStream() {
            $("#datatable-list").DataTable().ajax.reload( null, false );
            setTimeout(reloadStream, 15000);
        }
        function player(rID, rContainer) {
            $.magnificPopup.open({
                items: {
                    src: "./player.php?type=live&id=" + rID + "&container=" + rContainer,
                    type: 'iframe'
                }
            });
        }
        $(document).ready(function() {
            $('select:not(.multiple_select)').select2({width: '100%',theme: 'bootstrap4'});
            
            $("#datatable").DataTable({
                responsive: false,
                paging: false,
                bInfo: false,
                searching: false,
                scrollY: "250px",
                columnDefs: [
                    {"className": "dt-center", "targets": [0]},
                ],
                "language": {
                    "emptyTable": ""
                }
            });
            
            $("#datatable-files").DataTable({
                responsive: false,
                paging: false,
                bInfo: false,
                searching: true,
                scrollY: "250px",
                columnDefs: [
                    {"className": "dt-center", "targets": [0]},
                ],
                "language": {
                    "emptyTable": "No compatible files found"
                }
            });
            
            $("#datatable-vod").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                },
                createdRow: function(row, data, index) {
                    $(row).addClass('vod-' + data[0]);
                    var rIndex = rSelection.indexOf(parseInt(data[0]));
                    if (rIndex > -1) {
                        $(row).find(".btn-remove").show();
                    } else {
                        $(row).find(".btn-add").show();
                    }
                },
               /* bInfo: false,
                bAutoWidth: false,*/
                searching: true,
                pageLength: 20,
                lengthChange: false,
                processing: true,
                serverSide: true,
                responsive: true,
				columnDefs: [
                    {"className": "dt-center", "targets": [0,2]}
                ],
                ajax: {
                    url: "../functions/table.php",
                    "data": function(d) {
                        d.id = "vod_selection";
                        d.category_id = getCategory();
                        d.server_id = getServer();
                    }
                },
                
            });
            /*columnDefs: [
                    {"className": "dt-center", "targets": [0,2]}
                ],*/
            $("#category_idv").on("select2:select", function(e) { 
                $("#datatable-vod").DataTable().ajax.reload(null, false);
            });
            $('#vod_search').keyup(function(){
                $('#datatable-vod').DataTable().search($(this).val()).draw();
            })
            
            var elems = Array.prototype.slice.call(document.querySelectorAll('.js-switch'));
            elems.forEach(function(html) {
              var switchery = new Switchery(html);
              window.rSwitches[$(html).attr("id")] = switchery;
            });
            
            $("#select_folder").click(function() {
                if ($("#server_id").val() != $("#created_channel_location").val()) {
                    $("#created_channel_location").val($("#server_id").val());
                    $("#videos_sort").empty();
                }
                $("#import_folder").val($("#server_id option:selected").text());
                $("#datatable-files").DataTable().rows().every(function ( rowIdx, tableLoop, rowLoop) {
                    var data = this.data();
                    rExt = data[1].split('.').pop().toLowerCase();
                    if ((["mp4", "mkv", "mov", "avi", "mpg", "mpeg", "flv", "wmv"].includes(rExt)) && ($("#videos_sort option[value='" + (window.currentDirectory + data[1]).replace("'", "\\'") + "']").length == 0)) {
                        $("#videos_sort").append(new Option(window.currentDirectory + data[1], window.currentDirectory + data[1]));
                    }
                });
                $.magnificPopup.close();
            });
            
            $("#changeDir").click(function() {
                window.currentDirectory = $("#current_path").val();
                if (window.currentDirectory.substr(-1) != "/") {
                    window.currentDirectory += "/";
                }
                $("#current_path").val(window.currentDirectory);
                $("#datatable").DataTable().clear();
                $("#datatable").DataTable().row.add(["", "Loading..."]);
                $("#datatable").DataTable().draw(true);
                $("#datatable-files").DataTable().clear();
                $("#datatable-files").DataTable().row.add(["", "Please wait..."]);
                $("#datatable-files").DataTable().draw(true);
                rFilter = "video";
                $.getJSON("../functions/api_xerox.php?action=listdir&dir=" + window.currentDirectory + "&server=" + $("#server_id").val() + "&filter=" + rFilter, function(data) {
                    $("#datatable").DataTable().clear();
                    $("#datatable-files").DataTable().clear();
                    if (window.currentDirectory != "/") {
                        $("#datatable").DataTable().row.add(["<i class='fa fa-arrow-left'></i>", "Parent Directory"]);
                    }
                    if (data.result == true) {
                        $(data.data.dirs).each(function(id, dir) {
                            $("#datatable").DataTable().row.add(["<i class='fa fa-folder-open'></i>", dir]);
                        });
                        $("#datatable").DataTable().draw(true);
                        $(data.data.files).each(function(id, dir) {
                            $("#datatable-files").DataTable().row.add(["<i class='fa fa-file-video'></i>", dir]);
                        });
                        $("#datatable-files").DataTable().draw(true);
                    }
                });
            });
            
            $('#datatable').on('click', 'tbody > tr', function() {
                if ($(this).find("td").eq(1).html() == "Parent Directory") {
                    selectParent();
                } else {
                    selectDirectory($(this).find("td").eq(1).html());
                }
            });
            $('#server_tree').jstree({ 'core' : {
                'check_callback': function (op, node, parent, position, more) {
                    switch (op) {
                        case 'move_node':
                            if (node.id == "source") { return false; }
                            return true;
                    }
                },
                'data' : <?=json_encode($rServerTree)?>
            }, "plugins" : [ "dnd" ]
            });
            
            $("#stream_form").submit(function(e){
                var rVideoFiles = [];
                if ($("#channel_type").val() == 0) {
                    if ($("#series_no").val() == 0) {
                        toastr.info("Please select a series to map.");
                        e.preventDefault();
                    }
                } else if ($("#channel_type").val() == 1) {
                    if ($("#videos_sort option").length == 0) {
                        toastr.info("Please add at least one video to the channel.");
                        e.preventDefault();
                    }
                    $("#videos_sort option").each(function() {
                        rVideoFiles.push($(this).val());
                    });
                    $("#created_channel_location").val($("#server_id").val());
                } else if ($("#channel_type").val() == 2) {
                    if ($("#review_sort option").length == 0) {
                        toastr.info("Please add at least one video to the channel.");
                        e.preventDefault();
                    }
                    $("#review_sort option").each(function() {
                        rVideoFiles.push($(this).val());
                    });
                    $("#created_channel_location").val($("#server_idc").val());
                }
                if (!$("#transcode_profile_id").val()) {
                    toastr.info("Please select a trancoding profile.");
                    e.preventDefault();
                }
				
				$('#loader_spinner').show();
                $("#server_tree_data").val(JSON.stringify($('#server_tree').jstree(true).get_json('#', {flat:true})));
                $("#video_files").val(JSON.stringify(rVideoFiles));
            });
            
            $("#filebrowser").magnificPopup({
                type: 'inline',
                preloader: false,
                focus: '#server_id',
                callbacks: {
                    beforeOpen: function() {
                        if ($(window).width() < 830) {
                            this.st.focus = false;
                        } else {
                            this.st.focus = '#server_id';
                        }
                    }
                }
            });
            $("#filebrowser-sub").magnificPopup({
                type: 'inline',
                preloader: false,
                focus: '#server_id',
                callbacks: {
                    beforeOpen: function() {
                        if ($(window).width() < 830) {
                            this.st.focus = false;
                        } else {
                            this.st.focus = '#server_id';
                        }
                    }
                }
            });
            
            $("#filebrowser").on("mfpOpen", function() {
                $("#changeDir").click();
                $($.fn.dataTable.tables(true)).css('width', '100%');
                $($.fn.dataTable.tables(true)).DataTable().columns.adjust().draw();
            });
            $("#filebrowser-sub").on("mfpOpen", function() {
                $("#changeDir").click();
                $($.fn.dataTable.tables(true)).css('width', '100%');
                $($.fn.dataTable.tables(true)).DataTable().columns.adjust().draw();
            });
            
            $(document).keypress(function(event){
                if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
            });
            $("#server_id").change(function() {
                $("#current_path").val("/");
                $("#changeDir").click();
            });
            
            $("#series_no").change(function() {
                if ($("#series_no").val() > 0) {
                    $("#stream_display_name").val("24/7 " + $("#series_no option:selected").text());
                }
            });
            
            $("#channel_type").change(function() {
                if ($("#channel_type").val() == 0) {
                    $("#review_nav").hide();
                    $("#selection_nav").hide()
                    $("#videos_nav").hide();
                    $("#series_nav").show();
                } else if ($("#channel_type").val() == 1) {
                    $("#review_nav").hide();
                    $("#selection_nav").hide()
                    $("#videos_nav").show();
                    $("#series_nav").hide();
                } else {
                    $("#review_nav").show();
                    $("#selection_nav").show()
                    $("#videos_nav").hide();
                    $("#series_nav").hide();
                }
            });
            
            $("#server_idc").change(function() {
                $("#review_sort").empty();
                $("#datatable-vod").DataTable().ajax.reload(null, false);
            });
            
            <?php if (isset($rChannel)) { ?>
            $("#datatable-list").DataTable({
                ordering: false,
                paging: false,
                searching: false,
                processing: true,
                serverSide: true,
                reponsive: true,
                bInfo: false,
                ajax: {
                    url: "../functions/table_search.php",
                    "data": function(d) {
                        d.id = "streams";
                        d.stream_id = <?=$rChannel["id"]?>;
                    }
                },
                columnDefs: [
                    {"className": "dt-center", "targets": [3,4,5,6]},
                    {"visible": false, "targets": [0,1,2,7]}
                ],
            });
            setTimeout(reloadStream, 5000);
            $("#season_num").trigger('change');
            <?php } ?>
            
            $("#next_0").click(function() {
                if ($("#channel_type").val() == 0) {
                    $('[href="#load-balancing"]').tab('show');
                } else if ($("#channel_type").val() == 1) {
                    $('[href="#selection"]').tab('show');
                } else {
                    $('[href="#videos"]').tab('show');
                }
            });
            $("#previous_0").click(function() {
                if ($("#channel_type").val() == 0) {
                    $('[href="#stream-details"]').tab('show');
                } else if ($("#channel_type").val() == 1) {
                    $('[href="#videos"]').tab('show');
                } else {
                    $('[href="#review"]').tab('show');
                }
            });
            
            $("form").attr('autocomplete', 'off');
            $("#changeDir").click();
            $("#channel_type").trigger('change');
        });
        </script>
     
       
    