<?php 
//require("../layout/header.php");
header('Content-type: text/html; charset=utf-8');
require('../includes/inc_db.php');
include "../functions/functions_xerox.php";




$streamOpen = "menu-open";
$streamActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
  <style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}
	
	
	.dd-list .dd-item .dd-handle {
				background: #f1f5f7;
				border: none;
				padding: 8px 16px;
				height: auto;
				font-weight: 500;
				border-radius: 3px;
				font-size: x-large;
			}
			.dd-list .dd3-handle {
				margin: 0;
				height: 36px!important;
				float: left;
			}
			.dd-list .dd3-content {
				height: auto;
				border: none;
				padding: 8px 16px 8px 46px;
				background: #f1f5f7;
				font-weight: 600;
			}
			.dd-list .dd3-handle:before {
				content: "=";
				font-family: "Material Design Icons";
				color: #adb5bd;
			}

  </style>
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Fingerprint </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;"> 
					<li class="breadcrumb-item">
                        <a href="./streams.php"><i class="fa fa-backspace"></i> Back to Streams</a>
                    </li>
             </ol>
         
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9"><?=$_["fingerprint_stream"]?></h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
					
					<div class="row">
                    <div class="col-xl-12">
                        <div class="card">
                            <div class="card-body">
                                <form action="./fingerprint.php" method="POST" id="fingerprint_form">
                                    <div id="basicwizard">
                                        <ul class="nav nav-pills bg-light nav-justified form-wizard-header mb-4">
                                            <li class="nav-item" id="stream-selection-tab">
                                                <a href="#stream-selection" id="stream-selection-nav" data-toggle="tab" class="nav-link rounded-0 pt-2 pb-2 active"> 
                                                    <i class="fa fa-play mr-1"></i>
                                                    <span class="d-none d-sm-inline"><?=$_["stream"]?></span>
                                                </a>
                                            </li>
                                            <li class="nav-item disabled" id="stream-activity-tab">
                                                <a href="#stream-activity" data-toggle="tab" class="nav-link rounded-0 pt-2 pb-2"> 
                                                    <i class="fa fa-users mr-1"></i>
                                                    <span class="d-none d-sm-inline"><?=$_["activity"]?></span>
                                                </a>
                                            </li>
                                        </ul>
                                        <div class="tab-content b-0 mb-0 pt-0">
                                            <div class="tab-pane fade active show" id="stream-selection">
                                                <div class="row">
                                                    <div class="col-md-5 col-6">
                                                        <input type="text" class="form-control" id="stream_search" value="" placeholder="<?=$_["search_streams"]?>...">
                                                    </div>
                                                    <div class="col-md-4 col-6">
                                                        <select id="category_search" class="form-control" data-toggle="select2">
                                                            <option value="" selected><?=$_["all_categories"]?></option>
                                                            <?php foreach ($rCategories as $rCategory) { ?>
                                                            <option value="<?=$rCategory["id"]?>"<?php if ((isset($_GET["category"])) && ($_GET["category"] == $rCategory["id"])) { echo " selected"; } ?>><?=$rCategory["category_name"]?></option>
                                                            <?php } ?>
                                                        </select>
                                                    </div>
                                                    <label class="col-md-1 col-2 col-form-label text-center" for="show_entries"><?=$_["show"]?></label>
                                                    <div class="col-md-2 col-8">
                                                        <select id="show_entries" class="form-control" data-toggle="select2">
                                                            <?php foreach (Array(10, 25, 50, 250, 500, 1000) as $rShow) { ?>
                                                            <option<?php if ($rAdminSettings["default_entries"] == $rShow) { echo " selected"; } ?> value="<?=$rShow?>"><?=$rShow?></option>
                                                            <?php } ?>
                                                        </select>
                                                    </div>
                                                    <table id="datatable-md1" class="table table-borderless mb-0">
                                                        <thead class="bg-light">
                                                            <tr>
                                                                <th class="text-center"><?=$_["id"]?></th>
                                                                <th><?=$_["stream_name"]?></th>
                                                                <th><?=$_["category"]?></th>
                                                                <th class="text-center"><?=$_["clients"]?></th>
                                                                <th class="text-center"></th>
                                                            </tr>
                                                        </thead>
                                                        <tbody></tbody>
                                                    </table>
                                                </div>
                                            </div>
                                            <div class="tab-pane fade" id="stream-activity">
                                                <div class="row">
                                                    <div class="alert alert-warning alert-dismissible fade show col-md-12 col-12 text-center" role="alert">
                                                        <?=$_["warning_fingerprint"]?>
                                                    </div>
                                                </div>
                                                <div class="row" id="filter_selection">
                                                    <label class="col-md-1 col-2 col-form-label text-center" for="fingerprint_type"><?=$_["type"]?></label>
                                                    <div class="col-md-2 col-6">
                                                        <select id="fingerprint_type" class="form-control text-center" data-toggle="select2">
                                                            <option value="1"><?=$_["activity_id"]?></option>
                                                            <option value="2"><?=$_["username"]?></option>
                                                            <option value="3"><?=$_["message"]?></option>
                                                        </select>
                                                    </div>
                                                    <label class="col-md-1 col-2 col-form-label text-center" for="font_size"><?=$_["size"]?></label>
                                                    <div class="col-md-1 col-2">
                                                        <input type="text" class="form-control text-center" id="font_size" value="36" placeholder="">
                                                    </div>
                                                    <label class="col-md-1 col-2 col-form-label text-center" for="font_color"><?=$_["colour"]?></label>
                                                    <div class="col-md-2 col-2">
                                                        <input type="text" id="font_color" class="form-control text-center" value="#ffffff">
                                                    </div>
                                                    <label class="col-md-1 col-2 col-form-label text-center" for="position"><?=$_["position"]?></label>
                                                    <div class="col-md-1 col-2">
                                                        <input type="text" class="form-control text-center" id="position_x" value="10" placeholder="X">
                                                    </div>
                                                    <div class="col-md-1 col-2">
                                                        <input type="text" class="form-control text-center" id="position_y" value="10" placeholder="Y">
                                                    </div>
                                                    <div class="col-md-1 col-2">
                                                        <button type="button" class="btn btn-info waves-effect waves-light" onClick="activateFingerprint()">
                                                            <i class="fa fa-fingerprint"></i>
                                                        </button>
                                                    </div>
                                                    <div class="col-md-12 col-2" style="margin-top:10px;display:none;" id="custom_message_div">
                                                        <input type="text" class="form-control" id="custom_message" value="" placeholder="<?=$_["custom_message"]?>">
                                                    </div>
                                                </div>
                                                <div class="row">
													<div class="col-sm-12">
                                                    <table id="datatable-md2" class="table table-borderless mb-0">
                                                        <thead class="bg-light">
                                                            <tr>
                                                                <th class="text-center"><?=$_["id"]?></th>
                                                                <th class="text-center"><?=$_["status"]?></th>
                                                                <th><?=$_["username"]?></th>
                                                                <th><?=$_["stream"]?></th>
                                                                <th><?=$_["server"]?></th>
                                                                <th class="text-center"><?=$_["time"]?></th>
                                                                <th class="text-center"><?=$_["ip"]?></th>
                                                                <th class="text-center"><?=$_["country"]?></th>
                                                                <th class="text-center"><?=$_["actions"]?></th>
                                                            </tr>
                                                        </thead>
                                                        <tbody></tbody>
                                                    </table>
													</div>
                                                </div>
                                            </div>
                                        </div> <!-- tab-content -->
                                    </div> <!-- end #basicwizard-->
                                </form>

                            </div> <!-- end card-body -->
                        </div> <!-- end card-->
                    </div> <!-- end col -->
                </div>
           
					
			   <!-- end row-->

					
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/bootstrap-colorpicker/bootstrap-colorpicker.min.js"></script>
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
    
	 <script>
        var rStreamID = -1;
        
        function getCategory() {
            return $("#category_search").val();
        }
        function getStreamID() {
			console.log(window.rStreamID);
            return window.rStreamID;
        }
        function selectFingerprint(rID) {
            $("#stream-activity-tab").attr("disabled", false);
            $('[href="#stream-activity"]').tab('show');
            window.rStreamID = rID;
        }
        function activateFingerprint() {
            rArray = {"id": window.rStreamID, "font_size": $("#font_size").val(), "font_color": $("#font_color").val(), "message": "", "type": $("#fingerprint_type").val(), "xy_offset": ""};
            console.log(rArray);
			if (rArray.type == 3) {
                rArray["message"] = $("#custom_message").val();
            }
            if (($("#position_x").val() >= 0) && ($("#position_y").val() >= 0)) {
                rArray["xy_offset"] = $("#position_x").val() + "x" + $("#position_y").val();
            }
            if ((rArray["font_size"] > 0) && (rArray["font_color"].length > 0) && ((rArray["message"].length > 0) || (rArray["type"] != 3))  && (rArray["font_size"] > 0) && (rArray["xy_offset"].length > 0)) {
                $.getJSON("../functions/api_xerox.php?action=fingerprint&data=" + encodeURIComponent(JSON.stringify(rArray)), function(data) {
                    console.log(data);
					if (data.result == true) {
                        $.toast("<?=$_["fingerprint_success"]?>");
                    } else {
                        $.toast("<?=$_["error_occured"]?>");
                    }
                });
                $("#datatable-md2").DataTable().ajax.reload( null, false );
                $("#filter_selection").fadeOut(500, function() {
                    $('#datatable-md2').parents('div.dataTables_wrapper').first().fadeIn(500);
                });
            } else {
                $.toast("<?=$_["fingerprint_fail"]?>");
            }
        }
        function api(rID, rType, rAID) {
            $.getJSON("../functions/api_xerox.php?action=user_activity&sub=" + rType + "&pid=" + rID, function(data) {
                if (data.result === true) {
                    if (rType == "kill") {
                        $.toast("<?=$_["connection_has_been_killed"]?>");
                        $("#row-" + rAID).remove();
                    }
                } else {
                    $.toast("<?=$_["error_occured"]?>");
                }
            });
        }
        (function($) {
          $.fn.inputFilter = function(inputFilter) {
            return this.on("input keydown keyup mousedown mouseup select contextmenu drop", function() {
              if (inputFilter(this.value)) {
                this.oldValue = this.value;
                this.oldSelectionStart = this.selectionStart;
                this.oldSelectionEnd = this.selectionEnd;
              } else if (this.hasOwnProperty("oldValue")) {
                this.value = this.oldValue;
                this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
              }
            });
          };
        }(jQuery));
        $(document).ready(function() {
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            $("#font_color").colorpicker({format:"auto"});
            $(document).keypress(function(event){
                if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
            });
            $("#probesize_ondemand").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("#delay_minutes").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("#tv_archive_duration").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("form").attr('autocomplete', 'off');
            $("#datatable-md1").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                },
                processing: true,
                serverSide: true,
                ajax: {
                    url: "../functions/table_search.php",
                    "data": function(d) {
                        d.id = "stream_unique",
                        d.category = getCategory()
                    }
                },
                pageLength: <?=$rAdminSettings["default_entries"] ?: 10?>,
                columnDefs: [
                    {"className": "dt-center", "targets": [0,3,4]},
                    {"orderable": false, "targets": [4]}
                ],
                order: [[ 3, "desc" ]],
            });
            $('#stream_search').keyup(function(){
                $("#datatable-md1").DataTable().search($(this).val()).draw();
            });
            $('#show_entries').change(function(){
                $("#datatable-md1").DataTable().page.len($(this).val()).draw();
            });
            $('#category_search').change(function(){
                $("#datatable-md1").DataTable().ajax.reload(null, false);
            });
			console.log('*-*-*-*-*-*-*');
            $("#datatable-md2").DataTable({
                language: {
                    paginate: {
                        previous: "<i class='fa fa-chevron-left'>",
                        next: "<i class='fa fa-chevron-right'>"
                    }
                },
                drawCallback: function() {
                    $(".dataTables_paginate > .pagination").addClass("pagination-rounded");
                },
                rowCallback: function (row, data) {
					console.log(data);
                    $(row).attr("id", "row-" + data[0]);
                },
                processing: true,
                serverSide: true,
                ajax: {
                    url: "../functions/table_search.php",
                    "data": function(d) {
                        d.id = "live_connections",
                        d.stream_id = getStreamID(),
                        d.fingerprint = true;
                    }
                },
                pageLength: <?=$rAdminSettings["default_entries"] ?: 10?>,
                columnDefs: [
                    {"className": "dt-center", "targets": [0,1,5,6,7,8]},
                    {"visible": false, "targets": [1,3]}
                ],
                pageLength: <?=$rAdminSettings["default_entries"] ?: 10?>,
                lengthMenu: [10, 25, 50, 250, 500, 1000],
                order: [[ 0, "desc" ]]
            });
            $("#fingerprint_type").change(function() {
                if ($(this).val() == 3) {
                    $("#custom_message_div").show();
                } else {
                    $("#custom_message_div").hide();
                }
            });
            $("#font_size").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("#position_x").inputFilter(function(value) { return /^\d*$/.test(value); });
            $("#position_y").inputFilter(function(value) { return /^\d*$/.test(value); });
            $('#datatable-md2').parents('div.dataTables_wrapper').first().hide();
            $(".nav li.disabled a").click(function() {
                return false;
            });
            $("#stream-selection-nav").click(function() {
                $("#stream-activity-tab").attr("disabled", true);
                window.rStreamID = -1;
                $("#filter_selection").show();
                $('#datatable-md2').parents('div.dataTables_wrapper').first().hide();
                $("#datatable-md1").DataTable().ajax.reload( null, false );
            });
        });
        </script>
     