<?php 
//require("../layout/header.php");

require('../includes/inc_db.php');
include "../functions/functions_xerox.php";


if (isset($_POST["replace_dns"])) {
	$rOldDNS = ESC(str_replace("/", "\/", $_POST["old_dns"]));
	$rNewDNS = ESC(str_replace("/", "\/", $_POST["new_dns"]));
	$db->query("UPDATE `streams` SET `stream_source` = REPLACE(`stream_source`, '".$rOldDNS."', '".$rNewDNS."');");
	$_STATUS = 1;
} else if (isset($_POST["move_streams"])) {
	$rSource = $_POST["source_server"];
	$rReplacement = $_POST["replacement_server"];
	$rExisting = Array();
	$result = $db->query("SELECT `id` FROM `streams_sys` WHERE `server_id` = ".intval($rReplacement).";");
	if (($result) && ($result->num_rows > 0)) {
		while ($row = $result->fetch_assoc()) {
			$rExisting[] = intval($row["id"]);
		}
	}
	$result = $db->query("SELECT `id` FROM `streams_sys` WHERE `server_id` = ".intval($rSource).";");
	if (($result) && ($result->num_rows > 0)) {
		while ($row = $result->fetch_assoc()) {
			if (in_array(intval($row["id"]), $rExisting)) {
				$db->query("DELETE FROM `streams_sys` WHERE `id` = ".intval($row["id"]).";");
			}
		}
	}
	$db->query("UPDATE `streams_sys` SET `server_id` = ".intval($rReplacement)." WHERE `server_id` = ".intval($rSource).";");
	$_STATUS = 2;
}
 else if (isset($_POST["cleanup_streams"])) {
    $rStreams = getStreamList();
    $rStreamArray = Array();
    foreach ($rStreams as $rStream) {
        $rStreamArray[] = intval($rStream["id"]);
    }
    $rDelete = Array();
    $result = $db->query("SELECT `server_stream_id`, `stream_id` FROM `streams_sys`;");
    if (($result) && ($result->num_rows > 0)) {
        while ($row = $result->fetch_assoc()) {
            if (!in_array(intval($row["stream_id"]), $rStreamArray)) {
                $rDelete[] = $row["server_stream_id"];
            }
        }
    }
    if (count($rDelete) > 0) {
        $db->query("DELETE FROM `streams_sys` WHERE `server_stream_id` IN (".join(",", $rDelete).");");
    }
    $rDelete = Array();
    $result = $db->query("SELECT `id`, `stream_id` FROM `client_logs`;");
    if (($result) && ($result->num_rows > 0)) {
        while ($row = $result->fetch_assoc()) {
            if (!in_array(intval($row["stream_id"]), $rStreamArray)) {
                $rDelete[] = $row["id"];
            }
        }
    }
    if (count($rDelete) > 0) {
        $db->query("DELETE FROM `client_logs` WHERE `id` IN (".join(",", $rDelete).");");
    }
    $rDelete = Array();
    $result = $db->query("SELECT `id`, `stream_id` FROM `stream_logs`;");
    if (($result) && ($result->num_rows > 0)) {
        while ($row = $result->fetch_assoc()) {
            if (!in_array(intval($row["stream_id"]), $rStreamArray)) {
                $rDelete[] = $row["id"];
            }
        }
    }
    if (count($rDelete) > 0) {
        $db->query("DELETE FROM `stream_logs` WHERE `id` IN (".join(",", $rDelete).");");
    }
    $rDelete = Array();
    $result = $db->query("SELECT `activity_id`, `stream_id` FROM `user_activity`;");
    if (($result) && ($result->num_rows > 0)) {
        while ($row = $result->fetch_assoc()) {
            if (!in_array(intval($row["stream_id"]), $rStreamArray)) {
                $rDelete[] = $row["activity_id"];
            }
        }
    }
    if (count($rDelete) > 0) {
        $db->query("DELETE FROM `user_activity` WHERE `activity_id` IN (".join(",", $rDelete).");");
    }
    $_STATUS = 3;
}



$streamOpen = "menu-open";
$streamActive = "active";

include('../layout/header_html.php');
?>


<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  
        <link href="../plugins/libs/nestable2/jquery.nestable.min.css" rel="stylesheet" />
  
        <link href="../plugins/treeview/style.css" rel="stylesheet" type="text/css" />
  <style>
	.dropdown-menu.show {
		text-align: center !important;
		background: #fbd7ff85;
	}

  </style>
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-4">
            <h1>Stream Tools </h1>
          </div>
          <div class="col-sm-8">
          
			<ol class="breadcrumb m-0" style="float: right;"> 
					<li class="breadcrumb-item">
                        <a href="./streams.php"><i class="fa fa-backspace"></i> Back to Streams</a>
                    </li>
             </ol>
         
		 </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header row">
                <h3 class="card-title col-md-9">Stream Tools</h3>
				<div class="col-md-3 text-right">
					
				</div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
					<div class="row">
                    <div class="col-xl-12">
                        <?php if ((isset($_STATUS)) && ($_STATUS == 1)) { ?>
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            Stream DNS replacement was successful. 
                        </div>
                        <?php } else if ((isset($_STATUS)) && ($_STATUS == 2)) { ?>
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            Streams have been moved from the source server to the replacement server.
                        </div>
                        <?php } else if ((isset($_STATUS)) && ($_STATUS == 3)) { ?>
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            Stream cleanup was successful!
                        </div>
                        <?php } ?>
                        <div class="card">
                            <div class="card-body">
							
											
					<div class="row">
						
						<div class="col-md-6">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">DNS Replacement</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										<form action="./stream_tools.php" method="POST" id="tools_form" data-parsley-validate="">
                                                <div class="row">
                                                    <div class="col-12">
														<p class="sub-header">
                                                            The DNS replacement tool can be used to replace the domain name of a stream with another. It can replace any text within a stream, such as username and password.
                                                        </p>
                                                        <div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="old_dns">Old DNS</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="old_dns" name="old_dns" value="" placeholder="http://example.com" required data-parsley-trigger="change">
                                                            </div>
                                                        </div>
														<div class="form-group row mb-4">
                                                            <label class="col-md-4 col-form-label" for="new_dns">New DNS</label>
                                                            <div class="col-md-8">
                                                                <input type="text" class="form-control" id="new_dns" name="new_dns" value="" placeholder="http://newdns.com" required data-parsley-trigger="change">
                                                            </div>
                                                        </div>
                                                    </div> <!-- end col -->
                                                </div> <!-- end row -->
                                                <ul class="list-inline wizard mb-0">
													<li class="list-inline-item">
														<div class="custom-control custom-checkbox">
															<input type="checkbox" class="custom-control-input" id="confirmReplace">
															<label class="custom-control-label" for="confirmReplace">I confirm that I want to replace the old DNS with the new DNS above.</label>
														</div>
													</li>
                                                    <li class="list-inline-item float-right">
                                                        <input disabled name="replace_dns" id="replace_dns" type="submit" onclick='showHide()' class="btn btn-primary" value="Replace DNS" />
                                                    </li>
                                                </ul>
											</form>       
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						<div class="col-md-6">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">Move Streams</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										<form action="./stream_tools.php" method="POST" id="tools_form" data-parsley-validate="">
												<div class="row">
													<div class="col-12">
														<p class="sub-header">
															This tool will allow you to move all streams from one server to another.
														</p>
														<div class="form-group row mb-4">
															<label class="col-md-4 col-form-label" for="source_server">Source Server</label>
															<div class="col-md-8">
																<select name="source_server" id="source_server" class="form-control select2" data-toggle="select2">
																	<?php foreach ($rServers as $rServer) { ?>
																	<option value="<?=$rServer["id"]?>"><?=$rServer["server_name"]?></option>
																	<?php } ?>
																</select>
															</div>
														</div>
														<div class="form-group row mb-4">
															<label class="col-md-4 col-form-label" for="replacement_server">Replacement Server</label>
															<div class="col-md-8">
																<select name="replacement_server" id="replacement_server" class="form-control select2" data-toggle="select2">
																	<?php foreach ($rServers as $rServer) { ?>
																	<option value="<?=$rServer["id"]?>"><?=$rServer["server_name"]?></option>
																	<?php } ?>
																</select>
															</div>
														</div>
													</div> <!-- end col -->
												</div> <!-- end row -->
												<ul class="list-inline wizard mb-0">
													<li class="list-inline-item">
														<div class="custom-control custom-checkbox">
															<input type="checkbox" class="custom-control-input" id="confirmReplace2">
															<label class="custom-control-label" for="confirmReplace2">I confirm that I want to move all streams from the source server to the replacement.</label>
														</div>
													</li>
													<li class="list-inline-item float-right">
														<input disabled name="move_streams" id="move_streams" type="submit" onclick='showHide()' class="btn btn-primary" value="Move Streams" />
													</li>
												</ul>
											</form>
										
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						<div class="col-md-6">
							<div class="card card-secondary collapsed-card">
								  <div class="card-header">
									<h3 class="card-title">Cleanup</h3>

									<div class="card-tools">
									  <button type="button" class="btn btn-tool" data-card-widget="collapse">
										<i class="fas fa-minus"></i>
									  </button>
									</div>
								  </div>
								  <!-- /.card-header -->
								  <div class="card-body" id="stream-details" style="display:block">
										<form action="./stream_tools.php" method="POST" id="tools_form" data-parsley-validate="">
												<div class="row">
													<div class="col-12">
														<p class="sub-header">
															This tool will clean up your streams database, removing invalid entries from the streams sys table and all logs. Xtream Codes monitors your streams sys table and will use resources doing so, it's best to clean this up periodically.
														</p>
													</div> <!-- end col -->
												</div> <!-- end row -->
												<ul class="list-inline wizard mb-0">
													<li class="list-inline-item">
														<div class="custom-control custom-checkbox">
															<input type="checkbox" class="custom-control-input" id="confirmReplace3">
															<label class="custom-control-label" for="confirmReplace3">I confirm that I want to clean up my streams database.</label>
														</div>
													</li>
													<li class="list-inline-item float-right">
														<input disabled name="cleanup_streams" id="cleanup_streams" onclick='showHide()' type="submit" class="btn btn-primary" value="Cleanup" />
													</li>
												</ul>
											</form>
                                                
								  </div>
								  <!-- /.card-body -->
							 </div>
						</div>	
						
						
						</div>
							
												
							
							</div> <!-- end card-body -->
                        </div> <!-- end card-->
                    </div> <!-- end col -->
                </div>
            
			   <!-- end row-->

					
			  </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		  
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 
 <?php
include("../common/body.php");
?>

<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  
        <script src="../plugins/libs/nestable2/jquery.nestable.min.js"></script>
<!-- Select2 -->
<script src="../plugins/select2/js/select2.full.min.js"></script>
    
 <script>
        $(document).ready(function() {
            $('select').select2({width: '100%',theme: 'bootstrap4'});
            $(window).keypress(function(event){
                if(event.which == 13 && event.target.nodeName != "TEXTAREA") return false;
            });
			$("#confirmReplace").change(function() {
				if ($(this).is(":checked")) {
					$("#replace_dns").attr("disabled", false);
				} else {
					$("#replace_dns").attr("disabled", true);
				}
			});
			$("#confirmReplace2").change(function() {
				if ($(this).is(":checked")) {
					$("#move_streams").attr("disabled", false);
				} else {
					$("#move_streams").attr("disabled", true);
				}
			});
            $("#confirmReplace3").change(function() {
				if ($(this).is(":checked")) {
					$("#cleanup_streams").attr("disabled", false);
				} else {
					$("#cleanup_streams").attr("disabled", true);
				}
			});
            $("form").attr('autocomplete', 'off');
        });
        </script>

     
     