<?php
	
	function decrypte($json)
	{
		global $hashkey;	 
		$json = str_replace(['!', ')', '('], ['+', '/', '='], $json);
		$json = base64_decode($json);
		
		$json = xorIt($json, $hashkey, 1);
	}
	
	function DBcnx()
	{
		$user = "Panel_ST";
		$pass = "Y7h9d7f8DB";
		
		$pdoPanel = new PDO('mysql:host=x12tv.co;dbname=xtream_iptvpro;port=7999', $user, $pass);
		$pdoPanel->exec("SET NAMES 'UTF8'");
		$pdoPanel->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);
		//
		$pdoPanel->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		return $pdoPanel;
	}
	
	function xorIt($string, $key, $type = 0)
	{
		$sLength = strlen($string);
		$xLength = strlen($key);
		for($i = 0; $i < $sLength; $i++) {
			for($j = 0; $j < $xLength; $j++) {
				if ($type == 1) {
					//decrypt
					$string[$i] = $key[$j]^$string[$i];
					
				} else {
					//crypt
					$string[$i] = $string[$i]^$key[$j];
				}
			}
		}
		return $string;
	}
	
	function randomKeyAlpha($length = 16) {
		$alphabet = 'ABCDEFGHJKMNPQRSTUVWXYZabcdefghjkmnopqrstuvwxyz0123456789';
		$pass = array();
		$alphaLength = strlen($alphabet) - 1;
		for ($i = 0; $i < $length; $i++) {
			$n = rand(0, $alphaLength);
			$pass[] = $alphabet[$n];
		}
		return implode($pass);
	}
	
	function checkCodeExist($code)
	{
		global $pdoPanel;
		try{
			$rUnitPrice = "SELECT * FROM panel.active_code WHERE code = :code LIMIT 1";
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			$stmtUnit->bindParam(":code", $code);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;		
			
		} catch (PDOException $e) {
			//print $e->getMessage ();
			return null;
		}
	}
	
	function checkCode($code)
	{
		global $pdoPanel;
		try{
			$rUnitPrice = "SELECT * FROM tigcode WHERE pin = :code LIMIT 1";
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			$stmtUnit->bindParam(":code", $code);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;		
			
		} catch (PDOException $e) {
			//print $e->getMessage ();
			return null;
		}
	}
	
	function checkMac($mac)
	{
		global $pdoPanel;
		try{
			$rUnitPrice = "SELECT * FROM tigcode WHERE mac = :mac LIMIT 1";
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			$stmtUnit->bindParam(":mac", $mac);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return  $rResultUnit;		
			
		} catch (PDOException $e) {
			//print $e->getMessage ();
			return null;
		}
	}
	
	function checkSerial($serial)
	{
		global $pdoPanel;
		try{
			$rUnitPrice = "SELECT * FROM tigcode WHERE serial = :serial LIMIT 1";
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			$stmtUnit->bindParam(":serial", $serial);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;		
			
		} catch (PDOException $e) {
			//print $e->getMessage ();
			return null;
		}
	}
	
	function checkMacSerial($mac, $serial)
	{
		global $pdoPanel;
		try{
			$rUnitPrice = "SELECT * FROM panel.users_extra AS UE 
			LEFT JOIN xtream_iptvpro.users AS U ON U.id = UE.user_id WHERE serial = :serial AND mac = :mac LIMIT 1";
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			$stmtUnit->bindParam(":serial", $serial);
			$stmtUnit->bindParam(":mac", $mac);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;		
			
		} catch (PDOException $e) {
			//print $e->getMessage ();
			return null;
		}
	}
	
	function checkUserActive($code, $mac, $serial)
	{
		global $pdoPanel;
		try{
			$rUnitPrice = "SELECT * FROM users AS U 
					LEFT JOIN panel.users_extra AS UE ON U.id = UE.user_id
					LEFT JOIN panel.active_code AS AC ON U.id = AC.user_id
					WHERE UE.serial = :serial AND UE.mac = :mac AND AC.code = :code AND U.exp_date>= :now LIMIT 1";
			$now = time();
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			$stmtUnit->bindParam(":serial", $serial);
			$stmtUnit->bindParam(":mac", $mac);
			$stmtUnit->bindParam(":code", $code);
			$stmtUnit->bindParam(":now", $now);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;		
			
		} catch (PDOException $e) {
			//print $e->getMessage ();
			return null;
		}
	}
	
	function createUserOLD($pin, $mac, $serial){
		global $pdoPanel;
		try{
			$username = randomKeyAlpha(10);
			$password = randomKeyAlpha(10);
			
			$rqtCreateUser = "INSERT INTO tigcode
(member_id,username,password,pin,   pool,bouquet,start_date,expire_date, active,max_connections,mac,serial,agent,          created_by, forced_country, play_token, is_trial) VALUES
(1,:username,     :password,:pin,1, :bouquet,:start_date,:expire_date,1,1,                 :mac,:serial,'iptv.AGENT1.0', 1,'ALL', '', 1)";
		
			$now = time();
			$expire = strtotime('+1 years', $now);
		
			$stmtCreate = $pdoPanel->prepare($rqtCreateUser);
			$stmtCreate->bindParam(":username",$username);
			$stmtCreate->bindParam(":password",$password);
			$stmtCreate->bindParam(":pin",$pin);
			$stmtCreate->bindValue(":bouquet", '[48]');
			$stmtCreate->bindParam(":start_date", $now);
			$stmtCreate->bindParam(":expire_date", $expire);
			$stmtCreate->bindParam(":mac", $mac);
			$stmtCreate->bindParam(":serial", $serial);
			
			$stmtCreate->execute();
			return true;
		} catch (PDOException $e) {
			//die($e->getMessage());
			return false;
		}
	}
	

	function getPackageBouquet($pack)
	{
		global $pdoPanel;
		try{
			$rUnitPrice = "SELECT * FROM packages WHERE id = :pack ";
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			$stmtUnit->bindParam(":pack", $pack);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;		
			
		} catch (PDOException $e) {
			//print $e->getMessage ();
			return [];
		}
	}
	
	function createUser($userCode, $mac, $serial, $chipid){
		global $pdoPanel;
		try{
			$checkCode = checkCodeExist($userCode);
			$username = randomKeyAlpha(10);
			$password = randomKeyAlpha(10);
			$rqtOutput = "INSERT INTO user_output(user_id,access_output_id) VALUES(:id,:idoutput)";
			$now = time();
			$dateCreated = date("Y-m-d H:i:s");
			//$expire = strtotime('+1 years', $now);
			//$bouquetsToUse = "[143,213,145,146,216,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,173,174,175,219,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,193,194,195,196,197,199,200,202,203,206,208,211]";
			
			$package = getPackageBouquet($checkCode[0]['package_id']);
		//die(json_encode($package));
			$bouquets = (!empty($package))?$package[0]['bouquets']:'[]';
			$bouquetsToUse = $bouquets;
			if($package[0]['is_trial']){
				$timeToAdd = '+ '.$package[0]['trial_duration'].' '.$package[0]['trial_duration_in'];
			}else{
				$timeToAdd = '+ '.$package[0]['official_duration'].' '.$package[0]['official_duration_in'];        
			}
			$timeEnd = strtotime(date("Y-m-d H:i:s",strtotime($dateCreated. $timeToAdd)));
			
			$dateCreated = strtotime($dateCreated);		
			/*echo json_encode($package);
			echo"<br>---------------------<br>";
			die($bouquetsToUse);*/
			//die(json_encode($package));
			$rqtCreateUser = "INSERT INTO users
		   (member_id,username,password,exp_date,   reseller_notes,bouquet,max_connections,is_restreamer,is_mag,is_e2,is_trial,created_at,created_by, forced_country) 
	VALUES(1,:username,:password,:exp_date,'Protocol 2',    :bouquet,1,0,                          0,	  0,0,:created_at,1, 'ALL')";
	
			$stmtCreate = $pdoPanel->prepare($rqtCreateUser);
			$stmtCreate->bindParam(":username",$username);
			$stmtCreate->bindParam(":password",$password);
			$stmtCreate->bindParam(":exp_date",$timeEnd);
			$stmtCreate->bindParam(":bouquet",$bouquetsToUse);
			$stmtCreate->bindParam(":created_at",$now);
			
			$stmtCreate->execute();
		$lastInserted = $pdoPanel->lastInsertId();
		
		$Status = "UPDATE panel.active_code 
        SET user_id={$lastInserted},
			date_activate = '".time()."'
        WHERE code = '".$userCode."' ;"."\n";
			$stmtUpdateCode = $pdoPanel->prepare($Status);
			$stmtUpdateCode->execute();
		
		$rqtCreateUserExtra = "INSERT INTO panel.users_extra(user_id, name, country_lock_date, package_id, mac, serial, chipid) 
														VALUE(:user,:name, null, :pack, :mac, :serial, :chipid)";
		$stmtCreateExtra = $pdoPanel->prepare($rqtCreateUserExtra);
		$stmtCreateExtra->bindParam(":user",$lastInserted);
		$stmtCreateExtra->bindParam(":name",$username);
		$stmtCreateExtra->bindParam(":pack",$checkCode['package_id']);
		$stmtCreateExtra->bindParam(":mac",$mac);
		$stmtCreateExtra->bindParam(":serial",$serial);
		$stmtCreateExtra->bindParam(":chipid",$chipid);
		$stmtCreateExtra->execute();
		
		$stmtOutput = $pdoPanel->prepare($rqtOutput);
		$stmtOutput->bindParam(':id',$lastInserted);
		$stmtOutput->bindValue(':idoutput',1);
		$stmtOutput->execute();
		$stmtOutput->bindParam(':id',$lastInserted);
		$stmtOutput->bindValue(':idoutput',2);
		$stmtOutput->execute();
		$stmtOutput->bindParam(':id',$lastInserted);
		$stmtOutput->bindValue(':idoutput',3);
		$stmtOutput->execute();

			return [
								"status" => 100,
								"message" =>  "The Code is active",
								"expire" => dateDifference($now, $timeEnd)." days",
								"user_agent" => "iptv.AGENT1.0",
								"code_id" => $userCode
							];
			
		} catch (PDOException $e) {
			die($e->getMessage());
			return [
								"status" => 99,
								"message" =>  "Server is down, please try again later.",
								"expire" => "0 days",
								"user_agent" => $_SERVER['HTTP_USER_AGENT'],
									"osd" => @$json['osd_test'],
								"code_id" => $userCode
							];
			return false;
		}
	}
	
	function dateDifference($start_date, $end_date)
	{
		// calulating the difference in timestamps 
		$diff = $start_date - $end_date;
		  
		// 1 day = 24 hours 
		// 24 * 60 * 60 = 86400 seconds
		return ceil(abs($diff / 86400));
	}
	
	function activate($userCode, $mac, $sn){
		$checkMacSerial = checkMacSerial($mac, $sn);
		
		if(!empty($checkMacSerial)){
			$now = time(); 
			$your_date = strtotime($checkMacSerial[0]['expire_date']);
			$datediff = $now - $your_date;
			$datediff = round($datediff / (60 * 60 * 24));
			return	[
					"status" => 100,
					"message" =>  "The Code is active",
					"expire" => $datediff+" days",
					"user_agent" => "iptv.AGENT1.0",
					"code_id" => $userCode
				];
		}else{
			if(createUser($userCode, $mac, $sn))	
				return [
					"status" => 100,
					"message" =>  "The Code is active",
					"expire" => "365 days",
					"user_agent" => "iptv.AGENT1.0",
					"code_id" => $userCode
				];
			else
				return [
					"status" => 99,
					"message" =>  "Server is down, please try again later.",
					"expire" => "0 days",
					"user_agent" => "iptv.AGENT1.0",
					"code_id" => $userCode
				];
		}		
		
	}

	function getBouquets($bouquets){
		Global $pdoPanel;
		try{
			$bouquets = json_decode($bouquets , true);
			//$param = "{".implode(', ',$bouquets)."}";
			$qMarks = str_repeat('?,', count($bouquets) - 1) . '?';
			//die($param);
			$rUnitPrice = "SELECT id, bouquet_name as name, `order`, '0' as parent FROM bouquets WHERE id IN ($qMarks)";
			
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			//$stmtUnit->bindParam($types, ...$bouquets);
			$stmtUnit->execute($bouquets);
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;	
		} catch (PDOException $e) {
			die($e->getMessage());
			return false;
		}
	}
	
	function getLives($type){
		Global $pdoPanel;
		try{
			$rUnitPrice = "SELECT id, category_name as name, cat_order as `order`, parent_id as parent FROM xtream_iptvpro.stream_categories 
				WHERE category_type = '{$type}' AND Enabled = 1 ORDER BY cat_order ASC";
			
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			//$stmtUnit->bindParam($types, ...$bouquets);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;	
		} catch (PDOException $e) {
			die($e->getMessage());
			return false;
		}
	}
	
	function getBouquetById($bouquetId)
	{
		Global $pdoPanel;
		try{
			
			$rUnitPrice = "SELECT * FROM xtream_iptvpro.bouquets WHERE id = :id LIMIT 1";
			
			$stmtUnit = $pdoPanel->prepare($rUnitPrice);
			$stmtUnit->bindParam(':id', $bouquetId);
			$stmtUnit->execute();
			$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
			return $rResultUnit;	
		} catch (PDOException $e) {
			die($e->getMessage());
			return false;
		}
	}
	
	function getChannelBouquet($categorie, $lenght, $from)
	{
		Global $pdoPanel;
		try{
				$rUnitPrice = "SELECT id, stream_display_name as name, `order`, stream_icon as logo, stream_source as url, category_id 
				FROM xtream_iptvpro.streams WHERE category_id = '{$categorie}' AND Enabled = 1
				ORDER BY `order` ASC LIMIT {$lenght} OFFSET {$from}";
			
				$stmtUnit = $pdoPanel->prepare($rUnitPrice);
				//$stmtUnit->bindParam($types, ...$bouquets);
				$stmtUnit->execute();
				$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
				return $rResultUnit;	
			
			
		} catch (PDOException $e) {
			die($e->getMessage());
			return false;
		}
	}
	
	function getMovies($categorie, $lenght, $from)
	{
		Global $pdoPanel;
		try{
				$rUnitPrice = "SELECT * FROM xtream_iptvpro.streams WHERE category_id = '{$categorie}' 
				ORDER BY `order` ASC LIMIT {$lenght} OFFSET {$from}";
			
				$stmtUnit = $pdoPanel->prepare($rUnitPrice);
				//$stmtUnit->bindParam($types, ...$bouquets);
				$stmtUnit->execute();
				$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
				return $rResultUnit;	
			
			
		} catch (PDOException $e) {
			die($e->getMessage());
			return false;
		}
	}
	
	function getMovieInfo($movieId)
	{
		Global $pdoPanel;
		try{
				$rUnitPrice = "SELECT * FROM xtream_iptvpro.streams WHERE id = '{$movieId}' ";			
			
				$stmtUnit = $pdoPanel->prepare($rUnitPrice);
				$stmtUnit->execute();
				$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
				if(!empty($rResultUnit))
					return $rResultUnit;	
				else
					return false;
			
			
		} catch (PDOException $e) {
			die($e->getMessage());
			return false;
		}
	}	
	
	function getSeries($categorie, $lenght, $from)
	{
		Global $pdoPanel;
		try{
				$rUnitPrice = "SELECT * FROM xtream_iptvpro.series WHERE category_id = '{$categorie}' 
				ORDER BY `title` ASC LIMIT {$lenght} OFFSET {$from}";
			
				$stmtUnit = $pdoPanel->prepare($rUnitPrice);
				$stmtUnit->execute();
				$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
				return $rResultUnit;	
			
			
		} catch (PDOException $e) {
			die($e->getMessage());
			return false;
		}
	}
	
	function getSerieEpisode($serieId)
	{
		Global $pdoPanel;
		try{
				$rUnitPrice = "SELECT SE.*, S.stream_display_name, S.stream_source, S.target_container FROM xtream_iptvpro.series_episodes as SE 
							LEFT JOIN streams AS S ON S.id = SE.stream_id 
							WHERE series_id = '{$serieId}' ORDER BY `sort` ASC";
			
				$stmtUnit = $pdoPanel->prepare($rUnitPrice);
				$stmtUnit->execute();
				$rResultUnit = $stmtUnit->fetchAll(PDO::FETCH_ASSOC);
				return $rResultUnit;	
			
			
		} catch (PDOException $e) {
			die($e->getMessage());
			return false;
		}
	}

?>
	