<?php 
require('../includes/inc_db.php');
session_start();
if($_POST){
    
    $admin = 0;
    if($_SESSION['admin']){
        $admin = 1;
    }
	if(isset($_POST['type']) && $_POST['type'] == 2){
		$rqt="UPDATE tickets_replies set message = :msg WHERE id = :id";
		//echo $rqt;
		$stmt = $pdo->prepare($rqt);
		
		$stmt->bindParam(":id",$_POST['id']);
		$stmt->bindParam(":msg",$_POST['message']);
		if($stmt->execute()){
			$rReturn["good"] = 1;
		}else{
			$rReturn["good"] = 0;
		}
		echo json_encode($rReturn);
		exit();
	}
    $rReturn = Array();
    $rqt="INSERT INTO tickets_replies(ticket_id,admin_reply,message,date) VALUES(:id,:admin,:message,:date)";
    $stmt = $pdo->prepare($rqt);
    $date = time();
    $stmt->bindParam(":id",$_POST['id']);
    $stmt->bindParam(":admin",$admin);
    $stmt->bindParam(":message",$_POST['message']);
    $stmt->bindParam(":date",$date);
    $rReturn["admin"] = intval($admin);
    $rReturn["message"] = $_POST['message'];
    $rReturn["date"] = $date ;
    $rReturn["username"] = $_SESSION['username'];
    if($stmt->execute()){
		$rReturn["reply_id"] = $pdo->lastInsertId();
        $rReturn["good"] = 1;
        $rqtUpdate = "UPDATE tickets SET admin_read = :adR, user_read = :usR WHERE id = :id";
        $stmtUpdate = $pdo->prepare($rqtUpdate);
        $userRead = 1; 
        $adminRead = 0;
        if($_SESSION['admin']){
            $adminRead = 1;
            $userRead = 0; 

        }
        $stmtUpdate->bindParam(":adR",$adminRead);
        $stmtUpdate->bindParam(":usR",$userRead);
        $stmtUpdate->bindParam(":id",trim($_POST['id']));
        $stmtUpdate->execute();
    }else{
        $rReturn["good"] = 0;
    }
    echo json_encode($rReturn);
}

?>