<?php
include("../layout/header.php");
if($_GET){
    $stmtTicket = $pdo->prepare("SELECT * FROM tickets LEFT JOIN panel.ticket_extra AS TE ON TE.ticket_id = tickets.id WHERE tickets.id=:id");
    $stmtTicket->bindParam(":id",trim($_GET['id']));
    $stmtTicket->execute();
    $rsTicket = $stmtTicket->fetchAll(PDO::FETCH_ASSOC);
    if(count($rsTicket)>0){
        $rqtUpdate = "UPDATE tickets SET admin_read = :adR, user_read = :usR WHERE id = :id";
        $stmtUpdate = $pdo->prepare($rqtUpdate);
        $userRead = $rsTicket[0]["user_read"]; 
        $adminRead = $rsTicket[0]["admin_read"];
        if($_SESSION['admin']){
            $adminRead = 1;
        }else{
			$userRead = 1;
		}
        $stmtUpdate->bindParam(":adR",$adminRead);
        $stmtUpdate->bindParam(":usR",$userRead);
        $stmtUpdate->bindParam(":id",trim($_GET['id']));
        $stmtUpdate->execute();
        $stmtUsername = $pdo->prepare("SELECT username FROM reg_users WHERE id=:id");
        $stmtUsername->bindParam(":id",$rsTicket[0]['member_id']);
        $stmtUsername->execute();
        $rsUsername = $stmtUsername->fetchAll(PDO::FETCH_ASSOC);
        $stmtInfoTicket = $pdo->prepare("SELECT * FROM tickets_replies WHERE ticket_id = :tId ORDER BY id ASC");
        $stmtInfoTicket->bindParam(":tId",$_GET['id']);
        $stmtInfoTicket->execute();
        $rsInfoTicket = $stmtInfoTicket->fetchAll(PDO::FETCH_ASSOC);
        $admin_reply = "";
        $date_ticket ="";
        $string_date_ticket ="";
        $admin = 0;
    }else{
        echo"<script>location.replace('tickets_history.php')</script>";
    }
    

}else{
    echo"<script>location.replace('tickets_history.php')</script>";
}

$ticketOpen = "menu-open";
$ticketActive = "active";
include("../layout/header_html.php");
?>
 
 
 <style>
	.deleteMSG{
		float: right;
		display:none;
		cursor: pointer;
	}
	
	.direct-chat-msg:hover .deleteMSG{
		display:block;
	}
	
	.direct-chat-text  img{
		width: 50% !important;
	}
	
 </style>
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Tickets </h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">ticket</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
	
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
		  
		  
				<!-- DIRECT CHAT WARNING -->
            <div class="card card-warning direct-chat direct-chat-info">
              <div class="card-header">
                <h3 class="card-title"><?php echo $rsTicket[0]['title'].' --- '.$rsTicket[0]['step1'].' --- '.$rsTicket[0]['step2'].' --- '.$rsTicket[0]['step3'].' --- '.$rsTicket[0]['step4']; ?></h3>

              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <!-- Conversations are loaded here -->

                <div class="direct-chat-messages" id="block_msgs">				
					<input type="hidden" name="idTicket" id="idTicket" value="<?php echo trim($_GET['id']); ?>">
					
					 <?php 
                        foreach($rsInfoTicket as $row){
                            if($row['admin_reply'] == 1){ ?> 
							  <!-- Message. Default to the left -->
							  <div class="direct-chat-msg">
								<div class="direct-chat-infos clearfix">
								  <span class="direct-chat-name float-left">Admin</span>
								  <span class="direct-chat-timestamp float-right"><?php  echo date("d-m-Y (H:i)",$row['date']); ?></span>
								</div>
								<!-- /.direct-chat-infos -->
								<img class="direct-chat-img" src="../dist/img/user1-128x128.jpg" alt="Message User Image">
								<!-- /.direct-chat-img -->
								<div class="direct-chat-text" id="msg_<?=$row['id']; ?>" <?php if($_SESSION['admin']){ ?>onClick="editMSG(this)" <?php } ?>  data-id="<?php echo $row['id']; ?>">
								  <?php echo $row['message']; ?>
								</div>
								<?php if($_SESSION['admin']){ echo "<span class='deleteMSG' data-id='{$row['id']}' >X</span>"; } ?>
								<!-- /.direct-chat-text -->
							  </div>
							  <!-- /.direct-chat-msg -->
							<?php
                            }if($row['admin_reply'] == 0){
                                ?>
								  <!-- Message to the right -->
								  <div class="direct-chat-msg right">
									<div class="direct-chat-infos clearfix">
									  <span class="direct-chat-name float-right"><?php echo $rsUsername[0]['username']; ?></span>
									  <span class="direct-chat-timestamp float-left"><?php  echo date("d-m-Y (H:i)",$row['date']); ?></span>
									</div>
									<!-- /.direct-chat-infos -->
									<img class="direct-chat-img" src="../dist/img/user2-160x160.jpg" alt="<?php echo $rsUsername[0]['username']; ?>">
									<!-- /.direct-chat-img --> 
									<div class="direct-chat-text">
									  <?php echo $row['message']; ?>
									</div>
									<!-- /.direct-chat-text -->
								  </div>
				  
				  <?php
                            }
                            
                        }
                    ?>
                  <!-- /.direct-chat-msg -->
                </div>
                <!--/.direct-chat-messages-->                
			  
			  </div>
             

			 <!-- /.card-body -->
              <div class="card-footer">
                <form action="#" method="post">
                  <div class="input-group">
                    <textarea placeholder="Type a message" aria-describedby="button-addon2"
                            class="form-control rounded py-4" id="message"></textarea>
                    <span class="input-group-append" style="margin-bottom: 1rem;">
                      <button type="submit" id="button-addon2" onclick="sendTicketAnswer()" class="btn btn-warning">Send</button>
                    </span>
                  </div>
                </form>
              </div>
              <!-- /.card-footer-->
            </div>
            <!--/.direct-chat -->
			
			
			
			
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  <div class="modal fade" tabindex="-1" id="editMSGTXT" role="dialog" aria-labelledby="extendLabel" aria-hidden="true" style="display: none;" data-id="">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" >Modifier reponse</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
                <div class="modal-body" >
					<input type="hidden" name="msg_id" id="msg_id" value="">
                     <div class="input-group mb-3">
                        <textarea placeholder="Type a message" aria-describedby="button-addon2"
                            class="form-control rounded py-4" id="messagetxt"></textarea>
                        <div class="input-group-append">
                            <button onclick="editTicketAnswer()" type="button" class="btn btn-default"> <i class="fas fa-paper-plane"></i></button>
                        </div>
                    </div>
                </div>
            </div><!-- /.modal-content -->
        </div>
    </div><!-- /.modal-dialog -->
    
 
  
<?php 
	include("../layout/footer.php");
?>
<?php
require("../common/body.php");
?>
<script>
    function sendTicketAnswer() {
        let message = $('#message').val();
        let ticketId = $('#idTicket').val();
		if(message != ''){
			$.ajax({
				url: 'send_ticket.php',
				type: 'POST',
				data: {
					id: ticketId,
					message: message,
					type: 1
				}, // On fait passer nos variables, exactement comme en GET, au script more_com.php
				success: function (response) {
					response = JSON.parse(response)
					if (response['good'] === 1) {
						append(response['admin'],response['username'],response['message'],response['date'],response['reply_id'])
						$('#message').val("")
						$('#message').summernote('reset');
						
						$("#block_msgs").scrollTop($("#block_msgs")[0].scrollHeight);
						
					} else {
						console.log("NOK")

					}
				}
			});
		}
        
    } 
	
    function editTicketAnswer() {
        let message = $('#messagetxt').val();
        let ticketId = $('#msg_id').val();
		console.log(ticketId);
        $.ajax({
            url: 'send_ticket.php',
            type: 'POST',
            data: {
                id: ticketId,
                message: message,
				type: 2
            }, // On fait passer nos variables, exactement comme en GET, au script more_com.php
            success: function (response) {
                response = JSON.parse(response)
				console.log(response);
				$('#editMSGTXT').modal('hide');
                if (response['good'] === 1) {
                    
					$("#msg_"+ticketId).text(message)
                    $('#messagetxt').val("")
                    
                } else {
                    console.log("NOK")

                }
            }
        });
    } 
    function format_date(date) {
        month=date.getMonth();
        month=month+1; //javascript date goes from 0 to 11
        if (month<10) month="0"+month; //adding the prefix

        year=date.getFullYear();
        day=date.getDate();
        hour=date.getHours();
        minutes=date.getMinutes();
        seconds=date.getSeconds();

        return day+"-"+month+"-"+year+" ("+hour+":"+minutes+")";

    }
    
	function append(admin,username,message,date, reply_id){
        let selector = $('.chat-box ');
        let formatedDate = format_date(new Date(date*1000));
        let div =""
        if(admin == 1){
            div = '<div class="media w-50 mb-3"><img src="/images/logoveep.png" alt="Admin" width="50"><div class="media-body ml-3" style="display: grid;"> Admin <div class="bg-light adminPanel rounded py-2 px-3 mb-2 edit-msg" onClick="editMSG(this)" data-msg="'+message+'" data-id="'+reply_id+'"> <p class="text-small mb-0 text-white">'+message+'</p></div><p class="small text-muted">'+formatedDate+'</p></div></div>'
                                
                                    
        }
        if(admin == 0){
            div = '<div class="media w-50 ml-auto mb-3"><div class="media-body">'+username+'<div class="bg-primary bluePanel rounded py-2 px-3 mb-2"><p class="text-small mb-0 text-white">'+message+'</p></div> <p class="small text-muted">'+formatedDate+'</p> </div> </div>'
        }
        selector.append(div);
    }
	
	function editMSG(self)
	{
		console.log($(self).text());
		console.log($(self));
		//$("#messagetxt").val($(self).text())
		$("#msg_id").val($(self).data('id'))
		$('#messagetxt').summernote('code', $(self).text());
		$('#editMSGTXT').modal('show');
	}
	
	
</script>

<!-- Summernote -->
<script src="../plugins/summernote/summernote-bs4.min.js"></script>


<script>
$(document).ready(function(){
	
	$('.deleteMSG').on('click', function(){
		var self = this;
		var id = $(this).data('id');
		var r = confirm("Are you sure ");
		if (r == true) {
		  $.ajax({
            url: '../common/getData.php?type=delete_msg&q='+id,
            type: 'GET',
            success: function (response) {
                response = JSON.parse(response)
				console.log(response);
				console.log($(self).parent().parent());
                $(self).parent().remove();
            }
        });
		} 
	})
	
	
	$("#block_msgs").scrollTop($("#block_msgs")[0].scrollHeight);
    $('#message, #messagetxt').summernote({
    fontSizes: ['12', '14', '16', '18', '24', '36', '48'],
    fontNames:['Arial', 'Arial Black', 'Comic Sans MS', 'Courier New'],
    toolbar: [
    ['style', ['style']],
    ['font', ['bold', 'underline', 'clear']],
    ['fontnames', ['fontname']],
    ['fontsize', ['fontsize']],
    ['insert', ['picture']],
    ['view', ['fullscreen','undo','redo', 'codeview', 'help']],
    ],
    popover: {
  image: [
    ['image', ['resizeFull', 'resizeHalf', 'resizeQuarter', 'resizeNone']],
    ['float', ['floatLeft', 'floatRight', 'floatNone']],
    ['remove', ['removeMedia']]
  ],
  link: [
    ['link', ['linkDialogShow', 'unlink']]
  ],
  table: [
    ['add', ['addRowDown', 'addRowUp', 'addColLeft', 'addColRight']],
    ['delete', ['deleteRow', 'deleteCol', 'deleteTable']],
  ],
  air: [
    ['color', ['color']],
    ['font', ['bold', 'underline', 'clear']],
    ['para', ['ul', 'paragraph']],
    ['table', ['table']],
    ['insert', ['link', 'picture']]
  ]
    },
    });

})

</script>
