<?php 
include("../layout/header.php");
if($_SESSION['admin'] != 1){
    $rqt = "SELECT id, template_name, bouquets FROM panel_templates WHERE user_id = :id AND deleted=0";
    $stmt = $pdoPanel->prepare($rqt);
    $stmt->bindParam(":id",$_SESSION['id']);
    $stmt->execute();
    $rs=$stmt->fetchAll(PDO::FETCH_ASSOC);
}else{
    $rqt = "SELECT id, template_name, bouquets FROM panel_templates WHERE deleted=0";
    $stmt = $pdoPanel->prepare($rqt);
    $stmt->execute();
    $rs=$stmt->fetchAll(PDO::FETCH_ASSOC);
}

$toast = false;
if(isset($_SESSION['message'])){
	$toast = true;
	unset($_SESSION['message']);
}

               if(isset($_SESSION['message_delete_template'])){
					unset($_SESSION['message_delete_template']);
                   echo '<script>
                   setTimeout(function() {
                       Swal.fire({
                           title: "Template deleted !",
                           text: "The template successfully deleted",
                           icon: "success"
                       }).then(function() {
                           //window.location = window.location.pathname;
                       });

                   }, 1000);
               </script>';
               }
               if(isset($_SESSION['message_edit_template'])){
					unset($_SESSION['message_edit_template']);
                   echo '<script>
                   setTimeout(function() {
                       Swal.fire({
                           title: "Template edited !",
                           text: "The template successfully edited",
                           icon: "success"
                       }).then(function() {
                           //window.location = window.location.pathname;
                       });

                   }, 1000);
               </script>';
               }
			   

$toolOpen = "menu-open";
$toolActive = "active";
include('../layout/header_html.php');
            ?>
   
   
<!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="../plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  
  
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Tempalte </h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Tools</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
	
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
			 <div class="card">
              <div class="card-header">
                <h3 class="card-title">List of template</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table id="example1" class="table table-bordered table-striped templatelist">
                  <thead>
                  <tr>
                    <th>
                        Template's name
                    </th>
                    <th>
                        Options
                    </th>
                  </tr>
                  </thead>
                   <tbody>
                        <?php foreach($rs as $row): ?>
                            <tr>
                                <td class="py-1"><?php echo($row['template_name']); ?></td>
                                <td class="py-1"><div style="display:inline">
                                <a href="<?php echo'editTemplate.php?id='.$row['id'];?>">
                                    <button data-toggle="tooltip" data-placement="top" title="" data-original-title="Edit" type="button" class="btn btn-outline-info waves-effect waves-light btn-xs">
                                        <i class="fas fa-pencil-alt"></i>
                                    </button>
                                </a>
                                <a class="deleteIt" href="javascript:void(0);" onClick="deleteTemplate(this)" data-href="<?php echo'deleteTemplate.php?id='.$row['id'];?>">
                                    <button data-toggle="tooltip" data-placement="top" title="" data-original-title="Disable" type="button" class="btn btn-outline-danger waves-effect waves-light btn-xs deleteIt ">
                                        <i class="far fa-trash-alt"></i>
                                    </button>
                                </a>
                            </div></td>
                            </tr>
                            
                        <?php endforeach; ?>
                        </tbody>
                  <tfoot>
                  <tr>
                     <th>
                        Template's name
                    </th>
                    <th>
                        Options
                    </th>
                  </tr>
                  </tfoot>
                </table>
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
		   </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
  
<?php 
	include("../layout/footer.php");
?>
 


<!-- DataTables  & Plugins -->
<script src="../plugins/datatables/jquery.dataTables.min.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="../plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="../plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="../plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="../plugins/jszip/jszip.min.js"></script>
<script src="../plugins/pdfmake/pdfmake.min.js"></script>
<script src="../plugins/pdfmake/vfs_fonts.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="../plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
  
  <script>
  $(function () {
    $(".templatelist").DataTable({
      "responsive": true, 
	  "lengthChange": false, 
	  "autoWidth": false,
    });
    $('#example2').DataTable({
      "paging": true,
      "lengthChange": false,
      "searching": false,
      "ordering": true,
      "info": true,
      "autoWidth": false,
      "responsive": true,
    });
  });
  
  function deleteTemplate(self){
	  console.log(self)
	  var url = $(self).data("href");
	  console.log(url);
	  Swal.fire({
		  title: "Are you sure?",
		  text: "You will not be able to recover this template!",
		  icon: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Yes, I am sure!'
		}).then(function(result) {
		  if (result.isConfirmed) {
				window.location.href = url;
		  }
		})
  }
</script>
   
   
</body>
</html>