<?php 
require("../layout/header.php");
$rqtGetAllMag = "SELECT users.id,users.member_id, mag.mag_id FROM users INNER JOIN mag_devices mag ON users.id = mag.user_id";
$rqtInsertMessage = "INSERT INTO `mag_events`(`status`, `mag_device_id`, `event`, `need_confirm`, `msg`, `reboot_after_ok`, `send_time`) VALUES (0, :id,'send_msg', 1, :message, 0, :time )";
if($_POST){
    if(isset($_POST['message'])){
        $stmtGetAll = $pdo->prepare($rqtGetAllMag);
        $stmtInsert = $pdo->prepare($rqtInsertMessage);
        $stmtGetAll->execute();
        $rsAllMag = $stmtGetAll->fetchAll(PDO::FETCH_ASSOC);
        $message = trim($_POST['message']);
        $message = filter_var($message,FILTER_SANITIZE_STRING);
        $arrayId = [];
        foreach($rsAllMag as $rRow){
            if($_SESSION['admin'] == 0){
                if($_SESSION['id'] == $rRow['member_id']){
                    array_push($arrayId,$rRow['mag_id']);
                }
            }else{
                array_push($arrayId,$rRow['mag_id']);
            }
        }
        if(count($arrayId)>0){
            $time = time();
            $trouble = "ok";
            $indexError = 0;
            foreach($arrayId as $v){
                $stmtInsert->bindParam(":id",$v);
                $stmtInsert->bindParam(":message",$message);
                $stmtInsert->bindParam(":time",$time);
                if(!$stmtInsert->execute()){
                    $indexError++;
                    $trouble=$indexError."request(s) cannot be send";
					echo '<script>
						setTimeout(function() {
							Swal.fire({
								title: "Message !",
								text: "Request(s) cannot be send",
								icon: "danger"
							}).then(function() {
								//window.location = window.location.pathname;
							});

						}, 1000);
					</script>';
                }else{
                    $msg = $_SESSION['username']." send message to all of his mag's client (".count($arrayId)." MAGs) with message :".$message;
                    logEvent($pdo,$_SESSION['username'],"Send Message To All MAG",$msg);
                }
            }
        }

        
    }else{
        $trouble="Empty message";
		echo '<script>
            setTimeout(function() {
                Swal.fire({
                    title: "Message !",
                    text: "Empty message",
                    icon: "danger"
                }).then(function() {
                    //window.location = window.location.pathname;
                });

            }, 1000);
        </script>';
    }
	
	echo '<script>
            setTimeout(function() {
                Swal.fire({
                    title: "Message !",
                    text: "Message has been sent to your clients",
                    icon: "success"
                }).then(function() {
                    //window.location = window.location.pathname;
                });

            }, 1000);
        </script>';
}

$toolOpen = "menu-open";
$toolActive = "active";
require("../layout/header_html.php");
?>

               
 
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header"> 
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Template</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Tools</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
				
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- jquery validation -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Send Message to All STB</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
			  <div class="row" style="margin: auto; margin-top: 2rem;">
				<div class="col-md-12">
					 
				</div>
			  </div>
			  
              <form name="longsubmit"  method="post" action="send_to_all.php">
                <div class="card-body">
				<div class="row">
					<div class="col-md-12">
						<div class="form-group">
							<label>Message</label>
							<textarea class="form-control form-control-lg" name="message" id="message" rows="3" required><?php echo $message; ?></textarea>
							<small style="color:#ffc107;">&nbsp;&nbsp;You can send a general message to all your stb users.</small>							
						</div>
					</div>
					
				</div>                
                <!-- /.card-body -->
                <div class="card-footer">
                  <button type="button" onClick="return submitForm(document.longsubmit, this)" name="submitForm" id="submitForm"  class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
            </div>
          <!--/.col (left) -->
         
          <!--/.col (right) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  
<?php 
	include("../layout/footer.php");
?>
<?php 
require("../common/body.php");
?>
 <script>
 var submitDone = false;
 
 function submitForm(myForm, button) {
   
      if (!submitDone) {
         submitDone = true;
         button.value = 'Please Wait';
         button.disabled = true;
         myForm.submit();
      } 
      else {
        alert ("Already submitted, please wait!");
      }
   return true;
 }
 </script>