<?php 
require('../includes/inc_db.php');
include("../functions/function.php");
$trouble = "";
if($_SESSION['admin'] == 0){
    if(!(in_array($_POST['ownerId'],$_SESSION['sub']))){
        $trouble="notAllowed";
    }
}
try{
if($_POST){
    if($trouble == ""){
        $id = $_POST['idLine'];
        $renew = false;
		
		$rqtOutput = "INSERT INTO user_output(user_id,access_output_id) VALUES(:id,:idoutput)";
		$stmtOutput = $pdo->prepare($rqtOutput);
		
		$allBouquets = array_merge($_POST['toUse'], $_POST['toUseVOD']);
        $bouquetsToUse = "[".implode(',',$allBouquets)."]";
		
		//die($bouquetsToUse);
        if((isset($_POST['reset_userpass'])) && ($_POST['reset_userpass'] == 'on')){
            $rqtModifyBouquet = "UPDATE users SET reseller_notes = :notes, bouquet = :bouquets, password= :password,forced_country=:coutry_lock WHERE id = :id";
        }else{
            $rqtModifyBouquet = "UPDATE users SET reseller_notes = :notes, bouquet = :bouquets, forced_country=:coutry_lock WHERE id = :id";
        }
		
		$auto = $_POST['auto'];
		$countryLockDate = ($auto == "on")?date('Y-m-d',strtotime('+2 day')):null;		
		$country = ($auto == "on")?"":$_POST['coutry_lock'];
		
        $stmtModify=$pdo->prepare($rqtModifyBouquet);
        $stmtModify->bindParam(":notes",$_POST['notes']);
        $stmtModify->bindParam(":coutry_lock", $country);
       // $stmtModify->bindParam(":countryLockDate", $countryLockDate);
        $stmtModify->bindParam(":bouquets",$bouquetsToUse);
        $stmtModify->bindParam(":id",$id);
        
        if((isset($_POST['reset_userpass'])) && ($_POST['reset_userpass'] == 'on')){
            //$stmtModify->bindParam(":username",$_POST['user']);
            $stmtModify->bindParam(":password",$_POST['pass']);
            $renew = true;
        }
		
		$rqtCheck = "SELECT * FROM users_extra WHERE user_id=:id";
		
        $stmtCheck = $pdoPanel->prepare($rqtCheck);
        $stmtCheck->bindParam(':id',$id);
        $stmtCheck->execute();
        $rsCheck = $stmtCheck->fetchAll(PDO::FETCH_ASSOC);
		
		$rqtCheckOutput = "DELETE FROM user_output WHERE user_id=:id";
		
        $stmtCheckOutput = $pdo->prepare($rqtCheckOutput);
        $stmtCheckOutput->bindParam(':id',$id);
        $stmtCheckOutput->execute();
		
		$outputArray = $_POST['output_format'];
		if((is_array($outputArray)) && (!empty($outputArray))){
			foreach($outputArray as $output){				
				$stmtOutput->bindParam(':id',$id);
				$stmtOutput->bindValue(':idoutput',$output);
				$stmtOutput->execute();
			}
		}
		
		if (count($rsCheck) > 0) {
			$rqtCreateUserExtra = "UPDATE users_extra SET name = :name, country_lock_date = :countryClockDate WHERE user_id = :id";	
			$stmtCreateExtra = $pdoPanel->prepare($rqtCreateUserExtra);
			$stmtCreateExtra->bindParam(":id",$id);
			$stmtCreateExtra->bindParam(":name",$_POST['name']);
			$stmtCreateExtra->bindParam(":countryClockDate", $countryLockDate);
			$stmtCreateExtra->execute();
		}else{
			$rqtCreateUserExtra = "INSERT INTO users_extra(user_id, name, country_lock_date, package_id) VALUE(:user,:name,:countryClockDate, :package)";
			$stmtCreateExtra = $pdoPanel->prepare($rqtCreateUserExtra);
			$stmtCreateExtra->bindParam(":user",$id);
			$stmtCreateExtra->bindParam(":name",$_POST['name']);
			$stmtCreateExtra->bindParam(":countryClockDate", $countryLockDate);
			$stmtCreateExtra->bindParam(":package",$_POST['package_id']);
			$stmtCreateExtra->execute();
		}
		
		
						
        $msg = "User ".$_POST['username']." got edited";
        //$stmtModify->bindParam(":name",$_POST['name']);
        if($stmtModify->execute()){
            if($renew){
                $msg = "User ".$_POST['username']." got edited and username / password got reset. Old Username : ".$_POST['username']." --> ".$_POST['user']."<br> OLD PASSWORD : ".$_POST['password']." --> ".$_POST['pass'];
            }
			
			if($_SESSION['admin'] == 1){
				try{
					//echo $_POST['owner'].'--------'.$_POST['oldowner'];
					$owner = (is_null($_POST['owner']))?$_POST['oldowner']:$_POST['owner'];
					//die('****'.$owner);
					$date = new DateTime($_POST['expiration_date']);
					$rqt = "UPDATE users set exp_date = :date, member_id = :member_id WHERE id = :id";
					$stmtModifyDate=$pdo->prepare($rqt);
					$stmtModifyDate->bindParam(":date", $date->getTimestamp());
					$stmtModifyDate->bindParam(":member_id", $owner);
					$stmtModifyDate->bindParam(":id",$id);
					$stmtModifyDate->execute();				
				
				}catch(Exception $e){
					//die($e->getMessage());
				}
			}
			
			if((isset($_POST['pairId'])) && ($_POST['pairId']>0)){
                $rqtPaired = "UPDATE users SET reseller_notes = :notes, bouquet = :bouquets, forced_country=:coutry_lock WHERE id = :id";
                $stmtPaired=$pdo->prepare($rqtPaired);
                $stmtPaired->bindParam(":notes",$_POST['notes']);
                $stmtPaired->bindParam(":bouquets",$bouquetsToUse);
				//$stmtPaired->bindParam(":name",$_POST['name']);
				$stmtPaired->bindParam(":coutry_lock", $country);
				//$stmtPaired->bindParam(":countryLockDate", $countryLockDate);
                $stmtPaired->bindParam(":id",$_POST['pairId']);
				
                $stmtPaired->execute();  
				
				$rqtCheck = "SELECT * FROM users_extra WHERE user_id=:id";
				
				$stmtCheck = $pdoPanel->prepare($rqtCheck);
				$stmtCheck->bindParam(':id', $_POST['pairId']);
				$stmtCheck->execute();
				$rsCheck = $stmtCheck->fetchAll(PDO::FETCH_ASSOC);
				
				if (count($rsCheck) > 0) {
					$rqtCreateUserExtra = "UPDATE users_extra SET name = :name, country_lock_date = :countryClockDate WHERE user_id = :id";	
					$stmtCreateExtra = $pdoPanel->prepare($rqtCreateUserExtra);
					$stmtCreateExtra->bindParam(":id", $_POST['pairId']);
					$stmtCreateExtra->bindParam(":name",$_POST['name']);
					$stmtCreateExtra->bindParam(":countryClockDate", $countryLockDate);
					$stmtCreateExtra->execute();
				}else{
					$rqtCreateUserExtra = "INSERT INTO users_extra(user_id, name, country_lock_date, package_id) VALUE(:user,:name,:countryClockDate, :package)";
					$stmtCreateExtra = $pdoPanel->prepare($rqtCreateUserExtra);
					$stmtCreateExtra->bindParam(":user",$id);
					$stmtCreateExtra->bindParam(":name",$_POST['name']);
					$stmtCreateExtra->bindParam(":countryClockDate", $countryLockDate);
					$stmtCreateExtra->bindParam(":package",$_POST['package_id']);
					$stmtCreateExtra->execute();
				}
		
            }
			//die($_POST['username']);
            logEvent($pdo,"Edit",$_POST['username'],$msg);
            if($_POST['typeLine']=="e2"){
                $mac = $_POST['macAdress'];
                $rqtUpdate = "UPDATE enigma2_devices SET mac = :mac WHERE user_id = :id";
                $stmtUpdate = $pdo->prepare($rqtUpdate);
                $stmtUpdate->bindParam(':mac',$mac);
                $stmtUpdate->bindParam(':id',$id);
                $stmtUpdate->execute();
                header('Location: liste_e2.php?msg=editDone&id='.$id);
            }else if($_POST['typeLine'] == "mag"){
                $mac = base64_encode($_POST['macAdress']);
                $rqtUpdate = "UPDATE mag_devices SET mac = :mac WHERE user_id = :id";
                $stmtUpdate = $pdo->prepare($rqtUpdate);
                $stmtUpdate->bindParam(':mac',$mac);
                $stmtUpdate->bindParam(':id',$id);
                $stmtUpdate->execute();
                header('Location: liste_mag.php?msg=editDone&id='.$id);
            }else{
                header('Location: liste_ligne.php?msg=editDone&id='.$id);
            }
            
        }
    }else{
        header('Location: ../index.php');
    }
}else{
    header('Location: ../index.php');
}

}catch(Exception $e) {
  die( 'Message: ' .$e->getMessage());;
}
?>
