<?php 
require('../includes/inc_db.php');
require('../functions/function.php');
error_reporting(E_ALL);
$rqt = "SELECT username,exp_date, bouquet,member_id,pair_id FROM users WHERE id = :id";
$rqtModifyBouquet = "UPDATE users SET exp_date = :exp_date, is_trial = '0' WHERE id = :id";
$rqtModifyBouquetExtrat = "UPDATE users_extra SET  package_id = :pack_id WHERE user_id = :id";
$rqtRegUserCredit = "UPDATE reg_users SET credits = :credits WHERE id = :id";
$rqtPackage = "SELECT package_name,official_credits, official_duration,official_duration_in,is_trial FROM packages WHERE id=:id";
$stmtPackage = $pdo->prepare($rqtPackage);
$stmt=$pdo->prepare($rqt);
$stmtModify=$pdo->prepare($rqtModifyBouquet);
$stmtModifyExtras=$pdoPanel->prepare($rqtModifyBouquetExtrat);
$stmtCredit=$pdo->prepare($rqtRegUserCredit);
$return = array('status' => 0,'callback'=> "" );
if(!isset($_SESSION['username'])){
    exit();
}
if(isset($_POST)){
    $idUser = $_POST['user'];
    // $time = $_POST['time'];
    $creditBefore = $_SESSION['credits'];
    // $creditLeft = floatval($_POST['credit']);

    $idUser = $_POST['user'];
    $return['callback'] = $_POST['callback'];
    $stmt->bindParam(':id',$idUser);
    $stmt->execute();
    $rs=$stmt->fetchAll(PDO::FETCH_ASSOC);
    if(isset($_POST['package'])){
        $idPackage = trim($_POST['package']);
        $idPackage = filter_var($idPackage,FILTER_SANITIZE_NUMBER_INT);
        $stmtPackage->bindParam(":id",$idPackage);
        $stmtPackage->execute();
        $rsPackage = $stmtPackage->fetchAll(PDO::FETCH_ASSOC);
        if($rsPackage[0]['is_trial'] == 1){
            echo(json_encode($return));
            exit();
        }
        $creditLeft = floatval($creditBefore) - floatval($rsPackage[0]['official_credits']);
        if($creditLeft >= 0){
            if($_SESSION['admin']==0){
                if($rs[0]['member_id'] == $_SESSION['id'] ||in_array($rs[0]['member_id'],$_SESSION['sub'])){
                    $time = '+ '.$rsPackage[0]['official_duration'].' '.$rsPackage[0]['official_duration_in'];
                    $now = time();
                    $rsExp = date("Y-m-d H:i:s",$rs[0]['exp_date']);
                    if($rs[0]['exp_date'] >= $now)
                        $exp_date = date("Y-m-d H:i:s",$rs[0]['exp_date']);
                    if($rs[0]['exp_date'] < $now)
                        $exp_date = date("Y-m-d H:i:s",$now);
                    $date_exp = date("Y-m-d H:i:s",strtotime($exp_date. $time));
                    $timestamp = strtotime($date_exp);
                    $stmtModify->bindParam(":id",$idUser);
                    $stmtModify->bindParam(":exp_date",$timestamp);
                    $stmtModifyExtras->bindParam(":id",$id);
					 $stmtModifyExtras->bindParam(":pack_id",$idPackage);
					 $stmtModifyExtras->execute();
                    if($stmtModify->execute()){
                        if($rs[0]['pair_id'] != NULL){
                            $stmtModify->bindParam(":id",$rs[0]['pair_id']);
                            $stmtModify->bindParam(":exp_date",$timestamp);
                            $stmtModifyExtras->bindParam(":id",$id);
							 $stmtModifyExtras->bindParam(":pack_id",$idPackage);
							 $stmtModifyExtras->execute();
                            $stmtModify->execute();
                        }
                        $stmtCredit->bindParam(":credits",$creditLeft);
                        $stmtCredit->bindParam(":id",$_SESSION['id']);
                        if($stmtCredit->execute()){
                            $return["status"] = 1;
                            $_SESSION['credits'] = $creditLeft;
                            $msg = $rs[0]['username'].' extended from '.$rsExp.' to '.$date_exp.' with package : '.$rsPackage[0]["package_name"].' Credits Before : <font color="red">'.$creditBefore.'</font> After : <font color="green">'.$creditLeft.'</font>';
                            logEvent($pdo,"Extend",$_SESSION['username'],$msg);
                        }else{
                            $return["status"] = 0;
                        }
                    }else{
                        $return["status"] = 0;
                    }
                    
                }else{
                    $return["status"] = 0;
                }
            }else{
                    $time = '+ '.$rsPackage[0]['official_duration'].' '.$rsPackage[0]['official_duration_in'];
                    $now = time();
                    if($rs[0]['exp_date'] >= $now)
                        $exp_date = date("Y-m-d H:i:s",$rs[0]['exp_date']);
                    if($rs[0]['exp_date'] < $now)
                        $exp_date = date("Y-m-d H:i:s",$now);
                    $date_exp = date("Y-m-d H:i:s",strtotime($exp_date. $time));
                    $timestamp = strtotime($date_exp);
                    $stmtModify->bindParam(":id",$idUser);
                    $stmtModify->bindParam(":exp_date",$timestamp);
                    $stmtModifyExtras->bindParam(":id",$id);
					 $stmtModifyExtras->bindParam(":pack_id",$idPackage);
					 $stmtModifyExtras->execute();
                    if($stmtModify->execute()){
                        if($rs[0]['pair_id'] != NULL){
                            $stmtModify->bindParam(":id",$rs[0]['pair_id']);
                            $stmtModify->bindParam(":exp_date",$timestamp);
                            $stmtModifyExtras->bindParam(":id",$id);
					 $stmtModifyExtras->bindParam(":pack_id",$idPackage);
					 $stmtModifyExtras->execute();
                            $stmtModify->execute();
                        }
                        $stmtCredit->bindParam(":credits",$creditLeft);
                        $stmtCredit->bindParam(":id",$_SESSION['id']);
                        if($stmtCredit->execute()){
                            $return["status"] = 1;
                            $_SESSION['credits'] = $creditLeft;
                            $msg = $rs[0]['username']." extended to ".$date_exp.' Credits Before : <font color="red">'.$creditBefore.'</font> After : <font color="green">'.$creditLeft.'</font>';
                            logEvent($pdo,"Extend",$_SESSION['username'],$msg);
                        }else{
                            $return["status"] = 0;
                        }
                    }else{
                        $return["status"] = 0;
                    }
                }
        }
        if($creditLeft < 0){
            $return["status"] = 0;
        }
       
    }else{
        $return["status"] = 0;
    }
    echo(json_encode($return));
}